/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         minimal_base_yyparse
#define yylex           minimal_base_yylex
#define yyerror         minimal_base_yyerror
#define yydebug         minimal_base_yydebug
#define yynerrs         minimal_base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram_minimal.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2024, PgPool Global Development Group
 * Portions Copyright (c) 1996-2024, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include "utils/pgstrcasecmp.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static PartitionStrategy parsePartitionStrategy(char *strategy);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 325 "gram_minimal.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_MINIMAL_BASE_YY_GRAM_MINIMAL_H_INCLUDED
# define YY_MINIMAL_BASE_YY_GRAM_MINIMAL_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int minimal_base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSENT = 276,
    ABSOLUTE_P = 277,
    ACCESS = 278,
    ACTION = 279,
    ADD_P = 280,
    ADMIN = 281,
    AFTER = 282,
    AGGREGATE = 283,
    ALL = 284,
    ALSO = 285,
    ALTER = 286,
    ALWAYS = 287,
    ANALYSE = 288,
    ANALYZE = 289,
    AND = 290,
    ANY = 291,
    ARRAY = 292,
    AS = 293,
    ASC = 294,
    ASENSITIVE = 295,
    ASSERTION = 296,
    ASSIGNMENT = 297,
    ASYMMETRIC = 298,
    ATOMIC = 299,
    AT = 300,
    ATTACH = 301,
    ATTRIBUTE = 302,
    AUTHORIZATION = 303,
    BACKWARD = 304,
    BEFORE = 305,
    BEGIN_P = 306,
    BETWEEN = 307,
    BIGINT = 308,
    BINARY = 309,
    BIT = 310,
    BOOLEAN_P = 311,
    BOTH = 312,
    BREADTH = 313,
    BY = 314,
    CACHE = 315,
    CALL = 316,
    CALLED = 317,
    CASCADE = 318,
    CASCADED = 319,
    CASE = 320,
    CAST = 321,
    CATALOG_P = 322,
    CHAIN = 323,
    CHAR_P = 324,
    CHARACTER = 325,
    CHARACTERISTICS = 326,
    CHECK = 327,
    CHECKPOINT = 328,
    CLASS = 329,
    CLOSE = 330,
    CLUSTER = 331,
    COALESCE = 332,
    COLLATE = 333,
    COLLATION = 334,
    COLUMN = 335,
    COLUMNS = 336,
    COMMENT = 337,
    COMMENTS = 338,
    COMMIT = 339,
    COMMITTED = 340,
    COMPRESSION = 341,
    CONCURRENTLY = 342,
    CONDITIONAL = 343,
    CONFIGURATION = 344,
    CONFLICT = 345,
    CONNECTION = 346,
    CONSTRAINT = 347,
    CONSTRAINTS = 348,
    CONTENT_P = 349,
    CONTINUE_P = 350,
    CONVERSION_P = 351,
    COPY = 352,
    COST = 353,
    CREATE = 354,
    CROSS = 355,
    CSV = 356,
    CUBE = 357,
    CURRENT_P = 358,
    CURRENT_CATALOG = 359,
    CURRENT_DATE = 360,
    CURRENT_ROLE = 361,
    CURRENT_SCHEMA = 362,
    CURRENT_TIME = 363,
    CURRENT_TIMESTAMP = 364,
    CURRENT_USER = 365,
    CURSOR = 366,
    CYCLE = 367,
    DATA_P = 368,
    DATABASE = 369,
    DAY_P = 370,
    DEALLOCATE = 371,
    DEC = 372,
    DECIMAL_P = 373,
    DECLARE = 374,
    DEFAULT = 375,
    DEFAULTS = 376,
    DEFERRABLE = 377,
    DEFERRED = 378,
    DEFINER = 379,
    DELETE_P = 380,
    DELIMITER = 381,
    DELIMITERS = 382,
    DEPENDS = 383,
    DEPTH = 384,
    DESC = 385,
    DETACH = 386,
    DICTIONARY = 387,
    DISABLE_P = 388,
    DISCARD = 389,
    DISTINCT = 390,
    DO = 391,
    DOCUMENT_P = 392,
    DOMAIN_P = 393,
    DOUBLE_P = 394,
    DROP = 395,
    EACH = 396,
    ELSE = 397,
    EMPTY_P = 398,
    ENABLE_P = 399,
    ENCODING = 400,
    ENCRYPTED = 401,
    END_P = 402,
    ENUM_P = 403,
    ERROR_P = 404,
    ESCAPE = 405,
    EVENT = 406,
    EXCEPT = 407,
    EXCLUDE = 408,
    EXCLUDING = 409,
    EXCLUSIVE = 410,
    EXECUTE = 411,
    EXISTS = 412,
    EXPLAIN = 413,
    EXPRESSION = 414,
    EXTENSION = 415,
    EXTERNAL = 416,
    EXTRACT = 417,
    FALSE_P = 418,
    FAMILY = 419,
    FETCH = 420,
    FILTER = 421,
    FINALIZE = 422,
    FIRST_P = 423,
    FLOAT_P = 424,
    FOLLOWING = 425,
    FOR = 426,
    FORCE = 427,
    FOREIGN = 428,
    FORMAT = 429,
    FORWARD = 430,
    FREEZE = 431,
    FROM = 432,
    FULL = 433,
    FUNCTION = 434,
    FUNCTIONS = 435,
    GENERATED = 436,
    GLOBAL = 437,
    GRANT = 438,
    GRANTED = 439,
    GREATEST = 440,
    GROUP_P = 441,
    GROUPING = 442,
    GROUPS = 443,
    HANDLER = 444,
    HAVING = 445,
    HEADER_P = 446,
    HOLD = 447,
    HOUR_P = 448,
    IDENTITY_P = 449,
    IF_P = 450,
    ILIKE = 451,
    IMMEDIATE = 452,
    IMMUTABLE = 453,
    IMPLICIT_P = 454,
    IMPORT_P = 455,
    IN_P = 456,
    INCLUDE = 457,
    INCLUDING = 458,
    INCREMENT = 459,
    INDENT = 460,
    INDEX = 461,
    INDEXES = 462,
    INHERIT = 463,
    INHERITS = 464,
    INITIALLY = 465,
    INLINE_P = 466,
    INNER_P = 467,
    INOUT = 468,
    INPUT_P = 469,
    INSENSITIVE = 470,
    INSERT = 471,
    INSTEAD = 472,
    INT_P = 473,
    INTEGER = 474,
    INTERSECT = 475,
    INTERVAL = 476,
    INTO = 477,
    INVOKER = 478,
    IS = 479,
    ISNULL = 480,
    ISOLATION = 481,
    JOIN = 482,
    JSON = 483,
    JSON_ARRAY = 484,
    JSON_ARRAYAGG = 485,
    JSON_EXISTS = 486,
    JSON_OBJECT = 487,
    JSON_OBJECTAGG = 488,
    JSON_QUERY = 489,
    JSON_SCALAR = 490,
    JSON_SERIALIZE = 491,
    JSON_TABLE = 492,
    JSON_VALUE = 493,
    KEEP = 494,
    KEY = 495,
    KEYS = 496,
    LABEL = 497,
    LANGUAGE = 498,
    LARGE_P = 499,
    LAST_P = 500,
    LATERAL_P = 501,
    LEADING = 502,
    LEAKPROOF = 503,
    LEAST = 504,
    LEFT = 505,
    LEVEL = 506,
    LIKE = 507,
    LIMIT = 508,
    LISTEN = 509,
    LOAD = 510,
    LOCAL = 511,
    LOCALTIME = 512,
    LOCALTIMESTAMP = 513,
    LOCATION = 514,
    LOCK_P = 515,
    LOCKED = 516,
    LOGGED = 517,
    MAPPING = 518,
    MATCH = 519,
    MATCHED = 520,
    MATERIALIZED = 521,
    MAXVALUE = 522,
    MERGE = 523,
    MERGE_ACTION = 524,
    METHOD = 525,
    MINUTE_P = 526,
    MINVALUE = 527,
    MODE = 528,
    MONTH_P = 529,
    MOVE = 530,
    NAME_P = 531,
    NAMES = 532,
    NATIONAL = 533,
    NATURAL = 534,
    NCHAR = 535,
    NESTED = 536,
    NEW = 537,
    NEXT = 538,
    NFC = 539,
    NFD = 540,
    NFKC = 541,
    NFKD = 542,
    NO = 543,
    NONE = 544,
    NORMALIZE = 545,
    NORMALIZED = 546,
    NOT = 547,
    NOTHING = 548,
    NOTIFY = 549,
    NOTNULL = 550,
    NOWAIT = 551,
    NULL_P = 552,
    NULLIF = 553,
    NULLS_P = 554,
    NUMERIC = 555,
    OBJECT_P = 556,
    OF = 557,
    OFF = 558,
    OFFSET = 559,
    OIDS = 560,
    OLD = 561,
    OMIT = 562,
    ON = 563,
    ONLY = 564,
    OPERATOR = 565,
    OPTION = 566,
    OPTIONS = 567,
    OR = 568,
    ORDER = 569,
    ORDINALITY = 570,
    OTHERS = 571,
    OUT_P = 572,
    OUTER_P = 573,
    OVER = 574,
    OVERLAPS = 575,
    OVERLAY = 576,
    OVERRIDING = 577,
    OWNED = 578,
    OWNER = 579,
    PARALLEL = 580,
    PARAMETER = 581,
    PARSER = 582,
    PARTIAL = 583,
    PARTITION = 584,
    PASSING = 585,
    PASSWORD = 586,
    PATH = 587,
    PGPOOL = 588,
    PLACING = 589,
    PLAN = 590,
    PLANS = 591,
    POLICY = 592,
    POSITION = 593,
    PRECEDING = 594,
    PRECISION = 595,
    PRESERVE = 596,
    PREPARE = 597,
    PREPARED = 598,
    PRIMARY = 599,
    PRIOR = 600,
    PRIVILEGES = 601,
    PROCEDURAL = 602,
    PROCEDURE = 603,
    PROCEDURES = 604,
    PROGRAM = 605,
    PUBLICATION = 606,
    QUOTE = 607,
    QUOTES = 608,
    RANGE = 609,
    READ = 610,
    REAL = 611,
    REASSIGN = 612,
    RECHECK = 613,
    RECURSIVE = 614,
    REF_P = 615,
    REFERENCES = 616,
    REFERENCING = 617,
    REFRESH = 618,
    REINDEX = 619,
    RELATIVE_P = 620,
    RELEASE = 621,
    RENAME = 622,
    REPEATABLE = 623,
    REPLACE = 624,
    REPLICA = 625,
    RESET = 626,
    RESTART = 627,
    RESTRICT = 628,
    RETURN = 629,
    RETURNING = 630,
    RETURNS = 631,
    REVOKE = 632,
    RIGHT = 633,
    ROLE = 634,
    ROLLBACK = 635,
    ROLLUP = 636,
    ROUTINE = 637,
    ROUTINES = 638,
    ROW = 639,
    ROWS = 640,
    RULE = 641,
    SAVEPOINT = 642,
    SCALAR = 643,
    SCHEMA = 644,
    SCHEMAS = 645,
    SCROLL = 646,
    SEARCH = 647,
    SECOND_P = 648,
    SECURITY = 649,
    SELECT = 650,
    SEQUENCE = 651,
    SEQUENCES = 652,
    SERIALIZABLE = 653,
    SERVER = 654,
    SESSION = 655,
    SESSION_USER = 656,
    SET = 657,
    SETS = 658,
    SETOF = 659,
    SHARE = 660,
    SHOW = 661,
    SIMILAR = 662,
    SIMPLE = 663,
    SKIP = 664,
    SMALLINT = 665,
    SNAPSHOT = 666,
    SOME = 667,
    SOURCE = 668,
    SQL_P = 669,
    STABLE = 670,
    STANDALONE_P = 671,
    START = 672,
    STATEMENT = 673,
    STATISTICS = 674,
    STDIN = 675,
    STDOUT = 676,
    STORAGE = 677,
    STORED = 678,
    STRICT_P = 679,
    STRING_P = 680,
    STRIP_P = 681,
    SUBSCRIPTION = 682,
    SUBSTRING = 683,
    SUPPORT = 684,
    SYMMETRIC = 685,
    SYSID = 686,
    SYSTEM_P = 687,
    SYSTEM_USER = 688,
    TABLE = 689,
    TABLES = 690,
    TABLESAMPLE = 691,
    TABLESPACE = 692,
    TARGET = 693,
    TEMP = 694,
    TEMPLATE = 695,
    TEMPORARY = 696,
    TEXT_P = 697,
    THEN = 698,
    TIES = 699,
    TIME = 700,
    TIMESTAMP = 701,
    TO = 702,
    TRAILING = 703,
    TRANSACTION = 704,
    TRANSFORM = 705,
    TREAT = 706,
    TRIGGER = 707,
    TRIM = 708,
    TRUE_P = 709,
    TRUNCATE = 710,
    TRUSTED = 711,
    TYPE_P = 712,
    TYPES_P = 713,
    UESCAPE = 714,
    UNBOUNDED = 715,
    UNCONDITIONAL = 716,
    UNCOMMITTED = 717,
    UNENCRYPTED = 718,
    UNION = 719,
    UNIQUE = 720,
    UNKNOWN = 721,
    UNLISTEN = 722,
    UNLOGGED = 723,
    UNTIL = 724,
    UPDATE = 725,
    USER = 726,
    USING = 727,
    VACUUM = 728,
    VALID = 729,
    VALIDATE = 730,
    VALIDATOR = 731,
    VALUE_P = 732,
    VALUES = 733,
    VARCHAR = 734,
    VARIADIC = 735,
    VARYING = 736,
    VERBOSE = 737,
    VERSION_P = 738,
    VIEW = 739,
    VIEWS = 740,
    VOLATILE = 741,
    WHEN = 742,
    WHERE = 743,
    WHITESPACE_P = 744,
    WINDOW = 745,
    WITH = 746,
    WITHIN = 747,
    WITHOUT = 748,
    WORK = 749,
    WRAPPER = 750,
    WRITE = 751,
    XML_P = 752,
    XMLATTRIBUTES = 753,
    XMLCONCAT = 754,
    XMLELEMENT = 755,
    XMLEXISTS = 756,
    XMLFOREST = 757,
    XMLNAMESPACES = 758,
    XMLPARSE = 759,
    XMLPI = 760,
    XMLROOT = 761,
    XMLSERIALIZE = 762,
    XMLTABLE = 763,
    YEAR_P = 764,
    YES_P = 765,
    ZONE = 766,
    FORMAT_LA = 767,
    NOT_LA = 768,
    NULLS_LA = 769,
    WITH_LA = 770,
    WITHOUT_LA = 771,
    MODE_TYPE_NAME = 772,
    MODE_PLPGSQL_EXPR = 773,
    MODE_PLPGSQL_ASSIGN1 = 774,
    MODE_PLPGSQL_ASSIGN2 = 775,
    MODE_PLPGSQL_ASSIGN3 = 776,
    UMINUS = 777
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSENT 276
#define ABSOLUTE_P 277
#define ACCESS 278
#define ACTION 279
#define ADD_P 280
#define ADMIN 281
#define AFTER 282
#define AGGREGATE 283
#define ALL 284
#define ALSO 285
#define ALTER 286
#define ALWAYS 287
#define ANALYSE 288
#define ANALYZE 289
#define AND 290
#define ANY 291
#define ARRAY 292
#define AS 293
#define ASC 294
#define ASENSITIVE 295
#define ASSERTION 296
#define ASSIGNMENT 297
#define ASYMMETRIC 298
#define ATOMIC 299
#define AT 300
#define ATTACH 301
#define ATTRIBUTE 302
#define AUTHORIZATION 303
#define BACKWARD 304
#define BEFORE 305
#define BEGIN_P 306
#define BETWEEN 307
#define BIGINT 308
#define BINARY 309
#define BIT 310
#define BOOLEAN_P 311
#define BOTH 312
#define BREADTH 313
#define BY 314
#define CACHE 315
#define CALL 316
#define CALLED 317
#define CASCADE 318
#define CASCADED 319
#define CASE 320
#define CAST 321
#define CATALOG_P 322
#define CHAIN 323
#define CHAR_P 324
#define CHARACTER 325
#define CHARACTERISTICS 326
#define CHECK 327
#define CHECKPOINT 328
#define CLASS 329
#define CLOSE 330
#define CLUSTER 331
#define COALESCE 332
#define COLLATE 333
#define COLLATION 334
#define COLUMN 335
#define COLUMNS 336
#define COMMENT 337
#define COMMENTS 338
#define COMMIT 339
#define COMMITTED 340
#define COMPRESSION 341
#define CONCURRENTLY 342
#define CONDITIONAL 343
#define CONFIGURATION 344
#define CONFLICT 345
#define CONNECTION 346
#define CONSTRAINT 347
#define CONSTRAINTS 348
#define CONTENT_P 349
#define CONTINUE_P 350
#define CONVERSION_P 351
#define COPY 352
#define COST 353
#define CREATE 354
#define CROSS 355
#define CSV 356
#define CUBE 357
#define CURRENT_P 358
#define CURRENT_CATALOG 359
#define CURRENT_DATE 360
#define CURRENT_ROLE 361
#define CURRENT_SCHEMA 362
#define CURRENT_TIME 363
#define CURRENT_TIMESTAMP 364
#define CURRENT_USER 365
#define CURSOR 366
#define CYCLE 367
#define DATA_P 368
#define DATABASE 369
#define DAY_P 370
#define DEALLOCATE 371
#define DEC 372
#define DECIMAL_P 373
#define DECLARE 374
#define DEFAULT 375
#define DEFAULTS 376
#define DEFERRABLE 377
#define DEFERRED 378
#define DEFINER 379
#define DELETE_P 380
#define DELIMITER 381
#define DELIMITERS 382
#define DEPENDS 383
#define DEPTH 384
#define DESC 385
#define DETACH 386
#define DICTIONARY 387
#define DISABLE_P 388
#define DISCARD 389
#define DISTINCT 390
#define DO 391
#define DOCUMENT_P 392
#define DOMAIN_P 393
#define DOUBLE_P 394
#define DROP 395
#define EACH 396
#define ELSE 397
#define EMPTY_P 398
#define ENABLE_P 399
#define ENCODING 400
#define ENCRYPTED 401
#define END_P 402
#define ENUM_P 403
#define ERROR_P 404
#define ESCAPE 405
#define EVENT 406
#define EXCEPT 407
#define EXCLUDE 408
#define EXCLUDING 409
#define EXCLUSIVE 410
#define EXECUTE 411
#define EXISTS 412
#define EXPLAIN 413
#define EXPRESSION 414
#define EXTENSION 415
#define EXTERNAL 416
#define EXTRACT 417
#define FALSE_P 418
#define FAMILY 419
#define FETCH 420
#define FILTER 421
#define FINALIZE 422
#define FIRST_P 423
#define FLOAT_P 424
#define FOLLOWING 425
#define FOR 426
#define FORCE 427
#define FOREIGN 428
#define FORMAT 429
#define FORWARD 430
#define FREEZE 431
#define FROM 432
#define FULL 433
#define FUNCTION 434
#define FUNCTIONS 435
#define GENERATED 436
#define GLOBAL 437
#define GRANT 438
#define GRANTED 439
#define GREATEST 440
#define GROUP_P 441
#define GROUPING 442
#define GROUPS 443
#define HANDLER 444
#define HAVING 445
#define HEADER_P 446
#define HOLD 447
#define HOUR_P 448
#define IDENTITY_P 449
#define IF_P 450
#define ILIKE 451
#define IMMEDIATE 452
#define IMMUTABLE 453
#define IMPLICIT_P 454
#define IMPORT_P 455
#define IN_P 456
#define INCLUDE 457
#define INCLUDING 458
#define INCREMENT 459
#define INDENT 460
#define INDEX 461
#define INDEXES 462
#define INHERIT 463
#define INHERITS 464
#define INITIALLY 465
#define INLINE_P 466
#define INNER_P 467
#define INOUT 468
#define INPUT_P 469
#define INSENSITIVE 470
#define INSERT 471
#define INSTEAD 472
#define INT_P 473
#define INTEGER 474
#define INTERSECT 475
#define INTERVAL 476
#define INTO 477
#define INVOKER 478
#define IS 479
#define ISNULL 480
#define ISOLATION 481
#define JOIN 482
#define JSON 483
#define JSON_ARRAY 484
#define JSON_ARRAYAGG 485
#define JSON_EXISTS 486
#define JSON_OBJECT 487
#define JSON_OBJECTAGG 488
#define JSON_QUERY 489
#define JSON_SCALAR 490
#define JSON_SERIALIZE 491
#define JSON_TABLE 492
#define JSON_VALUE 493
#define KEEP 494
#define KEY 495
#define KEYS 496
#define LABEL 497
#define LANGUAGE 498
#define LARGE_P 499
#define LAST_P 500
#define LATERAL_P 501
#define LEADING 502
#define LEAKPROOF 503
#define LEAST 504
#define LEFT 505
#define LEVEL 506
#define LIKE 507
#define LIMIT 508
#define LISTEN 509
#define LOAD 510
#define LOCAL 511
#define LOCALTIME 512
#define LOCALTIMESTAMP 513
#define LOCATION 514
#define LOCK_P 515
#define LOCKED 516
#define LOGGED 517
#define MAPPING 518
#define MATCH 519
#define MATCHED 520
#define MATERIALIZED 521
#define MAXVALUE 522
#define MERGE 523
#define MERGE_ACTION 524
#define METHOD 525
#define MINUTE_P 526
#define MINVALUE 527
#define MODE 528
#define MONTH_P 529
#define MOVE 530
#define NAME_P 531
#define NAMES 532
#define NATIONAL 533
#define NATURAL 534
#define NCHAR 535
#define NESTED 536
#define NEW 537
#define NEXT 538
#define NFC 539
#define NFD 540
#define NFKC 541
#define NFKD 542
#define NO 543
#define NONE 544
#define NORMALIZE 545
#define NORMALIZED 546
#define NOT 547
#define NOTHING 548
#define NOTIFY 549
#define NOTNULL 550
#define NOWAIT 551
#define NULL_P 552
#define NULLIF 553
#define NULLS_P 554
#define NUMERIC 555
#define OBJECT_P 556
#define OF 557
#define OFF 558
#define OFFSET 559
#define OIDS 560
#define OLD 561
#define OMIT 562
#define ON 563
#define ONLY 564
#define OPERATOR 565
#define OPTION 566
#define OPTIONS 567
#define OR 568
#define ORDER 569
#define ORDINALITY 570
#define OTHERS 571
#define OUT_P 572
#define OUTER_P 573
#define OVER 574
#define OVERLAPS 575
#define OVERLAY 576
#define OVERRIDING 577
#define OWNED 578
#define OWNER 579
#define PARALLEL 580
#define PARAMETER 581
#define PARSER 582
#define PARTIAL 583
#define PARTITION 584
#define PASSING 585
#define PASSWORD 586
#define PATH 587
#define PGPOOL 588
#define PLACING 589
#define PLAN 590
#define PLANS 591
#define POLICY 592
#define POSITION 593
#define PRECEDING 594
#define PRECISION 595
#define PRESERVE 596
#define PREPARE 597
#define PREPARED 598
#define PRIMARY 599
#define PRIOR 600
#define PRIVILEGES 601
#define PROCEDURAL 602
#define PROCEDURE 603
#define PROCEDURES 604
#define PROGRAM 605
#define PUBLICATION 606
#define QUOTE 607
#define QUOTES 608
#define RANGE 609
#define READ 610
#define REAL 611
#define REASSIGN 612
#define RECHECK 613
#define RECURSIVE 614
#define REF_P 615
#define REFERENCES 616
#define REFERENCING 617
#define REFRESH 618
#define REINDEX 619
#define RELATIVE_P 620
#define RELEASE 621
#define RENAME 622
#define REPEATABLE 623
#define REPLACE 624
#define REPLICA 625
#define RESET 626
#define RESTART 627
#define RESTRICT 628
#define RETURN 629
#define RETURNING 630
#define RETURNS 631
#define REVOKE 632
#define RIGHT 633
#define ROLE 634
#define ROLLBACK 635
#define ROLLUP 636
#define ROUTINE 637
#define ROUTINES 638
#define ROW 639
#define ROWS 640
#define RULE 641
#define SAVEPOINT 642
#define SCALAR 643
#define SCHEMA 644
#define SCHEMAS 645
#define SCROLL 646
#define SEARCH 647
#define SECOND_P 648
#define SECURITY 649
#define SELECT 650
#define SEQUENCE 651
#define SEQUENCES 652
#define SERIALIZABLE 653
#define SERVER 654
#define SESSION 655
#define SESSION_USER 656
#define SET 657
#define SETS 658
#define SETOF 659
#define SHARE 660
#define SHOW 661
#define SIMILAR 662
#define SIMPLE 663
#define SKIP 664
#define SMALLINT 665
#define SNAPSHOT 666
#define SOME 667
#define SOURCE 668
#define SQL_P 669
#define STABLE 670
#define STANDALONE_P 671
#define START 672
#define STATEMENT 673
#define STATISTICS 674
#define STDIN 675
#define STDOUT 676
#define STORAGE 677
#define STORED 678
#define STRICT_P 679
#define STRING_P 680
#define STRIP_P 681
#define SUBSCRIPTION 682
#define SUBSTRING 683
#define SUPPORT 684
#define SYMMETRIC 685
#define SYSID 686
#define SYSTEM_P 687
#define SYSTEM_USER 688
#define TABLE 689
#define TABLES 690
#define TABLESAMPLE 691
#define TABLESPACE 692
#define TARGET 693
#define TEMP 694
#define TEMPLATE 695
#define TEMPORARY 696
#define TEXT_P 697
#define THEN 698
#define TIES 699
#define TIME 700
#define TIMESTAMP 701
#define TO 702
#define TRAILING 703
#define TRANSACTION 704
#define TRANSFORM 705
#define TREAT 706
#define TRIGGER 707
#define TRIM 708
#define TRUE_P 709
#define TRUNCATE 710
#define TRUSTED 711
#define TYPE_P 712
#define TYPES_P 713
#define UESCAPE 714
#define UNBOUNDED 715
#define UNCONDITIONAL 716
#define UNCOMMITTED 717
#define UNENCRYPTED 718
#define UNION 719
#define UNIQUE 720
#define UNKNOWN 721
#define UNLISTEN 722
#define UNLOGGED 723
#define UNTIL 724
#define UPDATE 725
#define USER 726
#define USING 727
#define VACUUM 728
#define VALID 729
#define VALIDATE 730
#define VALIDATOR 731
#define VALUE_P 732
#define VALUES 733
#define VARCHAR 734
#define VARIADIC 735
#define VARYING 736
#define VERBOSE 737
#define VERSION_P 738
#define VIEW 739
#define VIEWS 740
#define VOLATILE 741
#define WHEN 742
#define WHERE 743
#define WHITESPACE_P 744
#define WINDOW 745
#define WITH 746
#define WITHIN 747
#define WITHOUT 748
#define WORK 749
#define WRAPPER 750
#define WRITE 751
#define XML_P 752
#define XMLATTRIBUTES 753
#define XMLCONCAT 754
#define XMLELEMENT 755
#define XMLEXISTS 756
#define XMLFOREST 757
#define XMLNAMESPACES 758
#define XMLPARSE 759
#define XMLPI 760
#define XMLROOT 761
#define XMLSERIALIZE 762
#define XMLTABLE 763
#define YEAR_P 764
#define YES_P 765
#define ZONE 766
#define FORMAT_LA 767
#define NOT_LA 768
#define NULLS_LA 769
#define WITH_LA 770
#define WITHOUT_LA 771
#define MODE_TYPE_NAME 772
#define MODE_PLPGSQL_EXPR 773
#define MODE_PLPGSQL_ASSIGN1 774
#define MODE_PLPGSQL_ASSIGN2 775
#define MODE_PLPGSQL_ASSIGN3 776
#define UMINUS 777

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 263 "gram_minimal.y" /* yacc.c:355  */

	core_YYSTYPE core_yystype;
	/* these fields must match core_YYSTYPE: */
	int			ival;
	char	   *str;
	const char *keyword;

	char		chr;
	bool		boolean;
	JoinType	jtype;
	DropBehavior dbehavior;
	OnCommitAction oncommit;
	List	   *list;
	Node	   *node;
	ObjectType	objtype;
	TypeName   *typnam;
	FunctionParameter *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs *objwithargs;
	DefElem	   *defelt;
	SortBy	   *sortby;
	WindowDef  *windef;
	JoinExpr   *jexpr;
	IndexElem  *ielem;
	StatsElem  *selem;
	Alias	   *alias;
	RangeVar   *range;
	IntoClause *into;
	WithClause *with;
	InferClause	*infer;
	OnConflictClause *onconflict;
	A_Indices  *aind;
	ResTarget  *target;
	struct PrivTarget *privtarget;
	AccessPriv *accesspriv;
	struct ImportQual *importqual;
	InsertStmt *istmt;
	VariableSetStmt *vsetstmt;
	PartitionElem *partelem;
	PartitionSpec *partspec;
	PartitionBoundSpec *partboundspec;
	RoleSpec   *rolespec;
	PublicationObjSpec *publicationobjectspec;
	struct SelectLimit *selectlimit;
	SetQuantifier setquantifier;
	struct GroupClause *groupclause;
	MergeMatchKind mergematch;
	MergeWhenClause *mergewhen;
	struct KeyActions *keyactions;
	struct KeyAction *keyaction;

#line 1461 "gram_minimal.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int minimal_base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_MINIMAL_BASE_YY_GRAM_MINIMAL_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1491 "gram_minimal.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  933
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   122895

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  540
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  730
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3412
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6471

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   777

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   529,     2,     2,
     534,   535,   527,   525,   538,   526,   536,   528,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   539,   537,
     522,   524,   523,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   532,     2,   533,   530,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   531
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   955,   955,   960,   964,   969,   977,   985,  1005,  1017,
    1031,  1032,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,
    1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,
    1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,  1123,
    1124,  1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,  1133,
    1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,  1142,  1143,
    1144,  1145,  1146,  1147,  1148,  1149,  1150,  1151,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,  1161,  1168,  1169,  1173,
    1174,  1178,  1179,  1183,  1184,  1185,  1194,  1210,  1222,  1223,
    1224,  1233,  1234,  1238,  1239,  1243,  1248,  1252,  1262,  1270,
    1274,  1278,  1283,  1287,  1335,  1337,  1341,  1345,  1349,  1353,
    1367,  1386,  1395,  1407,  1408,  1412,  1421,  1430,  1439,  1461,
    1469,  1477,  1485,  1493,  1501,  1519,  1538,  1550,  1551,  1562,
    1573,  1584,  1600,  1619,  1626,  1634,  1635,  1636,  1637,  1638,
    1639,  1653,  1660,  1667,  1674,  1684,  1693,  1702,  1706,  1715,
    1724,  1732,  1743,  1744,  1753,  1765,  1773,  1782,  1794,  1803,
    1812,  1820,  1830,  1841,  1842,  1846,  1847,  1850,  1852,  1856,
    1857,  1858,  1859,  1863,  1864,  1865,  1871,  1883,  1887,  1891,
    1908,  1916,  1917,  1918,  1922,  1923,  1924,  1928,  1929,  1933,
    1934,  1943,  1944,  1952,  1960,  1971,  1979,  1990,  1991,  1996,
    1997,  2003,  2009,  2015,  2022,  2029,  2036,  2043,  2054,  2065,
    2066,  2070,  2071,  2079,  2095,  2102,  2109,  2116,  2123,  2143,
    2153,  2163,  2173,  2183,  2195,  2207,  2217,  2227,  2237,  2249,
    2261,  2271,  2281,  2291,  2301,  2311,  2321,  2333,  2345,  2355,
    2368,  2369,  2374,  2388,  2401,  2417,  2434,  2444,  2454,  2464,
    2474,  2484,  2493,  2502,  2512,  2521,  2531,  2541,  2557,  2567,
    2577,  2587,  2597,  2614,  2624,  2634,  2644,  2655,  2669,  2685,
    2694,  2703,  2718,  2727,  2738,  2749,  2757,  2766,  2775,  2783,
    2791,  2800,  2809,  2818,  2826,  2834,  2843,  2851,  2859,  2868,
    2877,  2886,  2895,  2904,  2913,  2924,  2932,  2941,  2950,  2959,
    2968,  2977,  2986,  2994,  3002,  3010,  3017,  3028,  3029,  3033,
    3042,  3046,  3047,  3051,  3059,  3067,  3075,  3086,  3089,  3090,
    3094,  3095,  3100,  3104,  3108,  3113,  3120,  3122,  3127,  3131,
    3135,  3146,  3153,  3154,  3158,  3159,  3164,  3217,  3230,  3244,
    3256,  3263,  3267,  3281,  3294,  3295,  3300,  3310,  3321,  3332,
    3359,  3366,  3400,  3436,  3459,  3460,  3464,  3465,  3474,  3475,
    3476,  3479,  3480,  3485,  3486,  3490,  3494,  3498,  3502,  3506,
    3510,  3514,  3518,  3522,  3526,  3530,  3534,  3538,  3542,  3546,
    3555,  3559,  3563,  3567,  3571,  3572,  3577,  3581,  3588,  3595,
    3596,  3597,  3598,  3599,  3600,  3604,  3608,  3616,  3627,  3647,
    3667,  3688,  3709,  3730,  3764,  3765,  3766,  3767,  3768,  3775,
    3782,  3783,  3787,  3788,  3792,  3793,  3797,  3801,  3808,  3812,
    3819,  3820,  3821,  3825,  3826,  3829,  3853,  3872,  3894,  3895,
    3899,  3900,  3904,  3905,  3909,  3910,  3914,  3915,  3919,  3927,
    3928,  3929,  3961,  3969,  3977,  3990,  4002,  4015,  4027,  4037,
    4061,  4081,  4082,  4083,  4087,  4088,  4107,  4115,  4123,  4131,
    4143,  4155,  4156,  4157,  4161,  4162,  4163,  4164,  4165,  4166,
    4167,  4168,  4169,  4170,  4179,  4187,  4191,  4205,  4223,  4239,
    4256,  4272,  4292,  4327,  4335,  4339,  4353,  4369,  4370,  4374,
    4375,  4379,  4380,  4383,  4389,  4390,  4393,  4397,  4405,  4410,
    4416,  4417,  4421,  4426,  4433,  4434,  4438,  4448,  4458,  4466,
    4475,  4488,  4500,  4507,  4515,  4523,  4531,  4539,  4549,  4550,
    4554,  4555,  4558,  4570,  4571,  4574,  4585,  4596,  4610,  4611,
    4616,  4617,  4618,  4621,  4622,  4623,  4624,  4627,  4628,  4631,
    4632,  4635,  4655,  4668,  4690,  4691,  4694,  4700,  4706,  4723,
    4732,  4754,  4768,  4785,  4801,  4802,  4803,  4815,  4829,  4846,
    4860,  4861,  4873,  4894,  4905,  4919,  4928,  4940,  4941,  4944,
    4945,  4948,  4949,  4952,  4956,  4960,  4964,  4968,  4972,  4976,
    4980,  4984,  4988,  4992,  4997,  5001,  5005,  5011,  5012,  5016,
    5017,  5018,  5025,  5028,  5029,  5041,  5057,  5073,  5074,  5082,
    5083,  5087,  5088,  5092,  5093,  5097,  5098,  5102,  5103,  5113,
    5125,  5126,  5139,  5147,  5165,  5174,  5186,  5189,  5193,  5197,
    5201,  5208,  5220,  5231,  5234,  5238,  5251,  5261,  5271,  5281,
    5291,  5301,  5311,  5321,  5331,  5341,  5351,  5361,  5371,  5390,
    5402,  5403,  5404,  5405,  5409,  5410,  5414,  5415,  5425,  5434,
    5447,  5448,  5452,  5456,  5464,  5468,  5472,  5479,  5483,  5488,
    5493,  5500,  5507,  5512,  5522,  5535,  5551,  5552,  5557,  5558,
    5562,  5563,  5573,  5583,  5592,  5610,  5631,  5652,  5674,  5708,
    5724,  5725,  5729,  5738,  5753,  5763,  5776,  5777,  5789,  5798,
    5816,  5841,  5859,  5874,  5875,  5879,  5880,  5884,  5885,  5889,
    5890,  5894,  5908,  5912,  5913,  5917,  5918,  5919,  5920,  5921,
    5931,  5943,  5944,  5955,  5978,  6010,  6011,  6012,  6016,  6018,
    6040,  6042,  6044,  6046,  6048,  6053,  6054,  6058,  6059,  6063,
    6075,  6076,  6080,  6089,  6093,  6097,  6102,  6112,  6113,  6117,
    6118,  6122,  6123,  6127,  6128,  6132,  6133,  6134,  6138,  6142,
    6143,  6144,  6148,  6149,  6154,  6155,  6182,  6183,  6184,  6185,
    6186,  6187,  6200,  6211,  6226,  6228,  6233,  6238,  6240,  6245,
    6256,  6257,  6258,  6259,  6270,  6289,  6301,  6314,  6325,  6336,
    6348,  6357,  6365,  6373,  6383,  6393,  6403,  6413,  6423,  6434,
    6444,  6457,  6460,  6461,  6464,  6468,  6475,  6476,  6477,  6478,
    6479,  6480,  6483,  6486,  6487,  6495,  6502,  6503,  6506,  6508,
    6519,  6531,  6543,  6555,  6567,  6596,  6597,  6613,  6629,  6630,
    6634,  6647,  6658,  6667,  6677,  6687,  6688,  6691,  6692,  6695,
    6696,  6697,  6700,  6714,  6719,  6730,  6740,  6753,  6754,  6758,
    6767,  6780,  6791,  6805,  6816,  6839,  6850,  6869,  6880,  6891,
    6902,  6913,  6924,  6935,  6946,  6957,  6968,  6979,  6990,  7005,
    7006,  7007,  7008,  7009,  7010,  7011,  7012,  7013,  7014,  7015,
    7016,  7017,  7027,  7028,  7029,  7030,  7031,  7035,  7036,  7037,
    7038,  7039,  7040,  7041,  7042,  7047,  7048,  7049,  7053,  7054,
    7057,  7058,  7061,  7063,  7068,  7069,  7080,  7092,  7093,  7094,
    7104,  7113,  7122,  7131,  7140,  7149,  7158,  7167,  7176,  7185,
    7199,  7208,  7217,  7226,  7235,  7244,  7253,  7262,  7274,  7275,
    7289,  7300,  7311,  7322,  7333,  7344,  7355,  7366,  7377,  7388,
    7401,  7402,  7405,  7406,  7416,  7423,  7432,  7441,  7450,  7459,
    7468,  7477,  7486,  7495,  7504,  7513,  7522,  7531,  7540,  7549,
    7558,  7567,  7578,  7579,  7582,  7583,  7593,  7611,  7627,  7655,
    7657,  7659,  7661,  7669,  7679,  7680,  7683,  7691,  7699,  7707,
    7714,  7725,  7729,  7736,  7740,  7751,  7760,  7769,  7778,  7787,
    7796,  7805,  7814,  7823,  7832,  7841,  7850,  7859,  7867,  7876,
    7885,  7894,  7903,  7912,  7921,  7930,  7943,  7944,  7948,  7949,
    7954,  7955,  7965,  7976,  7990,  8002,  8020,  8021,  8025,  8032,
    8033,  8034,  8037,  8038,  8048,  8059,  8060,  8064,  8068,  8072,
    8083,  8097,  8112,  8130,  8131,  8132,  8133,  8134,  8135,  8147,
    8179,  8214,  8215,  8219,  8220,  8223,  8224,  8229,  8241,  8260,
    8265,  8270,  8277,  8278,  8281,  8282,  8285,  8286,  8290,  8291,
    8292,  8295,  8296,  8297,  8313,  8327,  8342,  8356,  8373,  8374,
    8377,  8378,  8382,  8383,  8387,  8388,  8393,  8407,  8415,  8423,
    8439,  8440,  8444,  8445,  8460,  8470,  8480,  8490,  8500,  8513,
    8514,  8515,  8516,  8517,  8523,  8527,  8542,  8543,  8549,  8559,
    8563,  8568,  8576,  8618,  8622,  8626,  8630,  8638,  8639,  8643,
    8655,  8656,  8661,  8662,  8667,  8668,  8675,  8679,  8683,  8687,
    8691,  8695,  8699,  8703,  8707,  8711,  8715,  8719,  8723,  8727,
    8731,  8735,  8740,  8747,  8751,  8755,  8759,  8763,  8769,  8770,
    8776,  8786,  8790,  8801,  8807,  8816,  8822,  8823,  8827,  8828,
    8832,  8833,  8836,  8849,  8853,  8868,  8877,  8886,  8899,  8900,
    8905,  8906,  8923,  8934,  8945,  8956,  8967,  8978,  8992,  9003,
    9017,  9028,  9042,  9050,  9052,  9054,  9059,  9061,  9066,  9067,
    9072,  9091,  9101,  9102,  9106,  9110,  9122,  9134,  9146,  9160,
    9161,  9162,  9166,  9179,  9180,  9190,  9203,  9207,  9211,  9215,
    9222,  9244,  9257,  9270,  9285,  9286,  9289,  9290,  9293,  9294,
    9304,  9314,  9332,  9342,  9352,  9362,  9372,  9382,  9392,  9402,
    9412,  9422,  9432,  9442,  9452,  9463,  9474,  9484,  9494,  9504,
    9514,  9524,  9534,  9545,  9556,  9567,  9578,  9589,  9600,  9611,
    9622,  9633,  9644,  9655,  9666,  9678,  9690,  9702,  9714,  9726,
    9738,  9749,  9760,  9772,  9784,  9795,  9806,  9815,  9825,  9835,
    9845,  9855,  9865,  9875,  9885,  9895,  9905,  9920,  9921,  9924,
    9925,  9935,  9945,  9955,  9965,  9976,  9986,  9998,  9999, 10009,
   10019, 10029, 10039, 10049, 10059, 10069, 10079, 10089, 10099, 10109,
   10119, 10129, 10139, 10149, 10159, 10169, 10179, 10189, 10199, 10209,
   10219, 10229, 10239, 10249, 10259, 10269, 10288, 10298, 10299, 10302,
   10304, 10306, 10312, 10313, 10314, 10315, 10316, 10328, 10344, 10353,
   10362, 10371, 10380, 10389, 10398, 10407, 10416, 10425, 10434, 10443,
   10452, 10461, 10470, 10479, 10488, 10497, 10506, 10515, 10524, 10533,
   10542, 10551, 10579, 10587, 10596, 10622, 10631, 10638, 10644, 10671,
   10682, 10691, 10699, 10701, 10723, 10731, 10741, 10751, 10770, 10789,
   10799, 10809, 10819, 10830, 10841, 10852, 10863, 10874, 10892, 10901,
   10918, 10936, 10937, 10938, 10943, 10949, 10958, 10959, 10960, 10961,
   10962, 10966, 10967, 10970, 10971, 10972, 10973, 10977, 10978, 10979,
   10991, 11002, 11003, 11006, 11016, 11023, 11043, 11053, 11062, 11072,
   11082, 11091, 11100, 11109, 11118, 11127, 11136, 11145, 11157, 11166,
   11178, 11179, 11180, 11184, 11187, 11190, 11193, 11196, 11203, 11205,
   11207, 11212, 11214, 11218, 11219, 11220, 11232, 11246, 11260, 11279,
   11301, 11302, 11303, 11304, 11314, 11331, 11342, 11343, 11347, 11348,
   11352, 11356, 11360, 11378, 11379, 11380, 11381, 11382, 11383, 11384,
   11391, 11392, 11403, 11411, 11419, 11428, 11438, 11456, 11465, 11474,
   11483, 11495, 11499, 11510, 11522, 11540, 11547, 11564, 11578, 11588,
   11597, 11606, 11616, 11628, 11640, 11651, 11652, 11663, 11674, 11686,
   11698, 11710, 11722, 11732, 11745, 11746, 11760, 11784, 11793, 11803,
   11815, 11827, 11841, 11842, 11854, 11875, 11886, 11898, 11910, 11914,
   11921, 11922, 11926, 11933, 11934, 11935, 11939, 11940, 11941, 11945,
   11946, 11950, 11951, 11954, 11955, 11958, 11959, 11963, 11964, 11968,
   11975, 11977, 11982, 11983, 11996, 12004, 12015, 12023, 12034, 12035,
   12036, 12037, 12038, 12039, 12040, 12041, 12042, 12043, 12053, 12064,
   12065, 12069, 12070, 12071, 12072, 12073, 12083, 12091, 12109, 12129,
   12130, 12140, 12149, 12158, 12167, 12186, 12197, 12218, 12222, 12230,
   12236, 12243, 12249, 12256, 12265, 12266, 12270, 12272, 12277, 12288,
   12298, 12308, 12314, 12323, 12332, 12338, 12339, 12350, 12365, 12366,
   12377, 12388, 12389, 12392, 12393, 12394, 12395, 12396, 12397, 12398,
   12399, 12402, 12403, 12407, 12408, 12409, 12420, 12437, 12452, 12453,
   12457, 12462, 12486, 12497, 12498, 12510, 12530, 12531, 12541, 12548,
   12555, 12562, 12572, 12585, 12586, 12590, 12591, 12595, 12596, 12600,
   12613, 12626, 12635, 12644, 12653, 12662, 12674, 12686, 12698, 12701,
   12702, 12703, 12704, 12705, 12706, 12709, 12710, 12711, 12759, 12760,
   12764, 12765, 12780, 12781, 12788, 12796, 12804, 12812, 12820, 12828,
   12839, 12840, 12872, 12888, 12905, 12906, 12925, 12929, 12933, 12948,
   12955, 12962, 12972, 12973, 12976, 12992, 12993, 12994, 12998, 13008,
   13019, 13025, 13037, 13050, 13056, 13057, 13061, 13073, 13081, 13086,
   13091, 13096, 13101, 13109, 13117, 13122, 13127, 13134, 13135, 13139,
   13140, 13141, 13148, 13149, 13153, 13154, 13158, 13159, 13163, 13164,
   13168, 13172, 13173, 13176, 13185, 13198, 13203, 13208, 13212, 13224,
   13225, 13229, 13238, 13254, 13263, 13272, 13281, 13293, 13296, 13301,
   13302, 13310, 13330, 13331, 13333, 13338, 13339, 13343, 13344, 13347,
   13348, 13373, 13382, 13392, 13393, 13397, 13398, 13399, 13400, 13401,
   13405, 13418, 13425, 13432, 13439, 13440, 13444, 13445, 13449, 13450,
   13454, 13455, 13459, 13471, 13472, 13473, 13474, 13478, 13479, 13489,
   13496, 13515, 13516, 13520, 13521, 13527, 13532, 13541, 13549, 13558,
   13565, 13573, 13582, 13591, 13595, 13600, 13607, 13636, 13640, 13654,
   13675, 13697, 13710, 13727, 13733, 13738, 13744, 13751, 13752, 13762,
   13768, 13776, 13780, 13784, 13791, 13799, 13804, 13805, 13806, 13807,
   13811, 13812, 13827, 13831, 13839, 13846, 13853, 13860, 13867, 13878,
   13879, 13892, 13896, 13904, 13918, 13932, 13933, 13948, 13959, 13972,
   13977, 13978, 13981, 13982, 13985, 13986, 13991, 13992, 13997, 13998,
   14007, 14012, 14013, 14017, 14021, 14027, 14052, 14063, 14077, 14078,
   14082, 14096, 14153, 14167, 14169, 14174, 14176, 14178, 14180, 14182,
   14187, 14189, 14194, 14202, 14213, 14241, 14242, 14246, 14248, 14253,
   14262, 14282, 14302, 14320, 14332, 14347, 14348, 14352, 14355, 14368,
   14373, 14380, 14385, 14391, 14396, 14405, 14407, 14410, 14414, 14415,
   14416, 14417, 14418, 14419, 14424, 14430, 14445, 14446, 14447, 14448,
   14449, 14460, 14466, 14474, 14475, 14481, 14486, 14491, 14496, 14501,
   14506, 14511, 14516, 14522, 14528, 14534, 14541, 14563, 14572, 14576,
   14584, 14588, 14596, 14608, 14629, 14633, 14639, 14643, 14656, 14664,
   14674, 14676, 14678, 14680, 14682, 14684, 14689, 14690, 14697, 14706,
   14714, 14723, 14734, 14742, 14743, 14744, 14748, 14750, 14752, 14754,
   14756, 14758, 14760, 14765, 14770, 14776, 14784, 14789, 14796, 14803,
   14807, 14811, 14819, 14854, 14855, 14857, 14866, 14873, 14889, 14891,
   14893, 14895, 14897, 14899, 14901, 14903, 14905, 14907, 14909, 14911,
   14913, 14915, 14918, 14920, 14923, 14925, 14927, 14929, 14932, 14937,
   14946, 14951, 14960, 14965, 14974, 14979, 14989, 14998, 15007, 15016,
   15035, 15044, 15053, 15062, 15071, 15088, 15097, 15106, 15115, 15124,
   15133, 15142, 15146, 15150, 15158, 15166, 15174, 15182, 15203, 15226,
   15238, 15245, 15261, 15266, 15272, 15279, 15286, 15294, 15302, 15319,
   15338, 15364, 15366, 15368, 15370, 15372, 15374, 15376, 15378, 15380,
   15382, 15384, 15386, 15388, 15390, 15392, 15394, 15396, 15398, 15400,
   15404, 15408, 15413, 15429, 15430, 15431, 15448, 15461, 15463, 15465,
   15477, 15502, 15514, 15526, 15534, 15545, 15556, 15566, 15572, 15581,
   15591, 15601, 15614, 15624, 15655, 15691, 15701, 15712, 15713, 15714,
   15721, 15728, 15732, 15736, 15740, 15744, 15748, 15752, 15756, 15760,
   15764, 15768, 15772, 15776, 15783, 15787, 15791, 15795, 15797, 15804,
   15811, 15818, 15825, 15836, 15850, 15860, 15871, 15887, 15897, 15904,
   15911, 15918, 15922, 15930, 15939, 15948, 15952, 15956, 15960, 15964,
   15968, 15977, 15981, 15991, 15995, 15999, 16004, 16015, 16021, 16035,
   16046, 16060, 16076, 16088, 16098, 16107, 16116, 16124, 16146, 16162,
   16186, 16188, 16192, 16194, 16196, 16199, 16202, 16205, 16206, 16209,
   16217, 16227, 16228, 16231, 16232, 16233, 16236, 16237, 16238, 16243,
   16247, 16251, 16255, 16262, 16263, 16271, 16272, 16276, 16277, 16285,
   16286, 16290, 16291, 16296, 16305, 16307, 16322, 16325, 16353, 16354,
   16357, 16358, 16366, 16374, 16382, 16391, 16401, 16419, 16465, 16474,
   16483, 16492, 16501, 16513, 16514, 16515, 16516, 16517, 16531, 16532,
   16533, 16536, 16537, 16540, 16543, 16544, 16545, 16548, 16549, 16552,
   16553, 16554, 16555, 16556, 16557, 16558, 16559, 16560, 16561, 16562,
   16563, 16566, 16568, 16573, 16575, 16580, 16582, 16584, 16586, 16588,
   16590, 16602, 16606, 16613, 16617, 16623, 16627, 16637, 16649, 16650,
   16653, 16654, 16657, 16661, 16665, 16671, 16672, 16677, 16687, 16688,
   16689, 16690, 16691, 16692, 16693, 16694, 16698, 16699, 16700, 16701,
   16706, 16711, 16720, 16741, 16745, 16750, 16761, 16778, 16784, 16785,
   16786, 16789, 16797, 16807, 16822, 16823, 16827, 16839, 16840, 16843,
   16844, 16847, 16851, 16858, 16862, 16866, 16875, 16887, 16888, 16892,
   16893, 16897, 16898, 16901, 16902, 16907, 16908, 16912, 16913, 16917,
   16929, 16930, 16931, 16932, 16933, 16934, 16935, 16936, 16937, 16941,
   16943, 16948, 16949, 16950, 16951, 16952, 16953, 16954, 16956, 16960,
   16962, 16964, 16967, 16971, 16974, 16978, 16987, 17004, 17011, 17016,
   17022, 17023, 17024, 17025, 17026, 17030, 17039, 17053, 17054, 17055,
   17056, 17057, 17066, 17067, 17068, 17069, 17070, 17074, 17076, 17086,
   17089, 17095, 17096, 17097, 17101, 17102, 17103, 17107, 17108, 17112,
   17130, 17150, 17151, 17160, 17161, 17165, 17166, 17169, 17177, 17185,
   17193, 17216, 17217, 17228, 17232, 17238, 17240, 17245, 17247, 17249,
   17259, 17261, 17272, 17276, 17280, 17284, 17288, 17297, 17305, 17337,
   17341, 17348, 17356, 17360, 17364, 17370, 17371, 17373, 17374, 17375,
   17379, 17420, 17448, 17452, 17456, 17462, 17464, 17478, 17514, 17527,
   17528, 17531, 17532, 17549, 17550, 17551, 17556, 17557, 17558, 17563,
   17564, 17565, 17566, 17572, 17573, 17574, 17575, 17576, 17582, 17583,
   17603, 17604, 17605, 17606, 17607, 17608, 17609, 17610, 17611, 17612,
   17613, 17614, 17615, 17616, 17617, 17618, 17619, 17620, 17621, 17622,
   17623, 17624, 17625, 17626, 17627, 17628, 17629, 17630, 17631, 17632,
   17633, 17634, 17635, 17636, 17637, 17638, 17639, 17640, 17641, 17642,
   17643, 17644, 17645, 17646, 17647, 17648, 17649, 17650, 17651, 17652,
   17653, 17654, 17655, 17656, 17657, 17658, 17659, 17660, 17661, 17662,
   17663, 17664, 17665, 17666, 17667, 17668, 17669, 17670, 17671, 17672,
   17673, 17674, 17675, 17676, 17677, 17678, 17679, 17680, 17681, 17682,
   17683, 17684, 17685, 17686, 17687, 17688, 17689, 17690, 17691, 17692,
   17693, 17694, 17695, 17696, 17697, 17698, 17699, 17700, 17701, 17702,
   17703, 17704, 17705, 17706, 17707, 17708, 17709, 17710, 17711, 17712,
   17713, 17714, 17715, 17716, 17717, 17718, 17719, 17720, 17721, 17722,
   17723, 17724, 17725, 17726, 17727, 17728, 17729, 17730, 17731, 17732,
   17733, 17734, 17735, 17736, 17737, 17738, 17739, 17740, 17741, 17742,
   17743, 17744, 17745, 17746, 17747, 17748, 17749, 17750, 17751, 17752,
   17753, 17754, 17755, 17756, 17757, 17758, 17759, 17760, 17761, 17762,
   17763, 17764, 17765, 17766, 17767, 17768, 17769, 17770, 17771, 17772,
   17773, 17774, 17775, 17776, 17777, 17778, 17779, 17780, 17781, 17782,
   17783, 17784, 17785, 17786, 17787, 17788, 17789, 17790, 17791, 17792,
   17793, 17794, 17795, 17796, 17797, 17798, 17799, 17800, 17801, 17802,
   17803, 17804, 17805, 17806, 17807, 17808, 17809, 17810, 17811, 17812,
   17813, 17814, 17815, 17816, 17817, 17818, 17819, 17820, 17821, 17822,
   17823, 17824, 17825, 17826, 17827, 17828, 17829, 17830, 17831, 17832,
   17833, 17834, 17835, 17836, 17837, 17838, 17839, 17840, 17841, 17842,
   17843, 17844, 17845, 17846, 17847, 17848, 17849, 17850, 17851, 17852,
   17853, 17854, 17855, 17856, 17857, 17858, 17859, 17860, 17861, 17862,
   17863, 17864, 17865, 17866, 17867, 17868, 17869, 17870, 17871, 17872,
   17873, 17874, 17875, 17876, 17877, 17878, 17879, 17880, 17881, 17882,
   17883, 17884, 17885, 17886, 17887, 17888, 17889, 17890, 17891, 17892,
   17893, 17894, 17895, 17896, 17897, 17898, 17899, 17900, 17901, 17902,
   17903, 17904, 17905, 17906, 17907, 17908, 17909, 17910, 17911, 17912,
   17913, 17914, 17915, 17916, 17917, 17918, 17919, 17920, 17921, 17922,
   17923, 17924, 17925, 17926, 17927, 17928, 17929, 17943, 17944, 17945,
   17946, 17947, 17948, 17949, 17950, 17951, 17952, 17953, 17954, 17955,
   17956, 17957, 17958, 17959, 17960, 17961, 17962, 17963, 17964, 17965,
   17966, 17967, 17968, 17969, 17970, 17971, 17972, 17973, 17974, 17975,
   17976, 17977, 17978, 17979, 17980, 17981, 17982, 17983, 17984, 17985,
   17986, 17987, 17988, 17989, 17990, 17991, 17992, 17993, 17994, 17995,
   17996, 17997, 17998, 17999, 18000, 18001, 18002, 18003, 18004, 18005,
   18019, 18020, 18021, 18022, 18023, 18024, 18025, 18026, 18027, 18028,
   18029, 18030, 18031, 18032, 18033, 18034, 18035, 18036, 18037, 18038,
   18039, 18040, 18041, 18051, 18052, 18053, 18054, 18055, 18056, 18057,
   18058, 18059, 18060, 18061, 18062, 18063, 18064, 18065, 18066, 18067,
   18068, 18069, 18070, 18071, 18072, 18073, 18074, 18075, 18076, 18077,
   18078, 18079, 18080, 18081, 18082, 18083, 18084, 18085, 18086, 18087,
   18088, 18089, 18090, 18091, 18092, 18093, 18094, 18095, 18096, 18097,
   18098, 18099, 18100, 18101, 18102, 18103, 18104, 18105, 18106, 18107,
   18108, 18109, 18110, 18111, 18112, 18113, 18114, 18115, 18116, 18117,
   18118, 18119, 18120, 18121, 18122, 18123, 18124, 18125, 18126, 18127,
   18128, 18141, 18142, 18143, 18144, 18145, 18146, 18147, 18148, 18149,
   18150, 18151, 18152, 18153, 18154, 18155, 18156, 18157, 18158, 18159,
   18160, 18161, 18162, 18163, 18164, 18165, 18166, 18167, 18168, 18169,
   18170, 18171, 18172, 18173, 18174, 18175, 18176, 18177, 18178, 18179,
   18180, 18181, 18182, 18183, 18184, 18185, 18186, 18187, 18188, 18189,
   18190, 18191, 18192, 18193, 18194, 18195, 18196, 18197, 18198, 18199,
   18200, 18201, 18202, 18203, 18204, 18205, 18206, 18207, 18208, 18209,
   18210, 18211, 18212, 18213, 18214, 18215, 18216, 18217, 18218, 18219,
   18220, 18221, 18222, 18223, 18224, 18225, 18226, 18227, 18228, 18229,
   18230, 18231, 18232, 18233, 18234, 18235, 18236, 18237, 18238, 18239,
   18240, 18241, 18242, 18243, 18244, 18245, 18246, 18247, 18248, 18249,
   18250, 18251, 18252, 18253, 18254, 18255, 18256, 18257, 18258, 18259,
   18260, 18261, 18262, 18263, 18264, 18265, 18266, 18267, 18268, 18269,
   18270, 18271, 18272, 18273, 18274, 18275, 18276, 18277, 18278, 18279,
   18280, 18281, 18282, 18283, 18284, 18285, 18286, 18287, 18288, 18289,
   18290, 18291, 18292, 18293, 18294, 18295, 18296, 18297, 18298, 18299,
   18300, 18301, 18302, 18303, 18304, 18305, 18306, 18307, 18308, 18309,
   18310, 18311, 18312, 18313, 18314, 18315, 18316, 18317, 18318, 18319,
   18320, 18321, 18322, 18323, 18324, 18325, 18326, 18327, 18328, 18329,
   18330, 18331, 18332, 18333, 18334, 18335, 18336, 18337, 18338, 18339,
   18340, 18341, 18342, 18343, 18344, 18345, 18346, 18347, 18348, 18349,
   18350, 18351, 18352, 18353, 18354, 18355, 18356, 18357, 18358, 18359,
   18360, 18361, 18362, 18363, 18364, 18365, 18366, 18367, 18368, 18369,
   18370, 18371, 18372, 18373, 18374, 18375, 18376, 18377, 18378, 18379,
   18380, 18381, 18382, 18383, 18384, 18385, 18386, 18387, 18388, 18389,
   18390, 18391, 18392, 18393, 18394, 18395, 18396, 18397, 18398, 18399,
   18400, 18401, 18402, 18403, 18404, 18405, 18406, 18407, 18408, 18409,
   18410, 18411, 18412, 18413, 18414, 18415, 18416, 18417, 18418, 18419,
   18420, 18421, 18422, 18423, 18424, 18425, 18426, 18427, 18428, 18429,
   18430, 18431, 18432, 18433, 18434, 18435, 18436, 18437, 18438, 18439,
   18440, 18441, 18442, 18443, 18444, 18445, 18446, 18447, 18448, 18449,
   18450, 18451, 18452, 18453, 18454, 18455, 18456, 18457, 18458, 18459,
   18460, 18461, 18462, 18463, 18464, 18465, 18466, 18467, 18468, 18469,
   18470, 18471, 18472, 18473, 18474, 18475, 18476, 18477, 18478, 18479,
   18480, 18481, 18482, 18483, 18484, 18485, 18486, 18487, 18488, 18489,
   18490, 18491, 18492, 18493, 18494, 18495, 18496, 18497, 18498, 18499,
   18500, 18501, 18502, 18503, 18504, 18505, 18506, 18507, 18508, 18509,
   18510, 18511, 18512, 18513, 18514, 18515, 18516, 18517, 18518, 18519,
   18520, 18521, 18522, 18523, 18524, 18525, 18526, 18527, 18528, 18529,
   18530, 18531, 18532, 18533, 18534, 18535, 18536, 18537, 18538, 18539,
   18540, 18541, 18542, 18543, 18544, 18545, 18546, 18547, 18548, 18549,
   18550, 18551, 18552, 18553, 18554, 18555, 18556, 18557, 18558, 18559,
   18560, 18561, 18562, 18563, 18564, 18565, 18566, 18567, 18568, 18569,
   18570, 18571, 18572, 18573, 18574, 18575, 18576, 18577, 18578, 18579,
   18580, 18581, 18582, 18583, 18584, 18585, 18586, 18587, 18588, 18589,
   18590, 18591, 18592
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT", "ABSOLUTE_P",
  "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL",
  "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY",
  "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC",
  "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD",
  "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P",
  "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED", "CASCADE",
  "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION", "CONCURRENTLY",
  "CONDITIONAL", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH", "DESC", "DETACH",
  "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P",
  "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "EMPTY_P", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ERROR_P", "ESCAPE", "EVENT",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORMAT", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "GROUPING", "GROUPS", "HANDLER",
  "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE",
  "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE",
  "INCLUDING", "INCREMENT", "INDENT", "INDEX", "INDEXES", "INHERIT",
  "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P",
  "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT",
  "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN",
  "JSON", "JSON_ARRAY", "JSON_ARRAYAGG", "JSON_EXISTS", "JSON_OBJECT",
  "JSON_OBJECTAGG", "JSON_QUERY", "JSON_SCALAR", "JSON_SERIALIZE",
  "JSON_TABLE", "JSON_VALUE", "KEEP", "KEY", "KEYS", "LABEL", "LANGUAGE",
  "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST",
  "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE", "MERGE_ACTION",
  "METHOD", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NESTED", "NEW", "NEXT", "NFC",
  "NFD", "NFKC", "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "OMIT",
  "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARAMETER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PATH",
  "PGPOOL", "PLACING", "PLAN", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "QUOTES", "RANGE", "READ", "REAL", "REASSIGN",
  "RECHECK", "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING", "REFRESH",
  "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE",
  "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE",
  "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR", "SCHEMA",
  "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SOURCE", "SQL_P",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STORED", "STRICT_P", "STRING_P", "STRIP_P",
  "SUBSCRIPTION", "SUBSTRING", "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "SYSTEM_USER", "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TARGET",
  "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES", "TIME",
  "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P",
  "UESCAPE", "UNBOUNDED", "UNCONDITIONAL", "UNCOMMITTED", "UNENCRYPTED",
  "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE",
  "USER", "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P",
  "VALUES", "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P",
  "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW",
  "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "FORMAT_LA", "NOT_LA", "NULLS_LA",
  "WITH_LA", "WITHOUT_LA", "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR",
  "MODE_PLPGSQL_ASSIGN1", "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3",
  "'<'", "'>'", "'='", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "parse_toplevel", "stmtmulti", "toplevel_stmt", "stmt",
  "opt_single_name", "opt_qualified_name", "opt_concurrently",
  "opt_drop_behavior", "CallStmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaEltList",
  "schema_stmt", "VariableSetStmt", "set_rest", "generic_set",
  "set_rest_more", "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_collate_clause", "alter_using", "replica_identity", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem",
  "alter_identity_column_option_list", "alter_identity_column_option",
  "set_statistics_value", "set_access_method_name", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "column_storage", "opt_column_storage",
  "ColQualList", "ColConstraint", "ColConstraintElem",
  "opt_unique_null_treatment", "generated_when", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "DomainConstraint",
  "DomainConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "opt_c_include", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem", "OptWhereClause",
  "key_actions", "key_update", "key_delete", "key_action", "OptInherit",
  "OptPartitionSpec", "PartitionSpec", "part_params", "part_elem",
  "table_access_method_clause", "OptWith", "OnCommitOption",
  "OptTableSpace", "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "stats_params", "stats_param", "AlterStatsStmt", "CreateAsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "grant_role_opt_list", "grant_role_opt",
  "grant_role_opt_value", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_relation", "reindex_target_all",
  "opt_reindex_option_list", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "opt_no",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterTypeStmt",
  "AlterOwnerStmt", "CreatePublicationStmt", "PublicationObjSpec",
  "pub_obj_list", "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "InsertStmtShort", "insert_target",
  "insert_rest", "override_kind", "insert_column_list",
  "insert_column_item", "opt_on_conflict", "opt_conf_expr",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "opt_nowait_or_skip", "UpdateStmt",
  "UpdateStmtShort", "set_clause_list", "set_clause", "set_target",
  "set_target_list", "MergeStmt", "merge_when_list", "merge_when_clause",
  "merge_when_tgt_matched", "merge_when_tgt_not_matched",
  "opt_merge_when_condition", "merge_update", "merge_delete",
  "merge_insert", "merge_values_clause", "DeclareCursorStmt",
  "cursor_name", "cursor_options", "opt_hold", "SelectStmt",
  "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "json_table",
  "json_table_path_name_opt", "json_table_column_definition_list",
  "json_table_column_definition", "path_opt",
  "json_table_column_path_clause_opt", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "JsonType", "a_expr", "b_expr", "c_expr", "func_application",
  "func_expr", "func_expr_windowless", "func_expr_common_subexpr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_indent_option", "xml_whitespace_option", "xmlexists_argument",
  "xml_passing_mech", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "opt_window_exclusion_clause", "row", "explicit_row",
  "implicit_row", "sub_type", "all_Op", "MathOp", "qual_Op", "qual_all_Op",
  "subquery_Op", "expr_list", "func_arg_list", "func_arg_expr",
  "func_arg_list_opt", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "position_list", "substr_list", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "opt_slice_bound", "indirection",
  "opt_indirection", "opt_asymmetric", "json_passing_clause_opt",
  "json_arguments", "json_argument", "json_wrapper_behavior",
  "json_behavior", "json_behavior_type", "json_behavior_clause_opt",
  "json_on_error_clause_opt", "json_value_expr", "json_format_clause",
  "json_format_clause_opt", "json_quotes_clause_opt",
  "json_returning_clause_opt", "json_predicate_type_constraint",
  "json_key_uniqueness_constraint_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor_null_clause_opt", "json_value_expr_list",
  "json_aggregate_func", "json_array_aggregate_order_by_clause_opt",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "attr_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "SignedIconst", "RoleId",
  "RoleSpec", "role_list", "PLpgSQL_Expr", "PLAssignStmt",
  "plassign_target", "plassign_equals", "ColId", "type_function_name",
  "NonReservedWord", "ColLabel", "BareColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,    60,    62,    61,    43,    45,    42,    47,    37,
      94,   777,    91,    93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -5899

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5899)))

#define YYTABLE_NINF -2992

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2992)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   18453,    52, 15019, -5899, -5899,    52, 72147, -5899, 81818,   686,
     895,  1351,   237, 21731, 82327, 93525,   723,   394, 16397,    52,
   93525,  1501, 62475, 77746,  1509, 93525,   510,  1313, 62475, 93525,
    1999, 94034,  1233,  1555,  1350, 94543, 82836, 76219,  1564, 93525,
    1794,   433, 95052, 83345,  1617, 83854,  1313, 57396,   162,  1592,
   95561, 93525,119909,   433, 84363, 84363, 84363,  2026,  2214,  1655,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899,  1377, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,  2044, -5899,
     216,  2456,  1732,   238,  1698, -5899, -5899,  2212, 72147, 93525,
   93525, 93525,  1919, 93525,  1880, 93525,   936, 72147, 68584, 84872,
    2088,  1883, 53208, 96070, -5899, 72147, 93525, 66039, 72147, 93525,
   93525, 96579, 93525, 97088, 93525,   810, 80291, 93525,  2037, 93525,
   93525, 66548, 97597,  2153,   273,   308, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
    1965,  2125, -5899,   320, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, 62984, 93525, 18713,   510,  2212, -5899,  2026,
   93525,  2333, 93525,  2005, 98106, 93525, -5899, 93525,  2165, 98615,
     949,  2112, 68584,  2219, 53736,  2260, 93525, 93525, 68584, 99124,
   99633,100142, 93525, 93525, -5899, -5899,  2250, 93525, -5899,  2369,
   69093,  1631,  2401,  2577,  2473,  1229, -5899, 85381, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, 71638,   394, -5899, -5899,
    2430, 72656,  2496, -5899, -5899,100651,120404,  2262, -5899,   960,
   73165, 69602,  2635,  2314, 54264,  2668, -5899, 73674, -5899, 70111,
   74183, -5899, -5899, -5899, -5899, -5899,101160, -5899,101669,  2359,
    2496, -5899,120899, 70620, -5899,  2565,102178,102687,103196,  2212,
    2293,  1975,  2011, 47501, -5899, -5899, -5899,  2349, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899,   929, -5899,   359,  1624,
     301,   262,   342, -5899, -5899,   265,   278,   288,   359,  2829,
    2829, -5899, 93525, -5899, -5899,  1624,   739,  2423,  2341,  2341,
    2341,  2558,    17, -5899,  2341,  2489, -5899, -5899, -5899, -5899,
   83854, -5899,  2347, 85890, 93525, 86399,   510,  2362,  2848,  2429,
   62984,  1428, 93525, -5899, -5899,  2869,  2416,  2725,  2424, -5899,
   -5899, -5899,  2622,  2659,   160,   113,   510,   282, -5899,  2821,
   -5899,  2678, 32344, 32344,   510, 86908,103705,   310, 71638,   510,
   87417,  2485,  1565,  2709, -5899, -5899, -5899,   783, -5899,  2966,
    2514,  2800,  2424,   273, 49561, -5899, -5899,  2504,  2125, 83854,
   -5899, -5899, -5899, 62984,  2863, 35506, 93525,  2502, -5899,  2512,
    2502, -5899, -5899,  2564, -5899,  2564,  2564,  2517,  2517,  2712,
    2522, -5899, -5899, -5899, -5899,  2114,  2564,  2517, -5899,121889,
   -5899,  1734,  2004, -5899, -5899,  3030, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899,  2538, -5899,  1418, -5899,  1991, -5899,
   -5899, -5899, 32344, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
    2543,  2554,  1732, -5899,  7410, 62984, 93525,  1126,  1126,  3014,
    1126,  1704,  1940, -5899,  2590, -5899,  2913,  2873,  2882, 83854,
    2588,  1065, -5899,  1797,  2633,  2056,  2605,  1846,  2061, -5899,
     979, 93525,   286,  2686, 87926, 10759,  2651,  2125,  2661, -5899,
   -5899, -5899, -5899,  2838,   452, -5899, -5899, -5899, -5899,  2946,
    3054,  8031,   386, 88435, -5899, -5899, -5899, -5899, 93525, 93525,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,  2694,
     181, -5899, -5899,  2670,  3065,  2940, 11359,  1161,  3060,  2901,
    1892, 12046,  2972,  2079,  3129,  7932,  1656,  3146,  2020,  2084,
   85890, 93525,  3103,  3156,  3401,  2015,  1119,  3021,  1146,  3060,
    3159,  2971,  1892,  3188,  6393, 93525, -5899,  3097,  3243,   785,
   -5899,   176, -5899, 25021, 35506, 56887, -5899,  2125, -5899,   989,
   -5899, -5899, 61966, -5899,  2896,  3061,   774, 72147,  2837, 93525,
   93525, -5899,119909, 72147, -5899,  3072, 54792, 72147, -5899, 72147,
   -5899, -5899,  3203,119909, 93525, 93525, -5899, 93525, -5899, -5899,
    2840, -5899, -5899, -5899, -5899, -5899,  2341, 93525,  3304,119909,
    3086,   431,  1819,  3341, 93525,  3088,  1819,  2886,104214, -5899,
   -5899,  1819, -5899, -5899, -5899, 93525, 93525,  2850,  2089,  3077,
     876,  1819,  3094,  3339,  3342,  3100,  2937,  3104,  2512, -5899,
    3307,  3075,  1185,   247,  2267,  1819,  2918,104723,105232, 93525,
    2919, 93525,  3318, 72147,  2954, 72147, 72147, 93525,  3236, 93525,
   -5899,  3062, -5899, -5899,  1985, -5899, -5899, -5899, -5899, -5899,
    3251, -5899,   229,  3253,  2879,  3259,  1921,  3261,   244, -5899,
   -5899,  2924, -5899,  3265,   313, -5899,  3267, -5899,  2890,105741,
   -5899,106250,106759,  3272,   350, -5899, 68584,  3276,   313,  3277,
    2890,  3278,   313,  3280,  1017,  3282, -5899,  1240,  3269,  3286,
     244,  3287,  2269,  2890, -5899,  3288,   369, -5899,  3289,   387,
   -5899,  3291,  3143, -5899, 35506, -5899,  3018, -5899,  1592,  2152,
    2011,  3231, 83854,  1624, -5899, 93525,  1624, 93525,  1624, 93525,
    1624, 93525,  1624, 93525, 93525, 93525,  1624, -5899, -5899, -5899,
   93525,  2923, 93525, -5899, 93525, -5899, -5899, -5899, 78764, 68584,
   79273, -5899, 93525, -5899,   483,   510, -5899, -5899, -5899,  1365,
   -5899,  2424, -5899,119909,  3422, 68584,  3318,  2158, -5899, -5899,
    3318, -5899, -5899,  3318,  3318, -5899, -5899, -5899,  3210, 93525,
    3292, 78764, 68584,  3294, -5899,107268, -5899, 71638,  3161,  2936,
   -5899, -5899, -5899, -5899, -5899,  2140,  3468,   260,  3473, 35506,
    2950,   260,   260,  2951,  3316, -5899, -5899, -5899,   341,  2956,
    2959, -5899,   267,   267, -5899,  2961,  2962, -5899,   284,  2963,
    2965,  3495,  3496,   298,   299,  2969,  2970,  2973,  2976,  2977,
    2978,  2979,  2982,  2983,  2984,  2985,  2986,  2987,  2114,   260,
    2988, 35506, -5899,  2994,   267,  2997,  2999,  3001,  3499,  3002,
   -5899,  3500,  3003, -5899,   271,   376,  3004,  3006, -5899,  3244,
   -5899,   322,  3008,  3010,  3012,  3015,  3016,  3017,  3019,  3020,
   35506, 35506, 35506, -5899, 29704,  2125,   510, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899,   326, -5899, 51624, -5899,  3056,
   -5899, -5899,  3232, -5899, -5899, 35506, -5899, -5899,  3389,   151,
   -5899,   337, -5899, -5899, -5899,  2125,  3334,  3023, -5899, -5899,
    1057,  3024, -5899,  2204, -5899, -5899, -5899, -5899, -5899, -5899,
   71129,  3519, -5899,   383,   510,   176,  2296,  3455, 60439, 60948,
   -5899, -5899,  3308, -5899, 93525, -5899, -5899,  2125,   208,  2169,
   -5899,  2349, 21466,  2178,  2502, 93525, 93525,  3525, -5899,  3032,
   -5899, -5899, 35506, -5899, -5899, -5899,  2829, -5899,  2564,  2564,
   -5899, -5899,  3530,  3125,  3126,  2829, -5899,  2829, -5899,  3040,
    3042,  2829,  3128,  3130,  3132, -5899,  3046,  3136,  2829, -5899,
   -5899, 64003,  2213, -5899,  3399,   391, -5899, -5899, -5899,  2183,
   -5899,  3047, -5899,  2512, -5899, -5899,  1732,  1732, 35506,  1732,
    1612,   179, 32871, 36033,  3415,  3283,  1413,  1915,  3419, -5899,
    3290,  1704,  1940, 83854, 93525, 83854,107777, -5899, 35506, -5899,
    3526,  3151,  3153,  3204, 59432, -5899,  3157,  3120,  3158,  3219,
    3074,  3165,  3167,  3228, -5899,  3365, -5899, -5899,  3172,  3250,
    3543,  3179,108286, -5899, -5899,  1221, -5899, -5899, -5899,  1221,
   -5899,  3105,  1598,  1130,   324,  3181,   331,   283,  3538, -5899,
    1451, -5899, -5899,  3242, -5899, 19578, 93525,  3475,  8407,  3326,
     386,  3241, -5899, -5899, -5899,  3388,  3190, 93525,  3192,  3343,
     386,   346,108795, -5899, -5899, 93525, -5899, -5899, -5899, -5899,
    8503,  3513, 28185, -5899,  2119,  3198,  3175,  3211, 93525, 75201,
    2239,  3322,  3345,  1912,  2414,   587,  3270, 93525,  1027,  3353,
   93525,  3122,  3212,  3213,  3464,  3127,   722,  3572,  3134, -5899,
   -5899, -5899,  3539, -5899,   524,  2117,  3344, -5899,  3469,  3517,
    9386,  3205,  3207,117929, -5899,  3229,  1133, 55320, 93525, 93525,
    3233,  3237,109304,  8503,  3558, 79782, 79782,  3240,  3245, 49046,
    3574,  1802,  3247, -5899, -5899, -5899,  1802,  3248,  3252,109813,
    8503,  3562, 93525,  3255,  3257, 93525,121889,   386, -5899,  3632,
     386,   386,  2066,  3638,  3260,   270,  3424,   699,  1819,  3134,
    3960, -5899,  3262,  3263,   378, -5899,  3394, 93525,  3264,  3271,
     120,  3357,   510, -5899,  3363, -5899,  3274,  3366,  3275,  1179,
    2850, -5899, -5899,  3279, 83854,  3390,  3395,  1027,   274,   746,
    3134, -5899,  3281,  3284,  3127,  3127, 93525, 93525, 93525, 93525,
   93525,   334,  3676,   464,  3285,   272,  1143,  3191, -5899,  1802,
   67057,  3293, -5899,  1802, 93525,   319,  1078,  3134,  2087,  1822,
   -5899, -5899, -5899,   273, -5899, 35506, 35506, 35506,  3200, -5899,
    2578, 21466,   927, -5899,   343, 17058,  3187, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, 93525, 62984, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, 93525, -5899, 93525,  3509,119909,  3512,  3429,
    3515,  3518,   386, 93525, 93525,  3522,  3523,  3524,119909,  3527,
    3528,  3534,  3433,  3296,   210,  3297,  3215,  3712,  3602, 93525,
   64003, -5899,  1221, -5899,119909,  3452,  3605, -5899, 93525,  3471,
      86, -5899,  3644,  3295, -5899, -5899,    89, 93525, 78255,  2850,
   -5899, -5899,  3608, 68584,  1641,  3609,   510,  3309,  3616,  3466,
     510, 68584,  3520, 93525, 93525, 93525, 93525,   204, -5899, 67057,
    3488, -5899, 93525,  3501,  3960,  3502,  3757,   118,  2341,110322,
    3626, -5899,110831,  3268, 93525,  3273,  3273,  3760,119909,  1526,
    3556, -5899, -5899,  2283, -5899,  3413, -5899, 72147, -5899, -5899,
   72147, -5899, -5899,119909, 93525,  3298,119909,119909, -5899, -5899,
   72147, 72147, -5899, 68584, 68584,  3651,   369,  3653,  3329,  3654,
    3340, 55320, 55320, -5899,   397, 72147, -5899, 68584, 72147, -5899,
   93525, -5899, 93525, -5899, -5899, -5899, -5899,119909,119909, -5899,
   68584, 67057,  3656, 93525, 93525, -5899, 93525, 93525, -5899, 93525,
   93525,  2191,111340,  2011, -5899, 93525,  3412, 93525, -5899, 93525,
   -5899, 93525, -5899, 93525, -5899, 93525, -5899, -5899, -5899, 93525,
   -5899, 93525,  2202, -5899, -5899,  2208,  1167, 93525, 93525,  1061,
   72147, 93525,  3514, 93525, 72147, 72147, 93525, 93525, 93525, 93525,
   93525,  3369,  3024,   730, -5899,  1720,  1029, 83854,  3529, -5899,
   -5899,  2224,  2026,    22, 93525, -5899, 93525, 93525, 93525, -5899,
   -5899, 77746,  3641,   479, 79273, 93525, -5899, -5899,  9945, 35506,
    2125, 31812, -5899, -5899, 21466,  3332, 35506, 35506,  3299,  2829,
    2829, -5899,  1169, 35506, 35506, 35506, 29177, 35506, 35506, 33398,
   35506, 35506, 35506, 35506, 35506, 35506,  2829,  2829,  3300, 35506,
    6824, 35506, 55320, 35506, 41303, 26087, 35506, 35506, 30231,   305,
    2961, 35506,  3544, 42351, 35506,  2296,  3545, 35506,  2296,  6824,
    3809,  3809,  2728,  6989,  3301,  2125, -5899,  2829,  1726, -5899,
     481,119909, 35506, 35506, 35506, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   35506, -5899, 64003, -5899, -5899, -5899, -5899, -5899, -5899,   166,
   -5899, -5899, -5899, -5899, -5899, -5899,  3430, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   93525, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, 30758, -5899, -5899,
   -5899, -5899,  3302, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899,  2801, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, 31285, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899,  3303, -5899, -5899, 35506, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899,  3376, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
     941, 35506, 35506, 35506, 35506, 35506, 35506, 35506, 35506, 35506,
   -5899, 35506,   593, -5899, -5899,  3640,  3389,    53,   462,  3306,
    3508, 88944, 32344,  3399, 25021, -5899,   316,  3399, -5899, -5899,
   -5899, 93525,  3519, -5899, -5899,  3379, -5899, -5899, -5899, -5899,
   -5899,   344, -5899, -5899, -5899, -5899, -5899, -5899, -5899,  3310,
   -5899, -5899, -5899, -5899,  3310, -5899,  3312,  3635,  3637,  1017,
   93525,  2616, 35506,   166,   303, 93525, 35506,  3302,  2801, 35506,
    3303, 35506,  3376, -5899, 35506, -5899,  2233,   921, 35506,  2237,
    3314, -5899, -5899,  3311,  3042,  3323,  3327,  3315,  3317,  2829,
     257,  3319,  1270,   188,  3451,  2829,  3577,  3320, -5899, 64003,
   -5899, 44411,  3368, -5899, -5899, -5899,   433, 93525, 93525, -5899,
    3639, -5899,  3325, -5899, 17185,  3639, -5899, -5899, 41827,  3453,
    3617,  3552, -5899, -5899, -5899,  3328, 21466, 36560, 36560, -5899,
    2321, 21466,  2348, -5899, -5899, -5899, -5899, -5899, -5899,  1545,
   -5899, 93525,   808,  3415,  1915,  3392, -5899,  3827,  3396, 93525,
   -5899,  2243, -5899, 68584, 93525, 93525,  3553, -5899,  3812, -5899,
  121889, -5899,  3337, -5899,121394,116939, -5899, -5899,   926, -5899,
    1174, 68584, -5899, 93525, 93525, 68584, 93525, 93525, -5899, 68584,
    3391, 93525, 93525, -5899, -5899, -5899, -5899, -5899, 61457,    95,
   77746,  3484, 76728, -5899, -5899,  3347, 93525,  3578, -5899, -5899,
  111849, -5899,  3580, 68584, 93525, 93525, 35506,  3585, 93525, 93525,
   -5899,   329,  3436,  3439, -5899, 93525,  3440, 72147,  3354,119909,
   72147, 55848, 72147, 72147,  3718,119909, 93525, 93525,  1525, 83854,
     458,  1131,  3134,  3593, -5899,   349, -5899, 68584, -5899, 93525,
    3583, -5899, -5899, -5899, 89453,  3845,  3485, -5899, -5899, -5899,
  112358, -5899, -5899,  3589, -5899,  2254, -5899, 68584, 68584, 93525,
    9668,  3364,112867, 93525,   697,  3659,  3610,  3660,  1256, -5899,
   -5899, -5899,119909, -5899, 93525, 89962, 93525, 93525,  3650, 93525,
   80800,113376,113885,  1551,  1610,  3652, 93525, 81309,  3655, -5899,
    3521, 93525, -5899, -5899, 64512, 68584, 93525,   912, 64003, -5899,
    3634, -5899, 93525, -5899,   325, -5899, 93525,  4358,  3599, -5899,
   -5899,  3461,  3474, 93525,   532,  1200,  3134,  3782, 93525, 93525,
    3374,  2255, 68584, 93525, 64003, -5899,  3606,   811, 68584, 93525,
   89453, -5899,  3607, -5899, 83854,  3715, -5899,  3375,  2341,  2504,
    2070,  3375, 68584, 93525, -5899,  3375, 93525,103705, -5899, 68584,
    1414, -5899, 68584, 93525, 89453, -5899,  3611,  3557, 68584, 93525,
    8737, -5899, -5899, -5899,   386, -5899, -5899, -5899, -5899, -5899,
   93525, 93525,   386, 93525, 93525,   386,   323, -5899, 68584, 93525,
   -5899, -5899, -5899,  3532, 68584, 93525, 93525,   403, 93525, -5899,
   93525, 68584,  3434, 93525, 93525, -5899, -5899, 93525,  5836, 93525,
   93525, 93525, 93525, 93525, 93525, 68584, 93525, -5899, -5899,  1579,
    1464,  1541,  1628,  1566, 93525,  3735, 93525,114394,   510, 68584,
   93525, 93525,   510, 93525, 64003,  1845, -5899, -5899,  3533, -5899,
   68584,  1414, -5899,  9903, 93525, 93525, 93525,  3494,  3497,   367,
    3576, -5899, -5899, -5899,  1114,  1114,  3633, -5899, 35506, 35506,
   33925,  3411, -5899, -5899, 35506,  2896, -5899, -5899, -5899,  1091,
    3910,  1091,114903,  1091,  1091,  3725,  3478,  3479,  1091,  1091,
    1091,  3709,  1091,  1091,  1091, 93525,  3603, -5899, -5899,  3603,
     976, 35506,119909, 93525, -5899,  2264, -5899,  3431, -5899, -5899,
   64003, 93525,   234,   183,  3800,  3658, 75710,  2346,  3787, 93525,
    3477, 93525,  3925,  3531,     7, -5899,  2346, 93525, -5899,  2148,
   77746, -5899, -5899, -5899, -5899, -5899, -5899, -5899, 93525, -5899,
   -5899,  3791, 93525, 44926,  3618, -5899,   510,  2850,  2850,  2850,
    2850,  3443,  2850, 93525,  3582,  3829,  2346,  3450,  3830, -5899,
    3960,  3832,  1395, 93525,  3690, 75710,  3535,  3503,  3701,  3957,
    2341,   510,  3704,  3691, -5899, 59930, -5899,  2850,  3973, 28681,
    6877,  7588,  3694,  3762, -5899, -5899,  3706,  1084, 93525,  3811,
    3818,  3840, -5899,   229, -5899,  3974,  1921,  3841,   244, -5899,
     313, -5899,  2890, -5899, 93525, -5899, 93525, 93525, 93525, 93525,
     350, -5899, -5899,   313,  2890,   313,  1017, -5899,  3771,   244,
    2890,  3619,  3844,   369, -5899,   387, -5899,  3708,  1017, -5899,
    3727,  2341, -5899,  1424, 50076, -5899, -5899, -5899, -5899, -5899,
   -5899,  2281, -5899, 93525, -5899,  3816,  3821,  3822,  3831,  3833,
    3493,  3504,  3540, 93525,  3505,  3493,   386,  3506,  3510, -5899,
    3505,  3505,  3493,  3024,  3024,  3493,  3504, 67566,  3971, 64003,
   -5899, -5899,  3586,  3507,  3860,   938, -5899,  1006,    97,  3765,
   -5899, -5899, -5899, -5899,119909, -5899, 68584,  3548, -5899, -5899,
   -5899,  3732,  3537, 67566,  1017,   174, -5899, 72147, 93525,119909,
   72147,  3746, 72147, 72147,119909, 93525, 93525,  2297, -5899,  2002,
   -5899,  2053, 35506,   218, -5899, 12463,  2299, 35506,  3516,  3536,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899,  3541,  3871, -5899,
    2303,  2304, 17607,  2355,119909,  2394,  3547, -5899,  3551,   251,
    3736,  3542,  6648,  3575,  2319,  3554,   259, -5899,  6648,   353,
    3549,  8450,  3678,  3550,  2326,  3563,  3564, -5899,  7187,  7901,
    3565, 17845,  3555,  3566,  3568,  3570, 41303, 41303, 29704,  2834,
   -5899, 41303,  3571,  3737,  2332, 17216,  3587,  3588, 18156, 34452,
   35506, 34452, 34452, 18943,  3569,  3594, -5899,  3920, -5899,  2338,
   64003,  3726, 19027,  2339, -5899, 35506, 64003,  8100, 35506, -5899,
   35506,  3613, -5899, -5899,  4541,  4541,  4541,  6824, -5899, -5899,
    3567, -5899, 41303, 41303, -5899,  3410, 29704, -5899, -5899,  3883,
   -5899, -5899,   630, -5899, -5899, -5899, -5899, -5899,  2815, -5899,
   -5899, -5899,  3770,  2355,  4174, 55320, 13580, 35506,   335, 35506,
    3302, 35506,  3615,  4541,  4541,  4541,   548,   548,   261,   261,
     261,  2352,   462, -5899, -5899, -5899,  3579,  3581,  3508,  3584,
   35506, -5899,  3595, 50591, -5899,  2445,  2462, 93525,  3492,  6295,
    6395, -5899, -5899, -5899,  3368,   927,  3368, -5899,   273,  2829,
    1726, 61966, -5899, -5899, -5899, -5899, -5899, -5899, 93525, 21466,
   -5899, -5899,  3797,  3612,  2367, -5899, -5899,  2829, -5899, -5899,
    2306,  2306,  3559, -5899,  3621, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899,  3614, -5899, -5899, -5899,  3623,  3625, 45441,  3887,
    3627, 43896, 90471,  3573,  2253, -5899, 90471, 90980, 90471, 90471,
   -5899,  3636, -5899, -5899,  2125, 35506,  3880, -5899, -5899, -5899,
   35506, -5899, -5899,  1228,  3596,   112,   797,  2511,  2511,  2321,
    1283, -5899, -5899,  3597, -5899, 35506,  2400, -5899,  2506, -5899,
   -5899, -5899, -5899,  3024, -5899,  3848, -5899, -5899, -5899, 44411,
    3629, 93525, 44411, -5899, -5899, -5899, -5899, -5899, -5899,116939,
    1991, -5899,121394, -5899,121394, -5899,  1991,  4014, -5899,116939,
    2014, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, 68584, 68584,  3813, 93525,  3817,  3834,
   35506,  1067, -5899,  3963,  1017, -5899, -5899,  3693, -5899, 21466,
   -5899, -5899, -5899, -5899, -5899, 68584, 93525, -5899, 71638, -5899,
   -5899,119909, -5899, -5899, 93525, 93525, -5899, -5899, -5899,119909,
   -5899, -5899, -5899, 93525,   203,  3705,  3713, 93525, -5899,   954,
    3394, 10064, 93525, 93525, 93525,  3927, -5899, -5899, -5899, -5899,
    3858, -5899,  4003, -5899,116939, -5899,  2890,  1626,  3719,  3134,
   35506,  3873, -5899,   255, 93525,  3642,  3647,  4010,  1296,  3962,
    3648, -5899,  3747, -5899,  3769,  1466, -5899, -5899,  3778, -5899,
   -5899, -5899, -5899,  4017,  1017,  4021,  1017, 93525, 93525, 93525,
   93525,  3789, -5899, -5899, -5899, -5899,  3792,  3934, -5899, 64003,
   64003, 64003,  2393, -5899, -5899,   510, -5899, -5899, -5899, -5899,
   -5899, -5899,  3982, -5899,  2397, -5899,  1007, 91489, -5899, -5899,
   -5899, -5899, -5899,  4030, 68584, 93525, 10176, 93525, 93525, 93525,
    3885,  2086,  1412,119909, -5899,118424, -5899, -5899,  2399, -5899,
    3672, 93525,  3750, 68584,  3730, -5899, -5899, -5899,  4043,  2341,
    3819, 79782,  3717,  3717,  2231, -5899, -5899, -5899, -5899, -5899,
    3956,  3879, -5899,  1118,  3881, 68584,  3744, -5899, -5899, -5899,
   -5899,  4054,  3774, -5899, -5899,  3775,  1204,  3134,  3960, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,  3799, -5899,
   -5899, -5899, -5899, -5899, -5899,   738,   738, -5899, -5899, -5899,
     738,  1644,   552,  1227,  3134, -5899,  1886,  1689,  3776, -5899,
    3781, -5899, -5899, -5899,  3968,  3970,  3977,  3796,  3804,  3836,
    3820,  3823,  3855, -5899,  3824,  3857,  3825,  3869,  3837,  4106,
    1017,119909,  3976,   510,  3864,  4103,  1017, -5899, -5899,  3838,
   -5899,  3843, -5899,  2420,  4222,  4227, -5899, 93525, -5899,   534,
    1239,  3134, -5899,  3846, -5899, 68584, 93525, -5899, -5899, -5899,
   35506,  3741,  3742,  3743, 21466, 21466, 35506, -5899, -5899, 21466,
    3748, -5899, -5899, -5899, -5899,119909, -5899, 93525,  4055, -5899,
   -5899,  1091, 93525, 93525, -5899, -5899, -5899, 93525, -5899, -5899,
   -5899,  4056, -5899,   315,   315, -5899, -5899,  4098,  8558,  3753,
     438, -5899, 64003, 52152,  3305,   915,  1819, -5899, 71638, 93525,
   71638, -5899,   183,  3980, 93525, 93525, 93525,  3761,  3759, -5899,
   -5899, -5899, -5899, 68584,   910, 68584,  2829, -5899, -5899,  3842,
   -5899, 93525,  2341,  4292,  4127,  3434, -5899,  4253,  3342,  1641,
    1884,   306,  2937,  4189,  2512, 35506,   178, -5899, -5899,  2125,
   93525,  3503, -5899, -5899, -5899, -5899,   510, -5899,  3772,  3767,
   -5899, 93525,  4138, 93525, 93525, 93525, 93525,  3548,  3779, 93525,
    3784,119909, 93525,  2404,  3127,  4276,  4159,  2026,  3535,  3875,
    4166, 83854,  3801,  2421, -5899, -5899,  1084, -5899,  2442,   182,
   -5899,   510, 71638,117434,  4155, -5899,   318,  7588, -5899, -5899,
     318,  1382, 93525, -5899, -5899, -5899, -5899,  4025,  2311, -5899,
    4140, -5899, -5899,  2026, -5899,119909,  3802, -5899,  2447, -5899,
   -5899, -5899,   369,  3859,  1017,  3862,  1017, -5899, -5899, -5899,
   -5899, 93525, -5899, 93525, 67057, -5899, -5899, 93525, -5899,  4173,
    3861,  1688, 48531,  4027, -5899, 93525,   409, -5899,  3814, -5899,
   -5899, -5899,  3948,  3952,  3958,  3961,  3964, 93525,  3493, -5899,
    3828, 93525, 93525, 68584,  1058, -5899, -5899, 68584,   489, -5899,
     241, -5899, 83854,  3953, -5899, -5899, -5899, -5899,  4199,  4200,
   -5899, -5899, -5899,   312, -5899, 78764,   497, -5899, 68584,  4133,
    4134,  4135,  4136,   386,  4137,  4141,  4143,  4144,  4147, -5899,
   -5899, -5899,  3847, 19313, 35506, -5899,  4215,119909, -5899,  8806,
   -5899, -5899, -5899, 35506, -5899, -5899,  4145, -5899, -5899,  3907,
    3909,  3849,  3547,  3678, -5899,  4068,  4070, 35506,  3678,  4322,
     358, 35506, 35506, 35506, -5899, -5899,  4074,  4077, 35506,  2355,
    2355, 35506, -5899,  3851, 35506, -5899, -5899, -5899, -5899,  2384,
   35506, -5899, 35506, -5899, -5899, 26620,  4375,  4375,  3852,119909,
   41303, 41303, 41303, 41303,  1718,  2997, 41303, 41303, 41303, 41303,
   41303, 41303, 41303, 41303, 41303, 41303,   622, -5899,  4071, 35506,
   35506, 34979, -5899, -5899,119909,  3865,  3569,  3870,  3872, 35506,
   -5899, -5899, -5899,  2459, 42866,  3876, 64003, -5899, 35506, 16926,
    2465,  3912, 19727,  2125,  8981,   510, 35506,  2769,  4293, 35506,
    2467, 35506, -5899, -5899, -5899, -5899,  4216, -5899, -5899, -5899,
   -5899, -5899, -5899,  4101,  2355, -5899, -5899, 35506,  3877,  4237,
   41303, 41303,  4960, -5899,  5278, 35506, 29704, -5899,  3633, -5899,
   27153,  3866, 35506,116430, -5899, -5899,  1313,  1313,  1313,  1313,
   -5899, 93525, 93525, 93525,  3880,  3878,  3880,   176,  3882, -5899,
   -5899, -5899, -5899,  2026, -5899,  3863, -5899, -5899, -5899, -5899,
   -5899, 35506, 90471, 90980, 90471, 90471,  3874, 43381, 27669,  2253,
    3886, 93525, -5899, -5899,  3884, 44411,  4172,  4088, -5899, 44411,
    4088,  1782,  4088,  4183,  3979, 51106, -5899, -5899,  3888, -5899,
   -5899,  4105, -5899,  2119, 21466,  4357,  4235, -5899,  3893, -5899,
    3596,   317, -5899, -5899, -5899,  1298, -5899,  3984, -5899, -5899,
   -5899,  3573, 37087,  4057, -5899,  1615,  2471,  2038, -5899, -5899,
  116939, -5899,  3972,  2890,  2890,  1811,  3493,  4260,  1811,  9247,
   -5899,  2083, 93525, -5899, 93525, -5899, -5899, -5899,  4397,  3965,
    3967,  4193, -5899,  2605, -5899, -5899, 68584, 93525, -5899, -5899,
   -5899,   547,  1249,  3134, -5899,  3993, -5899, -5899,  4228, 93525,
   -5899,  4382,  4006, 93525,  9377,  4289,  3975, -5899, -5899, 45956,
   93525, 93525, 93525, -5899, 93525, 93525,  2083, 91998, -5899,  4363,
    2083,  4033,  4272,  1767,  3127,   270,  2411, -5899,  1597, -5899,
   -5899,  3997, -5899, 93525, -5899, 93525, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899,  4061, -5899, -5899, -5899, -5899, 64512, -5899,
   -5899, 93525, -5899, 64003, 52152, 64003, -5899, -5899, -5899, 93525,
   -5899,  1729,   553,  1378,  3134, -5899,  4011, -5899,  4297,  4012,
    4013,  4072,   226,   264,  4015,  4016,  4075,  3930,  3932,  3933,
   -5899, 64003, 52680,  4102, 93525,  2890,  3937,  3981, 93525,  3717,
   92507, -5899,  3939, -5899, -5899,  3717,   359,   510, -5899, -5899,
     510,  2890,   510, 93525, 93525, 93525, 93525,   403, -5899, -5899,
   -5899,  4415,  4039, 93525, 93525, 93525, 93525, -5899,  3999, -5899,
   -5899, -5899, 93525, 93525,  4307,  1152,  2279, 68584, 93525, 93525,
   68584, 93525, 93525, 93525, 93525, 93525, 93525, 93525,  4175, -5899,
    4402,  4324,  2301,  4369,  4028, 93525, -5899, 93525,   510, -5899,
    3394, 93525, 93525, 93525, 93525, -5899, -5899, -5899, -5899, -5899,
    3633, -5899,  3951,  4263,  1091, -5899,  4264,  4266,  4268,  1091,
   -5899, -5899,  1819, -5899,   235, 93525, -5899,  2475, 93525, -5899,
   -5899, -5899,  3893,   524,  2117, -5899, -5899, -5899, -5899, -5899,
   -5899,  3959, 93525, 93525, 41303, -5899,  2383,  1383,  1537, -5899,
    4254, 93525,  3244, -5899, -5899, -5899,   919, 93525, -5899, -5899,
   -5899, -5899,  3966, -5899,   758,  3779, -5899,  4286, 75710,  2890,
   68584, 68584,  2890, -5899,119909,  3985,  3503, -5899,   302,  4049,
   -5899, 68584,  1641,115412,  3309,  4002,  4191, 10401, 44411, 44926,
     738, -5899,  3969,  3978, -5899, -5899, 93525,  3980, 67057,  2477,
    3960,  4463,   914,  2293, -5899, 77237,  4176,  3779,  4286, -5899,
    3127,  4201,  4202, -5899,  2026, 93525,  3548,  3503,   510, 93525,
    3975, 52152, -5899,  4504,  2324, -5899,116939, 35506, 35506, -5899,
    3983, -5899,  3986,  7588, -5899,  4052,  3987,  4467, 35506, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899,  4066,  3988, 93525,
   93525,  1084, 93525, -5899,  3989,  3841, -5899,  3841, -5899, 93525,
   -5899, 93525, -5899,  1017, -5899,  4116,  1017, 93525, -5899, -5899,
   -5899,  4041,  2478, -5899, -5899,  4433,  4057, -5899,  2492, 50076,
    3629, 35506,  2125, 93525, 93525, 93525, 93525, 93525,  3493,   386,
    3510, -5899, -5899,  4344, 67566,  4345, -5899, 64003, -5899, -5899,
   -5899, -5899, -5899,  2503, 93525, -5899, -5899, -5899,  4418,  4355,
    1017,   479,  1122,  1122,  1122,  1122,  4310,  1122,  1122,  1122,
    1122,  1122, -5899, 35506, 21466, -5899,  4001, -5899, 21466,  4392,
    4298,  4299, -5899, -5899,  4007,  4241,  4246, -5899,  4018, 35506,
    3678, 20063, -5899, -5899,  4248,  4251, -5899,  3678,  3678, 20063,
   -5899, 20063,  4020, 11076, 20259, -5899,  2509, 35506, -5899,   588,
     588,   588,  1280,  4372, -5899,  2884,   588,   588,   588,   537,
     537,   276,   276,   276,  4375,   622, 20499, 20307, 20675,  4022,
   -5899, -5899, -5899,  3569, -5899, 37614,   748,  4491, 42351, -5899,
   -5899, -5899,  4067,  4073,  4026, -5899, 35506, 38141,  4031,121889,
    4243, -5899,   473, 35506, 35506,  3446, -5899, 13642, 35506, -5899,
   -5899,  3446,   595, 35506,  4384,  4613, 35506, 35506,  5833, 11130,
    4029, -5899,  2515, 35506, 11184,  4236, -5899, 93525, 93525, 93525,
   93525, -5899, -5899, -5899,  4235,   510,  4235,   510,  4035, -5899,
    4036, -5899, -5899, -5899, -5899, 65021,  4034,  3726, 90471,  4037,
   93525,  2253, 44411, -5899, -5899,  2263, -5899, 44411,  4348, -5899,
   44411, 72147, -5899, 93525,  4042, 93525, -5899,  1126, 35506,  4087,
   55320, -5899, -5899, -5899, -5899,  4139, -5899,  4277, 21466, 32344,
   -5899, 35506, -5899,  4121,  2525, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899,  4148, 77746,  4405, -5899, -5899,  1434,  4376,   572,
   -5899,  1017, -5899,119909, 93525, 93525, 93525,  3074, -5899, -5899,
   93525, 93525, 93525, 93525, -5899, -5899, 68584, 93525, -5899, -5899,
   93525, 35506,  2526, -5899,  4094,  4509,   215,  2531, -5899,  2533,
    2083, -5899,  2539, -5899, -5899, 93016, -5899,  3980,   403,  2383,
    4393,  4395,  4294, -5899,   386, -5899,  4554,  2383,  4300,   403,
   -5899, -5899, -5899, -5899,  2340, -5899,119909,  1017,  1017, -5899,
   -5899, -5899, -5899, -5899,  4076, -5899,  4535,  4161, 93525, 93525,
   93525, 93525, 93525, 68584, 93525, 93525,  2829,  2829,119909,  4058,
   -5899,  2829,  2829,  4063, -5899, 68584, 93525, 93525, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899,  4157,
   -5899, 35506,  4530, -5899, -5899, -5899, -5899, -5899, 35506, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, 68584,
   93525,  4158, -5899,  4163, -5899,   878, -5899, -5899, 93525, 93525,
   93525, 93525,  4456, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899,  4454, 93525, -5899, -5899,   510,   510,
  119909,  1017,  1017, -5899, -5899, -5899,  4168, -5899, -5899,  4082,
    4394,  1091, -5899,  1091,  1091,  1091, -5899,  4086, -5899,  1819,
    4494, -5899,  2083,  2124,  4445, -5899, 35506, -5899,  1132,  1280,
   -5899,  4505,  4591, -5899, -5899, -5899, -5899,  3434,  2341,  3434,
   -5899, -5899, 72147,   422, -5899,  4434,   234, 64003,  4334, 75710,
    1886,  1834,  4104,  4238, -5899,  2890,  2890,  4167, 93525,  4603,
   -5899, -5899, -5899, -5899, -5899, -5899, 68584,  3730, -5899,  4350,
    1121,  4470, 93525, 44926, -5899,  3573, -5899, -5899, -5899,   510,
   -5899, -5899,  4250,  3503, -5899,  1402, 93525,  4343, 75710,  3548,
    2556, -5899, -5899, -5899,  4156,  4594,  3535, -5899,  1886,  4176,
   -5899, -5899,  4570,  4218,  4165,  4619, -5899,  4218,  4484,  4354,
    4130, -5899,  3801, -5899, 93525, -5899, 21466, 21466,   510,122384,
     318,119909,  4496, -5899, 21466, 93525,   230,  4142,  4306, -5899,
    4460,  1017,  2570, -5899,  1017,  1017, -5899, 93525, -5899,  2026,
    2428, 93525,  2125,   102, -5899,  4149, 93525, -5899,  4057, 21466,
    3493,  3493,  3493,  3493,  3493, -5899,  4361, -5899, -5899, -5899,
   -5899,  4453, -5899, 67566, -5899,  1017, -5899, -5899, -5899, -5899,
   -5899, -5899,  1122, -5899, -5899, -5899, -5899, -5899, 21466, -5899,
   93525, -5899, -5899, -5899, -5899, -5899, -5899,  3325,  4150, 35506,
    1499, -5899, -5899,  4151,  4153,  3678,  3678, -5899, -5899, 35506,
   -5899, 11774, 41303,  4499, -5899, 35506, 35506, 35506, -5899,  4162,
    2575,  2576, -5899, -5899,   748, -5899,  4491, -5899, -5899, -5899,
   11829,  4206, 21466,  4262,  4154,  1408,  3446,  3446, 13642,  3446,
   35506, 35506,  3446,  3446, 35506, -5899, -5899, -5899, 12115, -5899,
    4625,  3633, -5899, -5899, -5899, -5899,  4087, -5899,  4087, -5899,
    4301, 35506, -5899,  2585,  4652, 40249,  4610, -5899, 93525,  2591,
   -5899, 35506,  4164, -5899, -5899, 44411,  2263,  4171,  2596, 93525,
    2597,119909, 38668, 21466, 93525,  3633,  4160, -5899, 93525,  3023,
   20931, -5899, -5899, 67566,  4398, 67566,  2083, -5899, -5899, -5899,
   -5899, -5899, -5899,  4177, -5899, -5899, -5899, -5899,  4245, -5899,
   -5899,    39,  3529,  2083, -5899, 12555,  4506, 45956, 56376, 93525,
   -5899, 93525, -5899,  4349,  4506,  4506, -5899, -5899, -5899, -5899,
    4671,  4557,  4558, -5899, -5899,  4182, -5899, -5899, -5899,  4402,
   -5899, -5899, 52152, 68584, 93525, -5899,  4271, -5899, -5899, -5899,
   -5899, -5899, -5899, 48016, 55320, -5899,   226,  4185,  4187,   264,
   -5899, -5899, -5899, 93525, 12870,  4188, 13121,    47,  3529, 93525,
   93525,  4190,  4196,  4197,  1929,  1864,  1981,  3493,  4556, 93525,
   -5899, -5899, -5899,  4402, -5899, -5899, 93525, -5899,  1091, -5899,
   -5899, -5899, -5899, 64003, -5899,  3049,  4086,   510, 72147,  4694,
    4694, 14231,  4436, -5899, -5899,   775,  4267,  4471,  4267,  4204,
   93525,   919,  4209,  2598, -5899, 93525,  4205,  4335,  1757,  1757,
   93525, 93525, 93525,  2602,  2026,  2890,  3981,  1641,  4579, 75710,
    4631,  3980,   417, -5899, 93525,  4707, 93525,  3548,  3779, 93525,
    4211, -5899, -5899, 77237,  4435,  3305, 93525,  2404,  4176,  3535,
    1385, 93525, -5899,  1465, -5899,  2026, -5899, 93525, 83854, 45956,
    4571, -5899,121394, -5899,  2607, -5899, -5899, -5899,  4295, 22294,
    3368,  4337,  4339,  4214,  2203,  4583, 93525,   982, -5899, -5899,
   -5899, -5899, -5899, -5899,  1688, -5899, -5899,  4663, 45956,  4620,
   35506, -5899, -5899, -5899, 93525,   497, -5899, -5899, -5899, -5899,
    4219, -5899,  4720, 35506,  1095, -5899, -5899, -5899, -5899, -5899,
    4451, -5899,  4226, -5899, -5899,  2625,  1499, 21057, -5899,  5072,
   41303, 21466, 21466, 21466, 35506, -5899, 35506, -5899, -5899, -5899,
   -5899,   150, -5899, -5899,  4563,  4239,  3446,  3446,  3446, -5899,
   35506,  1099, -5899, -5899,  1803,  4658, 21098,  3636, 65021,  4242,
   -5899, 41303,  2608, -5899,  5095, 93525,  2613, -5899, 21466, 93525,
   -5899, -5899, 35506, -5899,  2619, -5899,  4244,    55,  4249, 25554,
    4233, -5899, -5899, -5899, -5899, -5899, 21466,  4247, -5899,  4735,
    1915, -5899, -5899,  2192,  1279, -5899,  4740,  4740,  1058,  1811,
     484, -5899, 93525,  4340, -5899,  4509,  4252,  3434, -5899,  4255,
   -5899, -5899,   441,  3127, 93525,  3434,  3434,  3305,  4585, -5899,
   -5899, 35506,  4312, -5899,  1254,  3529, 93525,119909, -5899,   170,
    4611, -5899,119909,119909, -5899, -5899, -5899, 35506, -5899,  4353,
   -5899, -5899, -5899, 35506, 35506, 74692, -5899, -5899, 93525, 93525,
   93525, 93525, 93525, -5899,  1017, -5899, -5899,  2626, -5899, 46986,
   -5899, -5899,  3341,   510,  3341,  2121, -5899, -5899,  3341,  3341,
   -5899,  3368, -5899,  4694,   392, -5899, -5899,  4503,  4261, 35506,
    4588, -5899,  1070,  4488, -5899,  4269, -5899, 72147,  4792, -5899,
   64003,  3779,  4286, 93525, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899,  2628,  3980,  4635,  3503,
    4165, -5899, 93525,  4308, -5899, 44411,  3980,  2026,  2293, -5899,
    4176,  3779,  4286, -5899, -5899,  4274,  4202,  3535,  2404,  4417,
   -5899,  4420, -5899,  4734,  4498,  4738,  3548, -5899,  3975,  2630,
   -5899, 93525, -5899, -5899,  7588,122384,119909, -5899, -5899, -5899,
    4287,  4689,  4336,  4351, -5899, -5899, -5899,  2203, -5899,  1796,
    4685,  4341, -5899,  4359, 93525, -5899, -5899,  4362, 93525,  2638,
     140, 21466,  3980,  1017, 35506, 64003, 21466, -5899, -5899,  4681,
   -5899,   456,   340,   252,  4523,  4305, 35506,  5072,  2642,  2644,
    4366, -5899, -5899, -5899,  3569, 39195, 39195, 39195,  4313,  4666,
    4682, 93525, -5899, 93525,  4525, -5899, -5899, 93525,  1280,  4315,
   40249, 64003,  2648, -5899,118919, -5899,  2652,  2665, -5899, 35506,
    4323, 35506, -5899, 38668, 93525,  4325,  3415, -5899,  4593, -5899,
   -5899, 35506,  4413,  4419, -5899,  4684, -5899, -5899, 93525, -5899,
   93525,  4267, 55320,  3596,   441,  2341,  4267,  4267,  4261, 14771,
   35506, -5899,  4427, -5899, -5899,  2666,  1226,  4508,  4508,  2672,
    2688, 15306, 93525,  2689,  2695, -5899,  2697,  2829,  3504,  1981,
    3504, -5899,  3493, -5899, -5899, 64003, -5899, -5899, 68075, -5899,
   -5899, -5899,   510, -5899,   510,  4572, 57905, 58414,   510,   510,
   -5899, -5899, -5899, -5899,  4659, -5899,  3960, -5899, 15619,  4431,
   -5899, -5899, -5899,   540, -5899,  4562,  4564, -5899,  4342, -5899,
    2699, -5899,  1886,  4472,  3980, -5899, -5899, 93525,  4835,  4840,
   -5899,  1140, 93525,  3573, -5899,  4165,  3548,  3535,  1886,  4176,
    3305, 46471,  4218,  2404,  4202, -5899, -5899,  4568, -5899,  4569,
   -5899,  4347,  4683, 45956, -5899,  2085,   318, -5899, -5899, -5899,
    1453,  4704,  4709, -5899, -5899, -5899,  3341, -5899,   124,  4356,
    4736, -5899, -5899,  2026, -5899,  3368, -5899,  4492, -5899, -5899,
   -5899, -5899, -5899,  4400,   348,   381, -5899,  4406, -5899,  4547,
    4550,  1499,  2406, -5899, 21466, -5899, -5899, -5899, 40776,  4531,
    1269, 17586,  4764, -5899,  4764,  4764, -5899,  4859,  4861,  1282,
   -5899,  4844,  2701, 42351, -5899, -5899, -5899, 93525,  4606,  1452,
    4889,  4561,  2703, 38668,  2711, -5899, -5899, -5899, -5899,  4871,
   21466,   515,  1651, 67566,  3529,  2715,  3717,  4396, -5899,  3596,
    4471, -5899, -5899, -5899, -5899, 21466, 93525, 72147,  4873, -5899,
   -5899, -5899, -5899, -5899, -5899, -5899,  3529,  4486, -5899, -5899,
   74692, -5899, 93525, -5899, -5899,  2727, -5899, -5899, -5899, 58923,
   -5899,  4142, -5899,  4142, -5899, -5899, -5899,  1944,  4511, 93525,
     987,   987,  4810, -5899,  4466, -5899,  4404, -5899,  4931,  4542,
   93525, -5899, -5899,   226,  2026, 75710,  3980, -5899, -5899,  2404,
    4176,  3535, 35506,  2735, -5899,  4509,   215, -5899,  4202,  4218,
   -5899, -5899, 45956,  4408,  3244, -5899,  4803, -5899, -5899, -5899,
    1529, 72147, 72147, 93525, -5899, -5899, -5899, 35506,   919, -5899,
   -5899, 50076, -5899,  4450, -5899,  4452, -5899, -5899,  4638,  4641,
    4416,  1499, -5899,  4915, -5899, -5899, -5899, -5899, -5899,  1092,
   -5899, -5899, -5899, 93525, 93525, 93525,  4421, -5899,  3726, -5899,
   -5899, 41303, 41303,  4655, -5899, 41303,  1452, -5899, 93525, -5899,
    4422, -5899, -5899,  2737, -5899,    99, -5899,  4664,  4559, -5899,
   -5899,  4667,   624, -5899,   484, -5899, -5899, -5899, -5899, -5899,
    4488,  2083,  2083,  3529, -5899, 93525, -5899,  4425, -5899, -5899,
   -5899, 68075, -5899,  4142, -5899, -5899, -5899, -5899,  4938, -5899,
    1372, -5899, -5899, -5899, -5899, 93525,  3980,  4058,  4165, -5899,
    4202,  3535,  2404, 16039, -5899, 46471, 93525, 93525,  4218, -5899,
    2739, 45956,  3503,  4580, -5899,  2681, -5899, -5899, -5899, -5899,
   -5899, -5899, -5899,   944,  4428,  4429, -5899, -5899, 16348, 72147,
    1821, -5899, -5899,  4581,  4584, -5899,  4660, 39722,  4587, -5899,
    4661, -5899,  1288,  1297,  1962,115921,  4893,  1280,  1280, -5899,
    1280, -5899, -5899, 35506, -5899, -5899, -5899, -5899, 50076, -5899,
    4501,  1688,  4442, 93525, -5899, -5899,  2083, -5899, -5899, -5899,
   35506, -5899, -5899,  2341,  2341,  3980, -5899, -5899,  4218,  2404,
    4202,  4509, -5899, -5899, -5899, -5899,  4683, -5899,  2741,  4218,
    4341,  2654, -5899, -5899,  2707,  2554,  4539,  4812, -5899,  4457,
   -5899,  4573,  4574,  4838, -5899, -5899, -5899, 93525, 93525, 65530,
   93525,   361,  2747, -5899,119414, 93525, 16801,  4458, -5899,  4517,
   35506,  2749,  2083,  2770, -5899, -5899, -5899, -5899,  4202,  4218,
   93525,  3244, -5899, 45956,  3368,  4841, -5899,  2681,  4586,  4589,
   63494, -5899, -5899, -5899, -5899, -5899,  4995,   352,  4882, -5899,
   -5899,   510,  1499,115921,  4692,   859,  2772, -5899,  4526,  2774,
     131, -5899,  4218, -5899, -5899,  3503, -5899, -5899,   919, -5899,
    4518,  4519, -5899,  2776, -5899, -5899, -5899, -5899, 35506, 65530,
    2389,  4473, -5899, -5899,  4679,   510,  2625,  4679, -5899, -5899,
   -5899,  1688, -5899, -5899,  4218, 72147,  4834,  4836, -5899, 63494,
    1114,  4544, 93525,  4483, -5899,  1499, -5899,   252,  2625,  4543,
    3368,  4485, 72147, 72147, -5899,  4487, 93525,  4937,115921, -5899,
    1499,   252,  4526, -5899, 63494, -5899, -5899,   510, -5899,  4489,
    2780, -5899,  1499, -5899,  2793,115921, -5899, -5899, -5899,  2802,
   -5899
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1725,  1462,   668,  1551,  1550,  1462,     0,   273,     0,  1562,
       0,  1462,   441,  1119,     0,     0,     0,     0,   668,  1462,
       0,  1725,     0,     0,     0,     0,     0,  1738,     0,     0,
       0,     0,     0,     0,  1259,     0,     0,     0,  1462,     0,
       0,  1745,     0,     0,     0,     0,  1738,     0,  1564,     0,
       0,     0,     0,  1745,     0,     0,     0,     0,     0,     2,
       9,    10,    45,    80,    81,    38,    37,    98,    63,    24,
      71,   133,   132,   134,    50,    46,    88,    33,    35,    47,
      51,    73,    75,    40,    53,    64,   110,    72,    31,    70,
      76,    96,    58,    19,    20,    59,    21,    60,    22,    61,
     106,    82,    99,    43,    69,    30,    52,    78,    79,    12,
      54,    86,    18,    65,    66,    68,    91,    92,    93,   116,
      94,   128,    49,   125,   103,   104,   122,   105,   123,    16,
     107,    62,    23,   119,   118,   120,    89,    55,    90,    77,
      97,   117,    34,   121,    25,    26,    28,    29,    27,    67,
      36,    74,    39,    95,   124,   114,   109,   129,   127,    11,
     135,   111,    83,    14,    15,   100,    13,    32,    57,    17,
      42,    41,    56,    48,   131,    44,  1562,   102,   115,   101,
      84,   108,    87,   112,   130,   113,    85,   126,  1689,  1688,
    1749,  1692,  1724,     0,  1704,  1461,  1460,  1475,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   667,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1472,  2453,  2470,  2471,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,  2483,
    2484,  2486,  2485,  2487,  2488,  2860,  2489,  2490,  2491,  2797,
    2798,  2861,  2799,  2800,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,  2499,  2500,  2801,  2802,  2501,  2502,  2503,  2504,  2505,
    2803,  2862,  2506,  2507,  2508,  2509,  2510,  2511,  2863,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2864,
    2522,  2523,  2524,  2865,  2525,  2526,  2527,  2528,  2529,  2530,
    2804,  2805,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,
    2549,  2550,  2551,  2552,  2553,  2554,  2555,  2556,  2557,  2558,
    2559,  2560,  2806,  2561,  2562,  2563,  2564,  2807,  2565,  2566,
    2567,  2568,  2808,  2569,  2570,  2571,  2572,  2866,  2867,  2573,
    2574,  2575,  2576,  2577,  2809,  2810,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2868,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,  2595,  2596,  2597,  2869,  2811,  2598,
    2599,  2600,  2601,  2812,  2813,  2814,  2602,  2870,  2871,  2603,
    2872,  2815,  2816,  2817,  2818,  2819,  2820,  2821,  2822,  2823,
    2824,  2825,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2826,  2873,  2612,  2874,  2613,  2614,  2615,  2616,  2617,  2618,
    2619,  2620,  2621,  2622,  2623,  2624,  2625,  2827,  2626,  2627,
    2628,  2629,  2630,  2631,  2632,  2633,  2828,  2875,  2829,  2634,
    2635,  2636,  2637,  2638,  2639,  2640,  2641,  2830,  2831,  2642,
    2643,  2644,  2876,  2645,  2832,  2646,  2833,  2647,  2648,  2649,
    2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,  2834,  2877,
    2658,  2878,  2835,  2659,  2660,  2661,  2662,  2663,  2664,  2665,
    2666,  2667,  2668,  2669,  2670,  2671,  2672,  2836,  2673,  2837,
    2676,  2674,  2675,  2677,  2678,  2679,  2680,  2681,  2682,  2683,
    2684,  2685,  2686,  2687,  2838,  2688,  2689,  2690,  2691,  2692,
    2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,
    2703,  2704,  2705,  2706,  2879,  2707,  2708,  2709,  2710,  2711,
    2839,  2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,
    2721,  2722,  2723,  2724,  2725,  2726,  2727,  2728,  2840,  2729,
    2730,  2880,  2731,  2732,  2841,  2733,  2734,  2735,  2736,  2737,
    2738,  2739,  2740,  2741,  2742,  2743,  2744,  2745,  2746,  2747,
    2748,  2842,  2749,  2750,  2751,  2752,  2881,  2753,  2754,  2755,
    2756,  2757,  2758,  2759,  2843,  2844,  2760,  2761,  2845,  2762,
    2846,  2763,  2764,  2765,  2766,  2767,  2768,  2770,  2769,  2771,
    2772,  2773,  2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,
    2847,  2848,  2782,  2882,  2783,  2784,  2785,  2786,  2787,  2788,
    2789,  2790,  2791,  2792,  2793,  2849,  2850,  2851,  2852,  2853,
    2854,  2855,  2856,  2857,  2858,  2859,  2794,  2795,  2796,   146,
       0,     0,  2420,  2454,  2455,  2458,  2453,   411,   410,  1678,
    2417,  2454,  1561,     0,  1540,   668,     0,  1475,   440,  1725,
       0,     0,     0,     0,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   138,
       0,   140,     0,     0,   465,   464,     0,     0,  1091,   470,
       0,     0,     0,     0,     0,   658,  1603,  2674,  1601,  1679,
     274,   277,   278,   275,   276,  2436,     0,  1231,  1232,  1234,
       0,     0,  1244,   925,   926,     0,     0,     0,   939,     0,
       0,     0,   923,     0,     0,     0,   945,     0,   942,     0,
       0,   946,   943,   920,   944,   927,     0,   919,     0,     0,
    1244,   947,     0,     0,   921,     0,     0,     0,     0,  1475,
    1600,   471,  1725,     0,  1584,  1585,  1586,  1562,  1574,  1587,
    1579,  1581,  1580,  1582,  1583,  1578,     0,  2435,  2472,  1015,
    1015,  1015,  1015,  1012,  1013,  1015,  1015,  1015,  2695,     0,
       0,   994,     0,   996,  2437,  1015,  1020,  2480,   550,   550,
     550,     0,  1019,  1024,   550,     0,  1443,  1484,  2419,  1737,
       0,   995,  1442,     0,     0,     0,  2760,  1590,     0,     0,
       0,     0,  2714,  1452,   256,  2726,  2843,  2760,   255,   249,
     251,   223,     0,     0,  1019,   550,     0,  1475,  1450,   991,
    1744,  1742,     0,  2404,  2499,  2516,  2615,   246,  2707,  2716,
    2726,  2843,  2760,  2793,   202,   212,   207,     0,   267,  2726,
    2843,  2760,   263,  1472,     0,  1705,  1855,  1854,  2413,     0,
    1445,  1444,  1563,     0,  1566,     0,  2690,  1709,  1712,  1568,
    1710,  2456,  1948,  1977,  1955,  1977,  1977,  1944,  1944,  2546,
    1957,  1945,  1946,  1982,  2002,     0,  1977,  1944,  1949,     0,
    1947,  1985,  1985,  1972,     3,  1927,  1928,  1929,  1930,  1958,
    1959,  1931,  1964,  1965,  1969,  1932,  1999,  1935,  1944,  2457,
    1746,  1747,  2404,     4,  2450,     5,  2331,  2449,     6,     7,
    1701,     0,     0,     1,  1725,     0,  1573,  1741,  1741,     0,
    1741,     0,  1693,  1701,  1696,  1700,     0,     0,     0,     0,
       0,     0,  1446,     0,     0,     0,   950,     0,  1487,  1076,
       0,     0,     0,     0,     0,  1328,     0,  1128,  1127,  2459,
    2442,  2443,  2444,     0,  2440,  2441,  2460,  2461,  2462,     0,
    2584,  1328,     0,     0,  2247,  2258,  2259,  2260,  2503,  2565,
    2255,  2256,  2257,  2249,  2250,  2251,  2252,  2253,  2254,     0,
       0,  1226,  2248,     0,  2584,     0,  1328,     0,   173,     0,
     150,  1328,     0,     0,  2584,     0,     0,  2584,     0,     0,
       0,     0,     0,  2584,     0,     0,     0,     0,     0,   173,
    2620,     0,   150,  2584,     0,     0,  1466,     0,     0,     0,
    1468,  1471,  1458,     0,  2328,     0,  2329,  2421,  1555,     0,
    1554,  1548,  1558,  1553,  1543,     0,  2413,     0,     0,     0,
       0,   933,     0,     0,   923,     0,     0,     0,   934,     0,
     935,   936,     0,     0,     0,     0,   932,     0,  1456,  1448,
       0,  1592,  1594,  1593,  1595,  1591,   550,     0,     0,     0,
    2584,     0,   150,  1526,     0,  2584,   150,     0,     0,   469,
     468,   150,  2440,   467,   466,  2503,  2565,     0,  1118,     0,
    1201,   150,  2584,     0,   194,  2584,   727,  2584,  1568,   139,
       0,   671,     0,   839,  2620,   150,     0,     0,     0,     0,
       0,     0,   142,     0,     0,     0,     0,     0,     0,     0,
     657,   668,  1604,  1602,     0,  1235,   248,   247,  1233,   937,
    2584,  1160,   145,     0,     0,  2584,  1507,  2584,   145,   954,
     938,     0,   924,  2584,   145,  1124,  2584,  2445,   183,     0,
     922,  2503,  2565,  2584,   145,  1228,     0,  2584,   145,  2584,
     179,  2584,   145,  2584,   145,  2584,   672,     0,     0,  2584,
     145,  2584,  2620,   181,   941,  2584,   145,   948,  2584,   145,
    2415,  2584,     0,  1459,     0,  1596,     0,  1576,  2847,     0,
    1725,     0,     0,  1015,  1014,     0,  1015,     0,  1015,     0,
    1015,     0,  1015,     0,     0,     0,  1015,  2438,  2439,   997,
       0,  1021,     0,  1029,     0,  1028,  1027,  1026,     0,     0,
       0,  1030,     0,  1859,  1632,     0,  1440,   250,   201,     0,
     262,   261,  1455,     0,     0,     0,   142,     0,  1257,  1254,
     142,  1256,  1255,   142,   142,  1451,   254,   252,     0,     0,
       0,     0,     0,     0,  1457,     0,  1449,     0,     0,     0,
    2423,  2425,  2426,  2261,  2331,     0,  2798,  2799,  2800,  2320,
       0,  2801,  2802,  2803,  2862,  2135,  2121,  2130,  2136,  2122,
    2124,  2131,  2804,  2805,  2070,  2806,  2807,  2433,  2808,  2809,
    2810,  2812,  2813,  2814,  2815,  2816,  2817,  2818,  2819,  2820,
    2821,  2822,  2823,  2825,  2826,  2126,  2128,  2827,  2828,  2829,
    2831,     0,  2434,  2832,  2833,  2653,  2835,  2836,  2838,  2839,
    2132,  2841,  2842,  2133,  2843,  2844,  2845,  2846,  2432,   513,
    2134,  2848,  2850,  2851,  2852,  2853,  2855,  2856,  2857,  2858,
       0,     0,     0,  2410,     0,  2099,     0,  1936,  1937,  1960,
    1961,  1938,  1966,  1967,  1939,     0,  1940,  2409,  2003,  2206,
    2098,  2116,     0,  2104,  2105,     0,  2097,  2093,  2208,  1727,
    2405,     0,  2094,  2422,  2424,  2321,  1727,  2403,   215,   269,
       0,   270,  2411,  2726,   203,   245,   217,   244,   218,   216,
       0,  2501,   204,     0,     0,   205,     0,     0,     0,     0,
     266,   264,     0,  1447,     0,  1857,  1856,  2414,   959,     0,
    1565,  1562,  2271,     0,  1711,     0,     0,     0,  1976,  1963,
    1971,  1970,     0,  1953,  1952,  1951,     0,  1950,  1977,  1977,
    1975,  1954,  1927,     0,     0,     0,  1981,     0,  1979,  1923,
    1919,     0,  1988,  1989,  1990,  1987,  2000,  1986,     0,  1933,
    1991,     0,  1944,  1941,  1812,     0,  1691,  1690,     8,     0,
    1570,  1572,  1546,  1568,  1739,  1740,     0,     0,     0,     0,
       0,     0,     0,     0,  1799,  1757,  1758,  1760,  1796,  1800,
    1808,     0,  1697,     0,     0,     0,  1861,  1647,     0,  1473,
       0,     0,     0,     0,     0,  1159,     0,     0,     0,     0,
     951,     0,     0,     0,  1493,     0,  1495,  1496,  1497,     0,
       0,     0,     0,  1498,  1499,  1487,   258,  1506,  1503,  1486,
    1488,  1501,     0,     0,     0,     0,     0,     0,     0,  1518,
       0,   187,   188,     0,   684,   668,     0,  2584,     0,     0,
       0,     0,  1169,  1176,  1327,     0,     0,     0,     0,     0,
       0,     0,     0,  1170,  1168,     0,  1171,   260,  1181,  1208,
    1211,     0,     0,  1126,  1129,     0,     0,     0,     0,     0,
    1318,     0,     0,     0,  1318,     0,     0,     0,  1327,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   285,   287,
     300,   366,     0,   649,     0,     0,     0,   652,     0,  2584,
    1328,     0,     0,     0,  1230,     0,     0,     0,     0,     0,
       0,     0,     0,  1211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   148,   149,   154,     0,     0,     0,     0,
    1211,     0,     0,     0,     0,     0,     0,     0,   635,   648,
       0,     0,     0,     0,     0,   645,     0,     0,   150,   290,
     625,   631,     0,     0,     0,   734,   733,     0,     0,     0,
       0,     0,     0,  1416,     0,  1415,     0,     0,     0,     0,
       0,  1516,  1515,     0,     0,     0,     0,     0,  1318,     0,
     279,   281,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   403,   404,     0,
       0,     0,   154,     0,     0,  1318,     0,   292,     0,     0,
    1467,  1464,  1465,     0,  1470,     0,     0,     0,     0,  2107,
       0,  2275,  1749,  2273,  1144,  2327,     0,  2463,  2883,  2884,
    2885,  2886,  2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,
    2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,
    2905,  2906,  2907,  2908,  2909,  2910,  2911,  2912,  2913,  2914,
    2915,  2916,  2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,
    2925,  2926,  2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,
    2935,  2936,  2937,  2938,  2939,  2940,  2941,  2942,  2943,  2944,
    2945,  2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,
    2955,  2956,  2957,  2958,  2959,  2960,  2324,  2323,  2418,  2464,
    2465,  2466,  2467,  2330,  1538,     0,   234,   235,   233,  1556,
     236,  1557,  1552,     0,  1539,     0,     0,     0,     0,     0,
       0,     0,     0,  2503,  2565,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   847,  1487,  1525,     0,     0,     0,   677,     0,  2584,
       0,   152,   886,     0,   837,   470,     0,     0,     0,     0,
    1392,   152,     0,     0,   190,     0,     0,   731,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   838,     0,
       0,   152,     0,  2584,   628,  2584,     0,   550,   550,     0,
       0,   141,   138,     0,     0,     0,     0,     0,     0,     0,
       0,  1683,  1682,  1685,  1684,     0,  1681,     0,   143,   144,
       0,  1218,  1243,     0,     0,     0,     0,     0,   915,   940,
       0,     0,  1212,     0,     0,  2584,   145,  2584,     0,  2584,
       0,     0,     0,  1220,   145,     0,  1214,     0,     0,  1216,
       0,  1418,     0,   931,   929,   928,   930,     0,     0,   913,
       0,     0,     0,     0,     0,   908,     0,     0,   910,     0,
       0,     0,     0,  1725,  1575,     0,     0,     0,  1005,     0,
    1009,     0,  1000,     0,  1006,     0,  1001,   998,   999,     0,
    1004,     0,     0,   551,   553,     0,     0,  2528,  2545,     0,
    2573,  2608,  2609,  2663,  2680,  2710,  2716,  2722,     0,  2753,
    2765,     0,  1035,  1073,  1025,   743,     0,     0,  1642,  1441,
    2280,     0,  1725,     0,     0,  1258,     0,     0,   138,   253,
     224,     0,     0,  1073,     0,  2714,  1454,   990,   668,     0,
    2095,     0,  2102,  2103,  2319,     0,     0,     0,     0,     0,
       0,  2101,     0,     0,     0,     0,  2376,     0,     0,  2376,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2026,     0,     0,  2279,     0,     0,  2279,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2027,
    2008,  2009,  2099,  2271,     0,  2100,  2429,     0,  1999,  2468,
    2261,     0,  2258,  2259,  2260,  2961,  2962,  2963,  2964,  2965,
    2966,  2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,
    2976,  2977,     0,  2978,  2979,  2980,  2981,  2982,  2984,  2983,
    2985,  2986,  2987,  2988,  2989,  2990,  2334,  2992,  2993,  2994,
    2995,  2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,
    3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
    3015,  3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,
    3025,  3026,  3027,  3028,  3029,  3030,  3031,  3032,  3033,  3034,
    3035,  3036,  3037,  3038,  3039,  3040,  3041,  3042,  3043,  3044,
    3045,  3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,  3054,
    3055,  3056,  3057,  3058,  3059,  3060,  3061,  3062,  3063,  3064,
    3065,  3066,  3067,  3068,  3069,  3070,  3071,  3072,  3073,  3074,
    3075,  3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,
    3085,  3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,  3094,
    3095,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,  3104,
    3105,  3106,  3107,  3108,  3109,  3110,  3111,  3112,  3113,  3114,
    3115,  3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,  3124,
    3125,  3126,  3127,  3128,  3129,  3130,  3131,  3132,  3133,  3134,
    3135,  3136,  3137,  3138,  3139,  3140,  3141,  3142,  3143,  3144,
    3145,  3146,  3147,  3148,  2041,  3149,  3150,  3151,  3152,  3153,
    3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
    3184,  3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,  3193,
    3194,  3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,  3203,
    3204,  3205,  3206,  3207,  3208,  3209,  3210,  3211,  3212,  3213,
    3214,  2043,  3215,  3216,  3217,  3218,  3219,  3220,  3221,  3222,
    3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,
    3243,  3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,
    3255,  3253,  3254,  3256,  3257,  3258,  3259,  3260,  3261,  3262,
    3263,  3264,  3265,  3266,  3267,  3268,  3269,  3270,  3271,  3272,
    3273,  3274,  3275,  3276,  3277,  3278,  3279,  3280,  3281,  3282,
    3283,  3284,  3285,  3286,  3287,  3288,  3289,  3290,  3291,  3292,
    3293,  3294,  3295,  3296,  3297,  3298,  3299,  3300,  3301,  3302,
    3303,  3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,  3312,
    3314,  3313,  3315,  3316,  3317,  3318,  3319,  3320,  3321,  3322,
    3323,  3324,  3325,  3326,  3327,  3328,  3329,  3330,  3331,  3332,
    3333,  3334,  3335,  3336,  3337,  3338,  3339,  3340,  3341,  3342,
    3343,  3344,  3345,  3346,  3347,  3348,  3349,  3350,  3351,  3352,
    3353,  3354,  3355,  3356,  3357,  3358,  3359,  3360,  3361,  3362,
    3363,  3364,  3365,  3366,  3367,  3368,  3369,  3371,  3370,  3372,
    3373,  3374,  3375,  3376,  3377,  3378,  3379,  3380,  3381,  3382,
    3383,  3384,  3385,  3386,  3387,  3388,  3389,  3390,  3391,  3392,
    3393,  3394,  3395,  3396,  3397,  3398,  3399,  3400,  3401,  3402,
    3403,  3404,  3405,  3406,  3407,  3408,  3409,  3410,  3411,  3412,
       0,  2255,  2256,  2257,  2249,  2250,  2251,  2252,  2253,  2254,
    2265,     0,     0,  2408,  2469,     0,  2208,     0,  2023,     0,
    2216,     0,     0,  1812,     0,  2427,  2322,  1812,   271,   272,
     268,     0,     0,   220,   219,     0,   238,   242,   243,   214,
     241,     0,   237,   222,  2192,  2191,   221,   213,   210,   208,
     225,   227,   228,   211,   209,   265,     0,     0,     0,   145,
    1573,  1560,     0,     0,  2334,     0,  2269,     0,     0,  2267,
       0,     0,     0,  1809,     0,  1713,     0,  1717,     0,     0,
       0,  1974,  1973,  1924,  1920,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   952,     0,
    1942,     0,  1877,  2451,  2452,  2332,  1745,  1573,     0,  1569,
    1708,  1707,  1750,  1751,  1110,  1706,  1779,  1780,     0,     0,
       0,     0,  1805,  1803,  1770,  1761,  1769,     0,     0,  1767,
       0,  1771,  2003,  1798,  1695,  1755,  1756,  1759,  1694,     0,
    1801,     0,  1645,  1799,  1760,  1629,  1606,  1607,     0,     0,
    1862,     0,  1474,     0,     0,     0,  1139,  1141,     0,  1140,
       0,  1143,     0,  1152,     0,     0,  1138,  1157,     0,  1146,
    1144,     0,  1514,     0,     0,     0,     0,     0,  1494,     0,
       0,     0,  2753,   257,  1497,  1502,  1489,  1500,     0,     0,
       0,     0,     0,  1075,  1074,     0,     0,     0,  1521,   544,
       0,   368,     0,     0,     0,     0,     0,     0,     0,     0,
     833,   830,     0,     0,   829,     0,   682,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   707,     0,
    1318,     0,   298,     0,  1178,     0,  1177,     0,  1182,     0,
       0,  1179,  1174,  1175,  2716,  2726,  2760,   259,  1180,  1210,
       0,  1209,  1205,     0,  1121,     0,  1122,     0,     0,     0,
       0,     0,     0,     0,  2557,     0,  2584,     0,   513,   306,
     330,   535,     0,  1317,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   352,
       0,     0,   355,   354,     0,     0,     0,     0,     0,   360,
       0,   338,     0,   339,     0,   359,     0,     0,     0,   650,
     651,     0,     0,     0,  1318,     0,   294,     0,     0,     0,
       0,     0,     0,     0,     0,  1227,     0,   760,     0,     0,
    2716,  1206,     0,  1401,     0,  2752,  1402,  1405,   550,     0,
     550,  1407,     0,     0,  1404,  1406,     0,     0,   176,     0,
     171,   175,     0,     0,  2716,  1207,     0,     0,     0,     0,
       0,   633,   634,   647,     0,   638,   639,   636,   640,   641,
       0,     0,     0,     0,     0,     0,     0,   632,     0,     0,
     729,   728,   732,     0,     0,     0,     0,     0,     0,  1410,
       0,     0,  1201,     0,     0,  1409,  1417,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1261,  1260,     0,
       0,     0,     0,  1328,     0,   876,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   178,   747,     0,   746,
       0,   172,   177,     0,     0,     0,     0,     0,     0,     0,
       0,   232,  1463,  1469,  1749,  1749,  1749,  2113,     0,     0,
       0,     0,  1748,  2325,  2328,  1543,  1549,  1542,  1541,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   414,   415,   417,
       0,     0,     0,     0,   849,     0,   852,   855,  1485,   497,
       0,     0,   674,   707,     0,     0,   473,   185,     0,     0,
       0,     0,   762,     0,  1201,  1200,   147,   138,   194,   471,
       0,   193,   195,   197,   198,   199,   196,   200,     0,   726,
     730,     0,     0,     0,     0,   670,     0,     0,     0,     0,
       0,     0,     0,  1882,     0,     0,   170,     0,     0,   623,
     627,     0,     0,     0,     0,   473,   589,   379,  2584,     0,
     550,     0,  2584,     0,   137,     0,   836,     0,     0,     0,
    1163,  1163,     0,     0,   776,   775,     0,     0,     0,     0,
       0,     0,  1680,   145,  1161,     0,  1508,     0,   145,   955,
     145,  1125,   184,  2446,     0,   917,     0,     0,     0,     0,
     145,  1229,   905,   145,   180,   145,   145,   673,     0,   145,
     182,     0,     0,   145,   949,   145,  2416,     0,   145,  1599,
    2584,   550,  1577,     0,     0,  1002,  1011,  1010,  1008,  1007,
    1003,     0,  1022,     0,   549,     0,     0,     0,     0,     0,
    1043,  1044,     0,     0,  1040,  1045,     0,  1047,  1031,  1033,
    1041,  1042,  1048,  1037,  1036,  1049,  1050,     0,     0,     0,
    1062,   741,     0,     0,     0,     0,  1639,     0,  1637,     0,
    1860,  1641,  1630,  1589,     0,  1588,     0,   616,  1252,  1251,
    1253,     0,  1019,     0,   145,     0,  1453,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2284,     0,
    2285,     0,     0,  2318,  2314,     0,     0,     0,     0,     0,
    2288,  2291,  2292,  2293,  2290,  2294,  2289,     0,     0,  2295,
       0,     0,  2369,  2386,     0,  2099,  2369,  2397,     0,  2396,
    2402,     0,  2275,  2003,     0,     0,  2393,  2387,     0,  2393,
       0,     0,  2376,     0,     0,     0,     0,  2176,     0,     0,
       0,  2275,  2278,     0,     0,  2839,     0,     0,     0,     0,
    2071,     0,     0,  2242,     0,  2275,     0,     0,     0,     0,
       0,     0,     0,  2271,  2310,     0,   511,     0,  2061,     0,
       0,     0,  2190,     0,  2187,     0,     0,     0,     0,  2331,
       0,     0,  2430,  2004,  2019,  2020,  2021,  2024,  2407,  2007,
       0,  2333,     0,     0,  2005,  2032,     0,  2311,  2057,     0,
    2062,  2047,  2377,  2296,  2297,  2298,  2299,  2064,     0,  2040,
    2045,  2049,     0,  2386,  2028,     0,  2025,     0,  2334,  2270,
       0,  2268,     0,  2016,  2017,  2018,  2010,  2011,  2012,  2013,
    2014,  2015,  2022,  2246,  2244,  2245,     0,     0,  2216,     0,
       0,  2044,     0,     0,  2115,  2576,  2615,     0,  1738,  1738,
    1738,  1726,  1736,  2406,  1877,  1749,  1877,  2412,     0,     0,
    1999,     0,  1858,   957,   958,   956,  1545,  1559,  1573,  2272,
    1567,  1715,     0,     0,     0,  1943,  1956,     0,  1983,  1984,
    1985,  1985,     0,  1925,     0,  1968,  1993,  1994,  1995,  1996,
    1997,  1998,     0,  1992,  1934,   953,  2815,  2824,     0,  2712,
    2859,     0,  1838,  1811,  1813,  1823,  1838,  1845,  1838,  1838,
    2117,  1875,  2118,  2119,  2413,     0,  1782,  2448,  1547,  1571,
       0,  1108,  1109,     0,  1113,  2839,  2712,     0,     0,     0,
       0,  1772,  1806,     0,  1797,     0,  2423,  1773,  2422,  1774,
    1777,  1778,  1768,  1807,  1643,     0,  1802,  1699,  1698,     0,
    1880,     0,     0,  1863,  1810,  1368,  1262,  1329,  1142,     0,
    1944,  1153,     0,  1137,     0,  1136,  1944,     0,  1154,     0,
    1944,  1369,  1263,  1330,  1370,  1264,  1331,  1371,  1505,  1265,
    1504,  1492,  1491,  1490,     0,     0,     0,     0,     0,     0,
       0,     0,   814,  2584,   145,  1519,  1372,     0,  1266,   367,
    1520,  1332,  1524,   832,   831,     0,     0,  1333,     0,   683,
     688,     0,   690,   691,  2503,  2565,   692,   695,   696,     0,
     698,   687,   686,     0,     0,     0,     0,     0,   704,   709,
       0,     0,     0,     0,     0,     0,  1172,  1173,  1373,  1269,
       0,  1334,     0,  1120,     0,  1270,   186,     0,     0,   286,
       0,  2584,   308,     0,     0,     0,     0,     0,     0,     0,
       0,   814,   495,   814,     0,  1320,   305,   336,     0,   351,
     346,   347,   345,  2584,   145,  2584,   145,     0,     0,     0,
       0,     0,   348,   343,   344,   340,     0,     0,   353,  2475,
    2547,  2727,     0,   715,   717,     0,   722,   356,  1290,   375,
     374,   373,     0,   361,     0,   380,   383,     0,   358,   337,
     335,   332,   301,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1222,     0,  1376,  1335,     0,  1357,
    1361,     0,     0,     0,   754,  1379,  1276,  1338,     0,   550,
       0,     0,   565,   565,   550,  1390,  1277,   174,  1307,   163,
       0,     0,   159,     0,     0,     0,     0,   153,  1380,  1278,
    1339,     0,     0,  1381,  1279,     0,     0,   291,   626,   637,
     642,  1284,   646,   643,  1347,   644,  1388,  1280,     0,  1384,
    1310,  1342,   393,   609,   392,  1201,  1201,  1391,  1411,  1281,
    1201,     0,  1318,     0,   280,   282,     0,   142,     0,  1282,
       0,  1340,  1383,  1309,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1527,     0,     0,     0,     0,     0,     0,
     145,     0,     0,     0,  1320,  2584,   145,   874,  1382,     0,
    1315,     0,  1355,     0,     0,     0,   405,     0,  1308,  1318,
       0,   293,  1286,     0,  1349,     0,     0,   230,   229,   231,
       0,     0,     0,     0,  2276,  2277,     0,  2274,  2108,  2327,
       0,  1537,   979,   965,   978,     0,   961,  2545,     0,   964,
     966,     0,     0,     0,   967,   971,   972,     0,   963,   960,
     962,     0,   416,     0,     0,   771,   772,     0,     0,     0,
       0,   851,     0,     0,  1517,     0,   150,   681,     0,     0,
       0,   676,   706,   711,     0,     0,     0,     0,   472,   476,
     480,   481,   482,     0,     0,     0,     0,   164,   151,     0,
     894,     0,   550,     0,   764,  1201,  1394,     0,   194,   189,
       0,     0,   727,     0,  1568,     0,     0,   604,   607,   606,
       0,   379,   846,   844,   843,   845,   867,   842,     0,  1881,
    1883,     0,     0,     0,     0,     0,     0,   616,   475,     0,
       0,   553,     0,   592,     0,     0,     0,     0,   589,     0,
       0,     0,  2456,     0,   863,   835,     0,  1131,     0,  1149,
    1132,     0,     0,     0,     0,  1186,  1193,  1162,  1187,  1164,
    1193,     0,     0,   777,   781,   780,   784,   782,     0,   778,
     655,  1686,  1687,     0,  1219,     0,     0,  1513,     0,  1511,
     916,  1213,   145,     0,   145,     0,   145,  1221,  1215,  1217,
    1419,     0,   914,     0,     0,   907,   909,     0,   911,     0,
       0,     0,     0,  1621,  1609,     0,  1812,  1648,     0,  2331,
    1023,   552,     0,     0,     0,     0,     0,     0,  1039,   653,
    1046,     0,     0,     0,  1061,  1056,  1058,     0,  1073,  1067,
       0,   740,     0,     0,  1640,  1633,  1635,  1634,     0,     0,
    1631,  2281,   906,     0,   622,     0,  1073,  1064,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1743,
    2282,  2283,     0,     0,     0,  2315,     0,     0,  2152,     0,
    2123,  2125,  2138,     0,  2153,  2106,     0,  2368,  2365,     0,
       0,     0,  2369,  2376,  2172,     0,     0,     0,  2376,     0,
    2396,     0,     0,     0,  2167,  2169,     0,     0,     0,  2386,
    2386,     0,  2174,     0,     0,  2154,  2127,  2129,  2139,     0,
       0,  2262,     0,  2142,  2141,     0,  2073,  2074,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2088,  2143,  2241,     0,
       0,     0,  2145,  2144,     0,     0,  2309,     0,     0,     0,
    2150,   512,  2155,     0,     0,     0,     0,  2161,     0,  2198,
       0,     0,     0,  2096,  2272,     0,     0,     0,     0,     0,
       0,     0,  2379,  2380,  2381,  2378,     0,  2063,  2048,  2066,
    2042,  2046,  2050,     0,  2386,  2065,  2068,     0,     0,  2036,
       0,     0,  2034,  2058,  2030,     0,     0,  2059,     0,  2114,
       0,     0,     0,  2219,  2214,  2215,  1738,  1738,  1738,  1738,
    1735,     0,     0,     0,  1782,     0,  1782,   206,     0,   239,
     226,  1544,  1716,  1725,  1962,     0,  1980,  1978,  1921,  1926,
    2001,     0,  1838,  1845,  1838,  1838,     0,     0,  1701,     0,
    1823,     0,  1837,  1821,  1836,     0,     0,  1851,  1849,     0,
    1851,     0,  1851,     0,  1815,     0,  1841,  1817,  1836,  1819,
    1825,     0,  1867,  2414,  1876,     0,  1795,  1752,     0,  2263,
    1113,     0,  1754,  1776,  1775,     0,  1765,     0,  1804,  1762,
    1644,  1628,     0,  1626,  1608,     0,     0,  1944,  1134,  1135,
       0,  1158,     0,  1078,  1079,     0,  1077,     0,     0,     0,
     543,   546,     0,  1522,     0,  1389,  1306,   685,     0,     0,
       0,     0,   700,   659,   701,   703,     0,     0,   702,   705,
     708,  1318,     0,   299,  1292,     0,  1353,  1166,     0,     0,
    1123,     0,     0,     0,     0,     0,  1094,   534,  1093,     0,
       0,     0,     0,   814,     0,     0,   538,     0,   494,   491,
     331,     0,     0,     0,     0,   388,     0,   310,   323,   386,
     329,     0,   363,     0,   334,     0,   327,   349,   341,   350,
     342,   362,   364,     0,   719,   720,   718,   714,     0,   721,
     723,     0,   377,     0,     0,     0,   395,   357,   394,     0,
    1375,     0,  1318,     0,   295,  1288,     0,  1351,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1356,     0,     0,     0,     0,   759,     0,   756,     0,   565,
       0,  1403,     0,  1400,  1398,   565,     0,     0,   156,   155,
       0,   162,     0,     0,     0,     0,     0,     0,  1412,  1413,
    1414,     0,     0,     0,     0,     0,     0,   399,     0,   302,
     304,   303,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   406,
     370,     0,   870,     0,     0,     0,   408,     0,     0,  1367,
       0,     0,     0,     0,     0,  1374,  1271,  2111,  2112,  2109,
    1749,  2326,     0,     0,     0,   976,     0,     0,     0,     0,
     419,   420,   150,   418,   443,     0,   814,     0,     0,   848,
     853,   861,  2653,  2249,  2250,   859,   854,   856,   858,   860,
     857,     0,     0,     0,     0,   516,     0,     0,     0,   503,
       0,     0,   513,   496,   499,   500,     0,     0,   677,   680,
     678,   679,     0,   699,     0,   475,   523,   579,     0,   166,
       0,     0,   167,   165,     0,     0,   379,   761,     0,   758,
    1393,     0,   192,     0,   731,     0,     0,     0,     0,     0,
    1201,   669,     0,   866,   868,   840,     0,   711,     0,     0,
     628,     0,   550,  1600,   611,     0,   581,   475,   579,   588,
       0,     0,   596,   378,     0,     0,   616,   379,     0,     0,
    1094,     0,   862,     0,     0,  1130,     0,     0,     0,  1183,
    1188,  1184,     0,  1163,  1145,     0,  1185,     0,     0,  1191,
    1116,  1165,  1117,  1435,  1436,  1433,  1434,     0,     0,     0,
       0,     0,     0,  1677,     0,     0,  1509,     0,   918,     0,
     901,     0,   903,   145,   748,     0,   145,     0,  1613,  1615,
    1614,     0,     0,  1616,  2331,     0,  1626,  1653,     0,     0,
    1880,     0,  1652,     0,     0,     0,     0,     0,  1038,     0,
    1032,  1034,  1059,     0,     0,  1073,  1072,     0,  1063,  1071,
    1069,  1070,  1068,     0,     0,  1638,  1636,   614,     0,     0,
     145,  1073,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2286,     0,  2317,  2313,     0,  2120,  2287,  2367,
    2383,  2385,  2173,  2375,     0,     0,     0,  2398,     0,     0,
    2376,  2336,  2390,  2389,     0,     0,  2388,  2376,  2376,  2336,
    2175,  2336,     0,     0,     0,  2242,     0,     0,  2072,  2084,
    2085,  2086,  2302,     0,  2091,     0,  2081,  2082,  2083,  2075,
    2076,  2077,  2078,  2079,  2080,  2087,  2306,  2305,     0,     0,
    2147,  2148,  2149,  2308,  2156,     0,  2493,  2199,     0,  2160,
    2189,  2188,     0,     0,     0,  2163,     0,     0,  2185,     0,
    2243,  2431,  2006,     0,     0,  2033,  2312,  2051,     0,  2067,
    2069,  2029,  2262,     0,     0,     0,     0,     0,  2038,     0,
       0,  2239,     0,     0,     0,  2221,  2218,     0,     0,     0,
       0,  1729,  1728,  1734,  1795,  2108,  1795,     0,     0,  1922,
       0,  1822,  1818,  1820,  1826,     0,  2854,     0,  1827,  1834,
       0,  1814,     0,  1850,  1846,     0,  1847,     0,     0,  1848,
       0,     0,  1816,     0,  1834,     0,  1874,  1741,     0,  2210,
       0,  1753,  1111,  1112,  1763,     0,  1766,  2524,  1878,     0,
    1627,     0,  1155,     0,     0,  1147,  1084,  1085,  1088,  1086,
    1083,  1087,     0,     0,     0,   814,   817,     0,     0,     0,
     815,   145,  1267,     0,     0,     0,     0,   660,  1387,  1268,
       0,     0,     0,     0,  1167,  1321,     0,     0,  1291,   814,
       0,     0,     0,   560,     0,  1107,  1107,     0,   307,     0,
     540,   601,     0,   493,   492,     0,   490,   711,     0,     0,
     314,   324,     0,   319,     0,  1319,     0,     0,     0,     0,
     318,   321,   320,   390,     0,   387,     0,   145,   145,   365,
     716,   376,   381,   382,   385,  1326,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   895,
     878,     0,     0,   896,   897,     0,     0,     0,  1224,  1225,
    1223,  1358,  1359,  1365,  1362,  1360,  1364,  1366,  1363,     0,
    1274,     0,     0,   752,  1322,  1395,  1397,  1396,     0,  1399,
     160,   157,   158,   161,  1323,  1304,  1285,  1348,   610,     0,
       0,     0,  1283,     0,  1341,     0,  1300,  1294,     0,     0,
       0,     0,     0,  1386,  1314,  1346,  1385,  1312,  1344,  1311,
    1343,  1313,  1345,  1305,     0,     0,  1885,   875,     0,     0,
       0,   145,   145,   873,   750,  1287,     0,  1350,  1296,     0,
       0,     0,   968,     0,     0,     0,   970,   424,   444,   150,
       0,   770,   834,     0,     0,   850,     0,   501,     0,   507,
     514,     0,     0,   518,   519,   517,   502,  1201,   550,  1201,
     803,   804,     0,     0,   824,     0,   675,     0,     0,   473,
       0,   520,     0,     0,   477,   169,   168,     0,     0,     0,
     765,   769,   767,   766,   768,   763,     0,   754,   194,  2584,
       0,     0,     0,     0,   608,   602,   605,  1408,   841,     0,
    1884,   744,     0,   379,   624,     0,     0,     0,   473,   616,
       0,   478,   483,   484,   497,     0,   589,   580,     0,   581,
     590,   591,     0,   598,  1483,     0,   617,   598,     0,     0,
       0,   865,     0,   864,     0,  1133,  1150,  1151,     0,     0,
    1193,     0,     0,  1195,  1190,     0,     0,   783,   786,   779,
     662,   145,     0,  1512,   145,   145,  1250,     0,   912,     0,
       0,     0,  1618,  1624,  1605,     0,     0,  1649,  1626,  1650,
    1053,  1054,  1055,  1052,  1051,   654,     0,  1057,  1016,  1066,
     742,     0,   615,     0,  1017,   145,   993,   985,   992,   981,
     984,   986,     0,   988,   989,   983,   980,   982,  2316,  2137,
       0,  2382,  2384,  2171,  2395,  2394,  2170,  2401,     0,     0,
    2364,  2392,  2391,     0,     0,  2376,  2376,  2140,  2151,     0,
    2241,  2272,     0,     0,  2092,     0,     0,     0,  2146,  2849,
       0,     0,  2203,  2204,     0,  2200,  2201,  2196,  2197,  2162,
       0,  2641,  2180,     0,     0,  2195,  2055,  2053,  2052,  2037,
       0,     0,  2035,  2031,     0,  2060,  2205,  2238,  2272,  2207,
       0,  1749,  1733,  1732,  1731,  1730,  2210,  2428,  2210,   240,
    1720,     0,  1870,     0,  1873,     0,     0,  1824,     0,     0,
    1828,     0,     0,  1830,  1832,     0,     0,     0,     0,     0,
       0,  2417,     0,  1794,     0,  1749,     0,  1764,     0,  1625,
       0,  1148,  1156,     0,     0,     0,   545,   819,   818,   821,
     816,   820,  1523,     0,   693,   694,   697,  1293,     0,  1354,
    1302,     0,  1642,   536,   309,     0,   555,     0,     0,     0,
    1100,   140,  1099,     0,   555,   555,   489,   488,   497,   317,
       0,     0,     0,   311,   389,     0,   391,   312,   316,   370,
     333,   326,     0,     0,     0,  1289,     0,  1352,  1298,  1325,
    1377,  1272,  1336,     0,     0,   884,     0,     0,     0,     0,
    1378,  1273,  1337,     0,     0,     0,     0,     0,  1642,     0,
       0,     0,     0,     0,     0,     0,     0,  1532,     0,     0,
     369,   872,   871,   370,   407,  1316,     0,  2110,     0,   969,
     974,   975,   973,     0,   413,   421,   424,     0,     0,  1241,
    1241,     0,     0,   498,   515,     0,   600,   559,   600,     0,
       0,     0,     0,     0,   712,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   757,   756,   191,     0,   473,
       0,   711,     0,   869,     0,     0,     0,   616,   475,     0,
       0,  1597,   474,     0,     0,   486,     0,   592,   581,   589,
       0,     0,   613,     0,  1476,     0,   619,     0,     0,     0,
     813,  1189,     0,  1203,     0,  1144,  1114,  1198,     0,  1725,
    1877,     0,     0,     0,     0,   796,     0,   666,  1242,  1510,
     902,   904,   749,  1610,     0,  1611,  1617,     0,     0,     0,
       0,  1654,  1646,  1060,     0,  1073,  1065,   987,  2366,  2400,
    2335,  2337,     0,     0,  2358,  2351,  2354,  2352,  2353,  2355,
       0,  2350,     0,  2168,  2399,  2348,  2362,  2301,  2243,  2089,
       0,  2304,  2303,  2307,     0,  2157,     0,  2158,  2202,  2164,
    2181,     0,  2165,  2193,     0,     0,  2056,  2054,  2039,  2240,
       0,  2225,  1703,  1702,     0,  1723,  1906,  1875,     0,     0,
    1869,     0,     0,  1900,     0,     0,     0,  1835,  1853,     0,
    1831,  1829,     0,  1842,     0,  1844,  2523,  2810,  2709,     0,
    1781,  1783,  1786,  1788,  1787,  1789,  1785,  2209,  2211,     0,
    1760,  2264,  1879,     0,  1626,  1656,  1668,  1668,  1061,     0,
     145,   689,     0,     0,   288,  1107,     0,  1201,   561,  2653,
     562,  1106,  1110,   139,     0,  1201,  1201,   485,     0,   315,
     325,     0,   372,   384,     0,  1642,     0,     0,   882,   891,
     891,   879,     0,     0,   898,  1275,   753,     0,   564,     0,
     283,  1301,  1295,     0,     0,     0,  1534,  1535,     0,     0,
       0,     0,     0,  1324,   145,  1297,   977,     0,   446,   454,
     425,   429,  1526,     0,  1526,     0,   426,   430,  1526,  1526,
     423,  1877,   442,  1241,     0,  1238,  1237,   548,   630,     0,
       0,   505,     0,   570,   504,     0,   825,     0,     0,   710,
       0,   475,   579,     0,   533,   524,   525,   526,   527,   529,
     528,   530,   531,   532,   522,   521,     0,   711,   888,   379,
    1483,   751,     0,     0,   724,     0,   711,     0,  1600,   612,
     581,   475,   579,   479,   497,     0,   596,   589,   592,     0,
     593,     0,   597,     0,     0,     0,   616,  1536,  1094,     0,
    1095,     0,   814,  1202,  1163,     0,     0,  1192,  1196,  1197,
       0,     0,     0,     0,  1245,   790,   791,   785,   787,     0,
     798,   802,   661,     0,     0,   665,   656,     0,     0,     0,
       0,  1651,   711,   145,     0,     0,  2349,  2356,  2357,     0,
    2178,     0,     0,  2374,     0,     0,     0,  2090,     0,     0,
    2183,  2182,  2194,  2166,  2220,     0,     0,     0,     0,     0,
       0,     0,  1714,     0,  2336,  1868,  1871,     0,  1903,     0,
       0,     0,     0,  1888,     0,  1833,     0,     0,  1843,     0,
       0,     0,  1790,     0,     0,     0,  1799,  1663,     0,  1655,
    1657,     0,     0,     0,  1080,     0,  1081,  1303,     0,  1101,
       0,   600,     0,  1113,  1110,   550,   600,   600,   630,     0,
       0,   328,     0,   296,  1299,     0,     0,   893,   893,     0,
       0,     0,     0,     0,     0,   401,     0,     0,  1528,     0,
    1529,  1530,  1533,   409,   422,     0,   452,   451,     0,   449,
     448,   450,     0,   439,     0,     0,     0,     0,     0,     0,
     412,  1236,  1240,  1239,     0,   506,     0,   508,     0,     0,
     556,   557,   558,     0,   510,   566,   567,   822,     0,   827,
       0,   713,     0,     0,   711,   578,   735,     0,     0,     0,
    1477,     0,     0,   603,   745,  1483,   616,   589,     0,   581,
     487,     0,   598,   592,   596,   594,   595,     0,  1480,     0,
     618,     0,  1103,     0,   812,     0,  1193,  1204,  1199,  1194,
    1439,     0,     0,   788,   793,   792,  1526,   797,     0,     0,
       0,   664,   663,     0,  1623,  1877,  1620,     0,   739,  1018,
    2338,  2339,  2363,     0,     0,     0,  2342,     0,  2340,     0,
       0,  2362,     0,  2179,  2300,  2186,  2159,  2184,  2797,  2524,
    2768,     0,  2237,  2226,  2237,  2237,  2217,     0,     0,     0,
    1905,     0,     0,     0,  1901,  1902,  1886,     0,     0,  1890,
    1840,  1866,     0,     0,     0,  1784,  2212,  2213,  2447,  1665,
    1667,     0,     0,     0,  1642,     0,   565,     0,  1097,  1113,
     559,   814,   814,   322,   313,   371,     0,     0,     0,   889,
     892,   880,   881,   900,   899,   755,  1642,     0,   397,   396,
       0,   400,     0,   447,   457,     0,   455,   427,   432,     0,
     438,   437,   434,   433,   428,   431,   547,     0,     0,     0,
       0,     0,     0,   568,     0,   569,     0,   826,     0,     0,
       0,   737,   887,     0,     0,   473,   711,  1478,  1598,   592,
     581,   589,     0,     0,   583,  1107,  1107,   460,   596,   598,
    1481,  1482,     0,     0,   513,  1096,     0,  1115,  1438,  1437,
    1725,     0,     0,     0,   799,   800,   795,     0,     0,  1612,
    1622,     0,  2343,     0,  2346,     0,  2347,  2341,  2371,  2373,
       0,  2359,  2360,     0,  2230,  2229,  2228,  2232,  2231,     0,
    2224,  2222,  2223,     0,     0,     0,     0,  1872,     0,  1889,
    1892,     0,     0,     0,  1898,     0,  1891,  1893,     0,  1852,
       0,  1864,  1792,     0,  1791,     0,  1670,     0,     0,  1658,
    1659,     0,     0,  1660,   145,   289,   554,   814,   563,  1098,
     570,   539,   537,  1642,   883,     0,   284,     0,   402,  1531,
     453,     0,   436,   435,   629,   509,   599,   575,     0,   574,
       0,   572,   571,   823,   828,     0,   711,   877,  1483,   725,
     596,   589,   592,     0,   582,     0,   140,   140,   598,   458,
       0,     0,   379,     0,  1421,  1725,  1420,  1422,  1430,  1427,
    1429,  1428,  1426,     0,  1248,  1249,   789,   794,     0,     0,
    1877,  2344,  2345,     0,     0,  2177,     0,     0,     0,  2234,
       0,  2235,     0,     0,     0,     0,     0,  1895,  1896,  1897,
    1899,  1894,  1839,     0,  1793,  1664,  1666,  1661,     0,  1662,
       0,     0,     0,     0,  1671,  1082,   541,   814,   297,   890,
       0,   456,   573,   550,   550,   711,   736,  1479,   598,   592,
     596,  1107,   584,   586,   585,   462,  1103,  1104,     0,   598,
     802,     0,  1431,  1425,  1701,  1688,     0,     0,   801,     0,
    1619,     0,     0,     0,  2227,  2233,  2236,     0,     0,     0,
       0,  2634,     0,  1907,     0,     0,     0,  1669,  1675,     0,
       0,     0,   542,     0,   577,   576,   738,   461,   596,   598,
     140,   513,  1102,     0,  1877,     0,  1423,  1725,     0,     0,
     807,  2370,  2372,  2361,  1719,  1718,  2815,     0,     0,  1722,
    1915,     0,  2364,     0,     0,  1918,     0,  1865,     0,     0,
       0,   398,   598,   459,   587,   379,  1105,  1089,     0,  1424,
       0,     0,   809,     0,   805,   808,   810,   811,     0,     0,
       0,     0,  1908,  1909,  1918,     0,  2348,  1918,  1887,  1672,
    1676,     0,  1673,   463,   598,     0,     0,     0,   773,     0,
    1749,     0,     0,     0,  1904,  2364,  1917,  2374,  2348,     0,
    1877,     0,     0,     0,   806,     0,     0,     0,     0,  1912,
    2362,  2374,     0,  1090,   807,  1246,  1247,     0,  1721,     0,
       0,  1910,  2362,  1674,     0,     0,  1913,  1911,   774,     0,
    1914
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5899, -5899, -5899,  4090,  -478, -1735, -5153, -1131,  1805, -5899,
   -5899,  -965,   596,  3313, -2458, -5899, -5899, -5899,  1504, -5899,
   -5899, -5899, -5899,  4051, -5899, -2964, -5899, -5899,   190,   430,
   -1403,   198,  3620,  1586, -5899, -1005, -5899, -5899,  -590,     4,
   -5899,   451,   665, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
   -5899,  -686,  2050, -5899,  2144,  1387, -3184, -5899, -5899, -1552,
   -3807, -5899,   640, -5899,   666, -4160, -5899, -4862, -1033, -5899,
   -5899, -5899,  2031, -5899, -5899, -5899,  1982,  1176,  -384, -5899,
   -5899, -5899, -5899, -5899, -5899,  -850, -5899, -5899, -1168,     6,
    -663, -2975, -4334, -5899, -5899,   488,  -426, -1506, -5899,   682,
   -5899,   683, -5899, -4882, -5899,   -18, -2777, -3246, -5899, -5899,
   -5899,  -398, -1530,  1419, -5899,  1482, -5899,  -778, -1181,  1852,
   -2495,  -994, -5899,  -290, -3607, -1142,  -865,  -863, -1018, -4410,
   -4921, -5899, -5899, -1161, -3806, -5235, -5493, -4943, -5113,  1437,
   -5899,   -36,   499, -5899,     8, -3690, -3814,    11,   474, -5899,
      14,    16, -5899,   490,  -787, -1000, -1612, -5899,  -757, -5899,
   -5899, -5899, -3472, -5899, -5899, -5899,   209, -5899, -5899, -5899,
   -5899,   536, -5899, -5899, -5899, -5899, -5899, -5899, -3244,  2013,
    2021, -5899, -4431, -5899,  -951, -5899,   700, -3522,  1423, -5899,
   -5899,  1183,  4080,   523, -5899, -5899, -5899, -5899, -5899, -5899,
   -1815, -5899, -5899, -5899, -5899,    -9,  -357, -5899, -5899, -5899,
   -5899, -5899, -5899, -5899,    18, -5899,  1144,   460, -5899, -5899,
    -675, -5899, -5899, -5899, -5899, -5899, -5899, -1217, -5219, -1350,
   -1323, -5899, -3541, -5899, -5899, -5899,  -331, -5899, -5899, -5899,
   -5899, -5899,  -808, -5899,  1243, -4199, -5899, -5899,   498, -5899,
   -5899, -5899, -5899, -5899,  -987,  -269,  3239, -5899,  -532,  -759,
   -5899, -5899, -5899,  -266, -5899, -5899, -5899, -5899, -5899,  -535,
   -1284,  5106,  4461, -1124, 14000,  -852,  -573, -5899, -5899, -5899,
   -2793, -5899, -5899, -4183, -5899,  5097,  2562,  1696,    25, -5899,
      43,   117,  3890, -5899,  1096, -1186, -3160,   444,  -486, -5899,
   -5899, -5899,   447, -5899, -1957, -5899, -5899, -5899, -5899, -4145,
      32, -5899, -4421, -5269, -4672, -4191, -1172, -5899, -4529, -5223,
   -4158, -5899,  2058, -5899, -5899,  -530,  -180,  3223, -5899, -1495,
    2405, -1402, -5899, -2624,   529,  1602,  3230, -3302,  -108,  3217,
   -3044, -5899,  -647,  1190, -5899,  -347, -3815, -5899, -5899, -5899,
   -2764,  -610, -5899, -5899,  1627,   862, -5899, -5899, -5899, -5899,
    -671,  3197,  -200, -5899, -5899,  4443, -5899, -5050, -5899,  4414,
   -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -5899, -1502,
    1359, -5899,  -847, -5899, -5899,  2161,   745, -5899, -5899, -5899,
   -5899,  1446, -1243, -5899, -5899, -5899, -5899, -5899, -5899, -5899,
    -962, -1198, -5899, -5899, -4934, -5899, -5899, -5899, -5899, -5899,
    2331,  -969,  -743,  4309,   442,    34, -5448, -5899, -5899,  -463,
   -5899,  3646, -5899, -5899, -5899, -5899, -5899,   526,   527, -5899,
   -5899, -5899, -5899, -4429, -5899, -5899, -5096, -5899, -5899,  2138,
   -5899, -5899,  1031,     3,  3346, -5899, -5899, -5899,    -5, -5899,
   -5899, -1032,  2488, -5899, -2404, -5899,  -589, -5899, -5899, -1925,
      44, -4407, -5899,  -668, -5899,  3183, -5899, -5295, -1114,     5,
   -5899, -5899, -4461,    40, -5899, -5899, -5899, -5899, -5112, -5899,
    -664, -5899, -5712,   514, -3845, -5899,    42, -5899,  -427, -5899,
   -5899,  -429, -5899, -5899, -5899, -5898,    46,   103, -5899, -5899,
     107,   669,   -50,   -42,   -30,    61,   180,  3754, -5899, -5899,
   -5899,     2,  3794, -5899,    38,  -878,  5151,  5152, -5899,  -901,
    -134,   465,  1697,  -687, -2645,  3700,  3703, -5899,  1684,  2507,
   -2475, -2467, -5899,  -907,  -833,  -642, -5899, -5899, -5899, -5899,
   -1485,  -677, -2648, -5899,  3710, -5899, -5899, -5899, -2435, -3421,
   -3333,  1721, -3342, -3219, -5899,   961,   946,  -918,   -97,    70,
   -1498,  -795,  -829, -5899, -5899,  1733,  -368, -5899, -5899,  -364,
   -3331,   544, -5899, -4639, -2851,  1737, -1129,  -810, -5899,  -956,
   -5899,  -611,  1743, -5899, -4067, -1159, -5899, -3853,   379,  3773,
    -835, -5899, -5899,  -819,  9739, -5899, -5899, -5899, 10271, 10419,
   -5899, -5899, 11346, 12119, -5899,  -552, 13065,  8960,  -796, -1961,
     -63, 13260, 17536, -1854,  -355,    49, -5899, -2952, -2608, -5899,
   -5899, -5899,  -332,  1062,   633, -5899, -5899, -4693, -4493, -5899,
    2646, -1935, -5899,  -615,  1813,  -602, -5899, -5899, -5899, -2893,
   -5633, -3075,  2637, -5899, -5899, -5899,  -202, -5899, 18732, -3276,
   -5899,  -710, -1034, -1618,  3148, -3084, -1922, -5899, -5899, -5899,
   -3149, -5899, -5899, -5899,  -873,  1849, -5899, -5899,  1972, -5899,
   -5899, -5899,  -971,  2216,  -777, -1214,  1848, -4539, -5899,  -542,
   -4387, -5048, -5899, -5707, -5894, -1900, -1132, -3061, -3922, -1912,
    1866, -3146, -5899, -1970,  1946,  1156, -5899, -1893, -5899,  4352,
    -790,  2655,  -791, 18579,  -412,  9943, -1297, -5899,  1188, -4495,
    5806,  6844,    67,  -118, 13460,  -676,  2572,  2952, -5899, -5899,
      -6,  8207,  -635,  -957, -5899,  5020, 16525, 15339, -3712, -5899
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    58,    59,    60,    61,  1113,  1118,  1922,  1941,    62,
      63,  1645,  3077,  2930,  3897,  3898,    64,    65,  1641,    66,
      67,    68,    69,  1555,    70,  1894,  3091,    71,  2763,   855,
     856,   857,  2629,  2630,  3022,  2631,  2619,  1406,  1840,  1577,
     829,   830,  1537,  1578,    73,    74,  1400,  2610,    75,    76,
      77,  1608,  1701,  1609,  1610,  1549,  5036,  5871,  3683,  2885,
    3945,  3684,  3685,  4368,  4369,  3763,  4397,  4459,  5885,  5886,
      78,  1717,  1718,    79,    80,  3059,  3863,  4512,  5424,  5425,
    5690,   670,  5059,  5060,  5677,  5678,  5900,  6075,  6076,  3092,
     701,  3940,  4596,  3888,  5130,  3889,  5131,  3890,  5132,  4926,
    4927,  4358,  4359,  3874,  4543,  4544,  2100,  5072,  4545,  3891,
    5091,  5724,  3892,  2851,  2778,  2779,  5915,  3126,  2015,  2013,
    5627,  5703,  4912,  4913,  4433,  5924,  5925,  5926,  6221,  5093,
    5136,  5137,  6113,  6114,  3943,  4602,  5143,  5482,  5701,  3641,
      82,  3916,  3917,    83,   764,  1916,  4054,   765,  3129,   702,
     766,  3093,    88,  3119,  5917,  3120,  1671,  2944,  4525,  4030,
      89,  1141,  4322,  5507,  5785,  5786,   755,    90,  1902,    91,
      92,  3072,  3881,    93,  2796,  3589,    94,    95,  3608,  3609,
    3610,    96,  4553,  5443,  1611,  3672,  3673,  3674,  3675,  4389,
      97,  1897,  3100,  3101,    98,    99,   100,  3233,  3234,   101,
    3008,   102,   103,   104,   105,  4427,  4993,  5107,  3714,  3904,
    4569,  5105,   106,  3867,  3094,  3147,  3978,  3979,  5505,  5777,
    5778,  5779,  5976,  6256,  5781,  5978,  6136,  5980,  5082,  6403,
    6404,  5762,  4311,  4890,   108,  5083,  5084,  5930,   109,  2794,
     110,   111,  1871,  3065,  3066,  4526,  3136,  3953,  3954,  4582,
    4583,   112,  3803,   113,  4969,  4970,   703,  5938,  5877,  6061,
     114,   115,  4973,  4974,   116,   117,   118,   119,   120,   756,
    1075,  1076,   758,  1196,  1197,  3550,  1158,   121,  2639,   122,
    3843,   123,  1278,  5207,   124,   791,  1214,  1215,  3095,   126,
     801,  3252,   803,  3217,  3218,  2031,  4034,  4035,  4685,   127,
     128,  4038,  4039,  4692,  3230,   129,  1542,  2773,  2774,  4882,
    3096,   704,  3635,  5759,  5350,  5760,  6124,  6318,  5351,  3504,
    4282,   131,   705,  1583,  2835,  1164,  1165,  3140,  3958,  2743,
    2744,  1740,  4623,  2746,  3960,  2747,  1515,  2748,  1151,  1152,
    3966,  3967,  3968,  3969,  4619,  4629,  4630,  5499,  5770,  4626,
    1890,  5493,  5494,   132,  1580,  2832,   133,   134,   135,  1624,
     999,  1174,  1175,   136,   717,   718,   137,  5695,   138,  1154,
     139,  5503,   140,   141,  1263,  1264,   821,   142,   143,  2855,
    4371,   144,  1581,   145,   146,  3708,  3709,  4985,   147,   148,
     149,  2916,  2917,   150,   151,   152,   153,   154,  6246,  6321,
    6322,  6323,  4637,  6130,   155,  1246,   156,   157,   158,   159,
     197,  1040,  1041,  1042,   952,  3097,  5484,   161,   162,  1538,
    1539,  1540,  1541,  2768,   163,   164,   165,  3988,  3989,   166,
     167,   168,   169,  1874,   170,   171,  5668,   172,   173,  1844,
     174,   175,  1049,  1050,  1051,  1052,  1842,  3448,   664,   874,
    1431,  1437,  1480,  1481,  1482,   177,   768,   178,  1254,  1080,
     769,  1205,   180,   770,   181,  2726,  4013,  4661,  4662,  4663,
    4666,  5519,  4870,   771,  3530,   183,  2038,  3239,  3242,  3526,
     772,   184,  4016,  4017,  4018,  4668,   773,  5614,  5615,  5616,
    5617,  5852,  6189,  6190,  6193,  6294,   774,   793,  1144,  3151,
     775,  1365,   189,   190,   191,   932,   877,   878,  3453,  5575,
    5822,   776,  2603,  3431,   810,  1486,   920,   921,   922,   941,
    3032,  2692,  2693,  2717,  2718,  1495,  1496,  2705,  2709,  2710,
    3517,  3510,  2698,  4276,  5600,  5601,  5602,  5603,  5604,  5605,
    4859,  2713,  2714,  1498,  1499,  1500,  2722,   194,  2682,  3483,
    3484,  3485,  4252,  4253,  6179,  4267,  4263,  4844,  5303,  3486,
     866,  1244,  1507,  4852,  6181,  3487,  5292,  5293,  5580,  4272,
    3496,  4293,  3928,  3929,  3930,  3488,  5832,  5833,  6176,  6177,
    5582,  5583,  3489,  5824,  6342,  6343,  6381,  6416,  2749,  1460,
     905,  1366,   906,  1473,  1367,  1447,   908,  1368,  1369,  1370,
     911,  1371,  1372,  1373,   914,  1439,  1374,  1375,  1456,  1469,
    1470,  1376,  1432,  5584,  1378,  1379,  1380,  3491,  1381,  4788,
    5264,  5250,  3353,  3354,  2626,  5565,  4784,  4165,  4778,  2596,
    2600,  5315,  5607,  5608,  3424,  4214,  4815,  5281,  5818,  6012,
    6013,  6160,  1382,  1383,  1384,  3416,  2590,  1002,  1385,  4528,
    2592,  3344,  3322,  1743,  3323,  2041,  2063,  3271,  3287,  3288,
    3392,  3324,  3332,  3337,  3345,  3378,  1386,  3273,  3274,  4076,
    2065,  1387,  1046,  1746,  1047,  1475,  3373,  5230,  5530,  5531,
    5803,  5804,  5541,  5805,  5542,  5532,  4087,  4088,  6001,  3298,
    3393,  4091,  3306,  3307,  4109,  4098,  3299,  1388,  4100,  1396,
    1397,  1390,  2032,   867,  5299,  1200,  1827,   807,  1391,  1392,
    1393,  1394,  1617,   973,  1167,  1168,   923,   925,   926,  2686,
     660,   652,   975,  3676,  2593,   661,   654,   655,  1832,  2594
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     651,  1081,   193,   176,    72,  1083,    81,   931,    84,  1742,
    1001,    85,  1000,  1107,    86,  1670,    87,   804,   107,   806,
    1235,  1236,  1237,   812,   767,   125,  1241,   965,  1053,   823,
     831,   835,   130,   838,   160,  1006,   831,   831,  1011,   868,
     182,   871,   185,  1501,   179,  1956,   186,  1839,   927,   927,
     927,  2012,  1389,  2879,  1401,   649,   942,  1241,  2957,  2850,
    1487,   192,  1489,  1180,  1452,  1675,  1472,  1722,  1443,  1444,
    2060,  3640,  1734,  3492,  1428,  3527,  1833,  1193,  1451,  3528,
     833,  1147,   192,  2849,   869,  2052,  1899,  2836,  1828,   795,
     953,  1427,  2862,  4056,  3114,   795,  3254,  3970,  1206,  1009,
    4356,  3887,  4360,  4224,  1520,  4226,  1458,   187,  4291,  1415,
    3309,   658,  2745,  1031,  4581,   865,  4434,  3245,   709,  3026,
    3543,  3545,  4861,  4594,  3909,  2044,  1145,  1872,  1053,  2046,
    1074,  1877,  2047,  2048,  1612,  4328,  1881,  2918,  2918,  3270,
     802,  2918,  4607,  3800,  5296,  4266,  1891,  4384,  4249,  4386,
     944,  3918,  2987,  2988,   834,  4632,  5121,  3362,  4914,  1634,
    1911,  4530,   945,  4884,  1651,  1433,  3181,  3305,  3434,  2827,
    4667,   936,  3436,  1207,  2678,  3293,  3297,  3300,  3301,  1190,
    2745,  3310,  5540,  3312,  3313,  1053,  5129,  3133,  5139,  5150,
    1584,  1945,   651,   956,   956,  4953,  2983,   956,  5632,  4295,
    5235,   967,  5236,   868,  5486,  5184,  1003,  1178,  3768,   967,
    1182,   233,   967,  1147,  5308,   868,  5310,   956,  5479,  5787,
     868,  5090,  5707,  3015,   956,  1616,   868,  4280,  5447,  2827,
    5624,   880,   854,  3519,   828,  4093,  3446,  4296,  1053,  4193,
    3329,   862,  5746,  3522,  5352,  4591,  2827,  4196,  3846,  5789,
    3849,  3850,  5475,  5952,  1494,  3854,  3855,  3856,  1408,  3858,
    3859,  3860, -2568,  5138,  1497, -2610, -1977,  4264,   777,  4269,
    4270,  2807,  4095, -1944,  2121,  -150,  5478, -1985, -2636,  1427,
    4106,  -150,  5940,  3498,  5255,  1907,  5660,  5008, -2677,  4129,
   -1957,   668,  1938,  5349,  6150,  1841,  1024,  3877,  1036,  1884,
    1053, -2489,  4617,  2637, -1982, -2002,  2643,  1938,  1864,  5670,
    5671,  1551,   777,  3250, -2456,  1908,   715,   951,  1579,  3000,
    3906,   715, -2421, -2456, -2456,  5704, -2457,  2841, -1972,  1669,
    1216,  5100,   715,  1440,  1441, -2457, -2457,  1272,  1700,  2645,
     872,  5876, -2572,   715,  1450,  1199,  3371, -2865,  1727, -2420,
     715,  4058,  3111,   777,  2853,  4578, -2865, -2865,   715,  1579,
    4074,  3583,  -445,   946,  1579,  4329,  2981, -1916,   937,  4627,
     777,  1220,  3603,  2601,  4106,  6153,  1938,  5997,  3371,  4095,
    5696,  2994, -1985,  1996,   715,  6143,  2616,  3057,  1613,   715,
    2918,  1613,  4324,  2921,   777,  1036,  2925,   777,  1134,  2853,
     715,  3689,  1037,  2786,  4689,  4966,  2683,  5501,  4346,  5863,
    5517,  3878,  5151,  1938,   777,  3075,  2780,  1147,  6145,  2699,
    3123, -1777,  3369,  2784,  1273,  4697,  1552,  5101,  2845,  6260,
    1405,   904,  1938,  5986,  5912,  2947,   938,  3419,  5810,   783,
    3346,  5623,   783,  4971,  2781,  1886,  1734,  3124,  3080,  5659,
    1938,  2689,  3827,  6421,   947,   783,  1833,  5440,  5840,  3469,
    1938,  6119,   840,   784,  1239,   783,   784,  2700,  1038,  3246,
    2822,  3604,  3737,  3616,  3564,  2121,  5637,  1551,   783,   784,
    3501,  4048,  1001,  1443,  1444,  4862,  2121, -2633,  6411,   784,
    6419,  5999,  6422,  5993,  1991,  3492,  5358,  6107,  1889,  1037,
    1964,   195,   784,  2617,  2685,  1625,   948,  2643,  6134,  2966,
   -2247,  2997,  6285,  5954,  1828,  1451,   715, -2247,  5102,   783,
    5209,  5210,  5211,  3762,  5213,  5214,  5215,  5216,  5217,  2889,
     939,  1039,  1001,  5873,  2701,   777,  4967,  6286,  2853,  2967,
    2645,  6449,  6135,   784,  5994,  3721,   196,  1938,  4096,  1458,
    4129,  2645,  4690,  3737,  6463,  1240,  4107,  5747,  3112,  6000,
    1954,  2121,  4863,  2033,  1101,  1038,  3565,  4049,   841,  2823,
    1111,  3502,  3617,  3081,  4972,  2787,  6347,  1954,  5441,  2043,
    2638,  1466,  1125,  1626,  2702,  1954,  2681,  3420,  2115,  2074,
    2948,  5913,  1552,  2643,  5735,  2949,  2053,  3347,  1283,  2847,
    4698,  4129,  1939, -1777,   893, -2992, -2992, -2992,  1869,  6292,
    5987,  3370,  2853,  1833,  2853,  4518,  2782,  1939,  2606,  2863,
    3076,  1994,  3413,  3879, -2266,  6238,  2645,  2853,  1039,  3414,
    3690, -2266,  2853,  2853,  6334,  4129,  5518,   716,  4329,  2618,
    6186,  6049,  1147,  5911,  4453,  3084,  4125,  1234,  4968,  2703,
    4107,  6187,  3125,  2680,  2114,  4096,  2620,  3058,  1056,  3607,
    5811,  2632,  2632,  3228,   868,  6090,   956,  4182,   956,   188,
    5594,   956,  2788,  3228,  2725,  2960,  2728,  5502,  1003,  4325,
     940,  3228,  4530,  1114,  2036,   956,  1939,  2057,  1553,  2602,
     188,   956,  4628,  6380,  5330,  4691,   873,  5103,  1240,  3584,
    2952,  3024,  3025,  2955,  1623,  3272,  4618,  5058,   949,  1082,
    4988,  1084,  1240,   931,  1733,   651,  4579,  3880,  6118,  3001,
    2848,  2982,  2880,  1939,   967,  2962,   930,  5522,  1003,  1275,
     192,   967,  2659,  3372,   967,  4510,  4511,  6308,  3113,  1440,
    1441,  1438,  1939,  6461,  6290,  2880,  2037,  1044,  6046,  3002,
     956,  1045,   710,  6051,  6052,  6467,  1554, -2633,  1139,  5099,
    1939,  1643,  1210,  5558,  3023,  4200,  3014,  1940,  5359,  2880,
    1939,   669,  5104,  2897,  3266,  1147,  1085,  1450,  2785,  5368,
    6307,  1870,  1947,  1147,  1147,  1644,  1453,  1454,  3493,  4097,
    3463,  2589,  5146,  6072, -1977,  -150,  -150,  4108,  2731, -2568,
    5147,  1442, -2610,  2814,   868,  1455,  4144,   831,   831,   831,
    1502,  2995,  4920,  2821,  2723, -2636,  1265,  6359,  1446,  5947,
    2614,  2941,  4995,   192,  2724, -2677,   789,   790,  4999,  3828,
    3201,  2924, -1982,  2075, -2633,  5998,  1395,  1395, -2489,   868,
     831,  3031, -2456,  6144,   831,  1213, -2633,  1218,  1044,  1222,
   -2421,  1951,  1045,  6240, -2457,  1226, -1972,  1939,   868,  3183,
    2117,   943,  5950,   868,  1001,  6392,  1855,   789,   790,  1395,
    3492,  2604,  2812,  3492,  6230, -2865,  6146, -2420,  3439, -2572,
    1243,  2975,  2976,  1851,   789,   790,  6408,  1856,  1962,  1857,
     944,  1453,  1454, -2247,  3211,  1229,  2661,  2662,  4135,  4530,
    2942,  4266,   945,  2945,  2946,  3612,  3226,  1984,  1614,  1615,
    1457,  1614,  1615,  3067,  3228,  2684,  1395,  5995,  4298,  6259,
    4299,  3492,  4841,  1044,  3492,  1987,  4845,  1045,   789,   790,
     868,  4183,  6195,  2831,  2896,  1954,   193,   176,    72,  1243,
      81,  2998,    84,   868,  4572,    85,  6291,  4669,    86,  1846,
      87,  5996,   107,  5859,  6206,  4579,  2905,  2864,   868,   125,
    1417,  2881,  1536,  4737,  4738,  1870,   130,  4591,   160,  5698,
    4742,  2865,  1870,  2866,   182,  5062,   185,   868,   179,  3697,
     186,  4491,   956,   956,  2881,  6188,  2831,  2584,  2585,  2586,
    2587,  2588,  2589,  3398,  4900,   192,  6349,  6310,  4874,  4454,
    4958,  4448,  4449,  2831,  1543,  3415,  4450, -2266,  2881,  6117,
    6091,   828,  1249,  1251,   831,   831,  6414,  1954,  4184,  1506,
    2806,  2037,  4684,  4831,  2656,  4833,  4834,  4687,  6111,  5527,
    5734,  4723,  3679,  3519,  1558,  4684,  1404,  1395,  1395,  2867,
    1412,   187,  4285,  5061,  4231,  3304,  5331,  1888,  4800,   963,
    6217,   651,  3235,   956,   946,  5401,  1434,   967,  4505,   711,
    1003,   967,  1097,   967,  4141,  4142,  4143,  4144,   956,   946,
    6099,  4546,  2765,  1161,  6358,  2586,  2587,  2588,  2589,  5402,
    1938,  3085, -2417,  6313,  6314,  1231,  6110,  5088,  2954,  2685,
    3680,  6298,   868,  4044,  1731,  3045,  4560,   715,  5080,   956,
     956,  2880,  6292,  6266,  3524,  1159, -1778,  4185,  5252,  1079,
   -2992, -2992, -2992,  4139,  4140,  4141,  4142,  4143,  4144,  1544,
     712,   868,   868,   868,   715,   956,  6439,   651,   715,   651,
     651,  1159,  5797,  1509,  5740,  2984,  2882,  3399,  2712,  2775,
    3127,  4570,  3400,  3603,  1833,  1211,  4986,  4139,  4140,  4141,
    4142,  4143,  4144,  5849,  2880,  1484,  4914,  5115,  6293,  2882,
    1211,  4046,   713,   956,   714,   956,   956,  2883,   662,  3634,
    5170,  1711,  3280,  5643,  3212,   715,  6239,  1712,  3712,  6425,
    2608,  1020,  3865,  2882,  3236,  3368,  1635,  3451,  6022,  6231,
    2883,  6415,  2884,  3401,   650,  6268,  6248,   948,  1395,  2870,
    1053,  1203,  2775,   665,  4531,  3681,   868,  6394,  1706,  3974,
    3493, -1944,  1021,  3452,  2883,  2884,  5126,  3525,   828,  1249,
     663,  3229,  2776,  2880,  1524,  5253,  2014,  2880,  2014,  1889,
    1418, -1094,   868,  2878,   804,  2871,  3223,  3224,   984,  2884,
    3547,   939,  3604,  5127,  1248,   985,   986,   987,  5920,  4527,
    2880,  1707,  4534,  5902,  2609,  5904,  2878,  1133,  3713,  5908,
    5909,  1485,  2880,  2050,  1247,   868,  -706,  5081,  1954,  2056,
    5783,   192,  2880,  1232,  1903,  6218,  1987,  3162,  6269,  1276,
    2878,  1732,  1506,  1395,  3281,  6021,  1713,  5815, -1778,  4561,
    1283,  3174,  5089,  4129, -1944,  6315,  5936,  4130,  4131,  4132,
    3975,  1636,  5933,  1545,  3180,  5944,  1044,  1419,  3613,  5699,
    1045,  6248,  1525,  4536,   931,  5471,  5465,  1904,  1998,  1269,
    2000,  1134,  2002,  5019,  2004,  1395,  2006,  2007,  2008,  1973,
    5477,  5946,  5949,  2010,  5540,  2115,  3632,  5961,   188,  4624,
    2881,  5521,  3542,  4045,  5326,  5496,  1546,  3205,  3402,  3267,
    1930,  3269,  3907,  1510,  1395,  1395,  1395,  3276,  1395,  2777,
    6219,  5988,  3282,  3290,  3291,  6357,  1526,  1889,  5343,  5403,
     964,  4086,  1974,  3158,  1081,  3314,  6364,  5932,  1083,  1395,
    6270,  1547,  3475,  1098,  3682,  3334,   954,  5540,  3842,  6220,
    1939,  3349,  3698,  2881,  1162,   966,  5798,  4915,  5921,  1212,
    4113,  2880,  4547,   966,  3192,  3179,   966,  5948,  1135,  3068,
    3866,  4047,  3837,  3237,  1212,  4438,  6393,  3729,   868,  5206,
    3160,  3320,  2777,  3123,  5432,  1001,  2641,  2827,   939,  4539,
    3607,   188,   930,  6248,  3238,  3173,  1395,  4412,  3175,  6155,
    3283,  1850,  5126,  3284,  2690,  2691,  1708,  2695,  5128,  6423,
    3124,  1692,  1859,  5816,  1548,  6171,   945,   945,  5784,   945,
    3213,  3548,  2881,  3466,  3549,  3030,  2881,  3016,  1867,  5127,
    1714,  1691,  4126,  4127,  5855,  6276,  4540,  4146,  5922,  4229,
    1527,  6440,  1395,  6128,  5817,  1637,  1395,  1395, -1944,  2881,
    3214,  4362,  6303,  4541,  3220,  3221,  5297,   868,   868,   868,
    2730,  2881,  1395,  6101,  4134,  3730,  5073,  4633,  2957,  5300,
    5749,  2881,  1905,  1715,  5304,  2882,  3206,  5306,  4177,  4178,
    3614,  5020,  2903,  3265,  1834,  5750,   831,  1835,  1638,  5753,
    2974,  4394,  3003,  1462,     3,     4,  6271,  5754,  4278,  3976,
    6058,  3467,  1258,  4395,  4010,  2764,  2883,  6133,  1716,  4683,
    3207,  3936,  4413,  3144,  3977,  2099,   818,  5327,  5466,  1709,
    3731,  2818,  3285,  1639,  3208,  5444,   831,  1975,  2882,   956,
    3435,  2884,  6172,  1506,  3185,  1506,  3145,  1136,  1490,  5160,
    5074,  4670,   868,  2852,  2790,  3493,  6236,  6237,  3493,  3699,
    4135,   868,  4286,  4446,   956,  2791,  4684,  4542,  4634,  2883,
     761,   943,  3209,   188,  3784,  3210,  4363,  4864,  6156,  3215,
    3785,  1463,  2878,  5563,  3222,  1137,  4456,  3225,  6059,  5533,
      15,  1003,  3732,   868,  2884,  1906,   831,  3918,  4493,  2920,
    2920,  5328,  2040,  2920,  1259,  1833,  3493,  2882,  4902,  3493,
    2881,  2882,  5534,   831,  3959,  1536,   868,  3492,  5535,   868,
    1536,  3492,  3830,  5739,  4869,  5459,  5872,    20,  1533,  5075,
    4530,  1534,  5536,  1466,  2882,  2878,  1492,  2904,  2883,  6304,
    6129,   956,  2883,  5748,  6105,  6229,  2882,  3004,  3286,  1138,
    1976,  1139,   805,  5360,  6165,  1140,  2882,  1036,   868,  1464,
    6337,  5366,  1465,  2884,   666,  2883,  5564,  2884, -1944,  6338,
     956,   956,   956,   956,   868,  6048, -1944,  2883,  1442, -1944,
    1471,  5052, -1944,  1870,  3603,  4256,  5056,  2883,   868,  3786,
    2884,  5755,  1828,  1536,  3303,  3303,  5751,  1536,  3639,  1395,
    1395,  1395,  2884,  2745,  2878,  5120,  4414,  2745,  2878,  3330,
    3089,  3492,  2884,  3146,  6173,  3733,  4011,   809,  3351,  6174,
     990,   991,   992,   993,   994,   995,   996,   997,   998,  1001,
    1001,  2878,  3171,  3562,  2978,  5079,  5613,  4960,  3639,  2769,
    4527,  3161,  6125,  2878,  4287,  2792,  1921,  4635,  1601,  4415,
    2696,  2770,  6360,  2878,  6175,  2699,  5714,  6191,  3790,  4865,
      41,  1037,  1954,  4257,  1209,  6306,  5537,    41,  4984,  2771,
     195,   783,  4136,  4137,  4138,  4139,  4140,  4141,  4142,  4143,
    4144,  1466,  1418,  3604,  4416,  2882,  5117,  1260,  2793,    41,
    3203,   819,  6244,    29,  3090,   784,  3203,  4258,   868,    45,
    4352,  3791,  3154,  2700,  5076,  3203,    45,  4364,  4365,   868,
    5715,  1462,  4259,  5716,  6378,   196,  2883,   956,   956,  3605,
    5717,  1257,  4636,  4753,  1564,  4754,  4460,  1038,    45,   662,
    1261,  5819,  1262,   956,    33,  4260,  3792,  6192,  4366,  1490,
    3814,  2884,  3231,    49,  6356,  1491,  1712,  3734,  5718,   188,
      49,   868,  2920,  5294,   820,  3735,    50,  2781,  3736,  1419,
    1001,  6199,  3606,    50,  4261,  2697,    41,   956,   956,   956,
     956,  1269,    49,  3787,  1429,  1452,   868,   836,  3794,   954,
      51,   935,  2878,   868,  6431,    50,  3134,    51,   966,  1463,
    1039,  3686,  5939,  4871,    41,   966,  4930,  1467,   966,    57,
    3523,   651,  5820,  3798,   651,    45,    57,  3657,  5719,    51,
    3748,  5953,  5960,  3795,   967,   967,  3788,  3710,  3454,  4341,
    2702,  5720,  1468,  5538,  2062,  1003,  1003,  1492,  4012,   967,
    4257,  4931,   967,    45,  5721,  5539,  1479,  4451,  1601,  4365,
    3492,  3492,  5590,  3232,  2071,  2772,  1414,   956,   956,    49,
    1672,  3789,  1656,   762,   956,  3815,   868,  4527,  5448,   868,
    1126,  4876,    50,  4262,  4258,  3796,  3659,  1464,  1870,  4944,
    1465,  3607,  2901,  3658,  1657,  2014,  4457,    49,  1493,  4847,
    4755,  3563,   956,   195,   967,  2703,    51,  3219,   967,   967,
      50,   868,   868,  1673,   956,  1931,  3296,  1127,  4342,  6437,
    3797,   868,  4260,  2112,  5782,   763,   839,  5449,   868,  1932,
    3992,   868,  3134,  5525,    51,   804,  4452,  3710,   804,  3256,
    6317,  6451,  4956,  1395,   192,  1395,  1658,  4458,   196,  4932,
    1395,  1395,  3660,  6245,  1524,  1128,   863,  1395,  1395,  1395,
    1395,  1395,  1395,  1395,  1395,  1395,  1395,  1395,  1395,  1395,
    1490,  4688,  1082,  1395,  1084,  1395,  1003,  1395,  1395,  1395,
    1395,  1395,  1395,  1640,  3251,  1395,  1933,  1395,  1395,  4700,
    3195,  1395,  3196,   192,  3197, -1748,  3198,  3240,  3199,  1681,
     761, -1748,  3200,  3875,  5446,  1129,  1395,  1395,  1395,  1466,
    4659,  1511,  2890,  3831,  3832,  3833,   875,    41,   777,  4340,
      15,  4957,  6108,  1147,  1395,  1529,  2957,  2745,  4736,  1674,
    3722,  6109,  3723,  3724,  5457,  4173,  3799,  2745,  1659,  1085,
    4712,  6127,  1525,  5470,  3629,   943,   943,   681,   943,  4660,
    4262,  3918,  3626,  5618,  1512,  5620,    45,    20,  1492,  5771,
    1521,  3255,  6396,    36,   956,  1682,  5722,  3019,  2947,  5723,
    5974,  4724,  3793,  1448,  1449,  5642,  4728,  3749,  5931,  4655,
    3020,  3986,   934, -1748,  4877,  3752, -1701,  4727,  3755,  1513,
    1934,  4878,  4732,  4733,  2927,  4886,  1526,  4886,  4879, -1701,
      49,  1660,  3837,  1522,   933, -1701,  1661,  1683,  4500,  1493,
    3021,  5965,  2745,  2918,  1684,  -173,  3040,  3492,  1685,  5674,
    5975,   683,  2956,  5669,  3492,  1467,   950,  3051,  2870,  3492,
   -1119,  -621,  3492,  1126, -1748,   954,  4880,   951,  1523,  1453,
    1454,   966,  1410,  3069,  3747,   966,  6126,   966,  5419, -2440,
    5420,  5421,  5422,  -173, -1701,   959,    57,  1663,  1455,  4881,
    4455,   681,  4040,  1935,  2871,  2612,  4749,  4750,  4751,  4752,
    1127,  1395,  4756,  4757,  4758,  4759,  4760,  4761,  4762,  4763,
    4764,  4765,  3774,  4887,  -173,  4887,  2858, -1701,  2859,  3922,
    3923,  3924,  3925,  5428,  3927,  6232,  2928,  3143,  4828,  3495,
    1643,  2931,  5982,  5436,  5943,  5438,  1665,  4492,  4573,  2853,
    1527,  1923,  3155,  1925,  1926,  1159,  3159,  3821,  5038,  3955,
     681,  2854,   961,  2948,  1644,  1395,   234,  5429,  2949,  1702,
    1666,  4830,   667,  3511,  1678,   683,  4804,  4805, -1701,  3729,
     759,  5039,  3948,  4256, -1092,  5666,  3178,  1159, -1701,  4669,
    5910,  1668,  3493,  4256,  2860,  2121,  3493,   983,  1129,   837,
     813,  4888,  3893,  4888,    33,  4889,  1936,  4889,  1656,  5667,
    1516,  6460,  1703,  1643,  3006,  1528,  1704,  1679,  3012,   982,
    2624,  1395,  4603,  4163,  1529,  4915,  1035,  2643,  6469,  4170,
    1657,   814,  1987,  1653,   683,   815,    41,  1644,  1686,  6339,
    4409,  3017,  1643,  5905,   694,  5070,   695,  1705,  5906,  1517,
    5666,    41,  1680,  1518,  1530,  6309,  3910,  6432,  1531,  1026,
    2645,  4257,    36,  2625,  6340,  6319,  1644,  3730,  1909,  6197,
    1981,  4257,  5071,   699,  5667,    45,  1654,  1687,  -471,  1656,
    5021,  1688,  1658,  4410,  3018,  -150,  3493,  5847,  1519,  4029,
      45,   685,  1910,  1532,  1982,  4258,  4155,  1987,  4157,  4158,
    6433,  1657,  5666,  5907,  5022,  4258,  1217,  1219,  1221,  6214,
    4259,  1223,  1224,  1225,  5848,  5775,  1689,  3086,  4411,    49,
    4259,  1230,  3731,  1690,  2853,  2911,  5667,  4925,  1533,  1043,
    3363,  1534,    50,  4260,    49,  3492,  2861,  3116, -1701,  5776,
    6201,  6202,  2935,  4260,  1646,  6450,  4283,    50,  2115,  1453,
    1454,  4937,   777,  1658,  4935,  1442,    51,  1471,   694,  6462,
     695,  2786,  4261,  1719,  4225,  4070,  1723,  4915,  1457,  1089,
    2654,    51,  4261,  4302,  1659,    57, -1701,  3894,  1442,  6151,
    2679,  1099,  1535,  1100,  3732,  6152,  3765,  1885,  3766, -1701,
      57,  6435,  3770,  5875,  6438, -1701,  4915,  4873,  5879,  5880,
    4936,  5301,  1442,  -471,  2679,  1395,  1395,  1395,  1395,  1395,
    1395,  1395,  1395,  1395,   792,  1395,  4071,   694,  6424,   695,
     792,  4072,  4937,  3028,  3029,   868,  1395, -2413,  1395,  1001,
   -1119,  3596,  1044,  1087,  1234,   868,  1045,  1660, -1700,  3468,
    3470,  3471,  1661,   698, -1701,  1659,  1885,  1094,  4128,  4640,
    3593, -1700,  3597,  3598,  4641,  5676,  5294, -1700,  2956,  1108,
    4156,  4262,  5154,  1633,   868,  -620,  1395,  4641,  1650,   956,
    1395,  4262,  1122,  1395,  3447,  1395,  4461, -1701,  1395,     3,
       4,  1044,  1395, -2421,  6140,  1045,  6296,  1044,  1103,  4330,
    1104,  1045,   188,  1663,  4236,  4237,  4180,  1130,  3383,  3384,
    3385,  3386,  2061,  1131,    57,  3494, -1700,  3733,  1660,  1132,
    5069,   868,   868,  1661,  2632,  3493,  3493,  1993,  4297,  3590,
    1835,  1153,  1395,  2045,  4370,  4227,  1835,  3492, -1701,  2956,
    1149,  1395,  1395,  4938,  2640,  3520,  3521,  1835, -1701, -1700,
    4211,   188,  1665,  2653,  1160,   868,  2654,  4273,  2687,  3625,
    5966,  1835,  1169,  3533,  4198,  3895,  3189,  1176,  5198,  2654,
    3490,  2680, -1772, -1772,  1663,  5302,  1666,  3202,  3355,  3492,
    3203,  3358,   937,  3204,  5205,  3295,  3203,  1442,  4527,  2679,
    5514,  1187,  4589,  1833,  4943, -1749,  6352,  1668, -2414,  3243,
   -1700, -1749,  3244,  1044,   804,  1234,   804,  1045,  3450,  3348,
   -1700,  1987,  3455,  5122,  3149,  2654,  3150,  3896,  3534,  1283,
    1395,  2654,  4129,  1665, -1776, -1776,  4130,  4131,  4132,  3623,
    3704,   651,  3624,  3705,   967,  1003,   967,   967,  1170,  3871,
     956,  4028,  3872,   868,  4793,  4672,  1147,  1666,  1194,  3734,
     938,  3728,  4933,  3566,  4940,  3569,  4020,  3735,  5228,  3203,
    3736,  1453,  1454,    41,   831,  5233,  5234,  1204,  1668,  4901,
    4939,   662,  4069,  4357,  4078,  2654,  2852,  2654,  4084,  4085,
     777,  2654,  2654, -1749,  1283,  4918,  4089,  4129,  4090,  3645,
     868,  4130,  4131,  4132,  4104,  1233,  3656,  3830, -1701,  5635,
    5636,  4115,    45,  5861,  2654,   868,  1238,  4148,  5763,  4699,
    2654,  5866,  5867,  4162,  4167,  1234,  2654,  4168,  1242,  3611,
   -1701,  3492,  4576,  6194,  4216,  1245,  4217,   868,  4303,  4304,
   -1775, -1775,  3818, -1701, -1749,  4600,  1253,  4601,  2745, -1701,
    4959,  4218,  4234,  4219,   939,  2654,    49,  1255,   868,  1997,
    3492,  4548,  1999,  1256,  2001,  3067,  2003,  1266,  2005,    50,
   -1700,   831,  2009,  6014,  6015,  4333,  1044,  1267,  4387,  6330,
    1045,  4388,  4392,  1270,  4420,  4393,  3379,  4421,  3380,  6161,
    6162,  4429,  3493,    51,   956,  2878,  4435,   956, -1701,  3493,
    4186,  1268,  4187,  1147,  3493,  4489,  4612,  3493,  4421,  4613,
    1269,  3377,    57,  1948,  3381,  5846,  5063,  1271,  5064,  1952,
    3492,  3330,  3330,   868,   868,    29,  3330,  4615,  4188,  1963,
    4616, -1701,  4646,  1966,  3719,  4647,  1279,  1969,  3801,  1971,
    3804,  3806,  1277,  4134,  4774,  1979,  1413,  4775,  4317,  6115,
    4785,  1985,  4796,  4786,  1988,  2654,  4872,   928,   929,  3549,
    4404,  4915,  5123,  5180,  1420,  3203,  5181,  3330,  3330,  5243,
    1416,  5244,  1395,  1395,  1395,  1421,  1422,  5185,  1395,  3382,
    5186,  1426, -1701,  6397,  3764,  4133,   956,  4425,  5200,  1430,
    1435,  2037, -1701,  3382,  5240,  1438,  1436,  2654,  5140,   956,
    5277,  1442,  1445,  2654,   940,  1395,  1446,   956,  4134,  4441,
    5322,  5346,  4519,  3549,  5347,  5133,  5353,  1459,  5354,  3203,
    2852,  3203,  1461,  1488,  5355,   868,    41,  3203,  1476,  4135,
    4062,  3908,  4064,  4065,   804,  3383,  3384,  3385,  3386,  1477,
    1503,  5472,  3387,  3388,  5473,  1504,   956,  3919,  3389,  3383,
    3384,  3385,  3386,  5680,  1505,  5509,  4189,  3801,  4647,  6453,
    5555,  5557,  4190,  5556,  2654,    45,  5801,   956,  5802,  3941,
    5577,  3959,  1508,  5578,  4566,   954,  5587,  3492,   954,  1987,
    5470,  5593,  5595,  5709,  4586,  4586,  5710,  5729,   966,   966,
    3203,  1471,  5764,  5829,  4135,  5765,  5830,  1587,  5835,  4059,
    5681,  1987,  3490,   966,  5838,  4306,   966,  4586,   956,    49,
     956,  5894,   956,  5935,  5895,  5962,  2611,  1514,  5963,  4917,
    4915,  4919,    50,  5985,  4922,  5682,  5963,  6005,  3592,  6006,
    4168,  1556,  2654,  6026,  3600,  1582,  6027,  6030,  4019,  6366,
    1987,  6367, -1701,  1001,  5683, -2458,    51,  2014,  6038,  5684,
    6031,  6057,  2685,  2654,  3244,  1585,  1627,  6063,   966,  4780,
    3244,  1588,   966,   966,  2745,    57, -1432,  4559, -1432,  4562,
    3493,  5685,  1628,  6064,  6067,  5686,  3244,  2654,  1623,  3937,
    6068,  3642,  6069,  2654,  6097,  6070,  6167,  6098,  6182,  4586,
    5687,  2654,  1476,  1147, -1689,  1147,  6184,  4693,  1629,  2654,
    6196,   651,   956,  3203,   967,  3390,   967,   967,  1734,   956,
    1044,  1640,  6210,  1476,  1045,  6211,  1395,  3391,  1642,  4191,
    6234,  1395,  6284,  6235,  6316,  5843,  6362,  5963,   931,  6363,
    1652,  4192,  6382,  6115,  6390,  6383,  1655,  5181,  4549,  4915,
    4551,  4136,  4137,  4138,  4139,  4140,  4141,  4142,  4143,  4144,
    4014,  4279,  1833,  1677,  1693,  6391,  4706,  6418,  2654,  6420,
    6027,  6428,  2654,  1694,  6429,  6466,  3377,  4824,  6383,  4826,
    1395,  1395,  1395,  5545,  5546,  1395,   931,  1147,  6468,  1710,
    1720,  6429,  4943,  1395,  1395,  1395,  1395,  6470,  1721,  5286,
    6383,  5288,  4846,  3492,  4849,  1724,  5688,  6242,  1729,  1395,
    3482,  5572,  1395,  5573,  1395,  3492,  4136,  4137,  4138,  4139,
    4140,  4141,  4142,  4143,  4144,  1730,  1395,  1395,  1843,  1845,
    1395,  1847,  4621,  1852,  1858,  1863,  1866,  4531,  1868,  1873,
    1876,  1878,  4701,  4532,  1870,  1887,  1892,  1893,  5549,  1003,
    -137,  1395,  1895,  1395,  1896,  1395,  1898,  4533,  1900,  1901,
    4934,  5689,  1912,  1919,  5344,  1921,  1924,  1928,  1937,   214,
    1942,  4915,  3493,  1943,  1395,  4746,  1944,  4215,  1946,  1949,
    2120,   868,  1950,  2121,  1953,  4534,  1589,  4535,  1954,  1961,
   -2991,   931,  1590,  1965,  1967,  1968,  3686,  1970,  4954,  1972,
    1977,  3869,   868,  1978,  1980,  1983,  1986,  1695,  1989,  4773,
    5182,  1990,  1992,  1995,  3493,  2643,  2120,  2011,  5167,  2121,
    2042,  2049, -2992,  2051,  3710,  2054,  4221,  4222,  4223,  2058,
    2059,  4897,   651,  3371, -1948,  3494,  4254,  1592,  2680, -1955,
    4254,  4268,  4254,  4254,  2066,  2067,  4536,  2068,  2645,  1395,
    2069,  2643, -2755,  2070,  1395,    57,  2072,  2073, -2992,  2074,
    4812, -1945, -1946,  2076,  2077, -1949, -1947,  2078,  4580,  1395,
    2079,  2080,  2081,  2082,  3492,  4537,  2083,  2084,  2085,  2086,
    2087,  2088,  2089,  3494,  2645,  4294,  3494,  3490,  2091, -2991,
    3490,  2092,  1696,  2093,  1593,  2094,  2095,  2096,  2097,  5044,
    2098,  1594,  2101,  2099,  2102,  1595,  2103,  5057,  2595,  2104,
    2105,  2106,  2597,  2107,  2108,  2599,  2601,  2615,  2627,  2635,
    4179,  2602,  2611,  2657,  1395,  1081,  2658,  2663,  5793,  1083,
    2665,  2666,  2669,  1596,  2670,  2672,  2681,  2673,  3490,  2674,
    2675,  3490, -2991,  2676,  6395,  2688,  1491,  1493,   956,   956,
    2719, -2755,  2721,  2735,  2732, -2991,  3493,  4538,  2733,  5049,
    2734, -2991,  4539,  2752,  2751,  2753, -2992, -2991,  2754,  1597,
    2679, -2992,  2755, -2991,  2756,  4678, -2991,  2757,  2758,  2759,
   -2991,   813,  2760,  4051,  1395,  3493,  2761,  3492,  2783,  2767,
    2789,  2795,  2809,  3492,  2813,  2815,  2816,  2817,  4061,  2819,
    2820,  2833, -2992,  4066, -2755,  2837,  2838, -2992,  2839,  4540,
   -2991,  2856, -2991,  2857,  2868,  2872,  2874, -2755,  2877,  2875,
    2876,  2878, -2992, -2755,  2886,  4983,  4541,  2888,  2891, -2755,
    2892,  4279,  2887,  4092,  2893, -2755,  2902,  2898, -2755,  2899,
    2908,  4398, -2755, -2991,  2909,  3493,  2912,  2922,  2926,  1697,
    2936,  2943,  2923,  1599,  2929,  2932,  5807,  2950, -2992,  2933,
    2953,  2685,  2938,  1600,  2939,   868,  1601,  2951,  2968,  2958,
    2959,  2964, -2755,  1601,  2970,  2920,  2977,  2972,  2965,  2979,
    2650,  2971,  2973,  2996,  2980,  1602,  3034,  5828,  2985,  3005,
    4040,  2986,  2999,  3039, -2991,  3027,  3041,  3042, -2991,  3043,
    3010,  3055,  3044,  3056, -2991, -2755,  3048,  3049,  3050,  3061,
    3062,  3052,  3053,  3303,  3060,  3492,  2650,  5492,  3054,  3063,
    3070,  3165,  3071,  3074,   676,  3087,  3098,  3079,  1698,  3172,
    4542,  1604,  1605,  3102,  3103,  3330,  3330,  3330,  3330,  3106,
    3115,  3330,  3330,  3330,  3330,  3330,  3330,  3330,  3330,  3330,
    3330,   188,  1674,  3118,  3121,  3122, -2755,  3131,  3142,  3148,
   -2755,  3167,  3135,  1699,  3152, -2991, -2755,  3139,  3164,  4777,
    3166,  3168,  3169,  3182,  3194,  3216,  3227, -2992,  3253,  3272,
    3350,  3356,  2121,  3397,  1395,  3241,  3417,  3423,  3438,  3443,
    1395,  3444,  3157,  3277,  3458,  3317,  3376,  3395,  3459,  3360,
    3422,   956,  3493,  3457,  1466,  3330,  3330,  3442,  3441,  3456,
    3460,  3473,  3461, -2992,  3465,  3474,  3495,  3513,  3512,   938,
    3372,  3514,   188,  3500,  3529,  3531,  3515, -2755,  3532,   650,
    3538,  3539,  3541,  3567,  3558,  3572,  1607,  3575,   868,   868,
     868,  3570,  3580,  3585,  5095,  5096,  3586,  3588,  3591,  3599,
    3615,  3620,  4837,  1410, -2991,   868,  1414,  3622,  3630,  3636,
    3638,  3648,  3637,  3661,  3687,  3667,  3666,  3693,  3694,  1395,
    3700,  3695,  3703,  3721,  3711,  3718,  3720,  5453, -2991,  3741,
   -2991, -2991,  5195, -2992,  3742,  1889,   809,  2014,   868,   868,
    3802,  3829,  3817,   868,  3758,  2584,  2585,  2586,  2587,  2588,
    2589,  3825, -2991,  5133,  3826,   868,  3838,   939,  3845,  3851,
    3852,  3853,  3857,  3862,  5265,  3873, -2755,  3884,  3899, -2992,
    3885,  3901,   931,  3903,  3913, -2991,  3905, -2991, -2991,  3920,
    4318,  2584,  2585,  2586,  2587,  2588,  2589,  3926,  4321,  5312,
   -2755,  3931, -2755, -2755,  3933,   954,  3932,  3934,   966,  3935,
     966,   966,  3939,  3946,  3944,  3947,  3950,  2112,  1656,  3951,
    3956,   956,  3971,  3981, -2755,  3972,  4664,  3942,  3973,  4019,
    3982,  3983,  3985,  3987,  4001,  4004,  4007,  4022,  4003,  4009,
    1657,  4610,  4023,  4024, -2755,  3219,  4681, -2755, -2755, -2755,
    4037,  1987,  4025,  4041,  4026,  4027,   868,  4043,  4050,  4053,
    4055,  4042,  1984,  1951,  4031,  2112,  4032,  4063,  4083,   868,
    4099,  4080,  4103,  3294,  4606,  4161,  4164, -2239,  3493,  4086,
    4181,  4195,  4205,  4232,  4246,  5251,  4275,  4288,  1395,  3377,
    3493,  4081,  1658,  4300,  4810,  1240,  4082,  1395,  4176,  5319,
    4101,  5864,  4417,  4212,  4419,  4207,  4094,  4111,  4114,  4105,
    4643,  1395,  4238,  3830,  5426,  1395,  1395,  1395,  4116,  4117,
    4121,  4123,  1395,  4124,  4125,  1395,  4147,  2654,  1395,  4290,
    4281,  4255,  1243,  4206,  1395,  4208,  1395,  4292,  4210,  1395,
    4312,  4305,  4152,  4153,  1395,  1395,  1395,  1395,  4307,  4160,
    1395,  1395,  1395,  1395,  1395,  1395,  1395,  1395,  1395,  1395,
    4314,  4337,  4308,  1395,  1395,  1395,  4233,  4242,  4175,  4240,
    4248,  4271,  4326,  1395,  4239,  4338,   931,  2075,  1395,  4241,
    4327,  4247,  1395,  4339,  1659,  4345,  4343,  4351,  4354,  4357,
    1395,  4361,  4372,  1395,  4373,  1395,  4349,  5364,  4375,  3330,
    4480,  4350,  4355,  4381,  2120,  4383,  4382,  2121,  4391,  5316,
    4399,  1395,  4279,  4408,  1395,  1395,  4422,  4424,  3482,  1395,
    1395,  3482,  4426,  4428,  1395,  4432,  1395,  4816,  4430,  4436,
    4437,  2685,  4440,  4442,  4443,   868,   868,   868,  4447,  2643,
    4279,  4444,  4445,  4462,  4502,  4469, -2992,  1660,  4463,  3493,
    5341,  4464,  1661,  4465,  4478,  1395,  4254,  4268,  4254,  4254,
    4466,  1395,  4254,  4467,  4472,  4839,  4474,  2120,  2956,  3494,
    2121,  4468,  2645,  3494,  4817,  4818,  4819,  4820,  4476,  4854,
    4485,  5190,  5191,  5192,  5193,  5194,  4483,  4470,  4481,  2994,
    4471,  4473,  4475,  1082,  2997,  1084,  4497,  4498,  4499,  4504,
    4509,  4501,  2643,  1663,  4477,  4487,  1395,  4515,  4517, -2992,
    4488,   650,  4552,  4494,   192,  4567,  4557,  4558,  4568,  4564,
    5437,  4571,  4575,  1283,  3490,  4586,  4129,  4585,  3490,  4588,
    4130,  4131,  4132,  4595,  4604,  2645,  4605,  6277,  6278,  4598,
    3642,  6280,  4608,  4609,  4197,  4611,  4625,  4639,  4794,  4642,
    4657,  4649,  1665,  5397,  4651,  4665,  4645,  4673,  4671,  4658,
    1085,  4674,  3493,  4916,  2014,  2852,  2014,  4675,  3493,  2014,
    4676,  4924,  4694,  4677,  4695,  4696,  1666,  4702,  4703,  4704,
    4705,  4707,  4715,  5492,  4644,  4708,  4679,  4709,  4710,  4948,
   -2992,  4711,  4720,  4719,  4721, -2992,  4725,  1668,  4726,  2061,
    5571,  4729,  4734,  1589,  4722,  4735,  4740,  4803,  4129,  1590,
    4747, -2238,  4799,  4798,  1283,  4787,  4829,  4129,  3490,  4842,
    4770,  4130,  4131,  4132,  4813,  4771,  4843,  4772,  4835,  4279,
    4850,  4779,  4802,  4825,  5610,  4851,  4857,  4827,  4840,  5270,
    4856,  4838,  4855,  5256,  4997,  4858, -2992,  4860,  4866,  4875,
    5455,  4883,  4869, -2992,  1592,  4893,  4896,  4894, -2992,  4895,
    4903,  4906,  4904,  4907,  3445,   954,  4910,  3634,   966,  4925,
     966,   966,  4928,  4929,  4946,  4949,  4716,  4962,  4961,  4963,
    4964,  4965,  4975,  4976,  4977,  4978,  5679,  4979,  4980,  4989,
    3493,  4991,  4992,  4998,  5009,  2957,  5010,  5015,  5018,  5041,
    5035,  5037,  4935,  5034,  2650,  5040,  5050,  5051,  5053, -2992,
    5054,  1593,  5055,  5066,  5077,  5092,  5106,  5112,  1594,  5113,
    5087,  5125,  1595,  5000,  5118,  5135,  5141,  5152,  4748,  5161,
    5142,  5163,   956,  5165,  3764,  5177,  5119,  4134,  5179,  5098,
    5159,  5158,  5166,  5183,  5171,  5162,   956,  5196,  1395,  3228,
    1596,  5202,  5203,  4769,  5212,   868,  5219,  5220,  5224,  5221,
    5222,  5085,  5223,  5225,  5888,  5231,  5890,  2650,  5232,  5242,
    5254,  2120,  2852,  5226,  2121,  5237,  5257,  5248, -2992, -2992,
   -2992,  5259,  5258, -2240,  5276,  5280,  1597,   868,  5295,  5263,
    5290,  5298,  3494,  3919,  5291,  5305,  5309,  5314,  5321,  5318,
    3801, -2992,  5325,  5317,  5329,  5348,  2643,  5349,  5361,  5134,
    5362,  5363,  5365,  2644,  5373,  5323,  5386,  5367,  5374,   868,
    5372,  5389,  5395,  4135,  5393,  5399,  5404,  5405,  4134,  5407,
    5400,  1395,  1395,  5408,  5409,  5416,   188,  5417,  5418,  2645,
    5423,  5427,  1395,  1283,  5430,  5434,  4129,  3490,  3490,  5435,
    4130,  4131,  4132,  2014,   868,  5442,  5445,  5451,  5450,  5452,
    6019,  5454,  5458,  5460, -2992,  5469,  1697,  5474,  5271,  5464,
    1599,   868,   188,  5476,  5480,  5481,  5483,  5485,  1001,  5726,
    1600,  5487,  5488,  4019,  5489,  1395,   650,  5498,  5504,   650,
    1601,  5506,  5523,  5520,  5899,  5524,  5550,  5630,  5561,  6045,
    3203,   930,  1602,  5560,  5570,  5529,  5543, -2992,  5544,  5562,
    5579,  5585,  5622,  5574,  4135,  5611,  5554,  5644,  5589,  2584,
    2585,  2586,  2587,  2588,  2589,  5592,  5619,  1395,  5626,  5638,
    5634,  5144,  5621,  5649,  5639,  5640,  5641,   650,  5646,  5652,
     650,  5653,  5657,  1395,  5663,  6081,  6083,  5672,  1604,  1605,
    5664,  5665,  5694,  5076,  5713,  5702,  5732,  2646,  5705,  5700,
    5712,  1395,  2647,  5708,  5733,  5737,  5742,  5744,  5761,  5774,
   -2992,  5772,  5766,  5773,  5780,  5788,  5790,  5794,  5795,  5799,
    1606,  5800,  2584,  2585,  2586,  2587,  2588,  2589,  5812,  1395,
    5821,  5843,  1395,  5845,  5813,  5851,  5827,  5858,  5839,  5868,
    1395,  1395,  5876,  5841,  5870,  5844,  5860,  1395,  1395,  5862,
    5882,  5914,  1395,  2649,  5919,  5916,  5923,  1395,  5929,  5937,
    1395,  1395,  5955,  5942,  5927,  5956,  5957,  1395,  5951,  5958,
    5959,   868,   868,   868,   868,  4136,  4137,  4138,  4139,  4140,
    4141,  4142,  4143,  4144,  5969,  5970,  5977,  5971,  5979,   651,
    5992,  6002,  4254,  1607,  6017,  5981,  3494,  4134,  5991,  5983,
    6003,  3494,  5972,  6007,  3494,   651,  5809,  3801,  6016,  5311,
    6018,  2650,  1395,  6023,  1003,  5229,  6041,  6033,  6039,  4213,
    5814,  6043,  6042,  1395,  6056,  1395,  6060,  6086,  6089,  6079,
    6092,  6100,  6094,  6103,  6025,  2112,  6096,   804,  6104,  6120,
    6121,  6122,  5837,  6131,  3490,  6123,  5586,  3330,  6132,  2114,
    6137,  3490,  6138,  6074,  6141,  6142,  3490,  5586,  6213,  3490,
    6148,  6147,   188,  6149,  2852,  1395,  4136,  4137,  4138,  4139,
    4140,  4141,  4142,  4143,  4144,  6154,  6087,  6159,  6163,  5357,
    6164,  6170,  5901,  4135,  3482,  6166,  5324,  6178,  3482,  6180,
    6185,  6198,  6205,  6207,  6215,  6090,  6091,  6224,  5679,  6223,
    3330,  6225,  6241,  5097,  6243,  6261,  6263,  6262,  2652,  6264,
    6267,  6265,  6279,  5883,  5884,  6275,  6283,  6287,  3984,  6300,
    6289,  6288,  6302,  3990,  6320,  3991,  6326,  6327,  6333,  6331,
    2120,  6335,  6332,  2121,  6345,  3997,  6350,  6336,  3998,  6348,
    3999,  4000,  6272,  6273,  4002,  1395,  6368,  6373,  4005,  6369,
    4006,  6370,  1395,  4008,  6388,  3764,  4669,  6398,  6371,  6372,
    6400, -2002,  6409,  6401,  6292,  2643,  3764,  6413,  6434,  6426,
    6427,  6415, -2992,  6442,   956,  6443,  6446,  6448,  6459,  6454,
    6452,  5768,  6457,  6465,  1478,  1586,   653,  4230,  3775,   956,
    5887,  3692,  4367,  4952,  4945,  3011,  3816,  6208,  2645,  2634,
    4514,  3864,  5691,  6301,  1147,  6073,  5094,  5743,  4941,  4942,
    5433,  5725,  4347,  4310,  2580,  4021,  6200,  5628,  6297,  4057,
    1395,  6095,  6093, -2992, -2992, -2992,  2584,  2585,  2586,  2587,
    2588,  2589,   919,  6222,  6312,  4353,   651,  5462,  5116,  5145,
    5124,  6053,  1283,  2852,  5086,  4129,  3882,  6050,  4950,  4130,
    4131,  4132,  2014,  4385,  3883,  4574,  1676,  5111,  5456,  5731,
    4614,  5169,  5973,  6365,  6464,  1283,  6444,  3919,  4129,  5706,
    4806,  5153,  4130,  4131,  4132,  4520,  6227,  5651,  5878,  6062,
     956,  3078,  3941,  5654,   757,   811,  1077,  4680,  5197,  6032,
    2034,  6034,  5854,  5831,  5199,  4136,  4137,  4138,  4139,  4140,
    4141,  4142,  4143,  4144,  6361,  5155,  1001,  3911,   868,  3141,
    3544,  4301,  5769,  3137,  3153,  5967, -2992,  4631,  3170,   868,
    1148, -2992,  3490,  4484,  1188,  3813,  4981,  4431,  6247,  6399,
    4279,  5172,  1423,  3841,  5173,  4664,  3499,  5836,  3193,  6351,
    4019,  3036,  1001,  5187,  5650,  2766,  5516,  5850,  5853,  2655,
    2607,  6047,   842,   843,  5227,  3330,  2716,  4277,  2715,  4289,
    6183,  6035,  4250,  5648,  4832,  3509,  6074,  4848,  2720,  5591,
    5826,  4243, -2992,  5825,  5188,  4244,  6386,  6169,   653,  6024,
    6281,  4245,  5808,  1395,  6412,  2664,  3330,   653,   976,  6036,
    4781,  4209,  5467,  1395,  3421,   653,  1395,   976,   653,  1395,
    1395,  1395,  3418,  6037,  3336,  4075,  4201,  3482,  5693,  4203,
    3840,   976,  5990,  6417,  4194,  4110,  4730,  3433,  3497,     0,
    5892,     0,     0,  1147,  1395,  1395,     0,     0,  1395,     0,
    2650,     0,  5333,   188,  1474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1395,  5513,  5515,  2120,  1395,
       0,  2121,     0,     0,     0,  1395, -2992,     0,     0,  3494,
       0,     0,     0,  5311,     0,     0,  1395,     0,  5609,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4134,
       0,     0,     0,  2643,     0,  5369,     0,     0,     0,     0,
   -2992,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4916,  1003,   956,     0,   956,     0,  5385,     0,     0,
       0,     0,     0,     0,  3490,     0,  2645,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2992,     0,     0,
       0,     0,     0,     0,  6430,     0,     0,   967,  1003,  4313,
       0,     0,  4135,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3490,     0,     0,     0,
       0,     0,     0,     0,     0,  4135,     0,     0,     0,     0,
       0,     0,     0,  6407,     0,     0,     0,     0,     0,  5413,
       0,  5612,   967,     0,     0,     0,     0,     0,  4807,     0,
       0,     0,     0,     0,  5085,  5887,     0,     0,     0,   868,
       0,     0,     0,   650,   868,     0,     0,   650,     0,     0,
       0,     0,     0,  2852,     0,     0,     0,     0,     0,  4374,
       0,  4376,  6249,   868,     0,     0,  6251,  5134,     0,     0,
    5745,     0,  6407, -2992, -2992,  3330,     0,     0,     0, -2992,
       0,   956,   868,  4916,     0,  2584,  2585,  2586,  2587,  2588,
    2589,     0,     0,     0,     0,     0,     0,  6407,     0,     0,
       0,   193,   176,    72,     0,    81,     0,    84,     0,     0,
      85,  3482,  4916,    86,  1395,    87,  3482,   107,     0,  3482,
       0,     0,     0,     0,   125,  6354,  6355,  1395,     0,  6445,
   -2992,   130,     0,   160,     0,     0,     0,   650,  3490,   182,
    5497,   185,     0,   179,  1395,   186,     0,     0,  1395,   931,
    1395,     0,     0,     0,     0,     0,     0,     0,  5758,     0,
     192,  5730,     0,     0,  1395,     0,     0,  3490,     0,     0,
       0,     0,   651,     0,     0,  1395,  1147,  6249,     0,  5834,
       0,  6251,     0,     0,     0,     0,  1395,     0,  2650,     0,
    6353,     0,  5756,  1395,  4136,  4137,  4138,  4139,  4140,  4141,
    4142,  4143,  4144,     0,     0,  4479,   187,     0,     0,     0,
       0,  4486,     0,     0,     0,     0,     0,  4136,  4137,  4138,
    4139,  4140,  4141,  4142,  4143,  4144,     0,  3490,   868,     0,
       0,     0,     0,     0,     0,  1395,     0,     0,     0,     0,
    6389,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1395,     0,     0,     0,     0,     0,  1395,  1395,     0,
    1001,     0,   956,   956,   956,   956,     0,     0,  6168,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,     0, -2992,     0,     0,     0,     0,
    4480,     0,     0,  1395,     0,     0,     0,     0,     0,  6249,
       0,   651,   976,  6251,     0,     0,     0,     0,   976,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     976,     0,     0,     0,     0,     0,   868,     0,     0,  3494,
       0,     0,     0,     0,     0,     0,   976,     0,     0,     0,
       0,   653,     0,     0,     0,     0,   919,     0,     0,     0,
     653,   976,     0,     0,     0,   868,     0,   653,     0,   976,
     653,     0,     0,     0,     0,     0,   650,   650,     0,     0,
       0,     0,   919,   976,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,  3490,     0,     0,     0,  1395,     0,
       0, -2992,     0,     0,   188,     0,     0,  4648,     0,  4650,
    1395,  4652,     0,  2584,  2585,  2586,  2587,  2588,  2589,  1395,
    1395,  1395,     0,     0,     0,  2014,  3330,  3330,     0,     0,
    3330,  3801,     0,     0,  1395,     0,     0,     0,   794,     0,
       0,     0,     0,  1395,   794,  1395,     0,  1395,  5609,     0,
     976,     0,     0,  2120,  5945,  1395,  2121,     0,   188,   188,
       0,     0,     0,     0,  2014,     0,  1003,     0,     0,     0,
       0,  1589,   653,   653,  1395,     0,     0,  1590,   976,     0,
       0,     0,     0,     0,     0,     0,     0,  6204,  2643,     0,
       0,     0,  1695,     0,     0, -2992,     0,     0,     0,     0,
       0,     0,     0,   976,     0,   653,     0,     0,     0,     0,
    2014,  2014,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2645,  1592,     0,     0,     0,     0,     0,     0,   919,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   956,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,     0,     0,  6116,     0,     0,     0,     0,
       0,  6254,  6255,     0,     0,   976,     0,  4916,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1696,     0,  1593,
       0,     0,     0,     0,  3482,     0,  1594,     0,     0,     0,
    1595,     0,     0,  5274,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3490,     0,  1395,     0,     0,     0,     0,     0,  1596,     0,
       0,     0,  3490,     0,     0,     0,     0,  1395,     0,     0,
       0,  5834,     0,   650,     0,     0,  2040,  1395,     0, -2992,
     650,  2040,  2040,     0, -2992,   650,     0,     0,   650,  5307,
       0,     0,     0,     0,  1597,     0,     0,     0,     0,     0,
       0,   967,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   653,   653,  1829,   956,     0,     0,     0,
       0,     0,   976,  2014,     0,     0,     0,   653,     0,     0,
       0,     0,   919,   653,     0, -2992,     0,   653,     0,   653,
    6139,     0,     0,   919,     0,     0,     0,     0,     0,  2852,
       0,     0,     0,     0,     0,     0,  1395,     0,     0,   919,
       0,     0,     0,     0,     0,     0,  4916,     0,     0,     0,
       0,     0,     0,   188,  1697,   967,   967,  6257,  1599,     0,
       0,  1395,  6253,     0,     0,  4019,     0,     0,  1600,     0,
       0,     0,     0,  2650,     0,  5968,     0,     0,  1601,     0,
       0,     0,     0,   653,   188,   653,   653,  2014,  2014,  6274,
    1602,     0,     0,     0,     0,  1395,  1395,     0,   188,  1395,
    6250,  3490,  6282,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,     0,     0,     0,  6325,   976,     0,     0,   956,
       0,     0,     0,  3772,     0,     0,  1604,  1605,     0,     0,
       0,  6228,     0,  6029,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   653,     0,     0,     0,     0,  6116,
     956,   956,     0,     0,     0,  4916,     0,  6252,  3773,     0,
   -2992,     0,     0,     0,     0,     0,     0,  6253,     0,     0,
       0,     0,     0,   651,     0,     0,     0,     0,     0,   976,
       0,  1395,  6455,  6456,     0,     0,     0,     0,  2112,  6344,
    5439,     0,     0,   919,     0,   976,     0,  1395,     0,     0,
       0,     0,  4019,     0,  3490,  6250,     0,  4664,     0,     0,
    3490,     0,   976,     0,  1395, -2757,     0,   976,     0,     0,
       0,   650,     0,     0,     0,     0,   192,     0,     0,   653,
       0,  1607,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6374,  6375,   651,  6379,     0,     0,     0,     0,  5834,
       0,     0,     0,     0,  1395,     0, -2992,     0,     0,     0,
       0,   653,  6252,     0,   956,     0,     0,  4916,  2584,  2585,
    2586,  2587,  2588,  2589,     0,     0,     0,     0,     0,  6253,
       0,     0,     0,     0,     0,     0,     0,  6344,     0,     0,
     653,   653,   653,     0,   653,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -2757, -2774,     0,     0,     0,     0,
       0,     0,  1395,   651,  3482,   653,   188,  6250,     0,     0,
       0,     0,  3490,     0,     0,     0,     0,     0,  1589,   651,
       0,     0,     0,     0,  1590,     0,     0,     0,   192,     0,
     976,     0,     0,     0,     0,     0,   967,   967,   976,   976,
    6458,     0,  6344,     0,     0,     0,     0, -2757,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5176,  6344,
   -2757,  5178,   653,     0,     0,     0, -2757,     0,     0,  1592,
       0,     0, -2757,     0,  6252,     0,     0,     0, -2757,     0,
       0, -2757,     0,     0,     0, -2757,     0,     0,     0,     0,
       0,  1829,     0,   650, -2774,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5204,     0,     0,   653,     0,
       0,     0,   653,   653,     0, -2757,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1593,     0,   653,     0,
       0,     0,     0,  1594,   919,   650,     0,  1595,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2774, -2757,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2774,     0,     0,     0,     0,  1596, -2774,     0,     0,     0,
       0,   966, -2774,     0,     0,     0,     0,     0, -2774,     0,
       0, -2774,     0,     0,   794, -2774,   794,     0,   794,     0,
       0,     0,     0,     0,   794,  1227,  1228,     0,     0, -2757,
       0,  1597,   919, -2757,     0,     0,     0,     0,     0, -2757,
       0,     0,     0,     0,     0, -2774,   966,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   919,     0,     0,     0,     0, -2774,     0,
       0,     0,   188,     0,     0,     0,     0,     0,  2120,     0,
       0,  2121,     0,     0,     0,  2122,  2123,  2124,     0,     0,
   -2757,     0,     0,     0,     0,     0,   919,   650,     0,     0,
       0,  1697,     0,  2642,     0,  1599,     0,     0,     0,     0,
       0,     0,     0,  2643,     0,  1600,  5332,     0,     0, -2774,
    2644,     0,     0, -2774,     0,  1601,   650,     0,     0, -2774,
       0,     0,     0,     0,     0,     0,     0,  1602,     0,     0,
       0,     0,     0,  6385,     0,     0,  2645,     0,     0,   809,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     976,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5370,  5371,     0,   653,   653,   653,     0, -2757,
    1725,     0,     0,  1604,  1605,     0,   650,     0,     0,     0,
   -2774,     0,     0,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -2757,     0, -2757, -2757,     0,   794,     0,
       0,     0,     0,     0,     0,  1726,     0,     0,     0,   188,
       0,     0,     0,     0,     0,     0,     0, -2757,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2757,     0,   809,
   -2757, -2757, -2757,     0,  2120,     0,     0,  2121,     0,     0,
       0,  2122,  2123,  2124,  2646,     0,  5414,  5415,     0,  2647,
       0,     0,     0,     0,     0,   976,     0,     0,   794, -2774,
       0,   719,     0,     0,     0,     0,     0,   919,  1607,  2643,
     808,     0,  2648,  2314,     0,     0,  2644,     0,   919,     0,
       0,     0,     0, -2774,     0, -2774, -2774,     0,     0,     0,
    1829,     0,     0,     0,   919,  5928,     0,     0,     0,     0,
    2649,     0,  2645,     0,     0,     0,     0, -2774,     0,     0,
       0,     0,     0,   976,  6324,  3961,     0,     0,     0,     0,
       0,   976,     0,   650,     0,     0,     0, -2774,     0,   976,
   -2774, -2774, -2774,     0,     0,     0,     0,     0,     0,  1559,
       0,     0,     0,  2381,     0,     0,     0,     0,   919,     0,
       0,     0,     0,     0,     0,     0,     0,   653,  2650,     0,
     653,  2651,     0,   919,     0,     0,   919,   919,     0,     0,
     653,   653,     0,   976,   976,  1560,  5508,     0,     0,  5510,
    5511,     0,     0,     0,     0,   653,     0,   976,   653,     0,
       0,     0,     0,     0,     0,     0,     0,   919,   919,  2120,
     976,   976,  2121,     0,     0,     0,  2122,  2123,  2124,     0,
    5526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2646,     0,     0,     0,  2642,  2647,     0,     0,     0,     0,
       0,     0,     0,     0,  2643,     0,   188,     0,  1561,     0,
     653,  2644,     0,     0,   653,   653,     0,     0,  2648,  2314,
       0,     0,     0,     0,     0,  2652,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2645,     0,     0,
       0,     0,     0,     0,     0,  1562,  2649,     0,     0,   653,
       0,   653,     0,     0,     0,     0,   653,   653,     0,     0,
       0,     0,     0,   653,   653,   653,   653,   653,   653,   653,
     653,   653,   653,   653,   653,   653,     0,     0,     0,   653,
       0,   653,     0,   653,   653,   653,   653,   653,   653,  2381,
    3962,   653,     0,   653,   653,  1563,     0,   653,     0,     0,
       0,     0,     0,     0,  2650,     0,     0,     0,     0,   650,
       0,   919,   653,   653,   653,     0,     0,     0,     0,     0,
       0,   650,     0,     0,     0,     0,     0,     0,     0,     0,
     653,  2580,  1829,     0,     0,     0,     0,     0,     0,  1565,
    2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,
       0,     0,     0,     0,     0,  2646,     0,  4102,     0,     0,
    2647,     0,     0,     0,     0,     0,     0,  2120,     0,     0,
    2121,     0,  1567,     0,  2122,  2123,  2124,     0,     0,     0,
    1529,     0,     0,  2648,  2314,     0,     0,     0,     0,   794,
       0,     0,  2642,     0,   794,   794,     0,     0,     0,     0,
       0,  2652,  2643,     0,     0,     0,     0,     0,     0,  2644,
       0,  2649,     0,     0,     0,   966,     0,     0,    36,     0,
       0,     0,  2660,  3963,     0,     0,     0,     0,     0,     0,
       0,  2667,  1570,  2668,     0,  2645,     0,  2671,     0,     0,
       0,  1571,     0,     0,  2677,     0,     0,     0,     0,  2830,
       0,     0,     0,     0,  2381,     0,     0,     0,     0,     0,
       0,     0,  1573,     0,     0,     0,     0,     0,     0,  2650,
       0,  1574,  2651,     0,     0,     0,  1575,   653,     0,     0,
     650,     0,     0,     0,     0,     0,     0,     0,     0,   966,
     966,     0,     0,     0,     0,     0,     0,  3964,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2580,     0,     0,
       0,     0,     0,     0,     0,     0,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,     0,     0,     0,     0,     0,
       0,   653,     0,  1576,     0,     0,   794,  3965,     0,     0,
       0,     0,     0,     0,     0,     0,   794,     0,     0,     0,
       0,     0,     0,  2646,     0,     0,     0,     0,  2647,     0,
       0,     0,     0,     0,     0,     0,  2652,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -136,  2648,  2314,     0,     0,     0,     0,   653,     0,     0,
    1227,  1228,     0,   650,     0,  5856,     0,     0,     0,   650,
       1,     0,     0,     0,     0,     0,     0,     0,     0,  2649,
       0,     2,     0,     3,     4,     0,     0,  6329,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     0,   794,     0,     0,   794,   794,     0,     0,
       0,     6,     0,     0,     0,     0,     0,     0,     0,  5893,
       0,     0,  2381,     7,     0,     8,     9,     0,     0,     0,
       0,     0,    10,     0,    11,     0,     0,  2650,     0,     0,
    2651,     0,  2580,     0,     0,     0,     0,    12,     0,    13,
    1078,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
       0,     0,     0,     0,  3359,     0,    14,  6377,     0,    15,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,     0,    17,     0,     0,     0,
      18,   650,     0,     0,     0,     0,     0,    19,     0,     0,
    1146,   719,     0,     0,     0,     0,    20,     0,    21,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    23,  2652,     0,     0,  6377,  5989,     0,
       0,   653,   653,   653,   653,   653,   653,   653,   653,   653,
      24,   653,     0,  6441,     0,     0,     0,     0,     0,     0,
       0,     0,   653,     0,   653,     0,  3961,     0,     0,     0,
     966,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1559,     0,     0,     0,     0,     0,     0,     0,   794,     0,
    1252,     0,   653,     0,    25,    26,   653,     0,     0,   653,
      27,   653,     0,     0,   653,     0,     0,     0,   653,     0,
    1274,     0,     0,     0,     0,    28,  1560,     0,  1398,     0,
       0,  1407,  1146,  1409,     0,     0,     0,     0,     0,  1829,
    2580,   653,     0,     0,    29,     0,     0,     0,     0,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,   653,     0,
       0,     0,  4118,     0,     0,  4119,     0,   653,   653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    30,     0,     0,     0,     0,     0,  1561,
       0,     0,    31,   976,     0,     0,     0,     0,     0,     0,
     919,     0,     0,     0,   919,   919,     0,    32,     0,     0,
       0,   976,     0,    33,    34,   976,    35,     0,     0,   976,
       0,    36,     0,     0,     0,     0,  1562,    37,   976,     0,
      38,     0,     0,     0,     0,     0,     0,    39,     0,     0,
       0,     0,     0,   976,    40,    41,   653,     0,     0,     0,
       0,     0,    42,     0,     0,     0,    43,   653,     0,   919,
     653,     0,   653,   653,     0,   919,     0,    44,     0,     0,
       0,  3962,     0,     0,     0,     0,  1563,   976,     0,     0,
       0,     0,     0,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,   976,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,     0,
       0,     0,   919,     0,     0,  3278,  3279,    47,     0,     0,
    1565,     0,     0,    48,     0,     0,     0,     0,    49,     0,
       0,     0,  3315,  3316,  1829,   976,  1146,     0,  1829,     0,
       0,    50,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2120,     0,  1567,  2121,     0,     0,     0,  2122,  2123,
    2124,  1529,   976,  3361,  1829,    51,     0,     0,   976,     0,
       0,     0,     0,     0,     0,     0,  2642,     0,     0,     0,
       0,     0,   976,     0,    57,     0,  2643,  -136,     0,   976,
       0,     0,   976,  2644,     0,     0,     0,  1589,   976,    36,
       0,     0,     0,  1590,  1569,     0,     0,     0,     0,     0,
    1656,     0,     0,  1570,     0,     0,     0,     0,   976,  2645,
       0,     0,  1571,     0,   976,     0,     0,     0,     0,     0,
    2830,   976,  1657,     0,     0,     0,     0,     0,     0,  6295,
       0,     0,     0,  1573,     0,   976,     0,     0,  1592,     0,
       0,     0,  1574,     0,     0,     0,     0,  1575,     0,   976,
       0,     0,     0,     0,  1829,     0,     0,     0,     0,     0,
     976,     0,     0,     0,     0,     0,     0,     0,  3964,     0,
       0,     0,     0,     0,  1658,     0,     0,     0,   653,   653,
     653,     0,     0,     0,   653,     0,  1589,     0,     0,     0,
       0,     0,  1590,     0,     0,  1593,     0,     0,     0,     0,
       0,     0,  1594,     0,  1576,     0,  1595,  1591,  3965,     0,
       0,   653,   919,     0,     0,     0,     0,     0,     0,  2039,
    1829,     0,     0,     0,     0,     0,     0,  2646,     0,     0,
       0,     0,  2647,     0,  1596,     0,     0,  1592,     0,     0,
    2120,     0,     0,  2121,     0,     0,     0,  2122,  2123,  2124,
       0,  1146,     0,   653,     0,  2648,  2314,     0,     0,     0,
       0,     0,     0,     0,     0,  2642,  1659,     0,     0,     0,
    1597,     0,     0,     0,     0,  2643,     0,     0,     0,     0,
       0,     0,  2644,  2649,     0,   919,     0,     0,     0,   919,
       0,     0,     0,     0,  1593,     0,     0,     0,     0,     0,
       0,  1594,     0,     0,     0,  1595,     0,     0,  2645,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2381,     0,     0,  1660,
       0,     0,     0,  1596,  1661,     0,     0,     0,     0,     0,
    2116,  2650,     0,     0,  2651,     0,     0,     0,     0,  2118,
    1662,     0,     0,     0,  1599,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1600,  2605,     0,     0,     0,  1597,
       0,     0,     0,     0,  1601,     0,     0,   976,     0,  1829,
       0,     0,     0,     0,  1146,  1663,  1602,  2622,  2623,   918,
       0,     0,  1146,  1146,   919,     0,   976,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,   653,     0,   919,
     653,     0,   653,   653,   919,     0,     0,     0,     0,     0,
       0,     0,   653,     0,     0,     0,  2646,   653,     0,  1664,
       0,  2647,  1604,  1605,  1665,     0,     0,     0,  2652,     0,
       0,     0,     0,     0,   919,     0,     0,     0,     0,  1598,
       0,     0,     0,  1599,  2648,  2314,     0,     0,  1666,     0,
       0,     0,     0,  1600,  1667,     0,     0,     0,     0,     0,
       0,     0,     0,  1601,     0,     0,   653,   653,   653,  1668,
       0,   653,  2649,     0,     0,  1602,     0,     0,     0,   653,
     653,   653,   653,     0,     0,     0,     0,     0,     0,     0,
    1829,     0,     0,     0,     0,   653,  1829,     0,   653,     0,
     653,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,   653,     0,  2381,   653,     0,  1603,     0,
       0,  1604,  1605,     0,     0,     0,     0,  1607,     0,     0,
    2650,     0,     0,  2651,  2580,     0,     0,   653,     0,   653,
       0,   653,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,  1589,  1606,     0,     0,     0,     0,  1590,  4120,
     653,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2120,   976,     0,  2121,     0,     0,     0,  2122,  2123,  2124,
       0,     0,     0,     0,     0,  3462,  3464,     0,     0,     0,
       0,  3472,     0,  1592,     0,  2642,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2643,     0,     0,   653,     0,
       0,   653,  2644,     0,     0,     0,  1607,  2652,     0,     0,
       0,     0,     0,  3518,  3518,   653,     0,     0,  2961,     0,
     653,     0,     0,     0,     0,     0,  2969,     0,  2645,     0,
       0,     0,     0,     0,     0,   653,     0,     0,     0,     0,
    1593,     0,     0,     0,     0,     0,     0,  1594,     0,   653,
       0,  1595,   653,     0,     0,     0,     0,     0,     0,   919,
       0,     0,   919,     0,   919,  1559,     0,     0,  2120,   919,
       0,  2121,     0,     0,   794,  2122,  2123,  2124,     0,  1596,
       0,     0,     0,     0,   976,   976,     0,     0,     0,     0,
     653,     0,     0,  2642,     0,     0,     0,     0,     0,     0,
       0,  1560,     0,  2643,     0,   976,     0,     0,   976,     0,
    2644,   919,     0,  2580,     0,  1597,     0,     0,     0,   919,
       0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,     0,     0,     0,     0,     0,  2645,     0,  4171,     0,
       0,     0,     0,     0,   919,     0,  2646,     0,     0,     0,
     653,  2647,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3644,     0,     0,  1561,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2648,  2314,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1829,
    1829,  1829,     0,     0,     0,  1697,     0,     0,     0,  1599,
       0,  1562,  2649,     0,     0,     0,     0,     0,     0,  1600,
       0,     0,     0,     0,   976,     0,     0,     0,     0,  1601,
       0,     0,     0,   919,     0,   919,     0,     0,     0,     0,
       0,  1602,     0,   976,     0,     0,     0,     0,     0,     0,
    3099,     0,     0,     0,  3104,  2381,     0,     0,     0,     0,
     794,  1563,     0,     0,  2646,   976,     0,     0,   794,  2647,
    2650,   794,  1589,  2651,     0,     0,     0,     0,  1590,     0,
       0,     0,     0,   794,  2810,  1656,     0,  1604,  1605,     0,
       0,     0,  2648,  2314,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,     0,  1657,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2811,
    2649,     0,     0,  1592,     0,     0,  2120,     0,     0,  2121,
       0,   919,     0,  2122,  2123,  2124,     0,     0,  1567,     0,
       0,     0,     0,     0,     0,     0,  1529,     0,     0,     0,
       0,  2642,     0,     0,     0,   976,     0,     0,     0,  1658,
     653,  2643,     0,  2381,     0,     0,   653,  2652,  2644,     0,
       0,     0,     0,     0,     0,   919,     0,     0,  2650,     0,
    1593,  2651,     0,     0,    36,     0,  2829,  1594,     0,  1569,
       0,  1595,  1607,     0,  2645,     0,     0,     0,  1570,     0,
       0,     0,  1829,   919,     0,     0,     0,  1571,   976,     0,
     976,     0,     0,     0,     0,  2830,     0,     0,     0,  1596,
       0,     0,     0,   976,     0,   976,  3289,     0,  1573,     0,
       0,     0,     0,     0,     0,     0,     0,  1574,     0,     0,
       0,     0,  1575,   918,     0,   653,     0,     0,     0,     0,
       0,  1659,     0,     0,     0,  1597,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
       0,   919,     0,  2580,     0,  2652,     0,     0,     0,     0,
       0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,     0,   976,   919,     0,  4112,     0,     0,     0,  1576,
       0,  2120,     0,     0,  2121,     0,     0,     0,  2122,  2123,
    2124,     0,  2646,     0,  1660,   919,     0,  2647,     0,  1661,
       0,     0,   916,     0,     0,     0,  2642,     0,     0,     0,
       0,     0,   794,     0,   976,  1662,  2643,     0,     0,  1599,
    2648,  2314,     0,  2644,     0,     0,     0,     0,     0,  1600,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,     0,     0,   976,     0,     0,     0,   976,  2649,  2645,
    1663,  1602,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2580,     0,     0,     0,     0,     0,     0,   976,     0,
    2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,
       0,     0,     0,  4516,   653,     0,     0,   919,     0,     0,
       0,  2381,     0,   653,  3745,     0,   918,  1604,  1605,  1665,
       0,     0,     0,     0,     0,     0,  2650,   653,     0,  2651,
       0,   653,   653,   653,     0,     0,     0,     0,   653,     0,
       0,   653,     0,  1666,   653,     0,     0,     0,     0,  3746,
     653,     0,   653,     0,     0,   653,     0,     0,     0,   919,
     653,   653,   653,   653,  1668,     0,   653,   653,   653,   653,
     653,   653,   653,   653,   653,   653,     0,     0,     0,   653,
     653,   653,     0,     0,   919,     0,     0,  2646,     0,   653,
       0,     0,  2647,     0,   653,     0,  1829,     0,   653,     0,
       0,     0,     0,     0,     0,     0,   653,     0,     0,   653,
       0,   653,     0,     0,     0,  2648,  2314,     0,     0,     0,
       0,     0,  1607,  2652,     0,     0,     0,   653,     0,     0,
     653,   653,     0,     0,     0,   653,   653,     0,     0,     0,
     653,     0,   653,  2649,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4228,     0,   794,     0,     0,
    1744,     0,     0,     0,     0,     0,     0,  2120,     0,     0,
    2121,   653,     0,  4235,  2122,  2123,  2124,   653,     0,   918,
       0,     0,     0,     0,     0,   653,  2381,     0,     0,   653,
     918,     0,  2642,     0,     0,     0,     0,     0,     0,     0,
       0,  2650,  2643,     0,  2651,     0,   918,     0,     0,  2644,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,  4284,  4284,     0,     0,     0,     0,  2580,
     919,     0,     0,     0,     0,  2645,     0,     0,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,     0,
       0,  4717,     0,     0,     0,     0,   976,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   653,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2120,  2652,     0,
    2121,     0,     0,     0,  2122,  2123,  2124,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1829,     0,
       0,  1589,  2642,  1829,   919,  1829,     0,  1590,     0,     0,
       0,     0,  2643,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1829,   919,  2646,     0,     0,     0,     0,  2647,     0,
       0,     0,     0,     0,     0,  2645,     0,     0,     0,     0,
     918,     0,  1592,     0,     0,  3440,     0,     0,     0,     0,
       0,  2648,  2314,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
     976,     0,     0,     0,  2580,     0,     0,     0,     0,  2649,
       0,     0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,     0,     0,     0,     0,  4790,     0,     0,  1593,
       0,     0,     0,     0,     0,     0,  1594,     0,     0,     0,
    1595,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2381,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   653,     0,     0,  2650,  1596,     0,
    2651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2646,     0,     0,     0,     0,  2647,     0,
     976,   976,     0,     0,   919,     0,     0,     0,     0,     0,
       0,   976,     0,     0,  1597,     0,     0,     0,   653,   653,
       0,  2648,  2314,     0,     0,     0,     0,     0,   976,     0,
       0,     0,  1146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2649,
       0,   919,     0,     0,     0,     0,   919,   653,   653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   653,     0,
       0,     0,     0,     0,  2652,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1409,     0,
       0,     0,  2381,     0,  1598,     0,     0,     0,  1599,   794,
       0,     0,     0,     0,     0,     0,   916,  2650,  1600,     0,
    2651,   653,     0,  1589,     0,     0,     0,     0,  1601,  1590,
       0,     0,  4563,     0,   976,     0,     0,  1829,     0,     0,
    1602,     0,   916,     0,     0,     0,     0,     0,     0,     0,
       0,  2750,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1592,     0,     0,     0,     0,   653,
       0,     0,     0,  2894,  1409,     0,  1604,  1605,     0,     0,
    2580,     0,     0,     0,     0,     0,     0,   653,     0,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,  1409,     0,
       0,     0,  4885,     0,  2652,     0,     0,     0,  2895,  2750,
       0,   907,     0,     0,     0,   653,     0,     0,   653,     0,
       0,  1593,     0,     0,     0,     0,   653,   653,  1594,   919,
       0,     0,  1595,   653,   653,     0,     0,     0,   653,     0,
       0,     0,     0,   653,     0,     0,   653,   653,     0,     0,
     918,     0,     0,   653,     0,     0,     0,     0,     0,     0,
    1596,     0,  3807,     0,     0,     0,  3811,     0,     0,     0,
       0,     0,     0,     0,     0,   653,     0,     0,     0,   916,
       0,  1607,   653,   918,     0,     0,     0,   653,     0,   794,
     653,   653,     0,     0,     0,     0,  1597,     0,   653,     0,
       0,     0,     0,  3844,     0,  3844,     0,  3844,  3844,   653,
    2580,   653,  3844,  3844,  3844,     0,  3844,  3844,  3844,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,
       0,     0,  4909,   919,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   976,     0,  1589,     0,
       0,   653,     0,     0,  1590,     0,     0,     0,     0,     0,
       0,     0,  1744,  1744,  1744,     0,     0,     0,     0,     0,
    3921,   659,     0,     0,     0,     0,  1697,   708,   659,     0,
    1599,     0,     0,   760,     0,   659,   919,     0,   720,     0,
    1600,   659,     0,  3257,   817,  3949,     0,     0,     0,  1592,
    1601,     0,     0,   976,     0,     0,     0,     0,   919,     0,
       0,     0,  1602,   879,   879,   976,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   653,     0,     0,     0,     0,     0,     0,   653,     0,
       0,     0,   916,     0,   723,  3258,     0,     0,     0,   976,
       0,     0,     0,   916,     0,  3628,  1593,     0,  1604,  1605,
       0,   724,     0,  1594,     0,     0,     0,  1595,     0,   916,
       0,     0,     0,     0,   918,     0,     0,     0,     0,  1061,
     919,     0,     0,     0,     0,   918,     0,     0,     0,     0,
    1606,     0,     0,     0,     0,  1596,     0,     0,     0,     0,
       0,   918,     0,  3259,     0,     0,   653,     0,     0,  1589,
       0,     0,     0,     0,     0,  1590,   727,     0,     0,     0,
       0,     0,   653,     0,     0,   728,     0,  1829,     0,     0,
       0,  1597,     0,     0,     0,     0,     0,     0,   729,     0,
       0,     0,     0,     0,  3260,     0,   976,     0,     0,     0,
       0,     0,     0,   653,     0,   918,     0,     0,     0,     0,
    1592,     0,     0,  1607,   958,     0,     0,     0,   962,     0,
     918,  1064,     0,   918,   918,     0,  1005,     0,     0,  1007,
       0,     0,  1012,  1013,     0,  1016,     0,  1019,     0,     0,
    1025,     0,  1027,     0,     0,     0,     0,     0,     0,   919,
       0,   919,     0,     0,   918,   918,     0,     0,     0,  3261,
       0,  1697,     0,     0,     0,  1599,     0,  1593,     0,     0,
     794,  1589,     0,     0,  1594,  1600,     0,  1590,  1595,     0,
       0,   733,     0,   916,     0,  1601,     0,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,  1602,   794,     0,
       0,     0,     0,     0,     0,     0,  1596,     0,     0,     0,
       0,     0,   794,     0,     0,     0,     0,     0,     0,   653,
       0,     0,  1592,   794,     0,     0,     0,     0,     0,   653,
       0,     0,   653,     0,     0,   653,   653,   653,     0,     0,
    3819,     0,  1597,  1604,  1605,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1146,  1744,     0,     0,     0,
     653,   653,   214,  3262,   653,     0,   738,     0,     0,     0,
    1744,     0,     0,  1744,     0,  3820,     0,     0,     0,  1593,
       0,   653,     0,     0,     0,   653,  1594,     0,     0,     0,
    1595,   653,     0,   909,  1068,   653,     0,  3263,   918,  1227,
    1228,   919,   653,     0,   742,     0,     0,     0,     0,     0,
       0,   743,     0,   976,   744,   976,     0,     0,  1596,     0,
       0,     0,  1697,     0,     0,     0,  1599,     0,     0,     0,
       0,     0,     0,     0,   745,     0,  1600,   653,     0,     0,
       0,     0,  1070,  2621,     0,     0,  1601,     0,  1607,   747,
       0,     0,  1071,     0,  1597,     0,     0,   749,  1602,     0,
       0,     0,   919,   976,     0,     0,     0,     0,     0,     0,
       0,     0,  3264,   653,     0,     0,     0,     0,     0,     0,
       0,  2120,     0,     0,  2121,     0,     0,   794,  2122,  2123,
    2124,     0,     0,     0,     0,     0,     0,     0,     0,   754,
       0,  4331,  1146,     0,  1604,  1605,  2642,     0,     0,     0,
       0,     0,     0,  1829,     0,     0,  2643,     0,   653,     0,
       0,     0,     0,  2644,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1697,   907,  4332,     0,  1599,     0,
       0,   910,     0,     0,   916,     0,     0,     0,  1600,  2645,
       0,     0,     0,     0,     0,   794,     0,     0,  1601,     0,
       0,   907,     0,     0,     0,     0,     0,     0,     0,     0,
    1602,     0,     0,     0,     0,     0,     0,     0,     0,   653,
       0,     0,   919,     0,     0,     0,     0,     0,     0,  4390,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   653,  1607,
     653,     0,   916,  4402,     0,     0,  1604,  1605,     0,     0,
       0,     0,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     653,     0,     0,     0,   653,     0,   653,  4439,  4403,     0,
       0,     0,     0,   916,     0,     0,     0,     0,     0,     0,
     653,     0,     0,     0,     0,     0,     0,  2646,   653,     0,
       0,   653,  2647,     0,     0,     0,     0,  1055,     0,     0,
       0,     0,   653,     0,     0,     0,   916,     0,  1092,   653,
       0,     0,  1096,     0,     0,  2648,  2314,     0,     0,  1109,
    1110,     0,     0,  1116,     0,  1120,  1121,     0,   907,     0,
       0,     0,     0,     0,     0,     0,     0,  4482,     0,     0,
    1143,  1607,     0,  2649,     0,     0,     0,     0,     0,     0,
       0,   653,     0,     0,     0,     0,     0,   919,  1156,     0,
       0,     0,   919,   919,     0,     0,     0,   653,     0,     0,
       0,     0,     0,   653,   653,   976,     0,     0,     0,  1184,
       0,  1186,     0,     0,     0,  3844,  2381,     0,     0,   976,
       0,  1202,     0,     0,     0,     0,     0,  4513,  4513,     0,
       0,  2650,     0,     0,  2651,     0,     0,  4529,     0,   653,
       0,     0,  1146,     0,  1146,     0,     0,   653,     0,     0,
    1829,     0,     0,     0,   794,   659,     0,     0,     0,     0,
     794,     0,     0,     0,     0,   794,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   653,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4584,     0,  5383,  5384,     0,     0,     0,  5387,  5388,     0,
       0,     0,     0,     0,     0,   919,   919,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   907,     0,     0,     0,  4620,  1146,   916,  2652,     0,
       0,  1744,   907,     0,   653,  1829,     0,     0,   916,   879,
       0,  1559,     0,     0,     0,     0,   653,     0,   907,     0,
       0,     0,     0,     0,   916,   653,   653,   653,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     653,  1829,     0,     0,   919,     0,     0,  1560,     0,   653,
       0,   653,     0,   653,     0,     0,     0,     0,     0,     0,
       0,   653,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   916,     0,
     653,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   916,  1550,     0,   916,   916,     0,     0,
       0,     0,     0,     0,  2580,  1829,     0,     0,   976,     0,
    1561,     0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,     0,     0,     0,     0,  5114,   916,   916,     0,
       0,     0,     0,     0,     0,     0,     0,  3540,     0,     0,
       0,  2750,  3546,     0,     0,     0,     0,  1562,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   653,     0,     0,     0,     0,     0,     0,  1728,     0,
       0,     0,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,   907,     0,     0,     0,     0,   909,     0,     0,
       0,     0,     0,  1849,     0,     0,   918,  1563,     0,     0,
       0,     0,   918,     0,     0,     0,     0,     0,  1861,  4791,
    1862,     0,     0,   909,     0,     0,     0,     0,   653,     0,
    1865,     0,     0,     0,     0,     0,     0,  1875,     0,     0,
       0,     0,     0,   653,     0,     0,     0,  1564,     0,     0,
       0,  1565,     0,   653,     0,     0,     0,     0,     0,   918,
       0,     0,     0,   976,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   653,     0,     0,
    1927,   916,  1929,  1566,  1567,     0,  2120,     0,     0,  2121,
     976,     0,  1529,  2122,  2123,  2124,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2642,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2643,     0,     0,     0,     0,  1568,     0,  2644,     0,
      36,     0,   653,     0,     0,  1569,     0,     0,     0,     0,
    2120,     0,   653,  2121,  1570,   910,     0,  2122,  2123,  2124,
       0,   653,   653,  1571,  2645,     0,     0,   653,   659,     0,
     659,  1572,   659,     0,   659,  2642,   659,   659,   659,     0,
     909,   910,     0,   659,  1573,  2643,     0,     0,   794,     0,
       0,     0,  2644,  1574,     0,  2035,     0,     0,  1575,     0,
       0,   653,   653,     0,  2120,   653,     0,  2121,     0,     0,
       0,  2122,  2123,  2124,     0,     0,     0,     0,  2645,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2642,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2643,
       0,   976,     0,     0,     0,     0,  2644,  1744,  4529,     0,
       0,     0,     0,     0,     0,  1576,     0,     0,     0,     0,
       0,     0,     0,   907,     0,   653,     0,     0,     0,     0,
       0,   653,  2645,     0,     0,     0,  4987,     0,     0,   918,
       0,     0,  2646,     0,     0,     0,     0,  2647,     0,   653,
       0,  5001,     0,     0,  5002,     0,  5003,   653,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2648,  2314,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   910,     0,
     653,   907,     0,     0,     0,     0,  2646,     0,  2649,     0,
       0,  2647,  5043,   909,     0,     0,     0,     0,     0,     0,
       0,     0,  2750,     0,   909,     0,  2750,     0,  3844,     0,
       0,     0,     0,  3844,  2648,  2314,     0,     0,     0,   653,
     909,     0,   907,     0,   919,     0,     0,     0,     0,     0,
     653,  2381,     0,     0,     0,     0,     0,     0,   879,     0,
    2646,     0,  2649,   653,     0,  2647,  2650,     0,     0,  2651,
    1829,     0,     0,     0,     0,   907,     0,     0,   912,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2648,  2314,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1559,     0,     0,     0,  2381,     0,     0,   653,   653,
       0,     0,     0,     0,     0,     0,  2649,     0,     0,     0,
    2650,     0,     0,  2651,     0,   653,     0,     0,     0,  1829,
       0,   918,  5148,     0,     0,  4529,     0,  1560,     0,     0,
       0,     0,   653,   653,     0,     0,   918,     0,     0,     0,
       0,   918,     0,     0,  1829,     0,     0,     0,     0,  2381,
       0,   910,     0,  2652,     0,   794,     0,     0,     0,     0,
       0,     0,   910,     0,  2650,     0,     0,  2651,     0,  2808,
       0,   918,     0,     0,     0,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1561,     0,     0,     0,   909,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2652,     0,     0,
       0,     0,     0,     0,     0,     0,  5208,  5208,  5208,  5208,
       0,  5208,  5208,  5208,  5208,  5208,     0,  1562,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2906,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   907,     0,     0,  2580,
       0,  2652,     0,     0,     0,     0,     0,   907,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,  1563,     0,     0,
       0,  5238,     0,   907,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2580,     0,     0,     0,  1564,     0,     0,
       0,  1565,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,     0,     0,     0,     0,  5275,     0,   907,     0,  5287,
       0,  5289,   910,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   907,  1630,  1567,   907,   907,     0,     0,     0,
       0,     0,  1529,  6071,     0,     0,     0,  2580,     0,     0,
     916,     0,     0,     0,   916,   916,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,     0,   907,   907,     0,  5279,
       0,     0,     0,     0,     0,     0,  1631,     0,     0,     0,
      36,     0,     0,     0,     0,  1569,     0,     0,     0,     0,
       0,     0,     0,     0,  1570,     0,  2750,     0,     0,  3546,
       0,  3546,     0,  1571,     0,     0,  2750,     0,     0,   916,
       0,  1632,     0,     0,     0,   916,     0,     0,     0,     0,
       0,     0,     0,     0,  1573,     0,     0,     0,     0,     0,
       0,     0,     0,  1574,  2120,   909,  3037,  2121,  1575,     0,
       0,  2122,  2123,  2124,     0,     0,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,   918,     0,     0,  2642,
       0,     0,   916,     0,     0,     0,     0,     0,     0,  2643,
       0,  3073,     0,     0,     0,     0,  2644,     0,     0,     0,
       0,  2750,     0,     0,     0,     0,     0,     0,     0,  2120,
       0,     0,  2121,     0,     0,  1576,  2122,  2123,  2124,     0,
       0,     0,  2645,   909,     0,     0,     0,     0,     0,     0,
     907,     0,     0,     0,  2642,     0,     0,  3138,     0,     0,
       0,     0,     0,     0,  2643,     0,     0,     0,     0,     0,
       0,  2644,  5411,  5412,     0,     0,     0,  3156,     0,     0,
       0,     0,     0,     0,   909,  3844,     0,  3844,  3844,  3844,
       0,     0,     0,     0,     0,     0,     0,  2645,     0,     0,
     918,     0,   918,  3176,     0,  3177,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   909,     0,     0,
    3186,     0,  3187,   910,     0,     0,     0,     0,     0,     0,
     659,     0,   659,     0,   659,     0,   659,     0,   659,     0,
       0,     0,   659,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5463,     0,     0,     0,     0,     0,     0,
    2646,     0,     0,     0,     0,  2647,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3248,
       0,     0,     0,     0,     0,     0,     0,     0,  2648,  2314,
       0,   910,  5491,     0,     0,     0,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   916,     0,     0,  2646,  2649,     0,     0,     0,
    2647,     0,     0,     0,     0,     0,     0,  1744,     0,     0,
       0,     0,   910,  1744,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  2648,  2314,     0,  5208,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2381,
       0,     0,   912,     0,     0,   910,     0,     0,     0,     0,
    3546,  2649,     0,     0,  2650,     0,     0,  2651,     0,     0,
       0,     0,     0,     0,     0,   916,     0,     0,   912,   916,
       0,     0,     0,     0,     0,     0,     0,     0,  1559,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   909,     0,
       0,     0,     0,     0,  2381,  2120,     0,     0,  2121,   909,
       0,     0,  2122,  2123,  2124,     0,     0,     0,     0,  2650,
       0,     0,  2651,     0,  1560,   909,     0,     0,   918,     0,
    2642,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2643,     0,     0,     0,     0,     0,     0,  2644,     0,     0,
    3546,   913,     0,     0,     0,     0,  6405,     0,     0,     0,
       0,  2652,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  2645,     0,     0,     0,     0,     0,   909,
       0,     0,     0,     0,   916,     0,     0,  1561,     0,     0,
       0,     0,     0,     0,   909,     0,  4529,   909,   909,   916,
       0,     0,     0,     0,   916,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6405,  2652,     0,     0,     0,
       0,     0,     0,     0,  1562,   912,     0,     0,   909,   909,
       0,     0,     0,     0,   916,     0,     0,     0,     0,     0,
    6405,     0,  3844,     0,     0,     0,   910,     0,     0,     0,
       0,  5692,     0,     0,     0,     0,     0,   910,     0,     0,
       0,     0,     0,     0,   918,     0,     0,  2580,     0,     0,
       0,     0,     0,   910,  1563,     0,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,     0,     0,     0,     0,  5548,
       0,  2646,     0,     0,     0,     0,  2647,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1564,     0,   918,     0,  1565,  2648,
    2314,     0,  2580,     0,     0,     0,     0,   910,     0,     0,
       0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
       0,   918,   910,     0,  5559,   910,   910,  2649,     0,     0,
    1647,  1567,     0,     0,     0,     0,     0,     0,     0,  1529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   909,     0,     0,     0,   910,   910,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   912,     0,
    2381,     0,     0,  1648,     0,     0,     0,    36,     0,   912,
       0,     0,  1569,     0,     0,  2650,     0,     0,  2651,     0,
       0,  1570,     0,     0,     0,   912,     0,     0,     0,     0,
    1571,     0,     0,     0,     0,     0,     0,     0,  1649,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1573,     0,     0,     0,     0,     0,     0,     0,     0,
    1574,     0,     0,  2120,     0,  1575,  2121,     0,     0,   907,
    2122,  2123,  2124,   907,   907,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2642,   916,
       0,  4077,   916,     0,   916,     0,     0,  2750,  2643,   916,
       0,     0,     0,     0,     0,  2644,     0,     0,     0,     0,
       0,     0,  2652,  1146,     0,     0,     0,  5903,     0,     0,
       0,     0,  1576,     0,     0,     0,     0,     0,   907,     0,
     910,  2645,     0,     0,   907,     0,     0,     0,     0,     0,
       0,   916,     0,     0,     0,     0,     0,     0,     0,   916,
       0,     0,     0,     0,     0,  2120,     0,     0,  2121,     0,
       0,     0,  2122,  2123,  2124,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   916,     0,     0,     0,     0,     0,
    2642,   907,     0,     0,     0,     0,     0,     0,     0,   912,
    2643,  3546,     0,     0,     0,     0,     0,  2644,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2580,  3546,
       0,     0,     0,  2645,     0,     0,     0,  2581,  2582,  2583,
    2584,  2585,  2586,  2587,  2588,  2589,     0,     0,     0,     0,
    5569,     0,     0,     0,     0,     0,     0,     0,     0,  2646,
       0,     0,     0,   916,  2647,   916,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3536,  3537,     0,
       0,     0,     0,     0,     0,     0,     0,  2648,  2314,     0,
       0,     0,     0,     0,     0,     0,  3552,  3553,     0,  3555,
    3556,     0,     0,     0,  3559,  3560,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2649,     0,     0,     0,  3571,
       0,     0,     0,  3574,     0,     0,     0,  3577,  3578,     0,
       0,  3581,  3582,     0,     0,     0,     0,     0,  3587,     0,
       0,     0,  1146,     0,     0,     0,  6077,     0,  6078,     0,
    3602,  2646,  6084,  6085,     0,     0,  2647,     0,  2381,     0,
       0,   916,  3619,     0,     0,     0,     0,  3621,     0,     0,
       0,   918,     0,  2650,     0,     0,  2651,     0,     0,  2648,
    2314,     0,  3627,     0,     0,     0,  3633,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3643,     0,     0,
    3647,   907,  3649,  3652,  3654,   916,     0,  2649,     0,  3662,
    3665,     0,     0,     0,     0,     0,     0,     0,  3546,  3678,
       0,     0,     0,  2750,     0,  3688,     0,     0,     0,  3691,
       0,     0,     0,   916,     0,     0,     0,     0,     0,     0,
       0,  3701,  3702,     0,     0,   913,  3707,     0,     0,     0,
    2381,     0,  3716,  3717,     0,     0,     0,     0,     0,     0,
     912,     0,     0,     0,     0,  2650,  3726,     0,  2651,  3727,
    2652,   913,     0,     0,   907,     0,  3739,  3740,   907,     0,
    2120,     0,  3744,  2121,     0,     0,     0,  2122,  2123,  2124,
       0,     0,     0,     0,  3751,     0,     0,  3754,     0,     0,
       0,   916,  3757,     0,     0,  2642,     0,     0,  3760,  3761,
       0,     0,     0,     0,     0,  2643,  3769,     0,     0,     0,
    3771,     0,  2644,   916,  3778,  3779,  3780,  3781,   912,  3783,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3809,  3810,   916,  3812,     0,  2645,     0,
       0,     0,     0,     0,     0,     0,     0,  3822,  3823,  3824,
       0,     0,  2652,     0,     0,     0,     0,     0,     0,   912,
       0,     0,     0,     0,     0,     0,  2580,     0,     0,     0,
       0,     0,     0,   907,     0,  2581,  2582,  2583,  2584,  2585,
    2586,  2587,  2588,  2589,     0,     0,   918,     0,   907,     0,
       0,     0,   912,   907,     0,     0,     0,     0,     0,     0,
       0,   909,     0,     0,  3876,   909,   909,     0,   913,     0,
       0,     0,  3900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   907,     0,     0,     0,   916,     0,     0,
       0,  3912,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2646,     0,  2580,     0,
     909,  2647,     0,     0,     0,     0,   909,  2581,  2582,  2583,
    2584,  2585,  2586,  2587,  2588,  2589,     0,     0,     0,   916,
    5625,  3980,     0,     0,  2648,  2314,     0,     0,     0,     0,
     918,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3994,     0,  3996,     0,   916,     0,     0,   915,     0,     0,
       0,     0,  2649,   909,     0,     0,     0,     0,     0,     0,
       0,  2120,     0,     0,  2121,     0,     0,     0,  2122,  2123,
    2124,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,     0,     0,  2642,     0,     0,   910,
       0,     0,     0,   910,   910,  2381,  2643,     0,     0,     0,
       0,     0,     0,  2644,     0,   918,     0,     0,     0,     0,
    2650,   913,     0,  2651,     0,     0,     0,     0,     0,     0,
       0,     0,   913,   912,     0,     0,     0,     0,     0,  2645,
       0,     0,     0,     0,   912,     0,     0,     0,   913,  4068,
       0,     0,     0,     0,  6406,     0,     0,     0,   910,     0,
     912,  2605,     0,     0,   910,  6410,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6436,
     916,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   910,     0,  6406,   912,     0,     0,  2652,   907,     0,
       0,   907,     0,   907,     0,     0,     0,     0,   907,   912,
       0,     0,   912,   912,     0,     0,     0,     0,  6406,     0,
       0,  5287,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   917,     0,     0,     0,     0,  2646,     0,     0,
       0,     0,  2647,   912,   912,     0,     0,     0,     0,     0,
     907,     0,     0,   909,     0,     0,     0,     0,   907,     0,
       0,     0,     0,     0,     0,  2648,  2314,     0,     0,     0,
       0,     0,     0,     0,   916,     0,     0,     0,     0,     0,
       0,     0,     0,   907,     0,     0,  5495,     0,   918,     0,
       0,     0,   913,  2649,     0,     0,     0,     0,     0,     0,
       0,     0,   916,  2580,     0,     0,     0,     0,     0,     0,
       0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,     0,     0,     0,     0,  5656,   909,     0,     0,     0,
     909,     0,     0,     0,     0,     0,  2381,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2650,     0,     0,  2651,     0,     0,     0,     0,     0,
       0,     0,   907,     0,   907,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   909,     0,     0,   918,     0,
       0,     0,     0,     0,   916,     0,     0,     0,  2652,  4316,
     909,     0,     0,     0,     0,   909,     0,     0,     0,     0,
     907,     0,     0,     0,     0,     0,  4323,     0,     0,     0,
    4323,     0,     0,     0,   910,  4334,  4335,  4336,   910,     0,
       0,     0,     0,     0,     0,   909,     0,     0,     0,     0,
       0,   916,     0,     0,     0,     0,   916,  4348,     0,  3546,
       0,     0,     0,     0,   907,     0,     0,     0,     0,     0,
    2120,     0,     0,  2121,     0,     0,     0,  2122,  2123,  2124,
    4377,  4378,  4379,  4380,     0,     0,     0,     0,     0,     0,
       0,     0,   907,     0,     0,  2642,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2643,     0,     0,     0,     0,
       0,     0,  2644,   913,  2580,     0,     0,     0,  4401,     0,
    4405,  4406,  4407,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,  2120,     0,     0,  2121,  5658,     0,  2645,  2122,
    2123,  2124,     0,   910,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,  1010,   910,     0,
     907,     0,     0,   910,     0,     0,     0,  2643,     0,     0,
       0,  1032,     0,     0,  2644,     0,     0,     0,     0,  3546,
       0,   913,   907,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   910,     0,     0,     0,     0,     0,     0,
    2645,     0,     0,     0,   907,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   913,     0,     0,     0,     0,     0,     0,   916,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4490,     0,     0,     0,     0,     0,     0,     0,     0,  4496,
       0,     0,     0,     0,     0,   913,  2646,     0,     0,     0,
       0,  2647,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   915,     0,     0,     0,  4506,  4507,     0,     0,     0,
    4508,     0,     0,     0,  2648,  2314,     0,     0,     0,     0,
     909,     0,     0,   909,     0,   909,   907,   915,     0,     0,
     909,     0,  4550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2649,     0,     0,     0,     0,     0,  2646,     0,
       0,     0,     0,  2647,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   916,   918,     0,     0,     0,     0,   918,
     918,     0,   909,     0,     0,     0, -2992, -2992,   907,     0,
     909,     0,     0,     0,  4587,  2381,     0,     0,     0,  4593,
       0,     0,     0,     0,     0,  4599,     0,     0,     0,     0,
    2650,     0,     0,   907,  2649,   909,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   916,     0,     0,     0,
       0,     0,     0,     0,     0,  4638,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   916,     0,
       0,     0,     0,     0,     0,     0,     0, -2992,     0,     0,
       0,     0,     0,     0,  4653,     0,  4654,     0,     0,     0,
       0,     0,  2650,     0,     0,     0,     0,     0,   910,     0,
       0,   910,     0,   910,   915,     0,   913,     0,   910,     0,
       0,     0,  5495,   918,   909,     0,   909,   913,     0,     0,
       0,     0,     0,     0,     0,     0,   917,  2652,     0,     0,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
     916,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     910,     0,   917,     0,     0,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   907,
       0,   918,     0,   910,     0,     0,     0,   913,     0,  2652,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   913,     0,     0,   913,   913,     0,     0,     0,
       0,     0,   909,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   912,     0,     0,     0,
     912,   912,     0,  2580,     0,     0,   913,   913,     0,     0,
       0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,     0,     0,     0,     0,     0,   909,     0,     0,     0,
       0,   916,   910,     0,   910,     0,     0,   915,     0,     0,
       0,     0,     0,   907,     0,     0,     0,     0,   915,     0,
       0,     0,  1102,     0,   909,   912,     0,     0,  1102,     0,
       0,   912,     0,     0,   915,  2580,     0,     0,     0,   917,
    1102,   907,     0,     0,  2581,  2582,  2583,  2584,  2585,  2586,
    2587,  2588,  2589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   912,   955,
     957,     0,     0,   960,     0,     0,     0,     0,     0,     0,
       0,     0,   909,     0,     0,     0,     0,     0,     0,     0,
     910,     0,     0,  1018,     0,     0,     0,     0,     0,     0,
    1028,     0,     0,     0,   909,     0,     0,     0,     0,     0,
     913,  2120,     0,     0,  2121,     0,     0,     0,  2122,  2123,
    2124,     0,     0,     0,     0,  4891,   909,  4892,     0,     0,
       0,     0,     0,     0,   910,     0,  2642,     0,     0,     0,
    4899,   916,     0,     0,     0,     0,  2643,     0,     0,     0,
       0,     0,  4905,  2644,     0,     0,  4908,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,  4921,     0,     0,
       0,     0,     0,   907,     0,     0,     0,     0,     0,  2645,
       0,     0,     0,     0,     0,     0,  4947,     0,   915,     0,
       0,     0,   917,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   916,   917,  4951,     0,     0,     0,     0,     0,
       0,     0,  4955,     0,     0,     0,     0,     0,   909,   917,
     907,     0,     0,     0,     0,   907,     0,     0,     0,     0,
     910,     0,     0,     0,     0,     0,     0,  4990,     0,     0,
       0,  4994,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,  5004,  5005,  5006,  5007,
       0,     0,     0,     0,     0,     0,  5011,  5012,  5013,  5014,
     909,     0,     0,     0,   910,  5016,  5017,     0,   912,     0,
       0,  5024,  5025,     0,  5027,  5028,  5029,  5030,  5031,  5032,
    5033,     0,     0,     0,     0,   909,     0,  2646,     0,     0,
    5042,     0,  2647,     0,  5045,  5046,  5047,  5048,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   916,     0,     0,  2648,  2314,     0,  4323,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5068,     0,     0,     0,
       0,   912,     0,  2649,     0,   912,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   910,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   917,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2381,     0,   907,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2650,     0,     0,  2651,     0,     0,     0,   910,     0,
       0,   918,  5149,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   909,     0,   910,     0,     0,     0,     0,     0,   915,
       0,     0,     0,     0,     0,  4323,     0,     0,     0,     0,
     912,     0,  5174,     0,  5175,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   912,     0,   916,     0,     0,
     912,     0,   916,   916,     0,  1744,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   907,     0,     0,     0,     0,  5201,  2652,     0,
     912,     0,     0,     0,     0,     0,     0,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   909,     0,     0,     0,     0,
       0,     0,  1088,     0,  1091,     0,     0,  1093,     0,     0,
       0,     0,     0,     0,     0,   907,     0,     0,   915,     0,
       0,  1119,     0,   909,     0,     0,     0,  1123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   907,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   910,
       0,   915,     0,     0,     0,     0,   916,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2580,     0,     0,     0,     0,     0,
       0,     0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,     0,     0,     0,     0,  5697,     0,     0,     0,
       0,     0,     0,     0,   917,     0,     0,     0,     0,   907,
       0,  2120,     0,     0,  2121,     0,     0,     0,  2122,  2123,
    2124,     0,     0,     0,   916,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2642,     0,     0,     0,
       0,     0,     0,   910,     0,     0,  2643,     0,     0,     0,
       0,     0,     0,  2644,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   909,     0,  5334,  5335,  5336,
       0,   910,   917,  5337,  5338,  5339,  5340,     0,     0,  2645,
    5342,     0,     0,     0,     0,     0,     0,     0,     0,   913,
       0,     0,     0,   913,   913,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   909,   917,     0,   912,     0,   909,   912,     0,
     912,     0,     0,     0,     0,   912,     0,     0,     0,     0,
     907,  5375,  5376,  5377,  5378,  5379,     0,  5381,  5382,     0,
       0,     0,   915,     0,     0,     0,   917,     0,   913,  5391,
    5392,     0,     0,   915,   913,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   912,     0,   915,
       0,     0,     0,     0,     0,   912,     0,     0,     0,     0,
       0,     0,     0,  5398,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2646,     0,     0,
     912,   913,  2647,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   910,     0,     0,     0,     0,  1621,  1622,
       0,     0,     0,   915,     0,  2648,  2314,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   915,     0,
       0,   915,   915,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2649,     0,     0,     0,     0,     0,     0,
     910,     0,     0,     0,     0,   910,     0,     0,     0,     0,
       0,     0,   915,   915,     0,     0,     0,   198,     0,   912,
     907,   912,     0,     0,     0,  5461,     0,     0,     0,  1848,
     909,     0,     0,     0,     0,     0,  2381,     0,     0,     0,
       0,     0,     0,     0,  1860,     0,     0,     0,     0,     0,
       0,  2650,     0,     0,  2651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   199,     0,
       0,     0,     0,     0,     0,  1882,  1883,   917,     0,     0,
       0,   907,     0,     0,     0,   200,     0,     0,   917,     0,
    5512,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1920,     0,   201,   917,     0,     0,     0,     0,   202,
       0,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   203,     0,     0,
       0,     0,     0,  5528,   909,     0,     0,     0,     0,     0,
     204,  1958,  1960,     0,     0,     0,     0,     0,  2652,   205,
    3009,   913,     0,     0,     0,     0,   915,     0,   917,     0,
       0,   912,   206,     0,     0,     0,     0,     0,   207,     0,
       0,     0,     0,   917,     0,   208,   917,   917,   910,     0,
       0,     0,     0,     0,     0,     0,     0,   909,     0,   912,
       0,     0,     0,     0,     0,   209,     0,     0,     0,     0,
       0,   907,     0,     0,     0,     0,     0,   917,   917,   909,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   913,     0,     0,     0,   913,     0,
       0,   659,     0,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2580,   211,     0,   912,     0,     0,
       0,     0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,     0,     0,   916,     0,  6054,     0,     0,   912,
       0,   909,   910,     0,     0,     0,  2120,  5645,     0,  2121,
       0,     0,     0,  2122,  2123,  2124,     0,     0,     0,   212,
       0,   912,     0,     0,     0,     0,  5655,     0,     0,     0,
       0,  2642,  5661,  5662,     0,     0,     0,     0,     0,     0,
       0,  2643,  5673,  3088,     0,     0,   213,     0,  2644,  5675,
       0,  3105,     0,   913,     0,   910,   214,   215,     0,  3009,
     216,     0,     0,     0,     0,     0,     0,     0,   913,     0,
       0,   917,     0,   913,  2645,     0,   907,   910,     0,     0,
       0,   907,   907,     0,  5727,  5728,     0,     0,   217,     0,
       0,   218,     0,     0,     0,   219,     0,  5736,   220,  5738,
       0,     0,     0,   913,  3163,   221,     0,     0,   222,     0,
       0,     0,     0,   912,  5752,     0,     0,     0,     0,     0,
       0,     0,   909,     0,     0,     0,     0,     0,   223,     0,
       0,  3009,     0,     0,     0,     0,   224,     0,     0,  4323,
       0,   225,     0,   226,     0,     0,   227,     0,     0,   910,
       0,   228,     0,     0,     0,     0,     0,  5792,     0,     0,
       0,   229,     0,     0,     0,   912,   230,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     231,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     912,     0,  2646,   232,     0,   907,     0,  2647,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2648,  2314,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   968,   978,     0,     0,
       0,     0,     0,     0,   968,     0,   978,   968,  2649,     0,
       0,     0,     0,     0,     0,  5857,     0,     0,     0,     0,
     978,     0,     0,   907,     0,  2828,     0,     0,     0,     0,
     910,     0,   909,     0,     0,     0,     0,     0,     0,  5874,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2873,  2381,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2650,     0,     0,  2651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2120,
       0,     0,  2121,     0,     0,     0,  2122,  2123,  2124,     0,
       0,     0,     0,   909,     0,     0,   912,     0,     0,     0,
       0,     0,     0,     0,  2642,     0,  5934,     0,   913,     0,
       0,   913,     0,   913,  2643,     0,     0,     0,   913,     0,
       0,  2644,     0,     0,     0,     0,     0,  2963,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2645,     0,     0,
       0,     0,     0,     0,     0,     0,  2989,  2990,  2991,  2992,
     913,     0,     0,  2652,     0,     0,     0,     0,   913,     0,
       0,     0,     0,     0,     0,     0,     0,  4323,     0,     0,
     910,  5984,     0,     0,     0,     0,     0,     0,     0,     0,
     912,     0,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   909,     0,     0,  6020,     0,   912,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6044,     0,     0,     0,   915,     0,     0,     0,   915,
     915,     0,     0,     0,     0,  2646,     0,     0,     0,  2580,
    2647,     0,   913,     0,   913,  6066,     0,     0,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,     0,
       0,  6065,     0,  2648,  2314,     0,     0,     0,     0,     0,
       0,     0,     0,  3046,  3047,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   915,     0,     0,     0,     0,  3064,
     915,  2649,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3107,  3108,  3109,  3110,     0,     0,     0,
     912,   910,     0,     0,  2381,     0,     0,   915,   909,     0,
     913,     0,     0,   909,   909,     0,     0,     0,     0,  2650,
       0,     0,  2651,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,   912,     0,   913,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3184,     0,     0,     0,     0,     0,
    3188,     0,   913,     0,     0,     0,     0,     0,     0,  6203,
     917,     0,   978,     0,   917,   917,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   978,     0,     0,     0,     0,  2652,   978,     0,     0,
       0,     0,  6216,     0,     0,     0,     0,   909,     0,   978,
       0,     0,     0,  6226,     0,     0,     0,     0,     0,  2120,
       0,     0,  2121,     0,     0,   978,  2122,  2123,  2124,   917,
     913,     0,     0,     0,     0,   917,   910,     0,     0,   968,
     978,   910,   910,     0,  2642,     0,   968,     0,   978,   968,
       0,     0,   913,   907,  2643,     0,     0,     0,     0,     0,
       0,  2644,   978,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   978,     0,   913,   909,     0,     0,     0,     0,
       0,     0,   917,     0,     0,     0,     0,  2645,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   915,     0,     0,
       0,     0,  2580,     0,     0,   912,     0,     0,     0,     0,
       0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
       0,     0,     0,     0,  6088,     0,     0,     0,     0,   978,
       0,     0,     0,     0,     0,     0,     0,     0,  6305,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3374,     0,     0,     0,     0,   910,     0,   978,     0,     0,
       0,     0,     0,  3535,     0,     0,   913,     0,     0,     0,
     915,     0,     0,     0,   915,     0,     0,     0,     0,     0,
       0,  3551,   978,     0,     0,  3554,     0,     0,     0,  3557,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2646,     0,     0,     0,   912,
    2647,     0,     0,  3576,     0,     0,     0,     0,   913,     0,
       0,     0,     0,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2648,  2314,     0,     0,     0,     0,     0,
       0,     0,     0,   913,   978,     0,     0,  3618,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2649,   912,     0,     0,     0,     0,  1102,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   915,
       0,     0,     0,     0,   912,     0,     0,     0,     0,     0,
       0,     0,   917,     0,   915,     0,     0,     0,     0,   915,
       0,     0,     0,     0,  2381,  3677,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2650,
       0,     0,  2651,     0,     0,     0,     0,     0,  2120,   915,
       0,  2121,  3706,     0,     0,  2122,  2123,  2124,  3715,     0,
       0,     0,     0,     0,     0,  6447,     0,     0,     0,     0,
       0,     0,  3725,  2642,  1831,     0,   912,     0,     0,  1102,
       0,   978,  3738,  2643,     0,   917,     0,     0,  3743,   917,
    2644,     0,   968,     0,     0,     0,   968,     0,   968,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3756,   913,
     720,     0,     0,     0,  3759,   721,  2645,     0,     0,     0,
       0,  3767,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3782,  2652,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3808,
       0,     0,     0,   722,     0,     0,     0,     0,     0,     0,
    1102,     0,     0,     0,     0,     0,   723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   917,     0,     0,   912,     0,     0,
       0,   725,     0,   913,     0,   978,     0,     0,     0,   917,
       0,     0,     0,     0,   917,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   726,     0,     0,     0,     0,
       0,   913,     0,     0,  2646,     0,     0,     0,   727,  2647,
       0,     0,  2580,     0,   917,     0,     0,   728,     0,     0,
       0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
     729,     0,  2648,  2314,  6311,     0,   730,     0,   978,     0,
       0,     0,     0,   731,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   978,     0,     0,     0,     0,     0,
    2649,     0,     0,   732,   915,     0,     0,   915,     0,   915,
       0,   978,     0,     0,   915,   909,   978,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2381,     0,  3374,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   915,   912,  2650,     0,
       0,  2651,     0,   733,   915,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   913,     0,     0,     0,  4036,     0,   915,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4052,   734,     0,     0,
       0,     0,     0,  4036,     0,     0,     0,     0,   912,     0,
     735,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     913,     0,     0,   977,   736,   913,     0,     0,     0,     0,
       0,     0,   977,     0,   214,   737,     0,     0,   738,   978,
       0,     0,     0,     0,     0,  2652,   977,   978,   978,     0,
       0,     0,     0,   910,     0,     0,     0,     0,   915,     0,
     915,     0,     0,     0,     0,     0,   739,     0,     0,   740,
       0,     0,     0,   741,     0,     0,   742,     0,     0,     0,
       0,     0,     0,   743,     0,     0,   744,     0,     0,   917,
       0,     0,   917,     0,   917,     0,  3601,     0,     0,   917,
    1831,  2120,     0,     0,  2121,     0,   745,     0,  2122,  2123,
    2124,     0,     0,     0,   746,     0,     0,     0,     0,     0,
       0,   747,     0,     0,   748,     0,  2642,     0,   912,   749,
       0,     0,     0,     0,     0,     0,  2643,   750,     0,   751,
       0,   917,     0,  2644,   752,     0,     0,     0,     0,   917,
       0,  2580,     0,     0,     0,     0,   915,     0,   753,     0,
    2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,  2645,
       0,   754,     0,  6328,   917,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   913,     0,
     915,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2120,     0,   915,  2121,
       0,     0,     0,  2122,  2123,  2124,     0,     0,     0,     0,
    3750,     0,     0,  3753,     0,     0,     0,     0,     0,     0,
       0,  2642,     0,   917,     0,   917,     0,     0,     0,     0,
       0,  2643,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   912,     0,     0,     0,  2646,   912,   912,
       0,     0,  2647,     0,  2645,     0,   915,     0,     0,     0,
       0,     0,   913,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2648,  2314,     0,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3848,     0,     0,  4315,     0,     0,     0,     0,
     915,     0,     0,  2649,     0,  3861,     0,     0,     0,   978,
       0,   917,     0,  3870,     0,   913,     0,     0,  2120,     0,
       0,  2121,     0,     0,     0,  2122,  2123,  2124,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,  2642,     0,     0,  2381,     0,     0,     0,
       0,     0,  3914,  2643,     0,   917,     0,     0,     0,     0,
    2644,  2650,   912,     0,  2651,     0,     0,     0,     0,     0,
       0,     0,  2646,  3938,     0,     0,     0,  2647,     0,     0,
       0,     0,     0,   917,     0,     0,  2645,     0,     0,     0,
       0,     0,   915,     0,     0,     0,     0,     0,     0,     0,
    2648,  2314,     0,     0,  4400,     0,     0,     0,     0,   913,
       0,     0,     0,     0,     0,     0,  3993,     0,  3995,     0,
       0,     0,     0,     0,   978,     0,     0,     0,  2649,     0,
     912,     0,     0,     0,     0,     0,     0,     0,   977,     0,
       0,     0,     0,     0,   915,  2120,     0,     0,  2121,     0,
       0,   917,  2122,  2123,  2124,     0,     0,   977,  2652,  1831,
       0,     0,     0,   977,     0,     0,     0,     0,     0,   915,
    2642,  2381,     0,   917,  3501,   977,  2120,     0,     0,  2121,
    2643,     0,   978,  2122,  2123,  2124,  2650,  2644,     0,  2651,
     978,   977,     0,     0,     0,   917,     0,     0,   978,     0,
       0,  2642,     0,     0,  2646,     0,   977,     0,  4060,  2647,
       0,  2643,     0,  2645,   977,  4067,     0,  4782,  2644,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   977,     0,
     913,     0,  2648,  2314,     0,  4495,     0,     0,   977,   968,
     968,     0,   978,   978,  2645,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   968,     0,   978,   968,     0,     0,
    2649,     0,     0,     0,  2580,  3502,     0,     0,     0,   978,
     978,     0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,     0,  2652,     0,     0,  6387,   917,     0,     0,
       0,     0,     0,     0,     0,   977,     0,     0,     0,     0,
       0,     0,  4783,  2381,     0,     0,     0,     0,     0,   968,
       0,     0,     0,   968,   968,   915,     0,     0,  2650,     0,
       0,  2651,     0,   977,     0,     0,     0,     0,     0,     0,
       0,  2646,     0,     0,     0,     0,  2647,  4149,     0,   917,
       0,     0,     0,  4150,     0,     0,     0,     0,   977,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2648,
    2314,     0,  2646,     0,   917,     0,     0,  2647,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     913,     0,     0,     0,     0,     0,     0,  2649,     0,  2580,
    2648,  2314,     0,     0,     0,     0,     0,     0,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,   915,
     977,     0,     0,     0,  3009,  2652,     0,     0,  2649,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2381,  1831,     0,     0,     0,     0,     0,   915,     0,     0,
       0,   913,     0,  4682,     0,  2650,     0,  4686,  2651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2381,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2650,     0,     0,  2651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     917,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1830,  2580,     0,     0,     0,     0,     0,   977,     0,     0,
    2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,
       0,  3033,  2652,     0,  4319,  4320,  2120,     0,     0,  2121,
       0,     0,     0,  2122,  2123,  2124,     0,     0,     0,     0,
       0,   913,     0,     0,     0,     0,     0,  2120,     0,     0,
    2121,  2642,     0,  4151,  2122,  2123,  2124,     0,     0,   915,
       0,  2643,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,     0,  2642,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2643,     0,   917,     0,     0,  3503,     0,  2644,
       0,     0,     0,     0,  2645,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   915,     0,     0,     0,
       0,   915,   917,     0,     0,  2645,     0,     0,     0,     0,
     912,     0,     0,     0,     0,     0,     0,     0,  2580,     0,
       0,   977,     0,     0,     0,     0,     0,  2581,  2582,  2583,
    2584,  2585,  2586,  2587,  2588,  2589,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2580,
       0,     0,     0,     0,     0,     0,     0,     0,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6157,     0,     0,     0,
       0,     0,     0,     0,   977,     0,   913,     0,     0,     0,
       0,   913,   913,     0,     0,     0,     0,     0,     0,     0,
     977,     0,  2646,     0,     0,     0,  4898,  2647,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   977,     0,     0,
       0,     0,   977,  2646,     0,     0,     0,     0,  2647,     0,
    2648,  2314,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   917,     0,     0,     0,     0,     0,
       0,  2648,  2314,     0,     0,     0,     0,     0,  2649,     0,
       0,     0,     0,     0,     0,     0,     0,  4503,     0,     0,
       0,     0,     0,     0,   915,  2120,     0,     0,  2121,  2649,
       0,     0,  2122,  2123,  2124,     0,     0,     0,     0,     0,
       0,   917,     0,     0,     0,     0,   917,     0,     0,     0,
    2642,  2381,     0,     0,     0,   913,     0,     0,     0,     0,
    2643,     0,     0,     0,     0,     0,  2650,  2644,     0,  2651,
       0,     0,  2381,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2650,     0,     0,
    2651,     0,     0,  2645,     0,  6158,     0,  5023,     0,     0,
    5026,     0,     0,     0,     0,   977,     0,     0,     0,     0,
       0,     0,     0,   977,   977,     0,     0,     0,     0,     0,
       0,     0,     0,   913,     0,     0,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2652,     0,     0,  1830,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4656,     0,     0,
       0,   915,     0,     0,  2652,     0,     0,     0,  1831,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5108,     0,   915,     0,     0,     0,     0,     0,     0,
       0,  2646,     0,     0,     0,     0,  2647,     0,  3009,   917,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2648,
    2314,     0,   978,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     978,     0,     0,     0,   978,     0,     0,  2649,   978,  2580,
       0,     0,     0,     0,     0,   915,     0,   978,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,  4086,
    2580,     0,   978,     0,     0,     0,     0,     0,     0,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,   968,
    2381,   968,   968,     0,  4036,     0,     0,     0,     0,     0,
       0,     0,     0,   917,     0,  2650,   978,     0,  2651,     0,
       0,     0,     0,     0,     0,     0,  2120,     0,     0,  2121,
       0,     0,     0,  2122,  2123,  2124,   978,   978,     0,  4122,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2642,     0,     0,  4154,     0,     0,     0,     0,     0,
       0,  2643,     0,     0,     0,     0,   917,     0,  2644,     0,
       0,     0,     0,  1831,   978,     0,     0,  1831,     0,     0,
       0,     0,     0,     0,     0,     0,   915,     0,   917,     0,
       0,     0,     0,     0,  2645,     0,     0,     0,     0,     0,
       0,   978,     0,  1831,     0,   977,     0,   978,     0,     0,
       0,     0,  2652,     0,     0,     0,     0,     0,     0,     0,
       0,   978,     0,     0,     0,     0,     0,     0,   978,     0,
       0,   978,     0,     0,     0,     0,     0,   978,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   978,     0,     0,
     917,     0,     0,   978,     0,     0,     0,     0,     0,     0,
     978,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   978,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   978,     0,
       0,     0,     0,  1831,     0,     0,     0,     0,     0,   978,
       0,     0,  2646,     0,     0,     0,     0,  2647,  2580,     0,
     977,     0,     0,     0,     0,     0,     0,  2581,  2582,  2583,
    2584,  2585,  2586,  2587,  2588,  2589,   915,     0,  1377,  1377,
    2648,  2314,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1830,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2649,  1831,
       0,     0,     0,     0,     0,     0,     0,     0,   977,     0,
       0,   917,     0,  5380,     0,     0,   977,     0,     0,     0,
       0,     0,     0,     0,   977,  5390,     0,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2381,     0,  -136,     0,     0,     0,     0,  1377,     0,
       0,     0,     0,   913,     0,     0,  2650,     0,     0,  2651,
       0,     0,     0,     1,     0,     0,     0,     0,   977,   977,
       0,     0,     0,     0,     2,     0,     3,     4,     0,     0,
       0,     0,   977,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,   977,   977,     0,     0,     0,
       0,     0,     0,     0,     6,     0,     0,     0,  5065,     0,
       0,     0,     0,     0,     0,     0,     7,     0,     8,     9,
       0,     0,  5067,     0,     0,    10,     0,    11,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      12,     0,    13,     0,     0,     0,     0,   915,     0,     0,
       0,     0,     0,  2652,     0,     0,   978,     0,  1831,    14,
       0,   917,    15,     0,     0,     0,     0,     0,     0,  1741,
    1745,     0,     0,     0,     0,   978,     0,    16,     0,    17,
       0,     0,   978,    18,     0,     0,     0,     0,     0,   968,
      19,   968,   968,     0,     0,     0,     0,     0,     0,    20,
       0,    21,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   917,     0,     0,     0,    23,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4036,     0,     0,     0,  1830,     0,  2580,
       0,     0,     0,     0,     0,     0,     0,     0,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,  1831,
       0,     0,     0,     0,     0,  1831,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,    26,     0,
       0,     0,   915,    27,     0,     0,     0,   915,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,     0,     0,     0,   720,     0,     0,     0,
       0,  1057,     0,     0,     0,     0,     0,    29,     0,     0,
       0,     0,   917,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1058,
     978,     0,     0,  4036,     0,  4036,    30,     0,   981,     0,
       0,     0,   723,  1059,     0,    31,     0,     0,     0,     0,
    1015,     0,     0,     0,     0,  1060,     0,     0,     0,   724,
      32,  1034,     0,     0,     0,     0,    33,    34,     0,    35,
       0,     0,     0,     0,    36,  2064,     0,  1061,     0,     0,
      37,   915,     0,    38,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,    40,    41,     0,
       0,  1062,     0,     0,     0,    42,     0,     0,     0,    43,
       0,     0,     0,     0,   727,     0,     0,  2090,     0,     0,
      44,     0,     0,   728,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   729,    45,     0,     0,
       0,     0,  1063,     0,     0,     0,  2109,  2110,  2111,   915,
    2113,     0,     0,   978,   978,     0,     0,   917,    46,     0,
       0,     0,   917,   917,     0,     0,     0,     0,     0,  1064,
      47,  2598,     0,     0,   978,     0,    48,   978,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,     0,     0,     0,     0,
       0,     0,     0,  2120,     0,     0,  2121,  1065,     0,     0,
    2122,  2123,  2124,     0,     0,     0,     0,     0,    51,     0,
      52,    53,    54,    55,    56,     0,     0,     0,  2642,   733,
       0,     0,     0,     0,     0,     0,     0,    57,  2643,     0,
    -136,     0,     0,     0,     0,  2644,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1831,  1831,
    1831,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5406,  2645,     0,  1066,  2694,     0,   917,     0,  2706,  2711,
       0,     0,     0,   978,     0,  5410,     0,  2120,     0,     0,
    2121,     0,     0,     0,  2122,  2123,  2124,     0,     0,     0,
     736,     0,   978,     0,     0,     0,     0,     0,     0,     0,
     214,  1067,  2642,     0,   738,  4166,     0,     0,     0,     0,
       0,     0,  2643,     0,   978,     0,     0,     0,     0,  2644,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1068,     0,   917,  1069,     0,     0,     0,   741,
       0,     0,   742,     0,     0,  2645,     0,     0,     0,   743,
       0,     0,   744,     0,     0,     0,     0,     0,     0,     0,
    4159,     0,     0,     0,     0,     0,  5468,     0,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,  2646,
    1070,     0,     0,     0,  2647,     0,     0,   747,     0,     0,
    1071,     0,     0,     0,     0,   749,     0,     0,     0,     0,
       0,     0,     0,  1072,   978,   751,     0,  2648,  2314,     0,
    1073,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2649,     0,   754,     0,     0,
       0,     0,     0,     0,  1830,     0,     0,     0,     0,     0,
       0,  1831,     0,     0,     0,     0,     0,   978,     0,   978,
       0,     0,     0,  2646,     0,     0,     0,     0,  2647,     0,
       0,     0,   978,     0,   978,     0,     0,     0,  2381,     0,
       0,     0,     0,  1054,     0,     0,     0,     0,     0,  1086,
       0,  2648,  2314,  2650,     0,     0,  2651,     0,   977,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1741,  1741,  1741,     0,     0,   977,     0,     0,  2649,
     977,     0,     0,     0,   977,     0,     0,     0,     0,     0,
       0,     0,     0,   977,     0,     0,     0,     0,     0,     0,
       0,   978,     0,     0,     0,     0,     0,     0,   977,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2381,  2120,     0,     0,  2121,     0,     0,     0,
    2122,  2123,  2124,     0,     0,     0,     0,  2650,     0,     0,
    2651,     0,   977,   978,     0,     0,     0,     0,  2642,  5631,
    2652,  5633,     0,     0,     0,     0,     0,     0,  2643,     0,
       0,     0,   977,   977,     0,  2644,     0,     0,     0,     0,
       0,     0,   978,     0,     0,     0,   978,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2645,     0,     0,     0,     0,     0,   978,     0,  1830,
     977,     0,     0,  1830,     0,     0,     0,     0,     0,   915,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1402,     0,     0,   977,     0,  1830,
       0,     0,     0,   977,  2652,     0,     0,     0,     0,     0,
       0,     0,     0,  1425,     0,     0,     0,   977,     0,     0,
       0,     0,     0,     0,   977,     0,  2580,   977,     0,     0,
       0,     0,     0,   977,     0,  2581,  2582,  2583,  2584,  2585,
    2586,  2587,  2588,  2589,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   977,     0,     0,     0,  5757,     0,   977,
       0,     0,     0,     0,     0,     0,   977,     0,     0,     0,
       0,     0,     0,  4036,     0,  1831,     0,     0,     0,  2646,
     977,     0,     0,     0,  2647,  1483,     0,     0,     0,     0,
       0,     0,     0,     0,   977,     0,     0,     0,     0,  1830,
       0,     0,     0,     0,     0,   977,     0,  2648,  2314,     0,
    2580,     0,     0,     0,     0,     0,     0,     0,     0,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,
       0,     0,  1620,     0,     0,  2649,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1830,     0,     0,     0,     0,
       0,   720,  3275,     0,   917,     0,  2797,     0,  2381,     0,
       0,  3292,  3292,  3292,  3292,  3302,  3308,  3292,  3311,  3292,
    3292,     0,     0,  2650,     0,  3318,  2651,  3319,     0,  3321,
       0,     0,  3335,  3338,  3343,     0,     0,     0,     0,     0,
    3352,     0,     0,  3357,  2798,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   723,  3364,  3365,
    3366,     0,     0,     0,     0,   978,     0,     0,     0,  5889,
       0,  5891,     0,     0,   724,     0,  3367,  1880,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1061,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1914,  1917,  1918,     0,
       0,     0,     0,     0,     0,     0,  2799,     0,     0,     0,
    2652,     0,     0,     0,     0,     0,     0,  1831,     0,   727,
       0,     0,  1831,     0,  1831,     0,     0,  2120,   728,     0,
    2121,     0,     0,     0,  2122,  2123,  2124,     0,     0,     0,
       0,   729,   977,     0,  1830,     0,  4713,  2800,     0,     0,
    1831,     0,  2642,     0,     0,  4789,     0,     0,     0,     0,
       0,   977,  2643,     0,     0,     0,     0,     0,   977,  2644,
       0,     0,     0,     0,  1064,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2645,   978,     0,     0,   978,
       0,     0,     0,     0,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,  3375,     0,     0,  2580,     0,     0,     0,
       0,     0,     0,     0,     0,  2581,  2582,  2583,  2584,  2585,
    2586,  2587,  2588,  2589,   733,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1830,     0,  3394,     0,     0,
       0,  1830,     0,     0,     0,     0,     0,     0,  2801,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   978,
     978,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     978,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2646,     0,   214,  2802,   978,  2647,   738,
       0,     0,     0,  3396,     0,     0,     0,  6102,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2648,  2314,     0,     0,     0,     0,  1068,     0,     0,
    2803,     0,     0,     0,     0,     0,   977,   742,     0,     0,
       0,     0,     0,     0,   743,     0,     0,   744,     0,  2649,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,  2636,     0,  1070,     0,     0,     0,     0,
       0,     0,   747,     0,     0,  1071,     0,     0,     0,     0,
     749,     0,  2381,   978,     0,     0,  1831,     0,  2804,     0,
       0,     0,     0,     0,     0,  2805,     0,  2650,     0,     0,
    2651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   754,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6209,  2120,     0,     0,  2121,     0,     0,     0,
    2122,  2123,  2124,  2727,     0,     0,     0,     0,     0,   977,
     977,     0,     0,     0,     0,     0,     0,     0,  2642,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2643,  2591,
     977,     0,     0,   977,     0,  2644,     0,  3403,  3404,  3405,
    3406,  3407,  3408,  3409,  3410,  3411,     0,  3412,     0,     0,
       0,     0,     0,     0,  2652,     0,     0,     0,  1377,     0,
    1741,  2645,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2591,     0,     0,  2840,     0,     0,
       0,     0,     0,     0,     0,     0,  2869,     0,  3367,     0,
       0,     0,  3375,     0,     0,  3394,     0,  3396,     0,     0,
    3449,     0,     0,     0,  1830,  1830,  1830,     0,     0,     0,
       0,     0,     0,     0,     0,  6299,     0,     0,  2907,     0,
       0,     0,     0,     0,  2919,  2919,     0,     0,  2919,   977,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2937,     0,     0,  2940,     0,  1119,  1119,   977,     0,
    2580,     0,     0,  2110,  2111,   978,     0,     0,     0,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,  2646,
     977,     0,     0,     0,  2647,     0,     0,     0,     0,  2120,
       0,     0,  2121,     0,     0,     0,  2122,  2123,  2124,     0,
       0,     0,     0,     0,     0,     0,     0,  2648,  2314,  2993,
       0,     0,     0,     0,  2642,     0,     0,     0,     0,     0,
       0,     0,   978,  3013,  2643,     0,     0,     0,     0,     0,
       0,  2644,     0,     0,   978,  2649,     0,  2120,     0,     0,
    2121,     0,  3579,     0,  2122,  2123,  2124,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2645,     0,     0,
       0,     0,  2642,     0,     0,     0,     0,     0,   978,     0,
     977,     0,  2643,     0,     0,     0,     0,     0,  2381,  2644,
    1119,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2650,     0,     0,  2651,     0,     0,     0,
       0,     0,     0,     0,     0,  2645,     0,     0,     0,     0,
       0,     0,     0,  5229,     0,     0,     0,  1830,     0,     0,
       0,     0,     0,   977,     0,   977,     0,     0,     0,     0,
       0,     0,     0,  3035,     0,     0,     0,     0,   977,     0,
     977,     0,     0,     0,  3038,     0,  1831,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5239,     0,     0,     0,
       0,     0,     0,     0,     0,   978,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2646,     0,     0,     0,     0,
    2647,     0,     0,     0,     0,     0,  3082,  2919,     0,     0,
    2652,     0,     0,  2591,     0,     0,     0,  2591,  5246,     0,
       0,     0,     0,  2648,  2314,     0,     0,   977,     0,     0,
       0,  3117,     0,     0,     0,     0,     0,     0,  3130,     0,
       0,     0,     0,  2646,     0,     0,     0,     0,  2647,  2120,
       0,  2649,  2121,     0,     0,     0,  2122,  2123,  2124,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   977,
       0,  2648,  2314,     0,  2642,     0,     0,     0,     0,     0,
       0,     0,   978,     0,  2643,     0,     0,     0,     0,     0,
       0,  2644,     0,     0,  2381,     0,     0,     0,   977,  2649,
       0,     0,   977,     0,  3834,  3835,  1741,     0,     0,  2650,
    3839,  3191,  2651,     0,  2727,     0,  2580,  2645,     0,     0,
       0,     0,     0,   977,     0,  2581,  2582,  2583,  2584,  2585,
    2586,  2587,  2588,  2589,     0,     0,     0,  3868,     0,     0,
       0,     0,  2381,     0,     0,     0,  1402,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2650,     0,     0,
    2651,     0,     0,  3247,     0,     0,  3249,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   978,     0,   978,     0,  2652,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5245,     0,     0,     0,
       0,     0,     0,     0,     0,  2120,     0,     0,  2121,     0,
       0,  1830,  2122,  2123,  2124,  2646,     0,     0,     0,     0,
    2647,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2642,     0,   978,     0,  2652,     0,     0,     0,     0,     0,
    2643,     0,   968,  2648,  2314,     0,     0,  2644,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2649,     0,  2645,     0,     0,     0,     0,     0,     0,
       0,     0,  1831,     0,     0,     0,     0,   968,     0,     0,
       0,     0,  2580,     0,     0,     0,     0,     0,     0,     0,
       0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
       0,     0,     0,     0,  2381,     0,  2591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4073,  2650,
       0,     0,  2651,  4079,     0,     0,     0,     0,     0,     0,
    2580,     0,  2591,     0,     0,  5247,  3331,     0,     0,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,
       0,  2591,  2591,  2591,     0,  2591,     0,     0,     0,     0,
       0,   977,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2113,     0,     0,     0,     0,     0,
       0,  2646,     0,     0,     0,  3343,  2647,  3343,  3343,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4169,     0,     0,  4172,     0,  4174,     0,     0,  2648,
    2314,     0,     0,     0,     0,     0,  2652,     0,     0,     0,
       0,     0,     0,  1830,     0,     0,     0,     0,  1830,     0,
    1830,     0,     0,     0,     0,     0,     0,  2649,     0,     0,
       0,     0,     0,  4199,     0,  4202,     0,  4204,     0,     0,
       0,  2120,     0,     0,  2121,     0,  1830,     0,  2122,  2123,
    2124,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2642,     0,     0,     0,
    2381,     0,     0,     0,     0,     0,  2643,     0,     0,     0,
       0,     0,     0,  2644,     0,  2650,     0,     0,  2651,     0,
       0,     0,   977,     0,     0,   977,     0,     0,     0,     0,
       0,     0,     0,     0,   978,     0,     0,     0,     0,  2645,
       0,     0,  2580,     0,     0,     0,     0,     0,   978,     0,
       0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
       0,  4274,     0,     0,     0,     0,  2694,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1831,
       0,  2711,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2120,     0,     0,
    2121,     0,     0,     0,  2122,  2123,  2124,     0,     0,     0,
       0,     0,  2652,     0,     0,   977,   977,     0,     0,     0,
       0,     0,  2642,     0,     0,     0,   977,     0,     0,     0,
       0,     0,  2643,     0,     0,     0,  4309,     0,  2120,  2644,
       0,  2121,     0,   977,     0,  2122,  2123,  2124,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2646,     0,     0,
       0,     0,  2647,  2642,  1831,  2645,  5823,     0,     0,     0,
       0,     0,     0,  2643,     0,     0,     0,     0,     0,     0,
    2644,     0,     0,     0,     0,  2648,  2314,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4344,     0,     0,     0,
    1831,     0,     0,     0,     0,     0,  2645,     0,     0,     0,
    3432,     0,     0,  2649,     0,     0,     0,     0,  2580,     0,
    3437,     0,     0,     0,     0,     0,     0,  2581,  2582,  2583,
    2584,  2585,  2586,  2587,  2588,  2589,     0,     0,     0,   977,
       0,     0,  1830,     0,     0,     0,     0,     0,     0,  1483,
       0,     0,     0,     0,     0,     0,  2381,     0,  5806,     0,
       0,     0,     0,     0,  1831,     0,     0,   978,     0,     0,
       0,  2650,     0,     0,  2651,     0,     0,     0,     0,     0,
       0,     0,     0,  2646,     0,     0,     0,     0,  2647,     0,
       0,     0,     0,     0,     0,     0,  1483,  1483,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2648,  2314,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2646,     0,     0,     0,     0,  2647,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,  2649,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2648,  2314,     0,     0,     0,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,  2652,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2649,     0,  2381,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1741,  2650,     0,     0,
    2651,     0,  1741,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   978,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2381,     0,     0,   968,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2650,   978,
       0,  2651,     0,     0,     0,     0,     0,     0,  5613,     0,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,     0,
       0,   977,     0,     0,     0,  3646,     0,     0,  2591,     0,
       0,     0,     0,  2591,  2580,     0,     0,     0,     0,     0,
    3668,  4577,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,     0,     0,  2652,     0,     0,     0,     0,     0,
     968,   968,  3696,     0,     0,     0,  2120,     0,     0,  2121,
       0,     0,     0,  2122,  2123,  2124,     0,     0,   977,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     977,  2642,     0,     0,     0,  2652,     0,     0,     0,     0,
       0,  2643,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   977,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2645,     0,     0,     0,     0,     0,
     978,     0,     0,     0,     0,     0,     0,     0,  3776,  3777,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2580,     0,     0,     0,     0,     0,     0,     0,     0,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4714,  2580,  1830,     0,     0,     0,     0,     0,     0,  4718,
    2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,     0,
       0,   977,     0,  3292,     0,     0,     0,  4731,  3292,  3292,
       0,     0,     0,     0,  3308,     0,     0,  4739,     0,     0,
    4741,     0,     0,     0,     0,     0,  4743,     0,  4744,     0,
    3902,     0,  2646,     0,     0,     0,     0,  2647,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4766,  4767,  4768,     0,     0,
    2648,  2314,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3352,     0,     0,     0,     0,  1831,
       0,     0,  4792,     0,     0,  4795,     0,  4797,  2649,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   977,     0,
       0,     0,     0,  4801,     0,     0,     0,     0,     0,     0,
       0,  4808,  4809,     0,     0,     0,     0,     0,  4814,     0,
       0,     0,     0,     0,   671,     0,     0,     0,     0,     0,
       0,  2381,     0,     0,     0,     0,     0,     0,  1831,     0,
       0,     0,   672,     0,     0,     0,  2650,  3292,     0,  2651,
       0,   968,   968,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1831,     0,     0,     0,   673,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     674,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -886,  4868,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   675,     0,     0,   977,     0,
     977,   676,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   677,
       0,     0,     0,  2652,     0,     0,     0,     0,     0,     0,
       0,     0,   678,     0,     0,     0,     0,     0,     0,     0,
       0,   679,     0,     0,     0,     0,     0,     0,   977,     0,
       0,     0,     0,     0,   680,     0,     0,     0,     0,     0,
       0,     0,     0,   681,     0,     0,     0,   682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1092,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1830,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2580,
       0,     0,     0,     0,     0,     0,     0,   683,  2581,  2582,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,  -621,     0,     0,
       0,     0,     0,     0,     0,     0,  4220,  2591,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2591,     0,     0,  1483,     0,     0,
       0,     0,     0,     0,  2591,     0,     0,     0,     0,     0,
    2591,   684,     0,  2591,   685,     0,     0,     0,     0,     0,
    2591,  2591,     0,  2591,     0,     0,     0,     0,  3331,  3331,
       0,  4145,     0,  3331,     0,     0,     0,  2591,   686,     0,
    2591,     0,     0,     0,     0,  2591,     0,     0,     0,     0,
       0,     0,   687,     0,  2591,     0,     0,     0,     0,  2591,
    -471,     0,     0,     0,     0,     0,  2591,  2591,  2591,  2591,
       0,     0,     0,     0,  3331,  3331,     0,  2591,     0,     0,
     688,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     689,     0,     0,     0,     0,     0,  2591,  -471,  2591,     0,
     690,     0,     0,     0,     0,  2591,  2591,  2591,  2591,  2591,
    2591,  2591,  2591,  2591,  2591,     0,     0,     0,     0,     0,
     691,     0,     0,  5156,  5157,     0,     0,     0,   692,     0,
       0,     0,     0,     0,  5164,  -471,     0,     0,   693,     0,
     694,     0,   695,   696,     0,     0,     0,     0,     0,     0,
       0,  2591,     0,     0,     0,     0,     0,     0,   697,     0,
     977,     0,     0,     0,     0,     0,   698,     0,     0,   699,
       0,     0,   700,     0,   977,     0,     0,  5189,     0,     0,
       0,     0,     0,     0,     0,  -471,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1830,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5218,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2694,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5241,     0,     0,     0,     0,     0,     0,
    4423,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2919,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2591,     0,     0,     1,     0,     0,     0,     0,     0,
    1830,     0,  5260,  5262,     0,     2,     0,     3,     4,  5266,
    5267,     0,     0,     0,  5268,     0,     0,     0,     0,  5269,
       0,     0,  5272,  5273,     0,     0,     0,     0,     0,  5278,
       0,     0,     0,     0,     0,     6,  1830,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     7,     0,     8,
       9,     0,     0,     0,     0,     0,    10,     0,    11,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,     0,    13,  5313,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1377,     0,  5320,     0,     0,
      14,     0,     0,    15,     0,     0,     0,     0,     0,     0,
    1830,     0,     0,   977,     0,     0,     0,     0,    16,     0,
      17,     0,     0,     0,    18,     0,     0,     0,     0,     0,
       0,  5767,     0,     0,     0,     0,     0,  5345,     0,     0,
      20,     0,    21,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,  4554,  4555,  4556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    23,     0,     0,
    4565,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4590,  4592,     0,     0,     0,  4597,     0,
       0,     0,     0,     0,     0,     0,     0,  5394,     0,     0,
       0,     0,     0,     0,  5396,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2591,  2591,   977,    28,
       0,  2591,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,   977,     0,     0,     0,     0,
    2591,     0,  5431,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,  1402,     0,    31,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    32,     0,     0,     0,     0,     0,    33,    34,     0,
      35,     0,     0,     0,     0,    36,     0,     0,  4628,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,    39,     0,     0,     0,     0,     0,     0,    40,    41,
       0,     0,     0,     0,     0,     0,    42,     0,     0,     0,
      43,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,     0,
       0,     0,     0,     0,     0,     0,   977,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    47,     0,     0,     0,  3292,     0,    48,     0,     0,
       0,     0,    49,     0,     0,  5547,     0,     0,     0,     0,
       0,  5551,  5552,  5553,     0,    50,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4821,  4822,  4823,     0,     0,  2591,  5566,  5567,     0,    51,
    5568,  2591,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5576,    57,     0,
       0,  -136,     0,     0,     0,     0,     0,  5588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5606,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4145,  4145,
       0,     0,  3331,  3331,  3331,  3331,     0,     0,  3331,  3331,
    3331,  3331,  3331,  3331,  3331,  3331,  3331,  3331,  4145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1830,     0,     0,     0,     0,
       0,  2591,     0,     0,  2591,     0,  2591,     0,     0,  4145,
    4145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2591,  3331,  3331,  2591,     0,  2591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1830,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1830,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2591,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5796,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3352,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5078,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2113,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5869,     0,     0,
       0,     0,     0,     0,  3130,     0,     0,     0,     0,     0,
       0,     0,     0,  5881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5168,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5918,  3191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3331,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2591,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3292,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6004,     0,     0,     0,     0,     0,     0,     0,
       0,  6011,  6011,  6011,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5606,
       0,     0,     0,     0,     0,     0,     0,  6040,     0,     0,
       0,     0,     0,     0,     0,     0,  5282,  5283,  5284,  5285,
       0,     0,     0,     0,     0,     0,  6055,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2591,     0,     0,     0,     0,     0,     0,
       0,  2591,     0,  2591,     0,  2591,  2591,     0,     0,     0,
       0,  4145,  4145,  4145,  4145,     0,     0,     0,  4145,  4145,
    4145,  4145,  4145,  4145,  4145,  4145,  4145,  4145,  2591,  2591,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2591,     0,     0,  2591,     0,  2591,
       0,     0,     0,  2591,     0,     0,  4145,  4145,     0,     0,
    2591,  2591,     0,     0,  6011,     0,  2591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5606,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6258,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5490,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5500,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4145,     0,  6011,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6346,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2591,  2591,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2591,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1741,     0,     0,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2591,  3331,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2591,     0,  2591,     0,     0,     0,  2591,  2591,
    2591,  2591,     0,     0,  2591,  2591,     0,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5711,     0,     0,  3331,     0,  1402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2591,     0,     0,  5741,     0,
       0,     0,  2591,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2591,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2591,     0,  2591,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2591,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5865,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2591,
       0,  4145,  3331,  2591,  2591,  2591,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2591,  2591,
    2591,     0,     0,     0,     0,     0,     0,     0,  2591,     0,
       0,  5941,     0,  3331,     0,     0,  4145,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2591,     0,
    5964,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2591,     0,     0,     0,     0,  2591,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4145,     0,  3331,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2591,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2591,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,     0,
       0,     0,     0,  2591,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2591,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2591,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3331,  3331,     0,     0,  3331,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2591,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2591,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4145,
    4145,     0,  4145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,     0,  1280,   715,     0,  1281,
    1282,  1283,   777,  1284,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
    1735,   245,   246,   247,     0,     0,     0,     0,  1285,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1286,   261,  1287,  1288,  2591,   264,
     265,   266,   267,   268,   269,   270,  1289,  1290,   271,   272,
    1291,  1292,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,  1302,  1303,
     312,  1304,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,  1736,     0,   325,   326,
     889,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1305,   343,
     344,   345,   346,  1306,  1307,   348,     0,   349,   350,   351,
    1308,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,  1310,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1311,
    1312,     0,  1313,     0,   396,   397,   398,   399,   400,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,  1328,
     447,  1329,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,  1331,   460,   461,   462,   463,  1332,  1333,
     465,  1334,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1335,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1338,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1339,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,  1341,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1344,  1345,     0,     0,
     596,   597,  1346,   599,  1347,  1348,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1349,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
    1351,  1737,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,     0,  1360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1361,  1362,  1738,     0,
       0,     0,     0,     0,     0,  1364,  1739,   235,     0,  1280,
     715,     0,  1281,  1282,  1283,   777,  1284,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1285,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1286,   261,  1287,
    1288,     0,   264,   265,   266,   267,   268,   269,   270,  1289,
    1290,   271,   272,  1291,  1292,   275,     0,   276,   277,   278,
     279,  1293,     0,  1294,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,  1295,  1296,
    1297,  1298,  1299,  1300,  1301,   304,   305,   306,   307,   308,
     309,  1302,  1303,   312,  1304,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1305,   343,   344,   345,   346,  1306,  1307,   348,     0,
     349,   350,   351,  1308,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1309,
       0,  1310,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1311,  1312,     0,  1313,     0,   396,   397,   398,
     399,   400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,
    1322,   410,  1323,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1324,   421,   422,   423,     0,   424,   425,
     426,  1325,  1326,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1327,   438,   439,   440,   441,   442,   443,
     444,   445,  1328,   447,  1329,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1330,   459,  1331,   460,   461,   462,
     463,  1332,  1333,   465,  1334,   467,   468,   469,     0,   470,
     471,   472,     0,     0,  1335,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1336,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1337,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1338,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1339,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,    41,
     551,   552,   553,   554,   555,  1340,   556,   557,   558,   559,
     560,   561,   562,   563,  1341,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1342,   582,     0,   583,   584,  1343,    45,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1344,
    1345,     0,     0,   596,   597,  1346,   599,  1347,  1348,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  1349,
     610,   611,   612,   613,   614,  1350,     0,   615,   616,   617,
     618,   619,  1208,  1351,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,    50,   629,   630,   631,   632,
     633,   634,   635,  1352,  1353,  1354,  1355,   640,  1356,  1357,
    1358,  1359,   645,   646,   647,   648,     0,  1360,     0,    51,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1361,
    1362,     0,     0,     0,     0,     0,     0,     0,  1364,  5842,
     235,     0,  1280,   715,     0,  1281,  1282,  1283,   777,  1284,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1285,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1286,   261,  1287,  1288,     0,   264,   265,   266,   267,   268,
     269,   270,  1289,  1290,   271,   272,  1291,  1292,   275,     0,
     276,   277,   278,   279,  1293,     0,  1294,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,
     306,   307,   308,   309,  1302,  1303,   312,  1304,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   889,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1305,   343,   344,   345,   346,  1306,
    1307,   348,     0,   349,   350,   351,  1308,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1309,     0,  1310,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1311,  1312,     0,  1313,     0,
     396,   397,   398,   399,   400,  1314,  1315,  1316,  1317,  1318,
    1319,  1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1324,   421,   422,   423,
       0,   424,   425,   426,  1325,  1326,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1327,   438,   439,   440,
     441,   442,   443,   444,   445,  1328,   447,  1329,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1330,   459,  1331,
     460,   461,   462,   463,  1332,  1333,   465,  1334,   467,   468,
     469,     0,   470,   471,   472,     0,     0,  1335,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,  1336,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,  1337,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1338,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1339,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1340,   556,
     557,   558,   559,   560,   561,   562,   563,  1341,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1342,   582,     0,   583,   584,
    1343,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,  1344,  1345,     0,     0,   596,   597,  1346,   599,
    1347,  1348,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,  1349,   610,   611,   612,   613,   614,  1350,     0,
     615,   616,   617,   618,   619,   620,  1351,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,
     640,  1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,
    1360,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1361,  1362,     0,     0,     0,     0,     0,     0,
       0,  1364,  3333,   235,     0,  1280,   715,     0,  1281,  1282,
    1283,   777,  1284,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1285,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1286,   261,  1287,  1288,     0,   264,   265,
     266,   267,   268,   269,   270,  1289,  1290,   271,   272,  1291,
    1292,   275,     0,   276,   277,   278,   279,  1293,     0,  1294,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,  1300,
    1301,   304,   305,   306,   307,   308,   309,  1302,  1303,   312,
    1304,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   889,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,  1305,   343,   344,
     345,   346,  1306,  1307,   348,     0,   349,   350,   351,  1308,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,  1309,     0,  1310,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1311,  1312,
       0,  1313,     0,   396,   397,   398,   399,   400,  1314,  1315,
    1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,  1324,
     421,   422,   423,     0,   424,   425,   426,  1325,  1326,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1327,
     438,   439,   440,   441,   442,   443,   444,   445,  1328,   447,
    1329,   449,   450,   451,   452,   453,   454,   455,   456,   457,
    1330,   459,  1331,   460,   461,   462,   463,  1332,  1333,   465,
    1334,   467,   468,   469,     0,   470,   471,   472,     0,     0,
    1335,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,  1336,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,  1337,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1338,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  1339,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1340,   556,   557,   558,   559,   560,   561,   562,   563,
    1341,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,  1342,   582,
       0,   583,   584,  1343,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,  1344,  1345,     0,     0,   596,
     597,  1346,   599,  1347,  1348,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,  1349,   610,   611,   612,   613,
     614,  1350,     0,   615,   616,   617,   618,   619,   620,  1351,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,  1352,
    1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,   646,
     647,   648,     0,  1360,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1361,  1362,     0,     0,     0,
       0,     0,     0,     0,  1364,  4745,   235,     0,  1280,   715,
       0,  1281,  1282,  1283,   777,  1284,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1285,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,  1286,   261,  1287,  1288,
       0,   264,   265,   266,   267,   268,   269,   270,  1289,  1290,
     271,   272,  1291,  1292,   275,     0,   276,   277,   278,   279,
    1293,     0,  1294,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1295,  1296,  1297,
    1298,  1299,  1300,  1301,   304,   305,   306,   307,   308,   309,
    1302,  1303,   312,  1304,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   889,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1305,   343,   344,   345,   346,  1306,  1307,   348,     0,   349,
     350,   351,  1308,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1309,     0,
    1310,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1311,  1312,     0,  1313,     0,   396,   397,   398,   399,
     400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,
     410,  1323,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1324,   421,   422,   423,     0,   424,   425,   426,
    1325,  1326,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1327,   438,   439,   440,   441,   442,   443,   444,
     445,  1328,   447,  1329,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1330,   459,  1331,   460,   461,   462,   463,
    1332,  1333,   465,  1334,   467,   468,   469,     0,   470,   471,
     472,     0,     0,  1335,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1336,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1337,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1338,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  1339,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1340,   556,   557,   558,   559,   560,
     561,   562,   563,  1341,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1342,   582,     0,   583,   584,  1343,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,  1344,  1345,
       0,     0,   596,   597,  1346,   599,  1347,  1348,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,  1349,   610,
     611,   612,   613,   614,  1350,     0,   615,   616,   617,   618,
     619,   620,  1351,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,
    1359,   645,   646,   647,   648,     0,  1360,     0,     0,     0,
       0,     0,   656,     0,     0,     0,     0,     0,  1361,  1362,
       0,     0,     0,     0,     0,     0,     0,  1364,  4811,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,  4251,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0, -1838,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0, -1838,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386, -1838,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399, -1838,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420, -1838,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446, -1838,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533, -1838,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,     0,     0,     0,     0,     0,     0,     0,   881,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1476,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,     0,   882,   261,
     883,   884,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   885,   886,   275,     0,   276,   277,
     278,   279,     0,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,     0,
       0,     0,   303,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   887,   888,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   889,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,     0,   343,   344,   345,   346,     0,     0,   348,
       0,   349,   350,   351,   890,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
       0,     0,     0,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  2736,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,  2737,   389,
     390,   391,   392,   891,   892,     0,   893,     0,   396,   397,
     398,   399,   400,   894,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,     0,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   438,   439,   440,   441,   442,
     443,   444,   445,   895,   447,   896,   449,   450,   451,   452,
     453,   454,   455,   456,     0,     0,   459,     0,   460,   461,
     462,   463,     0,     0,   465,   897,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,  2739,   479,   480,   481,     0,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,     0,   498,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   898,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,     0,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,  2740,
     559,   560,   561,   562,   563,   900,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,     0,   582,     0,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
     901,   902,     0,     0,   596,   597,     0,   599,     0,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,     0,   903,  2741,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,     0,   881,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   646,   647,   648,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
    2834,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,     0,   882,   261,   883,   884,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     885,   886,   275,     0,   276,   277,   278,   279,     0,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,     0,     0,     0,   303,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   887,   888,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     889,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,     0,   343,
     344,   345,   346,     0,     0,   348,     0,   349,   350,   351,
     890,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,     0,     0,     0,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  2736,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,  2737,   389,   390,   391,   392,   891,
     892,     0,   893,     0,   396,   397,   398,   399,   400,   894,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
       0,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   895,
     447,   896,   449,   450,   451,   452,   453,   454,   455,   456,
       0,     0,   459,     0,   460,   461,   462,   463,     0,     0,
     465,   897,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,  2739,   479,
     480,   481,     0,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,     0,
     498,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   898,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,  2740,   559,   560,   561,   562,
     563,   900,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,     0,
     582,     0,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   901,   902,     0,     0,
     596,   597,     0,   599,     0,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,     0,
     903,  2741,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,     0,
     235,     0,  1280,   715,     0,  1281,  1282,  1283,   777,  1284,
     646,   647,   648,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1285,     0,  3957,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1286,   261,  1287,  1288,     0,   264,   265,   266,   267,   268,
     269,   270,  1289,  1290,   271,   272,  1291,  1292,   275,     0,
     276,   277,   278,   279,  1293,     0,  1294,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,
     306,   307,   308,   309,  1302,  1303,   312,  1304,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   889,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1305,   343,   344,   345,   346,  1306,
    1307,   348,     0,   349,   350,   351,  1308,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1309,     0,  1310,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1311,  1312,     0,  1313,     0,
     396,   397,   398,   399,   400,  1314,  1315,  1316,  1317,  1318,
    1319,  1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1324,   421,   422,   423,
       0,   424,   425,   426,  1325,  1326,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1327,   438,   439,   440,
     441,   442,   443,   444,   445,  1328,   447,  1329,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1330,   459,  1331,
     460,   461,   462,   463,  1332,  1333,   465,  1334,   467,   468,
     469,     0,   470,   471,   472,     0,     0,  1335,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,  1336,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,  1337,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1338,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,  3294,   532,   533,   534,   535,   536,   537,   538,
     539,  1339,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,    41,   551,   552,   553,   554,   555,  1340,   556,
     557,   558,   559,   560,   561,   562,   563,  1341,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1342,   582,     0,   583,   584,
    1343,    45,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,  1344,  1345,     0,     0,   596,   597,  1346,   599,
    1347,  1348,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,  1349,   610,   611,   612,   613,   614,  1350,     0,
     615,   616,   617,   618,   619,  1208,  1351,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,    50,   629,
     630,   631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,
     640,  1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,
    1360,     0,    51,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1361,  1362,     0,     0,     0,   235,     0,  1280,
     715,  1364,  1281,  1282,  1283,   777,  1284,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1285,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1286,   261,  1287,
    1288,     0,   264,   265,   266,   267,   268,   269,   270,  1289,
    1290,   271,   272,  1291,  1292,   275,     0,   276,   277,   278,
     279,  1293,     0,  1294,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,  1295,  1296,
    1297,  1298,  1299,  1300,  1301,   304,   305,   306,   307,   308,
     309,  1302,  1303,   312,  1304,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1305,   343,   344,   345,   346,  1306,  1307,   348,     0,
     349,   350,   351,  1308,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1309,
       0,  1310,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1311,  1312,     0,  1313,     0,   396,   397,   398,
     399,   400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,
    1322,   410,  1323,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1324,   421,   422,   423,     0,   424,   425,
     426,  1325,  1326,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1327,   438,   439,   440,   441,   442,   443,
     444,   445,  1328,   447,  1329,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1330,   459,  1331,   460,   461,   462,
     463,  1332,  1333,   465,  1334,   467,   468,   469,     0,   470,
     471,   472,     0,     0,  1335,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1336,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1337,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1338,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1339,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,    41,
     551,   552,   553,   554,   555,  1340,   556,   557,   558,   559,
     560,   561,   562,   563,  1341,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1342,   582,     0,   583,   584,  1343,    45,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1344,
    1345,     0,     0,   596,   597,  1346,   599,  1347,  1348,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  1349,
     610,   611,   612,   613,   614,  1350,     0,   615,   616,   617,
     618,   619,  1208,  1351,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,    50,   629,   630,   631,   632,
     633,   634,   635,  1352,  1353,  1354,  1355,   640,  1356,  1357,
    1358,  1359,   645,   646,   647,   648,     0,  1360,     0,    51,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1361,
    1362,     0,     0,     0,   235,     0,  1280,   715,  1364,  1281,
    1282,  1283,   777,  1284,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1285,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1286,   261,  1287,  1288,  3339,   264,
     265,   266,   267,   268,   269,   270,  1289,  1290,   271,   272,
    1291,  1292,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,  1302,  1303,
     312,  1304,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     889,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1305,   343,
     344,   345,   346,  1306,  1307,   348,     0,   349,   350,   351,
    1308,   353,     0,   354,     0,   355,   356,   357,  3340,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,  1310,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1311,
    1312,     0,  1313,     0,   396,   397,   398,   399,   400,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,  3341,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,  1328,
     447,  1329,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,  1331,   460,   461,   462,   463,  1332,  1333,
     465,  1334,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1335,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1338,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1339,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,  1341,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1344,  1345,     0,  3342,
     596,   597,  1346,   599,  1347,  1348,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1349,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
    1351,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,     0,  1360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1361,  1362,     0,     0,
       0,   235,     0,  1280,   715,  1364,  1281,  1282,  1283,   777,
    1284,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244, -2269,   245,   246,
     247,     0,     0,     0, -2269,  1285,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1286,   261,  1287,  1288,     0,   264,   265,   266,   267,
     268,   269,   270,  1289,  1290,   271,   272,  1291,  1292,   275,
       0,   276,   277,   278,   279,  1293,     0,  1294,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,
     305,   306,   307,   308,   309,  1302,  1303,   312,  1304,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   889,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1305,   343,   344,   345,   346,
    1306,  1307,   348,     0,   349,   350,   351,  1308,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1309,     0,  1310,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1311,  1312,     0,  1313,
       0,   396,   397,   398,   399,   400,  1314,  1315,  1316,  1317,
    1318,  1319,  1320,  1321,  1322,   410,  1323,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1324,   421,   422,
     423,     0,   424,   425,   426,  1325,  1326,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1327,   438,   439,
     440,   441,   442,   443,   444,   445,  1328,   447,  1329,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1330,   459,
    1331,   460,   461,   462,   463,  1332,  1333,   465,  1334,   467,
     468,   469,     0,   470,   471,   472,     0,     0,  1335,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1336,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1337,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1338,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  1339,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1340,
     556,   557,   558,   559,   560,   561,   562,   563,  1341,   565,
   -2269,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1342,   582,     0,   583,
     584,  1343,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1344,  1345,     0,     0,   596,   597,  1346,
     599,  1347,  1348,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  1349,   610,   611,   612,   613,   614,  1350,
       0,   615,   616,   617,   618,   619,   620,  1351,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1352,  1353,  1354,
    1355,   640,  1356,  1357,  1358,  1359,   645,   646,   647,   648,
       0,  1360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1361,  1362,     0,     0,     0,   235,     0,
    1280,   715,  1364,  1281,  1282,  1283,   777,  1284,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244, -2267,   245,   246,   247,     0,     0,
       0, -2267,  1285,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1286,   261,
    1287,  1288,     0,   264,   265,   266,   267,   268,   269,   270,
    1289,  1290,   271,   272,  1291,  1292,   275,     0,   276,   277,
     278,   279,  1293,     0,  1294,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,  1295,
    1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,   307,
     308,   309,  1302,  1303,   312,  1304,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   889,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1305,   343,   344,   345,   346,  1306,  1307,   348,
       0,   349,   350,   351,  1308,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1309,     0,  1310,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1311,  1312,     0,  1313,     0,   396,   397,
     398,   399,   400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,
    1321,  1322,   410,  1323,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1324,   421,   422,   423,     0,   424,
     425,   426,  1325,  1326,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1327,   438,   439,   440,   441,   442,
     443,   444,   445,  1328,   447,  1329,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1330,   459,  1331,   460,   461,
     462,   463,  1332,  1333,   465,  1334,   467,   468,   469,     0,
     470,   471,   472,     0,     0,  1335,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,  1336,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,  1337,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1338,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,  1339,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1340,   556,   557,   558,
     559,   560,   561,   562,   563,  1341,   565, -2267,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1342,   582,     0,   583,   584,  1343,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
    1344,  1345,     0,     0,   596,   597,  1346,   599,  1347,  1348,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
    1349,   610,   611,   612,   613,   614,  1350,     0,   615,   616,
     617,   618,   619,   620,  1351,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,  1356,
    1357,  1358,  1359,   645,   646,   647,   648,     0,  1360,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,  1362,     0,     0,     0,   235,     0,  1280,   715,  1364,
    1281,  1282,  1283,   777,  1284,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1285,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1286,   261,  1287,  1288,     0,
     264,   265,   266,   267,   268,   269,   270,  1289,  1290,   271,
     272,  1291,  1292,   275,     0,   276,   277,   278,   279,  1293,
       0,  1294,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,
    1299,  1300,  1301,   304,   305,   306,   307,   308,   309,  1302,
    1303,   312,  1304,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   889,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1305,
     343,   344,   345,   346,  1306,  1307,   348,     0,   349,   350,
     351,  1308,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1309,     0,  1310,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1311,  1312,     0,  1313,     0,   396,   397,   398,   399,   400,
    1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,
    1323,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1324,   421,   422,   423,     0,   424,   425,   426,  1325,
    1326,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1327,   438,   439,   440,   441,   442,   443,   444,   445,
    1328,   447,  1329,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1330,   459,  1331,   460,   461,   462,   463,  1332,
    1333,   465,  1334,   467,   468,   469,     0,   470,   471,   472,
       0,     0,  1335,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,  1336,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
    1337,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1338,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1339,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1340,   556,   557,   558,   559,   560,   561,
     562,   563,  1341,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
    1342,   582,     0,   583,   584,  1343,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,  1344,  1345,     0,
       0,   596,   597,  1346,   599,  1347,  1348,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,  1349,   610,   611,
     612,   613,   614,  1350,     0,   615,   616,   617,   618,   619,
     620,  1351,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,  1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,
     645,   646,   647,   648,     0,  1360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1361,  1362,     0,
       0,     0,     0,     0,  2061,  3268,  1364,   235,     0,  1280,
     715,     0,  1281,  1282,  1283,   777,  1284,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1285,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1286,   261,  1287,
    1288,     0,   264,   265,   266,   267,   268,   269,   270,  1289,
    1290,   271,   272,  1291,  1292,   275,     0,   276,   277,   278,
     279,  1293,     0,  1294,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,  1295,  1296,
    1297,  1298,  1299,  1300,  1301,   304,   305,   306,   307,   308,
     309,  1302,  1303,   312,  1304,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1305,   343,   344,   345,   346,  1306,  1307,   348,     0,
     349,   350,   351,  1308,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1309,
       0,  1310,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1311,  1312,     0,  1313,     0,   396,   397,   398,
     399,   400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,
    1322,   410,  1323,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1324,   421,   422,   423,     0,   424,   425,
     426,  1325,  1326,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1327,   438,   439,   440,   441,   442,   443,
     444,   445,  1328,   447,  1329,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1330,   459,  1331,   460,   461,   462,
     463,  1332,  1333,   465,  1334,   467,   468,   469,     0,   470,
     471,   472,     0,     0,  1335,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1336,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1337,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1338,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1339,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1340,   556,   557,   558,   559,
     560,   561,   562,   563,  1341,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1342,   582,     0,   583,   584,  1343,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1344,
    1345,     0,     0,   596,   597,  1346,   599,  1347,  1348,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  1349,
     610,   611,   612,   613,   614,  1350,     0,   615,   616,   617,
     618,   619,   620,  1351,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,  1352,  1353,  1354,  1355,   640,  1356,  1357,
    1358,  1359,   645,   646,   647,   648,     0,  1360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1361,
    1362,  1363,     0,     0,   235,     0,  1280,   715,  1364,  1281,
    1282,  1283,   777,  1284,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
    2704,   245,   246,   247,     0,     0,     0,     0,  1285,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1286,   261,  1287,  1288,     0,   264,
     265,   266,   267,   268,   269,   270,  1289,  1290,   271,   272,
    1291,  1292,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,  1302,  1303,
     312,  1304,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     889,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1305,   343,
     344,   345,   346,  1306,  1307,   348,     0,   349,   350,   351,
    1308,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,  1310,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1311,
    1312,     0,  1313,     0,   396,   397,   398,   399,   400,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,  1328,
     447,  1329,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,  1331,   460,   461,   462,   463,  1332,  1333,
     465,  1334,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1335,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1338,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1339,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,  1341,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1344,  1345,     0,     0,
     596,   597,  1346,   599,  1347,  1348,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1349,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
    1351,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,     0,  1360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1361,  1362,     0,     0,
       0,   235,     0,  1280,   715,  1364,  1281,  1282,  1283,   777,
    1284,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1285,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1286,   261,  1287,  1288,     0,   264,   265,   266,   267,
     268,   269,   270,  1289,  1290,   271,   272,  1291,  1292,   275,
       0,   276,   277,   278,   279,  1293,     0,  1294,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,
     305,   306,   307,   308,   309,  1302,  1303,   312,  1304,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   889,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1305,   343,   344,   345,   346,
    1306,  1307,   348,     0,   349,   350,   351,  1308,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1309,     0,  1310,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1311,  1312,     0,  1313,
       0,   396,   397,   398,   399,   400,  1314,  1315,  1316,  1317,
    1318,  1319,  1320,  1321,  1322,   410,  1323,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1324,   421,   422,
     423,     0,   424,   425,   426,  1325,  1326,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1327,   438,   439,
     440,   441,   442,   443,   444,   445,  1328,   447,  1329,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1330,   459,
    1331,   460,   461,   462,   463,  1332,  1333,   465,  1334,   467,
     468,   469,     0,   470,   471,   472,     0,     0,  1335,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1336,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1337,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1338,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,  3294,   532,   533,   534,   535,   536,   537,
     538,   539,  1339,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1340,
     556,   557,   558,   559,   560,   561,   562,   563,  1341,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1342,   582,     0,   583,
     584,  1343,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1344,  1345,     0,     0,   596,   597,  1346,
     599,  1347,  1348,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  1349,   610,   611,   612,   613,   614,  1350,
       0,   615,   616,   617,   618,   619,   620,  1351,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1352,  1353,  1354,
    1355,   640,  1356,  1357,  1358,  1359,   645,   646,   647,   648,
       0,  1360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1361,  1362,     0,     0,     0,   235,     0,
    1280,   715,  1364,  1281,  1282,  1283,   777,  1284,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1285,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1286,   261,
    1287,  1288,     0,   264,   265,   266,   267,   268,   269,   270,
    1289,  1290,   271,   272,  1291,  1292,   275,     0,   276,   277,
     278,   279,  1293,     0,  1294,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,  1295,
    1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,   307,
     308,   309,  1302,  1303,   312,  1304,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   889,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1305,   343,   344,   345,   346,  1306,  1307,   348,
       0,   349,   350,   351,  1308,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1309,     0,  1310,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1311,  1312,     0,  1313,     0,   396,   397,
     398,   399,   400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,
    1321,  1322,   410,  1323,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1324,   421,   422,   423,     0,   424,
     425,   426,  1325,  1326,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1327,   438,   439,   440,   441,   442,
     443,   444,   445,  1328,   447,  1329,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1330,   459,  1331,   460,   461,
     462,   463,  1332,  1333,   465,  1334,   467,   468,   469,     0,
     470,   471,   472,     0,     0,  1335,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,  1336,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,  1337,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1338,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,  1339,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1340,   556,   557,   558,
     559,   560,   561,   562,   563,  1341,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1342,   582,     0,   583,   584,  1343,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
    1344,  1345,     0,     0,   596,   597,  1346,   599,  1347,  1348,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
    1349,   610,   611,   612,   613,   614,  1350,     0,   615,   616,
     617,   618,   619,   620,  1351,  3836,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,  1356,
    1357,  1358,  1359,   645,   646,   647,   648,     0,  1360,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,  1362,     0,     0,     0,   235,     0,  1280,   715,  1364,
    1281,  1282,  1283,   777,  1284,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1285,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1286,   261,  1287,  1288,     0,
     264,   265,   266,   267,   268,   269,   270,  1289,  1290,   271,
     272,  1291,  1292,   275,     0,   276,   277,   278,   279,  1293,
       0,  1294,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,
    1299,  1300,  1301,   304,   305,   306,   307,   308,   309,  1302,
    1303,   312,  1304,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   889,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1305,
     343,   344,   345,   346,  1306,  1307,   348,     0,   349,   350,
     351,  1308,   353,     0,   354,     0,   355,   356,   357,  3340,
     358,   359,   360,   361,   362,     0,   363,  1309,     0,  1310,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1311,  1312,     0,  1313,     0,   396,   397,   398,   399,   400,
    1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,
    1323,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1324,   421,   422,   423,     0,   424,   425,   426,  1325,
    1326,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1327,   438,   439,   440,   441,   442,   443,   444,   445,
    1328,   447,  1329,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1330,   459,  1331,   460,   461,   462,   463,  1332,
    1333,   465,  1334,   467,   468,   469,     0,   470,   471,   472,
       0,     0,  1335,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,  1336,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
    1337,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1338,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1339,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1340,   556,   557,   558,   559,   560,   561,
     562,   563,  1341,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
    1342,   582,     0,   583,   584,  1343,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,  1344,  1345,     0,
       0,   596,   597,  1346,   599,  1347,  1348,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,  1349,   610,   611,
     612,   613,   614,  1350,     0,   615,   616,   617,   618,   619,
     620,  1351,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,  1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,
     645,   646,   647,   648,     0,  1360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1361,  1362,     0,
       0,     0,   235,     0,  1280,   715,  1364,  1281,  1282,  1283,
     777,  1284,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1285,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1286,   261,  1287,  1288,     0,   264,   265,   266,
     267,   268,   269,   270,  1289,  1290,   271,   272,  1291,  1292,
     275,     0,   276,   277,   278,   279,  1293,     0,  1294,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,
     304,   305,   306,   307,   308,   309,  1302,  1303,   312,  1304,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,  1305,   343,   344,   345,
     346,  1306,  1307,   348,     0,   349,   350,   351,  1308,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,  1309,     0,  1310,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1311,  1312,     0,
    1313,     0,   396,   397,   398,   399,   400,  1314,  1315,  1316,
    1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1324,   421,
     422,   423,     0,   424,   425,   426,  1325,  1326,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1327,   438,
     439,   440,   441,   442,   443,   444,   445,  1328,   447,  1329,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1330,
     459,  1331,   460,   461,   462,   463,  1332,  1333,   465,  1334,
     467,   468,   469,     0,   470,   471,   472,     0,     0,  1335,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
    1336,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,  1337,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1338,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  1339,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1340,   556,   557,   558,   559,   560,   561,   562,   563,  1341,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1342,   582,     0,
     583,   584,  1343,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,  1344,  1345,  3397,     0,   596,   597,
    1346,   599,  1347,  1348,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,  1349,   610,   611,   612,   613,   614,
    1350,     0,   615,   616,   617,   618,   619,   620,  1351,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,  1352,  1353,
    1354,  1355,   640,  1356,  1357,  1358,  1359,   645,   646,   647,
     648,     0,  1360,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1361,  1362,     0,     0,     0,   235,
       0,  1280,   715,  1364,  1281,  1282,  1283,   777,  1284,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,  1285,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,  1286,
     261,  1287,  1288,     0,   264,   265,   266,   267,   268,   269,
     270,  1289,  1290,   271,   272,  1291,  1292,   275,     0,   276,
     277,   278,   279,  1293,     0,  1294,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,
     307,   308,   309,  1302,  1303,   312,  1304,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   889,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1305,   343,   344,   345,   346,  1306,  1307,
     348,     0,   349,   350,   351,  1308,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1309,     0,  1310,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1311,  1312,     0,  1313,     0,   396,
     397,   398,   399,   400,  1314,  1315,  1316,  1317,  1318,  1319,
    1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1324,   421,   422,   423,     0,
     424,   425,   426,  1325,  1326,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1327,   438,   439,   440,   441,
     442,   443,   444,   445,  1328,   447,  1329,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1330,   459,  1331,   460,
     461,   462,   463,  1332,  1333,   465,  1334,   467,   468,   469,
       0,   470,   471,   472,     0,     0,  1335,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1336,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1337,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1338,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
    1339,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1340,   556,   557,
     558,   559,   560,   561,   562,   563,  1341,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1342,   582,     0,   583,   584,  1343,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,  1344,  1345,     0,     0,   596,   597,  1346,   599,  1347,
    1348,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,  1349,   610,   611,   612,   613,   614,  1350,     0,   615,
     616,   617,   618,   619,   620,  1351,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,
    1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,  1360,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,  1362,     0,     0,     0,   235,     0,  1280,   715,
    1364,  1281,  1282,  1283,   777,  1284,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1285,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,  1286,   261,  1287,  1288,
       0,   264,   265,   266,   267,   268,   269,   270,  1289,  1290,
     271,   272,  1291,  1292,   275,     0,   276,   277,   278,   279,
    1293,     0,  1294,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1295,  1296,  1297,
    1298,  1299,  1300,  1301,   304,   305,   306,   307,   308,   309,
    1302,  1303,   312,  1304,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   889,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1305,   343,   344,   345,   346,  1306,  1307,   348,     0,   349,
     350,   351,  1308,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1309,     0,
    1310,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1311,  1312,     0,  1313,     0,   396,   397,   398,   399,
     400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,
     410,  1323,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1324,   421,   422,   423,     0,   424,   425,   426,
    1325,  1326,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1327,   438,   439,   440,   441,   442,   443,   444,
     445,  1328,   447,  1329,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1330,   459,  1331,   460,   461,   462,   463,
    1332,  1333,   465,  1334,   467,   468,   469,     0,   470,   471,
     472,     0,     0,  1335,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1336,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1337,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1338,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  1339,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1340,   556,   557,   558,   559,   560,
     561,   562,   563,  1341,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1342,   582,     0,   583,   584,  1343,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,  1344,  1345,
       0,     0,   596,   597,  1346,   599,  1347,  1348,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,  1349,   610,
     611,   612,   613,   614,  1350,     0,   615,   616,   617,   618,
     619,   620,  1351,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,
    1359,   645,   646,   647,   648,     0,  1360,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2707,  2708,
       0,     0,     0,   235,     0,  3516,   715,  1364,  1281,  1282,
    1283,   777,  1284,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1285,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1286,   261,  1287,  1288,     0,   264,   265,
     266,   267,   268,   269,   270,  1289,  1290,   271,   272,  1291,
    1292,   275,     0,   276,   277,   278,   279,  1293,     0,  1294,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,  1300,
    1301,   304,   305,   306,   307,   308,   309,  1302,  1303,   312,
    1304,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   889,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,  1305,   343,   344,
     345,   346,  1306,  1307,   348,     0,   349,   350,   351,  1308,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,  1309,     0,  1310,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1311,  1312,
       0,  1313,     0,   396,   397,   398,   399,   400,  1314,  1315,
    1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,  1324,
     421,   422,   423,     0,   424,   425,   426,  1325,  1326,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1327,
     438,   439,   440,   441,   442,   443,   444,   445,  1328,   447,
    1329,   449,   450,   451,   452,   453,   454,   455,   456,   457,
    1330,   459,  1331,   460,   461,   462,   463,  1332,  1333,   465,
    1334,   467,   468,   469,     0,   470,   471,   472,     0,     0,
    1335,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,  1336,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,  1337,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1338,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  1339,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1340,   556,   557,   558,   559,   560,   561,   562,   563,
    1341,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,  1342,   582,
       0,   583,   584,  1343,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,  1344,  1345,     0,     0,   596,
     597,  1346,   599,  1347,  1348,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,  1349,   610,   611,   612,   613,
     614,  1350,     0,   615,   616,   617,   618,   619,   620,  1351,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,  1352,
    1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,   646,
     647,   648,     0,  1360,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1361,  1362,     0,     0,     0,
     235,     0,  1280,   715,  1364,  1281,  1282,  1283,   777,  1284,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1285,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1286,   261,  1287,  1288,     0,   264,   265,   266,   267,   268,
     269,   270,  1289,  1290,   271,   272,  1291,  1292,   275,     0,
     276,   277,   278,   279,  1293,     0,  1294,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
    4867,  1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,
     306,   307,   308,   309,  1302,  1303,   312,  1304,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   889,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1305,   343,   344,   345,   346,  1306,
    1307,   348,     0,   349,   350,   351,  1308,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1309,     0,  1310,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1311,  1312,     0,  1313,     0,
     396,   397,   398,   399,   400,  1314,  1315,  1316,  1317,  1318,
    1319,  1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1324,   421,   422,   423,
       0,   424,   425,   426,  1325,  1326,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1327,   438,   439,   440,
     441,   442,   443,   444,   445,  1328,   447,  1329,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1330,   459,  1331,
     460,   461,   462,   463,  1332,  1333,   465,  1334,   467,   468,
     469,     0,   470,   471,   472,     0,     0,  1335,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,  1336,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,  1337,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1338,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1339,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1340,   556,
     557,   558,   559,   560,   561,   562,   563,  1341,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1342,   582,     0,   583,   584,
    1343,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,  1344,  1345,     0,     0,   596,   597,  1346,   599,
    1347,  1348,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,  1349,   610,   611,   612,   613,   614,  1350,     0,
     615,   616,   617,   618,   619,   620,  1351,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,
     640,  1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,
    1360,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1361,  1362,     0,     0,     0,   235,     0,  1280,
     715,  1364,  1281,  1282,  1283,   777,  1284,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1285,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1286,   261,  1287,
    1288,     0,   264,   265,   266,   267,   268,   269,   270,  1289,
    1290,   271,   272,  1291,  1292,   275,     0,   276,   277,   278,
     279,  1293,     0,  1294,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,  1295,  1296,
    1297,  1298,  1299,  1300,  1301,   304,   305,   306,   307,   308,
     309,  1302,  1303,   312,  1304,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1305,   343,   344,   345,   346,  1306,  1307,   348,     0,
     349,   350,   351,  1308,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1309,
       0,  1310,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1311,  1312,     0,  1313,     0,   396,   397,   398,
     399,   400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,
    1322,   410,  1323,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1324,   421,   422,   423,     0,   424,   425,
     426,  1325,  1326,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1327,   438,   439,   440,   441,   442,   443,
     444,   445,  1328,   447,  1329,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1330,   459,  1331,   460,   461,   462,
     463,  1332,  1333,   465,  1334,   467,   468,   469,     0,   470,
     471,   472,     0,     0,  1335,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1336,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1337,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1338,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1339,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1340,   556,   557,   558,   559,
     560,   561,   562,   563,  1341,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1342,   582,     0,   583,   584,  1343,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1344,
    1345,     0,     0,   596,   597,  1346,   599,  1347,  1348,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  1349,
     610,   611,   612,   613,   614,  1350,     0,   615,   616,   617,
     618,   619,   620,  1351,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,  5249,  1352,  1353,  1354,  1355,   640,  1356,  1357,
    1358,  1359,   645,   646,   647,   648,     0,  1360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1361,
    1362,     0,     0,     0,   235,     0,  1280,   715,  1364,  1281,
    1282,  1283,   777,  1284,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1285,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1286,   261,  1287,  1288,     0,   264,
     265,   266,   267,   268,   269,   270,  1289,  1290,   271,   272,
    1291,  1292,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,  1302,  1303,
     312,  1304,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     889,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1305,   343,
     344,   345,   346,  1306,  1307,   348,     0,   349,   350,   351,
    1308,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,  1310,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1311,
    1312,     0,  1313,     0,   396,   397,   398,   399,   400,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,  1328,
     447,  1329,   449,   450,   451,   452,   453,   454,   455,  5261,
     457,  1330,   459,  1331,   460,   461,   462,   463,  1332,  1333,
     465,  1334,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1335,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1338,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1339,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,  1341,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1344,  1345,     0,     0,
     596,   597,  1346,   599,  1347,  1348,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1349,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
    1351,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,     0,  1360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1361,  1362,     0,     0,
       0,   235,     0,  1280,   715,  1364,  1281,  1282,  1283,   777,
    1284,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1285,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1286,   261,  1287,  1288,     0,   264,   265,   266,   267,
     268,   269,   270,  1289,  1290,   271,   272,  1291,  1292,   275,
       0,   276,   277,   278,   279,  1293,     0,  1294,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
    5596,   302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,
     305,   306,   307,   308,   309,  1302,  1303,   312,  1304,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   889,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1305,   343,   344,   345,   346,
    1306,  1307,   348,     0,   349,   350,   351,  1308,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1309,     0,  5597,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1311,  1312,     0,  1313,
       0,   396,   397,   398,   399,   400,  1314,  1315,  1316,  1317,
    1318,  1319,  1320,  1321,  1322,   410,  1323,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1324,   421,   422,
     423,     0,   424,   425,   426,  1325,  1326,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1327,   438,   439,
     440,   441,   442,   443,   444,   445,  1328,   447,  1329,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1330,   459,
    1331,   460,   461,   462,   463,  1332,  1333,   465,  1334,   467,
     468,   469,     0,   470,   471,   472,     0,     0,  1335,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1336,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1337,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1338,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,  5598,
     538,   539,  1339,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1340,
     556,   557,   558,   559,   560,   561,   562,   563,  1341,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1342,   582,     0,   583,
     584,  1343,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1344,  1345,     0,     0,   596,   597,  1346,
     599,  1347,  1348,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  1349,   610,   611,   612,   613,   614,  1350,
       0,   615,   616,   617,   618,   619,   620,  1351,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1352,  1353,  1354,
    1355,   640,  1356,  1357,  1358,  1359,   645,   646,   647,   648,
       0,  1360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1361,  1362,     0,     0,     0,   235,     0,
    1280,   715,  5599,  1281,  1282,  1283,   777,  1284,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1285,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,  6008,  1286,   261,
    1287,  1288,     0,   264,   265,   266,   267,   268,   269,   270,
    1289,  1290,   271,   272,  1291,  1292,   275,     0,   276,   277,
     278,   279,  1293,     0,  1294,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,  6009,  1295,
    1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,   307,
     308,   309,  1302,  1303,   312,  1304,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   889,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1305,   343,   344,   345,   346,  1306,  1307,   348,
       0,   349,   350,   351,  1308,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1309,     0,  1310,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1311,  1312,     0,  1313,     0,   396,   397,
     398,   399,   400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,
    1321,  1322,   410,  1323,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1324,   421,   422,   423,     0,   424,
     425,   426,  1325,  1326,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1327,   438,   439,   440,   441,   442,
     443,   444,   445,  1328,   447,  1329,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1330,   459,  1331,   460,   461,
     462,   463,  1332,  1333,   465,  1334,   467,   468,   469,     0,
     470,   471,   472,     0,     0,  1335,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,  1336,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,  1337,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1338,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,  1339,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1340,   556,   557,   558,
     559,   560,   561,   562,   563,  1341,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1342,   582,     0,   583,   584,  1343,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
    1344,  1345,     0,     0,   596,   597,  1346,   599,  1347,  1348,
     601,   602,   603,   604,   605,  6010,   607,   608,   609,     0,
    1349,   610,   611,   612,   613,   614,  1350,     0,   615,   616,
     617,   618,   619,   620,  1351,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,  1356,
    1357,  1358,  1359,   645,   646,   647,   648,     0,  1360,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,  1362,     0,     0,     0,   235,     0,  1280,   715,  1364,
    1281,  1282,  1283,   777,  1284,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1285,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1286,   261,  1287,  1288,     0,
     264,   265,   266,   267,   268,   269,   270,  1289,  1290,   271,
     272,  1291,  1292,   275,     0,   276,   277,   278,   279,  1293,
       0,  1294,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,  6009,  1295,  1296,  1297,  1298,
    1299,  1300,  1301,   304,   305,   306,   307,   308,   309,  1302,
    1303,   312,  1304,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   889,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1305,
     343,   344,   345,   346,  1306,  1307,   348,     0,   349,   350,
     351,  1308,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1309,     0,  1310,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1311,  1312,     0,  1313,     0,   396,   397,   398,   399,   400,
    1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,
    1323,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1324,   421,   422,   423,     0,   424,   425,   426,  1325,
    1326,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1327,   438,   439,   440,   441,   442,   443,   444,   445,
    1328,   447,  1329,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1330,   459,  1331,   460,   461,   462,   463,  1332,
    1333,   465,  1334,   467,   468,   469,     0,   470,   471,   472,
       0,     0,  1335,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,  1336,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
    1337,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1338,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1339,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1340,   556,   557,   558,   559,   560,   561,
     562,   563,  1341,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
    1342,   582,     0,   583,   584,  1343,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,  1344,  1345,     0,
       0,   596,   597,  1346,   599,  1347,  1348,   601,   602,   603,
     604,   605,  6010,   607,   608,   609,     0,  1349,   610,   611,
     612,   613,   614,  1350,     0,   615,   616,   617,   618,   619,
     620,  1351,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,  1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,
     645,   646,   647,   648,     0,  1360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1361,  1362,     0,
       0,     0,   235,     0,  1280,   715,  1364,  1281,  1282,  1283,
     777,  1284,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1285,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1286,   261,  1287,  1288,     0,   264,   265,   266,
     267,   268,   269,   270,  1289,  1290,   271,   272,  1291,  1292,
     275,     0,   276,   277,   278,   279,  1293,     0,  1294,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,
     304,   305,   306,   307,   308,   309,  1302,  1303,   312,  5581,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,  1305,   343,   344,   345,
     346,  1306,  1307,   348,     0,   349,   350,   351,  1308,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,  1309,     0,  1310,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1311,  1312,     0,
    1313,     0,   396,   397,   398,   399,   400,  1314,  1315,  1316,
    1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1324,   421,
     422,   423,     0,   424,   425,   426,  1325,  1326,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1327,   438,
     439,   440,   441,   442,   443,   444,   445,  1328,   447,  1329,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1330,
     459,     0,   460,   461,   462,   463,  1332,  1333,   465,  1334,
     467,   468,   469,     0,   470,   471,   472,     0,     0,  1335,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
    1336,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,  1337,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1338,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  3325,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1340,   556,   557,   558,   559,   560,   561,   562,   563,  1341,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1342,   582,     0,
     583,   584,  1343,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,  1344,  1345,     0,     0,   596,   597,
    1346,   599,  1347,  1348,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
    1350,     0,   615,   616,   617,   618,   619,   620,  1351,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,  1352,  1353,
    1354,  1355,   640,  1356,  1357,  1358,  1359,   645,   646,   647,
     648,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3326,  3327,     0,     0,     0,   235,
       0,  1280,   715,  3328,  1281,  1282,  1283,   777,  1284,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,  1285,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258, -2992,  1286,
     261,  1287,  1288,     0,   264,   265,   266,   267,   268,   269,
     270,  1289,  1290,   271,   272,  1291,  1292,   275,     0,   276,
     277,   278,   279,  1293,     0,  1294,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,  6009,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,
     307,   308,   309,  1302,  1303,   312,  1304,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   889,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1305,   343,   344,   345,   346,  1306,  1307,
     348,     0,   349,   350,   351,  1308,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1309,     0,  1310,   366,   367,     0,   368,   369,   370,
     371,   372, -2992,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1311,  1312,     0,  1313,     0,   396,
       0,     0,   399,   400,  1314,  1315,  1316,  1317,  1318,  1319,
    1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1324,   421,   422, -2992,     0,
     424,   425,   426,  1325,  1326,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1327,   438,   439,   440,   441,
     442,   443,   444,   445,  1328,   447,  1329,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1330,   459,  1331,   460,
     461,     0,   463,  1332,  1333,   465,  1334,   467,   468,   469,
       0,   470,   471,   472,     0,     0,  1335,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1336,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1337,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1338,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
    1339,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1340,   556,   557,
     558,   559,   560, -2992,   562,   563,  1341,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1342,   582,     0,   583,   584,  1343,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,  1344,  1345,     0,     0,   596,   597,  1346,   599,  1347,
    1348,   601,   602,   603,   604,   605,  6010,   607,   608,   609,
       0,  1349,   610,   611,   612,   613,   614,  1350,     0,   615,
     616,   617,   618,   619,   620,  1351,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,
    1356,  1357,  1358,  1359,   645,   646,   647,   648,     0, -2992,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,  1362,     0,     0,     0,   235,     0,  1280,   715,
    1364,  1281,  1282,  1283,   777,  1284,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1285,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,  1286,   261,  1287,  1288,
       0,   264,   265,   266,   267,   268,   269,   270,  1289,  1290,
     271,   272,  1291,  1292,   275,     0,   276,   277,   278,   279,
    1293,     0,  1294,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1295,  1296,  1297,
    1298,  1299,  1300,  1301,   304,   305,   306,   307,   308,   309,
    1302,  1303,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   889,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1305,   343,   344,   345,   346,  1306,  1307,   348,     0,   349,
     350,   351,  1308,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1309,     0,
    1310,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1311,  1312,     0,  1313,     0,   396,   397,   398,   399,
     400,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,
     410,  1323,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1324,   421,   422,   423,     0,   424,   425,   426,
    1325,  1326,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1327,   438,   439,   440,   441,   442,   443,   444,
     445,  1328,   447,  1329,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1330,   459,     0,   460,   461,   462,   463,
    1332,  1333,   465,  1334,   467,   468,   469,     0,   470,   471,
     472,     0,     0,  1335,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1336,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1337,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1338,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  3325,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1340,   556,   557,   558,   559,   560,
     561,   562,   563,  1341,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1342,   582,     0,   583,   584,  1343,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,  1344,  1345,
       0,     0,   596,   597,  1346,   599,  1347,  1348,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,  1350,     0,   615,   616,   617,   618,
     619,   620,  1351,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,
    1359,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3326,  3327,
     235,     0,  1280,   715,     0,  1281,  1282,  3328,   777,  1284,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1285,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1286,   261,  1287,  1288,     0,   264,   265,   266,   267,   268,
     269,   270,  1289,  1290,   271,   272,  1291,  1292,   275,     0,
     276,   277,   278,   279,  1293,     0,  1294,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,  1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,
     306,   307,   308,   309,  1302,  1303,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   889,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1305,   343,   344,   345,   346,  1306,
    1307,   348,     0,   349,   350,   351,  1308,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1309,     0,  1310,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1311,  1312,     0,  1313,     0,
     396,   397,   398,   399,   400,  1314,  1315,  1316,  1317,  1318,
    1319,  1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1324,   421,   422,   423,
       0,   424,   425,   426,  1325,  1326,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1327,   438,   439,   440,
     441,   442,   443,   444,   445,  1328,   447,  1329,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1330,   459,     0,
     460,   461,   462,   463,  1332,  1333,   465,  1334,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,  1336,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,  1337,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1338,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  3505,  3506,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1340,   556,
     557,   558,   559,   560,   561,   562,   563,  1341,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1342,   582,     0,   583,   584,
    1343,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,  1344,  1345,     0,     0,   596,   597,  1346,   599,
    1347,  1348,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,  1350,     0,
     615,   616,   617,   618,   619,   620,  1351,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,
     640,  1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3507,  3508,   235,     0,  1280,   715,     0,  1281,
    1282,  3328,   777,  1284,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1285,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1286,   261,  1287,  1288,     0,   264,
     265,   266,   267,   268,   269,   270,  1289,  1290,   271,   272,
    1291,  1292,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,  1302,  1303,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     889,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1305,   343,
     344,   345,   346,  1306,  1307,   348,     0,   349,   350,   351,
    1308,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,  1310,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1311,
    1312,     0,  1313,     0,   396,   397,   398,   399,   400,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,  1328,
     447,  1329,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,     0,   460,   461,   462,   463,  1332,  1333,
     465,  1334,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1338,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  3325,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,  1341,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1344,  1345,     0,     0,
     596,   597,  1346,   599,  1347,  1348,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
    1351,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,     0,     0,     0,     0,     0,     0,   235,
       0,  1280,   715,     0,  1281,  1282,     0,   777,  1284,     0,
       0,     0,     0,     0,     0,  3328,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,  1285,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,  1286,
     261,  1287,  1288,     0,   264,  4776,   266,   267,   268,   269,
     270,  1289,  1290,   271,   272,  1291,  1292,   275,     0,   276,
     277,   278,   279,  1293,     0,  1294,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,
     307,   308,   309,  1302,  1303,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   889,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1305,   343,   344,   345,   346,  1306,  1307,
     348,     0,   349,   350,   351,  1308,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1309,     0,  1310,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1311,  1312,     0,  1313,     0,   396,
     397,   398,   399,   400,  1314,  1315,  1316,  1317,  1318,  1319,
    1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1324,   421,   422,   423,     0,
     424,   425,   426,  1325,  1326,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1327,   438,   439,   440,   441,
     442,   443,   444,   445,  1328,   447,  1329,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1330,   459,     0,   460,
     461,   462,   463,  1332,  1333,   465,  1334,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1336,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1337,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1338,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
    3325,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1340,   556,   557,
     558,   559,   560,   561,   562,   563,  1341,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1342,   582,     0,   583,   584,  1343,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,  1344,  1345,     0,     0,   596,   597,  1346,   599,  1347,
    1348,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,  1350,     0,   615,
     616,   617,   618,   619,   620,  1351,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,
    1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,   235,     0,  1280,   715,     0,  1281,
    1282,     0,   777,  1284,     0,     0,     0,     0,     0,     0,
    3328,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1285,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1286,   261,  1287,  1288,     0,   264,
     265,   266,   267,   268,   269,   270,  1289,  1290,   271,   272,
    1291,  1292,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,  1302,  1303,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     889,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1305,   343,
     344,   345,   346,  1306,  1307,   348,     0,   349,   350,   351,
    1308,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,  1310,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1311,
    1312,     0,  1313,     0,   396,   397,   398,   399,   400,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,  1328,
     447,  1329,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,     0,   460,   461,   462,   463,  1332,  1333,
     465,  1334,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1338,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  3325,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,  1341,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1344,  1345,     0,     0,
     596,   597,  1346,   599,  1347,  1348,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
    1351,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,  4836,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,     0,     0,     0,     0,     0,     0,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3328,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,  1290,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,  1293,     0,  1294,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,  1306,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1309,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,  3476,  1315,  1316,  1317,  1318,  1319,
    1320,  1321,  1322,  3477,  1323,   412,   413,   414,   415,   416,
     417,   418,  3478,     0,   419,  1324,   421,   422,   423,     0,
     424,   425,   426,  1325,  1326,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1327,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1330,   459,     0,   460,
     461,   462,   463,     0,  1333,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,   864,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1336,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1337,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,  3479,   542,   543,   544,   545,   546,   547,   548,   549,
     550,    41,   551,   552,   553,   554,   555,  1340,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1342,   582,     0,   583,   584,  1343,
      45,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,  1346,   599,  1347,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,  1350,     0,   615,
     616,   617,   618,   619,  1208,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,    50,   629,   630,
     631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,
    1356,  1357,  1358,  1359,  3480,   646,   647,   648,     0,     0,
       0,    51,     0,     0,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3481,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,  1290,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1306,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,  3476,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,  3477,  1323,
     412,   413,   414,   415,   416,   417,   418,  3478,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,     0,   460,   461,   462,   463,     0,  1333,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
     864,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,  3479,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,  1346,   599,  1347,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,  3480,
     646,   647,   648,     0,     0,     0,     0,     0,     0,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3481,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,  1290,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,  1293,     0,  1294,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,  1306,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1309,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,  3476,  1315,  1316,  1317,  1318,  1319,
    1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1324,   421,   422,   423,     0,
     424,   425,   426,  1325,  1326,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1327,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1330,   459,     0,   460,
     461,   462,   463,     0,  1333,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1336,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1337,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1340,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1342,   582,     0,   583,   584,  1343,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,  1346,   599,  1347,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,  1350,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,
    1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3915,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,  1290,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1306,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,  3476,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,  3477,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,     0,   460,   461,   462,   463,     0,  1333,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,  3479,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,  1346,   599,  1347,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,  3480,
     646,   647,   648,     0,     0,     0,     0,     0,     0,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    57,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,  1290,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,  1293,     0,  1294,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,  1306,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1309,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,  3476,  1315,  1316,  1317,  1318,  1319,
    1320,  1321,  1322,   410,  1323,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1324,   421,   422,   423,     0,
     424,   425,   426,  1325,  1326,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1327,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1330,   459,     0,   460,
     461,   462,   463,     0,  1333,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1336,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1337,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1340,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1342,   582,     0,   583,   584,  1343,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,  1346,   599,  1347,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,  1350,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,  1352,  1353,  1354,  1355,   640,
    1356,  1357,  1358,  1359,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4911,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,  1290,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1306,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,  3476,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,     0,   460,   461,   462,   463,     0,  1333,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,  1346,   599,  1347,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,     0,     0,     0,     0,     0,     0,   969,
       0,  1613,   715,     0,     0,     0,     0,   777,     0,     0,
       0,     0,     0,     0,     0,  6112,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,     0,   303,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  5896,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,  1836,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,  1837,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
    1838,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,   969,     0,     0,     0,     0,     0,
       0,  1614,  1615,  5897,     0,     0,     0,     0,     0,     0,
    5898,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     3,     4,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,     0,     0,     0,   303,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,    41,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,    45,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,  1208,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,    50,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,  1048,     0,     0,    51,     0,     0,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    57,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,     0,   303,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5647,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,    41,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,    45,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,  1208,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,    50,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,     0,     0,     0,    51,     0,     0,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    57,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,  2913,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,   864,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
    2914,  2915,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1870,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,     0,     0,     0,     0,     0,     0,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1424,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4015,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,     0,     0,     0,     0,     0,     0,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4213,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2119,     0,     0,
       0,     0,     0,     0,  2120,     0,     0,  2121,     0,     0,
    4853,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,
    2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,
    2141,     0,  2142,  2143,  2144,  2145,  2146,  2147,  2148,  2149,
    2150,  2151,  2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,
    2160,  2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,
    2170,  2171,  2172,     0,     0,  2173,  2174,  2175,  2176,  2177,
    2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,
    2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,
    2198,  2199,  2200,     0,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,     0,
    2216,  2217,  2218,  2219,  2220,  2221,  2222,  2223,  2224,  2225,
    2226,  2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,  2235,
    2236,  2237,  2238,  2239,  2240,  2241,  2242,  2243,  2244,  2245,
    2246,  2247,  2248,  2249,  2250,  2251,     0,  2252,  2253,  2254,
    2255,  2256,  2257,  2258,  2259,  2260,  2261,  2262,  2263,     0,
       0,  2264,  2265,  2266,  2267,     0,  2268,  2269,  2270,  2271,
    2272,     0,  2273,  2274,  2275,  2276,  2277,     0,  2278,  2279,
       0,  2280,  2281,  2282,     0,  2283,  2284,     0,  2285,  2286,
    2287,  2288,  2289,  2290,  2291,  2292,  2293,  2294,  2295,  2296,
    2297,  2298,  2299,  2300,  2301,  2302,  2303,  2304,  2305,  2306,
    2307,  2308,  2309,  2310,     0,  2311,     0,  2312,  2313,  2314,
    2315,  2316,  2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,
    2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,  2334,
    2335,  2336,  2337,  2338,  2339,  2340,  2341,     0,  2342,  2343,
    2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,
    2354,  2355,  2356,  2357,  2358,     0,  2359,  2360,     0,  2361,
    2362,  2363,  2364,  2365,  2366,  2367,  2368,  2369,  2370,  2371,
    2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,
    2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,     0,  2390,
    2391,  2392,     0,  2393,  2394,  2395,  2396,  2397,     0,  2398,
    2399,  2400,  2401,     0,     0,  2402,  2403,  2404,  2405,  2406,
    2407,  2408,  2409,  2410,  2411,  2412,  2413,     0,  2414,  2415,
    2416,  2417,  2418,  2419,     0,  2420,  2421,  2422,  2423,  2424,
    2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,  2433,  2434,
    2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,  2443,  2444,
    2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,     0,
    2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,  2463,
    2464,  2465,  2466,  2467,  2468,  2469,  2470,     0,  2471,  2472,
    2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,
    2483,  2484,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,  2494,  2495,  2496,  2497,  2498,  2499,  2500,  2501,  2502,
    2503,  2504,  2505,  2506,  2507,  2508,  2509,  2510,  2511,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2522,
    2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,     0,  2540,
    2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,  2549,  2550,
    2551,  2552,  2553,  2554,  2555,     0,  2556,  2557,  2558,  2559,
    2560,  2561,     0,  2562,     0,     0,     0,     0,  2563,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,
    2575,  2576,  2577,     0,  2578,  2579,     0,  2580,     0,     0,
       0,     0,     0,     0,     0,     0,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,   881,     0,  1613,   715,     0,
       0,     0,   984,   777,     0,     0,     0,     0,     0,   985,
     986,   987,   236,   237,   238,   239,   240,   241,   242,   243,
     244,  1748,   245,   246,   247,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,   248,   249,   250,  1756,   251,   252,   253,   254,
     255,   256,   257,   258,     0,   882,   261,   883,   884,  1757,
     264,   265,   266,   267,   268,   269,   270,  1758,  1759,   271,
     272,   885,   886,   275,  1760,   276,   277,   278,   279,     0,
    1761,   281,  1762,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,  1763,   293,   294,   295,   296,   297,
     298,  1764,   299,   300,   301,   302,  1765,  1766,  1767,   303,
    1768,  1769,  1770,   304,   305,   306,   307,   308,   309,   887,
     888,   312,  1771,   313,  1772,   314,   315,   316,   317,   318,
     319,   320,  1773,   321,   322,   323,   324,  1774,  1775,   325,
     326,   889,   328,   329,  1776,   330,   331,   332,   333,  1777,
     334,   335,   336,   337,  1778,   338,   339,   340,   341,     0,
     343,   344,   345,   346,     0,  1779,   348,  1780,   349,   350,
     351,   890,   353,  1781,   354,  1782,   355,   356,   357,  1783,
     358,   359,   360,   361,   362,  1784,   363,     0,  1785,     0,
     366,   367,  1786,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1787,   378,   379,   380,   381,   382,   383,
     384,   385,  1788,   386,   387,     0,   389,   390,   391,   392,
     891,   892,  1789,   893,  1790,   396,   397,   398,   399,   400,
     894,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,   413,   414,   415,   416,   417,   418,  1791,  1792,
     419,     0,   421,   422,   423,  1793,   424,   425,   426,  1794,
    1795,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     895,   447,   896,   449,   450,   451,   452,   453,   454,   455,
     456,  4521,     0,   459,  1796,   460,   461,   462,   463,  1797,
       0,   465,   897,   467,   468,   469,  1798,   470,   471,   472,
    1799,  1800,  4522,   474,   475,  1801,  1802,   476,   477,     0,
     479,   480,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,  1803,   494,   495,   496,
       0,   498,     0,   500,   501,   502,  1804,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   898,   515,
     516,   517,   518,  1805,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,  1806,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,  1807,   551,   552,
     553,   554,   555,  1808,   556,   557,  2740,   559,   560,   561,
     562,   563,   900,   565,  1809,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
       0,   582,  1810,   583,   584,  1811,  1812,   585,   586,   587,
     588,   589,   590,   591,   592,  1813,   593,   901,   902,  1814,
    1815,   596,   597,     0,   599,     0,  1816,   601,   602,   603,
     604,   605,   606,   607,   608,   609,  1817,  1818,   610,   611,
     612,   613,   614,  1819,  1820,   615,   616,   617,   618,   619,
       0,   903,  1821,   622,   623,   624,   625,   626,   627,  1822,
    1823,   628,  1824,  1825,   629,   630,   631,   632,   633,   634,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   646,   647,   648,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   990,   991,   992,  4523,  4524,   995,
     996,   997,   998,   881,     0,  1613,   715,     0,     0,     0,
     984,   777,     0,     0,     0,     0,     0,   985,   986,   987,
     236,   237,   238,   239,   240,   241,   242,   243,   244,  1748,
     245,   246,   247,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
     248,   249,   250,  1756,   251,   252,   253,   254,   255,   256,
     257,   258,     0,   882,   261,   883,   884,  1757,   264,   265,
     266,   267,   268,   269,   270,  1758,  1759,   271,   272,   885,
     886,   275,  1760,   276,   277,   278,   279,     0,  1761,   281,
    1762,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,  1763,   293,   294,   295,   296,   297,   298,  1764,
     299,   300,   301,   302,  1765,  1766,  1767,   303,  1768,  1769,
    1770,   304,   305,   306,   307,   308,   309,   887,   888,   312,
    1771,   313,  1772,   314,   315,   316,   317,   318,   319,   320,
    1773,   321,   322,   323,   324,  1774,  1775,   325,   326,   889,
     328,   329,  1776,   330,   331,   332,   333,  1777,   334,   335,
     336,   337,  1778,   338,   339,   340,   341,     0,   343,   344,
     345,   346,     0,  1779,   348,  1780,   349,   350,   351,   890,
     353,  1781,   354,  1782,   355,   356,   357,  1783,   358,   359,
     360,   361,   362,  1784,   363,     0,  1785,     0,   366,   367,
    1786,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,  1787,   378,   379,   380,   381,   382,   383,   384,   385,
    1788,   386,   387,     0,   389,   390,   391,   392,   891,   892,
    1789,   893,  1790,   396,   397,   398,   399,   400,   894,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   412,
     413,   414,   415,   416,   417,   418,  1791,  1792,   419,     0,
     421,   422,   423,  1793,   424,   425,   426,  1794,  1795,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   895,   447,
     896,   449,   450,   451,   452,   453,   454,   455,   456,  4982,
       0,   459,  1796,   460,   461,   462,   463,  1797,     0,   465,
     897,   467,   468,   469,  1798,   470,   471,   472,  1799,  1800,
    4522,   474,   475,  1801,  1802,   476,   477,     0,   479,   480,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,  1803,   494,   495,   496,     0,   498,
       0,   500,   501,   502,  1804,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   898,   515,   516,   517,
     518,  1805,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  1806,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,  1807,   551,   552,   553,   554,
     555,  1808,   556,   557,  2740,   559,   560,   561,   562,   563,
     900,   565,  1809,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,     0,   582,
    1810,   583,   584,  1811,  1812,   585,   586,   587,   588,   589,
     590,   591,   592,  1813,   593,   901,   902,  1814,  1815,   596,
     597,     0,   599,     0,  1816,   601,   602,   603,   604,   605,
     606,   607,   608,   609,  1817,  1818,   610,   611,   612,   613,
     614,  1819,  1820,   615,   616,   617,   618,   619,     0,   903,
    1821,   622,   623,   624,   625,   626,   627,  1822,  1823,   628,
    1824,  1825,   629,   630,   631,   632,   633,   634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   646,
     647,   648,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   990,   991,   992,  4523,  4524,   995,   996,   997,
     998,   656,     0,     0,     0,     0,     0,     0,   984,     0,
       0,     0,     0,     0,     0,   985,   986,   987,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   988,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   989,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   656,
       0,     0,     0,     0,     0,     0,   984,     0,     0,     0,
       0,     0,     0,   985,   986,   987,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
    1105,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
    1106,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   656,     0,     0,
       0,     0,     0,     0,   984,     0,     0,     0,     0,     0,
       0,   985,   986,   987,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,  1171,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,  1172,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1173,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   656,     0,     0,     0,     0,
       0,     0,   984,     0,     0,     0,     0,     0,     0,   985,
     986,   987,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,  1853,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,  1854,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   656,     0,     0,     0,     0,     0,     0,
     984,     0,     0,     0,     0,     0,     0,   985,   986,   987,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   656,     0,     0,     0,     0,     0,     0,   984,     0,
       0,     0,     0,     0,     0,   985,   986,   987,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,  3594,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,  3595,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   656,
       0,     0,     0,     0,     0,     0,   984,     0,     0,     0,
       0,     0,     0,   985,   986,   987,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,  5629,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
    1747,     0,     0,     0,     0,     0,     0,     0,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   236,   237,   238,
     239,   240,   241,   242,   243,   244,  1748,   245,   246,   247,
    1749,  1750,  1751,  1752,  1753,  1754,  1755,   248,   249,   250,
    1756,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,  1757,   264,   265,   266,   267,   268,
     269,   270,  1758,  1759,   271,   272,   273,   274,   275,  1760,
     276,   277,   278,   279,   280,  1761,   281,  1762,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,  1763,
     293,   294,   295,   296,   297,   298,  1764,   299,   300,   301,
     302,  1765,  1766,  1767,   303,  1768,  1769,  1770,   304,   305,
     306,   307,   308,   309,   310,   311,   312,  1771,   313,  1772,
     314,   315,   316,   317,   318,   319,   320,  1773,   321,   322,
     323,   324,  1774,  1775,   325,   326,   327,   328,   329,  1776,
     330,   331,   332,   333,  1777,   334,   335,   336,   337,  1778,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1779,   348,  1780,   349,   350,   351,   352,   353,  1781,   354,
    1782,   355,   356,   357,  1783,   358,   359,   360,   361,   362,
    1784,   363,   364,  1785,   365,   366,   367,  1786,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1787,   378,
     379,   380,   381,   382,   383,   384,   385,  1788,   386,   387,
     388,   389,   390,   391,   392,   393,   394,  1789,   395,  1790,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,  1791,  1792,   419,   420,   421,   422,   423,
    1793,   424,   425,   426,  1794,  1795,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,  1796,
     460,   461,   462,   463,  1797,   464,   465,   466,   467,   468,
     469,  1798,   470,   471,   472,  1799,  1800,   473,   474,   475,
    1801,  1802,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,  1803,   494,   495,   496,   497,   498,   499,   500,   501,
     502,  1804,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,  1805,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,  1806,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,  1807,   551,   552,   553,   554,   555,  1808,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,  1809,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,  1810,   583,   584,
    1811,  1812,   585,   586,   587,   588,   589,   590,   591,   592,
    1813,   593,   594,   595,  1814,  1815,   596,   597,   598,   599,
     600,  1816,   601,   602,   603,   604,   605,   606,   607,   608,
     609,  1817,  1818,   610,   611,   612,   613,   614,  1819,  1820,
     615,   616,   617,   618,   619,   620,   621,  1821,   622,   623,
     624,   625,   626,   627,  1822,  1823,   628,  1824,  1825,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1826,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   870,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6080,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6082,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   881,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6212,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,     0,   882,   261,   883,   884,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   885,   886,   275,     0,   276,   277,   278,   279,     0,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,     0,     0,     0,   303,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   887,
     888,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   889,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,     0,
     343,   344,   345,   346,     0,     0,   348,     0,   349,   350,
     351,   890,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,     0,     0,     0,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  2736,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,  2737,   389,   390,   391,   392,
     891,   892,     0,   893,     0,   396,   397,   398,   399,   400,
     894,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,     0,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     895,   447,   896,   449,   450,   451,   452,   453,   454,   455,
     456,     0,     0,   459,     0,   460,   461,   462,   463,     0,
       0,   465,   897,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,  2738,   476,   477,  2739,
     479,   480,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
       0,   498,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   898,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,  2740,   559,   560,   561,
     562,   563,   900,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
       0,   582,     0,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,   901,   902,     0,
       0,   596,   597,     0,   599,     0,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
       0,   903,  2741,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
       0,     0,     0,  3952,     0,     0,     0,     0,     0,     0,
       0,   646,   647,   648,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,  2742,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,     0,   882,   261,   883,   884,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   885,
     886,   275,     0,   276,   277,   278,   279,     0,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,     0,     0,     0,   303,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   887,   888,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   889,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,     0,   343,   344,
     345,   346,     0,     0,   348,     0,   349,   350,   351,   890,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,     0,     0,     0,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,  2736,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,  2737,   389,   390,   391,   392,   891,   892,
       0,   893,     0,   396,   397,   398,   399,   400,   894,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,     0,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   895,   447,
     896,   449,   450,   451,   452,   453,   454,   455,   456,     0,
       0,   459,     0,   460,   461,   462,   463,     0,     0,   465,
     897,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,  2738,   476,   477,  2739,   479,   480,
     481,     0,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,     0,   498,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   898,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,  2740,   559,   560,   561,   562,   563,
     900,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,     0,   582,
       0,   583,   584,     0,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,   901,   902,     0,     0,   596,
     597,     0,   599,     0,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,     0,   903,
    2741,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   646,
     647,   648,   969,     0,  1613,   715,     0,     0,     0,     0,
     777,     0,     0,     0,     0,     0,     0,  2742,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,  2628,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,  1836,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,  1837,     0,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,  1838,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   969,     0,  1613,   715,     0,     0,     0,     0,   777,
       0,     0,     0,     0,  1614,  1615,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,     0,     0,     0,   303,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,  2633,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,  1836,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,  1837,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,  1838,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     969,     0,  1613,   715,     0,     0,     0,     0,   777,     0,
       0,     0,     0,  1614,  1615,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,     0,     0,     0,   303,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,  3561,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1836,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,  1837,     0,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,  1838,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   969,
       0,  1613,   715,     0,     0,     0,     0,   777,     0,     0,
       0,     0,  1614,  1615,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,     0,   303,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,  1836,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,  1837,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
    1838,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,   777,     0,     0,     0,
       0,  1614,  1615,     0,     0,   236,   237,   778,   239,   240,
     241,   242,   243,   244,   779,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   780,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   781,   352,   353,     0,   354,     0,   355,
     782,     0,   783,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,   784,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     785,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   786,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     787,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     788,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   969,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     789,   790,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     3,     4,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,  1048,  1747,     0,  6402,
     715,     0,     0,     0,     0,   777,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,  1748,   245,   246,   247,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,   248,   249,   250,  1756,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,  1757,   264,   265,   266,   267,   268,   269,   270,  1758,
    1759,   271,   272,   273,   274,   275,  1760,   276,   277,   278,
     279,   280,  1761,   281,  1762,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,  1763,   293,   294,   295,
     296,   297,   298,  1764,   299,   300,   301,   302,  1765,  1766,
    1767,   303,  1768,  1769,  1770,   304,   305,   306,   307,   308,
     309,   310,   311,   312,  1771,   313,  1772,   314,   315,   316,
     317,   318,   319,   320,  1773,   321,   322,   323,   324,  1774,
    1775,   325,   326,   327,   328,   329,  1776,   330,   331,   332,
     333,  1777,   334,   335,   336,   337,  1778,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,  1779,   348,  1780,
     349,   350,   351,   352,   353,  1781,   354,  1782,   355,   356,
     357,  1783,   358,   359,   360,   361,   362,  1784,   363,   364,
    1785,   365,   366,   367,  1786,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  1787,   378,   379,   380,   381,
     382,   383,   384,   385,  1788,   386,   387,   388,   389,   390,
     391,   392,   393,   394,  1789,   395,  1790,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
    1791,  1792,   419,   420,   421,   422,   423,  1793,   424,   425,
     426,  1794,  1795,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1796,   460,   461,   462,
     463,  1797,   464,   465,   466,   467,   468,   469,  1798,   470,
     471,   472,  1799,  1800,   473,   474,   475,  1801,  1802,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,  1803,   494,
     495,   496,   497,   498,   499,   500,   501,   502,  1804,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,  1805,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,  1806,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,  1807,
     551,   552,   553,   554,   555,  1808,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,  1809,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,  1810,   583,   584,  1811,  1812,   585,
     586,   587,   588,   589,   590,   591,   592,  1813,   593,   594,
     595,  1814,  1815,   596,   597,   598,   599,   600,  1816,   601,
     602,   603,   604,   605,   606,   607,   608,   609,  1817,  1818,
     610,   611,   612,   613,   614,  1819,  1820,   615,   616,   617,
     618,   619,   620,   621,  1821,   622,   623,   624,   625,   626,
     627,  1822,  1823,   628,  1824,  1825,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,  1747,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,  1748,   245,   246,   247,  1749,  1750,  1751,  1752,
    1753,  1754,  1755,   248,   249,   250,  1756,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
    1757,   264,   265,   266,   267,   268,   269,   270,  1758,  1759,
     271,   272,   273,   274,   275,  1760,   276,   277,   278,   279,
     280,  1761,   281,  1762,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,  1763,   293,   294,   295,   296,
     297,   298,  1764,   299,   300,   301,   302,  1765,  1766,  1767,
     303,  1768,  1769,  1770,   304,   305,   306,   307,   308,   309,
     310,   311,   312,  1771,   313,  1772,   314,   315,   316,   317,
     318,   319,   320,  1773,   321,   322,   323,   324,  1774,  1775,
     325,   326,   327,   328,   329,  1776,   330,   331,   332,   333,
    1777,   334,   335,   336,   337,  1778,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1779,   348,  1780,   349,
     350,   351,   352,   353,  1781,   354,  1782,   355,   356,   357,
    1783,   358,   359,   360,   361,   362,  1784,   363,   364,  1785,
     365,   366,   367,  1786,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1787,   378,   379,   380,   381,   382,
     383,   384,   385,  1788,   386,   387,   388,   389,   390,   391,
     392,   393,   394,  1789,   395,  1790,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,  1791,
    1792,   419,   420,   421,   422,   423,  1793,   424,   425,   426,
    1794,  1795,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  1796,   460,   461,   462,   463,
    1797,   464,   465,   466,   467,   468,   469,  1798,   470,   471,
     472,  1799,  1800,   473,   474,   475,  1801,  1802,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,  1803,   494,   495,
     496,   497,   498,   499,   500,   501,   502,  1804,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,  1805,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,  1806,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,  1807,   551,
     552,   553,   554,   555,  1808,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,  1809,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,  1810,   583,   584,  1811,  1812,   585,   586,
     587,   588,   589,   590,   591,   592,  1813,   593,   594,   595,
    1814,  1815,   596,   597,   598,   599,   600,  1816,   601,   602,
     603,   604,   605,   606,   607,   608,   609,  1817,  1818,   610,
     611,   612,   613,   614,  1819,  1820,   615,   616,   617,   618,
     619,   620,   621,  1821,   622,   623,   624,   625,   626,   627,
    1822,  1823,   628,  1824,  1825,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,  1747,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,  3669,   242,   243,
     244,  1748,   245,   246,   247,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,   248,   249,   250,  1756,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,  1757,
     264,   265,   266,   267,   268,   269,   270,  1758,  1759,   271,
     272,   273,   274,   275,  1760,   276,   277,   278,   279,   280,
    1761,   281,  1762,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,  1763,   293,   294,   295,   296,   297,
     298,  1764,   299,   300,   301,   302,  1765,  1766,  1767,   303,
    1768,  1769,  1770,   304,   305,   306,   307,   308,   309,   310,
     311,   312,  1771,   313,  1772,   314,   315,   316,   317,   318,
     319,   320,  1773,   321,   322,   323,   324,  1774,  1775,   325,
     326,   327,  3670,   329,  1776,   330,   331,   332,   333,  1777,
     334,   335,   336,   337,  1778,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,  1779,   348,  1780,   349,   350,
     351,   352,   353,  1781,   354,  1782,   355,   356,   357,  1783,
     358,   359,   360,   361,   362,  1784,   363,   364,  1785,   365,
     366,   367,  1786,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1787,   378,   379,   380,   381,   382,   383,
     384,   385,  1788,   386,   387,   388,   389,   390,   391,   392,
     393,   394,  1789,   395,  1790,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,  1791,  1792,
     419,   420,   421,   422,   423,  1793,   424,   425,   426,  1794,
    1795,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1796,   460,   461,   462,   463,  1797,
     464,   465,   466,   467,   468,   469,  1798,   470,   471,   472,
    1799,  1800,   473,   474,   475,  1801,  1802,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,  1803,   494,   495,   496,
     497,   498,   499,   500,   501,   502,  1804,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,  1805,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,  1806,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,  1807,   551,   552,
     553,   554,   555,  1808,  3671,   557,   558,   559,   560,   561,
     562,   563,   564,   565,  1809,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,  1810,   583,   584,  1811,  1812,   585,   586,   587,
     588,   589,   590,   591,   592,  1813,   593,   594,   595,  1814,
    1815,   596,   597,   598,   599,   600,  1816,   601,   602,   603,
     604,   605,   606,   607,   608,   609,  1817,  1818,   610,   611,
     612,   613,   614,  1819,  1820,   615,   616,   617,   618,   619,
     620,   621,  1821,   622,   623,   624,   625,   626,   627,  1822,
    1823,   628,  1824,  1825,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,  1290,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,  1293,     0,
    1294,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1295,  1296,  1297,  1298,  1299,
    1300,  1301,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1306,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1309,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,  3476,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   410,  1323,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1324,   421,   422,   423,     0,   424,   425,   426,  1325,  1326,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1327,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1330,   459,     0,   460,   461,   462,   463,     0,  1333,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1336,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1337,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1340,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1342,
     582,     0,   583,   584,  1343,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,  1346,   599,  1347,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,  1350,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1352,  1353,  1354,  1355,   640,  1356,  1357,  1358,  1359,   645,
     646,   647,   648,   235,     0,  1280,   715,     0,  1281,  1282,
       0,   777,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1286,   261,  1287,  1288,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,  1291,
    1292,   275,     0,   276,   277,   278,   279,   280,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,     0,     0,     0,   303,     0,     0,
       0,   304,   305,   306,   307,   308,   309,  1302,  1303,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   889,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,  1307,   348,     0,   349,   350,   351,  1308,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1311,  1312,
       0,  1313,     0,   396,   397,   398,   399,   400,  6376,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,  1328,   447,
    1329,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,  1332,   464,   465,
    1334,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1338,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
    1341,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,  1344,  1345,     0,     0,   596,
     597,   598,   599,   600,  1348,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,  1351,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   969,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  1008,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,   970,   303,     0,     0,   971,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     972,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   969,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  1029,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,     0,     0,   970,   303,     0,     0,   971,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,  1030,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   972,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     969,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,     0,     0,   970,   303,     0,     0,   971,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   972,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,  3007,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   969,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,   970,   303,     0,     0,   971,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,  4033,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   972,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   969,     0,
       0,   715,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,     0,
       0,     0,   303,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1836,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,  1837,     0,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,  1838,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   969,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
     970,   303,     0,     0,   971,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   972,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   969,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,     0,     0,   970,
     303,     0,     0,   971,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,  1124,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   972,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   969,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,     0,     0,   970,   303,
       0,     0,   971,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1166,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   972,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   969,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,     0,     0,   970,   303,     0,
       0,   971,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1179,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   972,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   969,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,     0,     0,   970,   303,     0,     0,
     971,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1191,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,  1192,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   972,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   969,     0,     0,   715,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,  2613,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   969,     0,     0,   715,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,     0,     0,     0,   303,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,     0,     0,     0,   303,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,     0,   303,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1150,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,     0,
       0,     0,   303,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1163,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1177,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,     0,     0,     0,
     303,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1181,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   969,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,     0,     0,     0,   303,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,  2841,   276,   277,   278,   279,   280,     0,
       0,  2842,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,  2843,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,  2844,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,  2845,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  2846,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,  2847,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  2848,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,  2841,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,  2843,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,  2844,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,  2845,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,  3886,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,  2847,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,  2848,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   796,   245,
     797,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   798,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,   832,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     799,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   800,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   796,   245,   797,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   798,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,  3568,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   799,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   800,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,  2841,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,  2843,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
    2844,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
    2845,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,  2847,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,  2848,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   796,   245,   797,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   798,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   799,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   800,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,  3083,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,  2913,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,   864,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,  2914,
    2915,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,  2016,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,  2017,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,  2018,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,  2019,   355,   356,
       0,     0,     0,  2020,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,  2021,  2022,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
    2023,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,  2024,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,  2025,   539,   540,   541,
     542,   543,   544,  2026,   546,   547,   548,   549,   550,     0,
    2027,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,  2028,   585,
       0,  2029,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,  2030,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   797,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   798,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   799,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   800,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,  2913,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,   864,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,  2914,  2915,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
    1022,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1023,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
     864,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,  3650,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,  3651,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  3663,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
    3664,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   657,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   706,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   707,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   824,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   825,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   826,   595,     0,     0,   827,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   858,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   859,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     860,   595,     0,     0,   861,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,   864,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,   924,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   979,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   980,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
    1142,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   824,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  1250,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  1399,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,  1410,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   844,   272,   273,   274,  1411,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   847,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   848,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   849,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,  1403,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   851,   595,     0,     0,   852,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   853,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1557,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,   864,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,  1618,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1619,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,  3425,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
    3426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,  3427,   585,
       0,   587,   588,  3428,   590,  3429,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,  3430,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,   715,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,   777,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,  4251,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,  4265,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,  4396,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,  4923,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,  4996,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  5356,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   816,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     822,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   844,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   845,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   846,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   847,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   848,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   849,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   850,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   851,   595,     0,
       0,   852,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   853,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     876,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1004,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1014,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1017,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1033,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1090,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1095,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1112,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1115,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1117,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1155,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1183,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1185,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1195,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1198,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1201,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   844,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   847,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   848,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   849,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,  1403,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     851,   595,     0,     0,   852,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   853,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1879,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1913,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1915,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1955,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1957,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1959,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,  2055,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,  2729,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,     0,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   844,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   847,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   848,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   849,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,  1403,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,  2762,   588,   589,   590,   591,   592,     0,
     593,   851,   595,     0,     0,   852,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   853,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   844,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   847,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   848,   536,   537,   538,   539,   540,
     541,   542,   543,   544,  2824,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,  2825,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     851,   595,     0,     0,  2826,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   853,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   844,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   847,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   848,   536,   537,   538,   539,   540,   541,
     542,   543,   544,  2910,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,  2825,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   851,
     595,     0,     0,  2826,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   853,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     844,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     847,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   848,   536,   537,   538,   539,   540,   541,   542,
     543,   544,  2934,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,  2825,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   851,   595,
       0,     0,  2826,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     853,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  3128,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  3132,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  3190,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  3573,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   844,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   847,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   848,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   849,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,  2825,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   851,   595,     0,     0,  2826,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   853,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  3631,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  3653,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    3655,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  3805,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,  3847,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  5109,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,  6341,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,     0,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,     0,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   882,   261,   883,   884,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   885,   886,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   887,   888,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   890,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    2736,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,  2737,   389,   390,   391,   392,   891,   892,     0,
     893,     0,   396,   397,   398,   399,   400,   894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   895,   447,   896,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   897,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,  2739,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   898,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  2740,   559,   560,   561,   562,   563,   900,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   901,   902,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   903,  2741,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   881,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   882,   261,   883,
     884,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   885,   886,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   887,   888,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   890,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   891,   892,     0,   893,     0,   396,   397,   398,
     399,   400,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   895,   447,   896,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,  2820,     0,   465,   897,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     898,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,  2740,   559,
     560,   561,   562,   563,   900,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,  4622,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   901,
     902,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   903,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   882,   261,   883,   884,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   885,   886,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   887,   888,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   890,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   891,   892,     0,
     893,     0,   396,   397,   398,   399,   400,   894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   895,   447,   896,
     449,   450,   451,   452,   453,   454,   455,   456,  2900,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   897,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   898,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   899,   559,   560,   561,   562,   563,   900,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   901,   902,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   903,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   881,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   882,   261,   883,
     884,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   885,   886,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   887,   888,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   890,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   891,   892,     0,   893,     0,   396,   397,   398,
     399,   400,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   895,   447,   896,   449,   450,   451,   452,   453,
     454,   455,   456,  4418,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   897,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     898,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   899,   559,
     560,   561,   562,   563,   900,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   901,
     902,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   903,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   882,   261,   883,   884,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   885,   886,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   887,   888,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   890,   353,
    6028,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   891,   892,     0,
     893,     0,   396,   397,   398,   399,   400,   894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   895,   447,   896,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   897,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   898,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   899,   559,   560,   561,   562,   563,   900,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   901,   902,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   903,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   881,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   882,   261,   883,
     884,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   885,   886,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   887,   888,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   890,   353,  6384,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   891,   892,     0,   893,     0,   396,   397,   398,
     399,   400,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   895,   447,   896,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   897,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     898,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   899,   559,
     560,   561,   562,   563,   900,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   901,
     902,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   903,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   882,   261,   883,   884,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   885,   886,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   887,   888,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   890,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   891,   892,     0,
     893,     0,   396,   397,   398,   399,   400,   894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   895,   447,   896,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   897,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   898,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   899,   559,   560,   561,   562,   563,   900,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   901,   902,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   903,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   881,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   882,   261,   883,
     884,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   885,   886,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   887,   888,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   890,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,  1157,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   891,   892,     0,   893,     0,   396,   397,   398,
     399,   400,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   895,   447,   896,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   897,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     898,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   899,   559,
     560,   561,   562,   563,   900,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   901,
     902,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   903,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   882,   261,   883,   884,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   885,   886,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   887,   888,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   890,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,  1189,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   891,   892,     0,
     893,     0,   396,   397,   398,   399,   400,   894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   895,   447,   896,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   897,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   898,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   899,   559,   560,   561,   562,   563,   900,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   901,   902,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   903,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   881,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   882,   261,   883,
     884,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   885,   886,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   887,   888,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   889,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   890,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   891,   892,     0,   893,     0,   396,   397,   398,
     399,   400,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   895,   447,   896,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   897,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     898,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,  2740,   559,
     560,   561,   562,   563,   900,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   901,
     902,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   903,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   882,   261,   883,   884,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   885,   886,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   887,   888,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   889,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   890,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   891,   892,     0,
     893,     0,   396,   397,   398,   399,   400,   894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   895,   447,   896,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   897,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   898,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,     0,   559,   560,   561,   562,   563,   900,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   901,   902,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   903,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   881,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,     0,   261,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,     0,     0,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,     0,     0,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,     0,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,     0,     0,     0,     0,     0,   396,   397,   398,
     399,   400,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   447,     0,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,     0,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
       0,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,     0,   559,
     560,   561,   562,   563,     0,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,     0,
       0,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,     0,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648
};

static const yytype_int16 yycheck[] =
{
       6,   669,     0,     0,     0,   669,     0,    57,     0,  1043,
     212,     0,   212,   684,     0,  1015,     0,    23,     0,    25,
     798,   799,   800,    29,    21,     0,   804,   207,   663,    35,
      36,    37,     0,    39,     0,   215,    42,    43,   218,    45,
       0,    47,     0,   944,     0,  1169,     0,  1052,    54,    55,
      56,  1232,   842,  1605,   845,     6,   190,   835,  1670,  1589,
     938,     0,   940,   739,   899,  1016,   918,  1032,   887,   888,
    1284,  2848,  1041,  2681,   869,  2723,  1047,   753,   897,  2724,
      37,   716,    21,  1589,    46,  1271,  1118,  1582,  1045,    22,
     198,   868,  1594,  3253,  1909,    28,  2053,  3141,   761,   217,
    3641,  3076,  3643,  3434,   956,  3436,   902,     0,  3529,   852,
    2080,     8,  1514,   231,  3921,    45,  3723,  2042,    15,  1737,
    2744,  2745,  4280,  3937,  3088,  1256,   716,  1092,   763,  1260,
     665,  1096,  1263,  1264,   981,  3607,  1101,  1635,  1636,  2061,
      23,  1639,  3948,  2994,  4837,  3487,  1111,  3669,  3481,  3671,
     192,  3103,  1704,  1705,    37,  3970,  4587,  2118,  4349,  1006,
    1125,  3873,   192,  4308,  1011,   875,  1981,  2079,  2603,  1572,
    4015,   176,  2607,   762,  1471,  2075,  2076,  2077,  2078,   752,
    1582,  2081,  5230,  2083,  2084,   820,  4593,  1922,  4598,  4610,
     967,  1156,   198,   199,   200,  4394,  1698,   203,  5351,  3532,
    4739,   207,  4741,   209,  5147,  4666,   212,   737,  2972,   215,
     740,     2,   218,   848,  4853,   221,  4855,   223,  5139,  5514,
     226,  4555,  5441,  1725,   230,   982,   232,  3503,  5090,  1632,
    5342,    51,    42,  2708,    36,  3296,  2640,  3539,   873,  3388,
    2094,    43,  5477,  2710,  4916,  3935,  1649,  3393,  3041,  5518,
    3043,  3044,  5134,  5746,   941,  3048,  3049,  3050,   848,  3052,
    3053,  3054,     0,  4597,   941,     0,     6,  3486,    11,  3488,
    3489,  1555,    21,     6,    13,     5,  5138,     6,     0,  1056,
      21,    11,  5730,  2687,  4777,    38,  5398,  4447,     0,    13,
       6,    54,    63,    78,  6001,  1052,   226,    63,   122,  1107,
     935,     0,   120,    95,     6,     6,    45,    63,  1086,  5405,
    5406,    25,    11,  2048,     6,  1123,     6,    35,   965,    47,
    3084,     6,     6,    15,    16,  5438,     6,    72,     6,  1015,
      29,    29,     6,   885,   886,    15,    16,   177,  1024,    78,
     178,   171,     0,     6,   896,   757,    43,     6,  1034,     6,
       6,   177,   148,    11,    80,   177,    15,    16,     6,  1006,
     142,    32,   127,   125,  1011,  3609,    92,     6,   152,    51,
      11,    29,   189,   222,    21,  6008,    63,    37,    43,    21,
    5430,    47,     6,  1212,     6,    37,     3,   177,     5,     6,
    1888,     5,   189,  1636,    11,   122,  1639,    11,    92,    80,
       6,    76,   226,   120,   163,   179,    15,   177,   153,  5632,
     308,   177,  4611,    63,    11,   329,    92,  1052,    37,   240,
     302,   309,   256,    92,   311,   113,   140,   125,   173,  6141,
     120,    52,    63,   293,    42,   112,   220,   384,   288,   177,
     135,   402,   177,   179,   120,  1108,  1415,   329,   359,   402,
      63,  1483,    85,   322,   216,   177,  1427,    35,   403,   271,
      63,  5954,    29,   201,   447,   177,   201,   288,   292,   447,
     124,   288,  2930,   124,   379,    13,  5358,    25,   177,   201,
      39,   384,   684,  1302,  1303,   168,    13,   177,  6382,   201,
    6388,   239,  6390,    37,  1204,  3103,  4927,  5945,   491,   226,
    1176,   449,   201,   120,  1475,   324,   268,    45,   384,   389,
      29,    47,   413,  5748,  1471,  1334,     6,    36,   216,   177,
    4703,  4704,  4705,   120,  4707,  4708,  4709,  4710,  4711,     5,
     314,   355,   734,  5645,   355,    11,   310,   438,    80,   419,
      78,  6435,   418,   201,    88,   538,   494,    63,   297,  1345,
      13,    78,   311,  3011,  6452,   538,   297,  5478,   354,   307,
     538,    13,   245,  1239,   682,   292,   471,   470,   135,   223,
     688,   130,   223,   484,   310,   292,  6288,   538,   156,  1255,
     372,   393,   700,   402,   405,   538,   177,   534,  1365,   534,
     267,   199,   140,    45,   177,   272,  1272,   292,    10,   344,
     288,    13,   373,   491,   221,    17,    18,    19,   177,   478,
     470,   445,    80,  1584,    80,   177,   292,   373,  1395,    32,
     534,  1210,    29,   389,    29,  6118,    78,    80,   355,    36,
     305,    36,    80,    80,  6267,    13,   534,   243,  3882,   256,
     125,  5864,  1277,  5693,    92,  1888,   534,   534,   422,   470,
     297,   136,   534,  1472,  1364,   297,  1413,   447,   664,   476,
     510,  1418,  1419,   184,   670,   125,   672,    37,   674,     0,
    5309,   677,   389,   184,  1503,   297,  1505,   447,   684,   476,
     464,   184,  4394,   689,   201,   691,   373,  1277,   402,   538,
      21,   697,   374,   332,   122,   454,   534,   395,   538,   370,
    1665,  1735,  1736,  1668,   534,   487,   524,   472,   470,   669,
    4422,   669,   538,   763,   538,   721,   538,   483,  5953,   447,
     465,   447,    23,   373,   730,  1676,    57,  5188,   734,   447,
     669,   737,  1442,   430,   740,   420,   421,  6230,   534,  1291,
    1292,   481,   373,  6450,   120,    23,   538,   532,  5861,   477,
     756,   536,    29,  5866,  5867,  6462,   470,   447,   452,  4566,
     373,   491,   767,  5256,  1733,   430,   447,   538,  4928,    23,
     373,   534,   470,  1620,  2058,  1410,   669,  1329,   447,  4939,
    6228,   534,   538,  1418,  1419,   515,   515,   516,  2681,   538,
     533,   530,  4606,  5889,   534,   525,   526,   538,  1508,   537,
    4607,   534,   537,  1560,   810,   534,   530,   813,   814,   815,
     944,   477,  4353,  1570,  1501,   537,   822,  6310,   534,  5740,
    1410,  1656,  4429,   762,  1501,   537,   525,   526,  4435,   462,
    2011,  1639,   534,   534,   524,   495,   842,   843,   537,   845,
     846,  1742,   534,   495,   850,   778,   536,   780,   532,   782,
     534,   538,   536,  6122,   534,   788,   534,   373,   864,  1983,
     534,   192,  5744,   869,  1066,  6358,  1066,   525,   526,   875,
    3478,   534,  1558,  3481,  6109,   534,   495,   534,   534,   537,
     810,  1689,  1690,  1063,   525,   526,   534,  1067,   538,  1069,
     932,   515,   516,   412,  2018,   792,  1448,  1449,   310,  4611,
    1657,  4243,   932,  1660,  1661,   447,  2030,   538,   525,   526,
     534,   525,   526,  1870,   184,   524,   922,   461,  3542,  6138,
    3544,  3529,  4255,   532,  3532,   538,  4259,   536,   525,   526,
     936,   301,  6044,  1580,  1620,   538,   934,   934,   934,   869,
     934,   477,   934,   949,  3908,   934,   322,   538,   934,  1057,
     934,   495,   934,  5625,  6066,   538,  1627,   370,   964,   934,
     177,   262,   958,  4109,  4110,   534,   934,  4657,   934,   194,
    4119,   384,   534,   386,   934,  4516,   934,   983,   934,   447,
     934,   447,   988,   989,   262,   470,  1633,   525,   526,   527,
     528,   529,   530,    52,   447,   934,  6291,  6232,  4300,   447,
     447,  3765,  3766,  1650,    25,   412,  3770,   412,   262,  5952,
     470,   813,   814,   815,  1020,  1021,   157,   538,   388,   949,
    1555,   538,   538,  4242,  1436,  4244,  4245,   538,  5949,  5212,
    5461,  4092,   120,  3508,   964,   538,   846,  1043,  1044,   452,
     850,   934,  3509,  4515,  3448,  2079,   474,   171,  4194,   113,
      63,  1057,    23,  1059,   125,   177,   876,  1063,  3851,   336,
    1066,  1067,   113,  1069,   527,   528,   529,   530,  1074,   125,
    5932,   156,  1535,   113,  6309,   527,   528,   529,   530,   201,
      63,  1889,   308,  6236,  6237,   346,  5948,   329,   389,  2060,
     178,  6203,  1098,   155,   309,  1852,   186,     6,   179,  1105,
    1106,    23,   478,  6151,   296,   726,   309,   477,   360,   667,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   140,
     397,  1127,  1128,  1129,     6,  1131,  6421,  1133,     6,  1135,
    1136,   752,    37,    68,  5468,   389,   437,   196,  1493,    72,
    1918,  3905,   201,   189,  2115,   216,  4422,   525,   526,   527,
     528,   529,   530,  5614,    23,    29,  5347,  4578,   534,   437,
     216,   155,   439,  1169,   441,  1171,  1172,   468,   482,   472,
    4642,    25,     3,  5372,   113,     6,  6119,    31,   367,  6398,
     123,   371,   206,   437,   155,  2142,    25,   266,  5827,  6110,
     468,   332,   493,   252,     6,   103,  6130,   268,  1204,   172,
    1835,   759,    72,   308,    72,   293,  1212,  6360,    89,   125,
    3103,    37,   402,   292,   468,   493,   302,   409,  1020,  1021,
     534,   491,    92,    23,     3,   477,  1232,    23,  1234,   491,
     447,   534,  1238,   534,  1240,   208,  2027,  2028,    10,   493,
     314,   314,   288,   329,   814,    17,    18,    19,   178,  3873,
      23,   132,   120,  5682,   197,  5684,   534,    28,   447,  5688,
    5689,   135,    23,  1269,   813,  1271,   312,   348,   538,  1275,
     288,  1210,    23,   534,    89,   288,   538,  1953,   186,   837,
     534,   496,  1212,  1289,   115,  5824,   140,   188,   491,   379,
      10,  1967,   534,    13,   120,  6238,  5727,    17,    18,    19,
     216,   140,  5712,   324,  1980,  5736,   532,   524,  2810,   534,
     536,  6245,    91,   181,  1364,  5129,  5123,   132,  1215,   536,
    1217,    92,  1219,   171,  1221,  1331,  1223,  1224,  1225,    89,
    5136,  5738,  5742,  1230,  6382,  2112,  2842,  5758,   669,  3963,
     262,  5186,  2744,   405,  4885,  5160,   367,   180,   407,  2059,
    1141,  2061,  3087,   288,  1360,  1361,  1362,  2067,  1364,   292,
     373,  5792,   193,  2073,  2074,  6308,   145,   491,  4909,   491,
     434,   512,   132,  1946,  2042,  2085,  6319,  5711,  2042,  1385,
     288,   402,  2679,   434,   472,  2095,   198,  6435,   297,   402,
     373,  2101,  2894,   262,   434,   207,   301,  4349,   328,   470,
    3312,    23,   487,   215,  1993,  1978,   218,  5741,   179,  1872,
     434,   405,  3030,   384,   470,   297,  6359,     3,  1424,   297,
    1950,  2092,   292,   302,   292,  1627,  1431,  2830,   314,   297,
     476,   762,   763,  6367,   405,  1965,  1442,    25,  1968,   170,
     271,  1062,   302,   274,  1486,  1487,   327,  1489,   534,  6392,
     329,  1021,  1073,   354,   475,     3,  1486,  1487,   476,  1489,
     399,   535,   262,   193,   538,   538,   262,   389,  1089,   329,
     324,  1020,  3326,  3327,  5619,  6168,   344,  3331,   408,  3440,
     259,  6424,  1488,    30,   385,   324,  1492,  1493,   314,   262,
    2020,    25,   120,   361,  2024,  2025,  4838,  1503,  1504,  1505,
    1506,   262,  1508,  5934,   224,    91,   123,   125,  3120,  4842,
     125,   262,   327,   367,  4847,   437,   349,  4850,  3372,  3373,
     389,   369,   389,  2058,   535,   140,  1532,   538,   367,    64,
     351,   524,   389,   115,    33,    34,   444,    72,   310,   455,
     314,   271,   114,   536,   120,   324,   468,  5976,   402,   491,
     383,   156,   140,    27,   470,   299,   323,   123,   156,   440,
     146,  1567,   393,   402,   397,  5087,  1572,   327,   437,  1575,
    2604,   493,   120,  1503,  1986,  1505,    50,   348,   165,  4623,
     197,  4016,  1588,  1589,   133,  3478,  6115,  6116,  3481,   389,
     310,  1597,   309,   389,  1600,   144,   538,   465,   216,   468,
      99,   932,   435,   934,    25,  2017,   140,   309,   339,  2021,
      31,   193,   534,   205,  2026,   386,   389,  2029,   392,   120,
     119,  1627,   208,  1629,   493,   440,  1632,  4579,   389,  1635,
    1636,   197,  1253,  1639,   206,  2606,  3529,   437,   389,  3532,
     262,   437,   143,  1649,  3139,  1641,  1652,  4255,   149,  1655,
    1646,  4259,   538,  5467,   375,   534,   402,   156,   437,   122,
    5372,   440,   163,   393,   437,   534,   253,   534,   468,   297,
     217,  1677,   468,  5479,   534,  6106,   437,   534,   509,   450,
     440,   452,   173,  4929,   402,   456,   437,   122,  1694,   271,
     402,  4937,   274,   493,   343,   468,   288,   493,   524,   402,
    1706,  1707,  1708,  1709,  1710,  5863,   532,   468,   534,   535,
     536,  4504,   538,   534,   189,   100,  4509,   468,  1724,   140,
     493,   256,  2679,  1719,  2079,  2080,   341,  1723,   472,  1735,
    1736,  1737,   493,  3135,   534,  4586,   324,  3139,   534,  2094,
      99,  4349,   493,   217,   292,   331,   322,   434,  2103,   297,
     522,   523,   524,   525,   526,   527,   528,   529,   530,  1961,
    1962,   534,  1962,  2768,  1694,  4542,   487,   389,   472,   171,
    4394,  1951,  5963,   534,   491,   324,    87,   395,   312,   367,
     168,   183,  6311,   534,   332,   240,    29,   136,   324,   491,
     395,   226,   538,   178,   763,  6226,   297,   395,  4422,   201,
     449,   177,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   393,   447,   288,   402,   437,  4580,   389,   367,   395,
     538,   266,   293,   294,   183,   201,   538,   212,  1834,   434,
     534,   367,  1940,   288,   297,   538,   434,   371,   372,  1845,
      83,   115,   227,    86,  6339,   494,   468,  1853,  1854,   324,
      93,   820,   470,   135,   288,   137,   167,   292,   434,   482,
     432,    58,   434,  1869,   363,   250,   402,   216,   402,   165,
      25,   493,   152,   478,  6305,   171,    31,   463,   121,  1210,
     478,  1887,  1888,  4835,   534,   471,   491,   120,   474,   524,
    2092,  6049,   367,   491,   279,   283,   395,  1903,  1904,  1905,
    1906,   536,   478,   324,   873,  2740,  1912,   343,   367,   721,
     515,   534,   534,  1919,  6409,   491,  1922,   515,   730,   193,
     355,  2878,  5729,   308,   395,   737,   159,   509,   740,   534,
    2721,  1937,   129,   367,  1940,   434,   534,   386,   181,   515,
    2940,  5747,  5756,   402,  1950,  1951,   367,  2904,  2658,   323,
     405,   194,   534,   454,  1285,  1961,  1962,   253,   534,  1965,
     178,   194,  1968,   434,   207,   466,   935,   323,   312,   372,
    4578,  4579,  5305,   253,  1305,   377,   411,  1983,  1984,   478,
     324,   402,    38,   482,  1990,   140,  1992,  4611,   154,  1995,
     359,   180,   491,   378,   212,   367,   386,   271,   534,   402,
     274,   476,  1623,   452,    60,  2011,   120,   478,   304,   227,
     292,  2768,  2018,   449,  2020,   470,   515,  2023,  2024,  2025,
     491,  2027,  2028,   367,  2030,    40,  2076,   396,   402,  6416,
     402,  2037,   250,  1364,  5506,   534,   242,   203,  2044,    54,
    3164,  2047,  2048,  5203,   515,  2051,   402,  3004,  2054,  2055,
    6241,  6438,   323,  2059,  1993,  2061,   112,   171,   494,   292,
    2066,  2067,   452,   534,     3,   434,   449,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
     165,  4038,  2042,  2089,  2042,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,   201,  2051,  2101,   111,  2103,  2104,  4056,
    1997,  2107,  1999,  2042,  2001,   165,  2003,  2037,  2005,    25,
      99,   171,  2009,  3070,  5089,   484,  2122,  2123,  2124,   393,
     432,   324,     5,  3024,  3025,  3026,   534,   395,    11,  3624,
     119,   402,  5946,  2768,  2140,   333,  3748,  3539,  4108,   483,
    2918,  5947,  2920,  2920,  5108,  3359,  2993,  3549,   204,  2042,
    4072,  5966,    91,  5128,  2840,  1486,  1487,   182,  1489,   471,
     378,  5113,  2838,  5323,   367,  5325,   434,   156,   253,  5500,
     324,  2054,  6363,   371,  2180,    91,   419,   355,   112,   422,
     384,  4093,  2990,    69,    70,  5369,  4098,  2944,  5710,  4004,
     368,  3156,   537,   253,   383,  2952,   152,  4097,  2955,   402,
     215,   390,  4102,  4103,   402,   122,   145,   122,   397,   165,
     478,   267,  3830,   367,     0,   171,   272,   133,  3836,   304,
     398,  5762,  3624,  3721,   140,   333,  1847,  4835,   144,  5413,
     434,   256,   288,   369,  4842,   509,   538,  1858,   172,  4847,
      92,   266,  4850,   359,   304,  1057,   435,    35,   402,   515,
     516,  1063,    48,  1874,  2940,  1067,   171,  1069,  5051,   367,
    5053,  5054,  5055,   371,   220,   346,   534,   323,   534,   458,
    3772,   182,  3229,   288,   208,    71,  4130,  4131,  4132,  4133,
     396,  2287,  4136,  4137,  4138,  4139,  4140,  4141,  4142,  4143,
    4144,  4145,  2978,   210,   402,   210,   384,   253,   386,  3107,
    3108,  3109,  3110,   179,  3112,  6111,  1641,  1928,  4233,   488,
     491,  1646,  5784,  5077,  5735,  5079,   372,  3819,   434,    80,
     259,  1133,  1943,  1135,  1136,  1946,  1947,  3013,    27,  3137,
     182,    92,   452,   267,   515,  2341,     5,   213,   272,   324,
     396,  4241,    11,  2698,   324,   256,  4200,  4201,   304,     3,
      19,    50,  3130,   100,   206,   491,  1977,  1978,   314,   538,
    5691,   417,  4255,   100,   452,    13,  4259,   484,   484,    38,
     371,   288,    26,   288,   363,   292,   391,   292,    38,   515,
     324,  6448,   367,   491,  1719,   324,   371,   367,  1723,   301,
      94,  2397,  3944,  3350,   333,  5347,   243,    45,  6465,  3356,
      60,   402,   538,   324,   256,   406,   395,   515,   324,   447,
     324,   324,   491,   292,   439,    32,   441,   402,   297,   363,
     491,   395,   402,   367,   363,  6231,  3089,    38,   367,   392,
      78,   178,   371,   137,   472,  6242,   515,    91,   171,  6046,
     171,   178,    59,   468,   515,   434,   367,   363,   359,    38,
     171,   367,   112,   367,   367,   534,  4349,   265,   402,  3216,
     434,   313,   195,   402,   195,   212,  3339,   538,  3341,  3342,
      81,    60,   491,   352,   195,   212,   780,   781,   782,   535,
     227,   785,   786,   787,   292,   282,   402,  1891,   402,   478,
     227,   795,   146,   409,    80,  1633,   515,    86,   437,   534,
    2121,   440,   491,   250,   478,  5113,    92,  1911,   464,   306,
    6051,  6052,  1650,   250,  1010,  6437,     5,   491,  3295,   515,
     516,   181,    11,   112,   113,   534,   515,   536,   439,  6451,
     441,   120,   279,  1029,  3435,   533,  1032,  5489,   534,   534,
     538,   515,   279,   529,   204,   534,   152,   201,   534,   143,
     536,   439,   491,   441,   208,   149,  2968,   468,  2970,   165,
     534,  6414,  2974,  5647,  6417,   171,  5518,   529,  5652,  5653,
     159,   308,   534,   484,   536,  2581,  2582,  2583,  2584,  2585,
    2586,  2587,  2588,  2589,    22,  2591,   533,   439,  6395,   441,
      28,   538,   181,    15,    16,  2601,  2602,   527,  2604,  2801,
     452,  2801,   532,   270,   534,  2611,   536,   267,   152,  2672,
    2673,  2674,   272,   465,   220,   204,   468,   452,  3328,   308,
    2800,   165,  2802,  2803,   313,  5418,  5578,   171,   288,   369,
    3340,   378,   308,  1006,  2640,   266,  2642,   313,  1011,  2645,
    2646,   378,   392,  2649,  2641,  2651,  3777,   253,  2654,    33,
      34,   532,  2658,   534,  5985,   536,  6197,   532,   439,  3610,
     441,   536,  1993,   323,  3460,  3461,  3376,   266,   284,   285,
     286,   287,   532,    96,   534,  2681,   220,   331,   267,   206,
    4534,  2687,  2688,   272,  3441,  4578,  4579,   535,  3540,  2797,
     538,   195,  2698,   535,  3645,  3438,   538,  5305,   304,   288,
     270,  2707,  2708,   292,   535,   384,   385,   538,   314,   253,
    3420,  2042,   372,   535,   452,  2721,   538,  3494,   535,  2837,
    5764,   538,    87,  2729,  3395,   379,   535,    59,  4685,   538,
    2681,  3550,   384,   385,   323,   472,   396,   535,  2105,  5347,
     538,  2108,   152,   535,  4701,  2076,   538,   534,  5372,   536,
     322,   392,  3933,  3724,  4366,   165,  6297,   417,   527,   535,
     304,   171,   538,   532,  2770,   534,  2772,   536,   535,  2100,
     314,   538,   535,  4588,   491,   538,   493,   431,   535,    10,
    2786,   538,    13,   372,   384,   385,    17,    18,    19,   535,
     535,  2797,   538,   538,  2800,  2801,  2802,  2803,   484,   535,
    2806,  3213,   538,  2809,    35,  4019,  3441,   396,   243,   463,
     220,  2929,  4364,  2770,  4366,  2772,   535,   471,  4730,   538,
     474,   515,   516,   395,  2830,  4737,  4738,   534,   417,  4331,
     419,   482,   535,   422,   535,   538,  2842,   538,   535,   535,
      11,   538,   538,   253,    10,  4351,   491,    13,   493,  2855,
    2856,    17,    18,    19,   535,   432,  2862,   538,   464,  5354,
    5355,   535,   434,  5627,   538,  2871,   308,   535,  5492,  4055,
     538,  5635,  5636,   535,   535,   534,   538,   538,   389,  2809,
     152,  5489,  3914,  6043,   439,   538,   441,  2893,  3564,  3565,
     384,   385,  3010,   165,   304,   491,   534,   493,  4300,   171,
    4402,   439,   535,   441,   314,   538,   478,    59,  2914,  1213,
    5518,  3876,  1216,   484,  1218,  3872,  1220,    48,  1222,   491,
     464,  2927,  1226,  5816,  5817,  3611,   532,   511,   535,  6260,
     536,   538,   535,   311,   535,   538,   135,   538,   137,  6014,
    6015,  3719,  4835,   515,  2950,   534,  3724,  2953,   220,  4842,
     135,   226,   137,  3588,  4847,   535,   535,  4850,   538,   538,
     536,  2292,   534,  1158,   163,  5610,   491,   308,   493,  1164,
    5578,  3326,  3327,  2979,  2980,   294,  3331,   535,   163,  1174,
     538,   253,   535,  1178,  2914,   538,   308,  1182,  2994,  1184,
    2996,  2997,   171,   224,   535,  1190,   511,   538,  3588,  5951,
     535,  1196,   535,   538,  1199,   538,   535,    55,    56,   538,
    3696,  5963,   535,   535,    48,   538,   538,  3372,  3373,   135,
     311,   137,  3028,  3029,  3030,   511,   226,   535,  3034,   228,
     538,   527,   304,  6364,  2967,   201,  3042,  3713,   535,   176,
     538,   538,   314,   228,   535,   481,   534,   538,  4600,  3055,
     535,   534,   340,   538,   464,  3061,   534,  3063,   224,  3735,
     535,   535,  3870,   538,   538,  4595,   535,    37,   535,   538,
    3076,   538,   534,    59,   535,  3081,   395,   538,   535,   310,
    3260,  3087,  3262,  3263,  3090,   284,   285,   286,   287,   535,
     177,   535,   291,   292,   538,   222,  3102,  3103,   297,   284,
     285,   286,   287,    54,   222,   535,   291,  3113,   538,  6440,
     535,   535,   297,   538,   538,   434,   491,  3123,   493,  3125,
     535,  4616,   534,   538,  3902,  1937,   535,  5735,  1940,   538,
    6105,   535,   535,   535,   538,   538,   538,   535,  1950,  1951,
     538,   536,   535,   535,   310,   538,   538,   201,   535,  3257,
     101,   538,  3103,  1965,   535,  3567,  1968,   538,  3164,   478,
    3166,   535,  3168,   535,   538,   535,   538,   534,   538,  4350,
    6122,  4352,   491,   535,  4355,   126,   538,   535,  2799,   535,
     538,   495,   538,   535,  2805,   534,   538,   535,  3194,   535,
     538,   537,   464,  3395,   145,   534,   515,  3203,  5846,   150,
     535,   535,  4173,   538,   538,   367,   536,   535,  2020,  4166,
     538,   157,  2024,  2025,  4616,   534,   535,  3893,   537,  3895,
    5113,   172,   157,   535,   535,   176,   538,   538,   534,  3122,
     535,  2852,   535,   538,   535,   538,   535,   538,   535,   538,
     191,   538,   535,  3878,   537,  3880,   535,  4042,   308,   538,
     535,  3257,  3258,   538,  3260,   454,  3262,  3263,  4227,  3265,
     532,   201,   535,   535,   536,   538,  3272,   466,   367,   454,
     535,  3277,   535,   538,   535,   538,   535,   538,  3328,   538,
     308,   466,   535,  6235,   535,   538,   157,   538,  3878,  6241,
    3880,   522,   523,   524,   525,   526,   527,   528,   529,   530,
    3193,  3503,  4273,   157,   201,   535,  4063,   535,   538,   535,
     538,   535,   538,   157,   538,   535,  2647,  4224,   538,  4226,
    3326,  3327,  3328,  5235,  5236,  3331,  3376,  3962,   535,   308,
     171,   538,  4944,  3339,  3340,  3341,  3342,   535,   367,  4824,
     538,  4826,  4260,  5951,  4262,   157,   297,  6124,   251,  3355,
    2681,  5286,  3358,  5288,  3360,  5963,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   122,  3372,  3373,   472,   308,
    3376,   534,  3962,   301,   171,   535,    72,    72,   292,    38,
     292,   495,  4058,    78,   534,   308,   292,    48,  5242,  3395,
      48,  3397,   292,  3399,   457,  3401,   292,    92,    91,   324,
    4365,   352,   484,   484,  4910,    87,   452,   171,   157,   347,
     157,  6363,  5305,   534,  3420,  4125,   157,  3423,   157,   495,
      10,  3427,   157,    13,   157,   120,    25,   122,   538,   157,
       0,  3481,    31,   157,   157,   157,  4393,   157,  4395,   157,
     171,  3062,  3448,   157,   157,   157,   157,    46,   157,  4159,
    4664,   308,   434,   222,  5347,    45,    10,   534,  4639,    13,
      38,   251,    52,   171,  4421,   171,  3428,  3429,  3430,   308,
     534,  4323,  3478,    43,     6,  3481,  3482,    76,  4297,     6,
    3486,  3487,  3488,  3489,   534,   534,   181,   171,    78,  3495,
     534,    45,     0,   534,  3500,   534,   534,   534,    52,   534,
    4210,     6,     6,   534,   534,     6,     6,   534,  3920,  3515,
     534,   534,   534,   534,  6122,   210,   534,   534,   534,   534,
     534,   534,   534,  3529,    78,  3531,  3532,  3478,   534,    99,
    3481,   534,   131,   534,   133,   534,   534,   534,   534,  4490,
     534,   140,   534,   299,   534,   144,   534,  4512,   492,   534,
     534,   534,   320,   534,   534,   166,   222,    38,   103,   251,
     150,   538,   538,    38,  3570,  4233,   534,    37,  5525,  4233,
     445,   445,   532,   172,   532,   447,   177,   447,  3529,   447,
     534,  3532,   152,   447,  6361,   538,   171,   304,  3594,  3595,
     171,    99,   302,   389,    68,   165,  5489,   292,   447,  4500,
     447,   171,   297,   483,   447,   447,   196,   177,   389,   208,
     536,   201,   447,   183,   447,  4027,   186,   389,   253,   447,
     190,   371,    79,  3244,  3630,  5518,   447,  6235,   447,   524,
      92,   389,   157,  6241,   308,   394,   248,   447,  3259,   447,
     297,   128,   196,  3264,   152,   447,   471,   201,   437,   344,
     220,   329,   222,   308,   384,   302,   534,   165,   194,   447,
     447,   534,   252,   171,    92,  4422,   361,   128,   324,   177,
     201,  3873,   538,  3294,   157,   183,   447,   472,   186,   472,
     447,  3687,   190,   253,   447,  5578,   128,   447,   114,   288,
     128,    59,   447,   292,   447,   447,  5550,    59,   252,   447,
     276,  4672,   447,   302,   447,  3711,   312,   447,   351,   447,
     447,   447,   220,   312,   351,  3721,   437,   351,   447,   329,
     310,   447,   447,    47,   329,   324,   539,  5581,   447,   538,
    4687,   447,   447,   224,   304,   535,   224,   308,   308,   224,
     447,   308,   224,   447,   314,   253,   224,   224,   224,   534,
      38,   224,   224,  4108,   457,  6363,   310,  5159,   224,   157,
     308,  1956,   157,   292,   120,   157,   157,   472,   367,  1964,
     465,   370,   371,   157,   308,  4130,  4131,  4132,  4133,   259,
     292,  4136,  4137,  4138,  4139,  4140,  4141,  4142,  4143,  4144,
    4145,  3122,   483,   292,   292,    38,   304,   171,    38,   243,
     308,   472,   534,   402,   391,   375,   314,   534,   157,  4164,
     157,   157,   472,   157,   402,   301,   447,   407,   177,   487,
     276,   276,    13,   447,  3830,   296,   186,   319,   449,   194,
    3836,   194,   534,   534,   511,   535,   534,   534,   511,   538,
     534,  3847,  5735,   532,   393,  4200,  4201,   535,   538,   535,
     535,   274,   535,   407,   535,   535,   488,   240,   405,   220,
     430,   309,  3193,   538,   472,    38,   538,   375,   472,  2681,
     317,    59,   535,   389,   483,   297,   475,   297,  3884,  3885,
    3886,   534,   297,   447,  4560,  4561,   447,   447,   534,   171,
     297,   308,  4247,    48,   464,  3901,   411,   308,   534,   240,
     240,   251,   292,   251,   270,   384,   251,   308,   447,  3915,
     128,   437,   538,   538,   308,   308,   201,  5098,   488,   308,
     490,   491,  4679,   513,   367,   491,   434,  3933,  3934,  3935,
     195,   355,   399,  3939,   402,   525,   526,   527,   528,   529,
     530,   447,   512,  5473,   447,  3951,   535,   314,    38,   224,
     472,   472,   243,   350,  4789,   524,   464,   157,   171,   513,
     302,   484,  4012,    38,   173,   535,   435,   537,   538,   351,
    3591,   525,   526,   527,   528,   529,   530,   534,  3599,  4857,
     488,   399,   490,   491,   534,  2797,   157,   157,  2800,   157,
    2802,  2803,   302,   292,   491,    38,   292,  3328,    38,   308,
      27,  4007,   308,   192,   512,   243,  4012,   472,   302,  4015,
     192,   171,    38,   172,   243,   171,   308,   201,   399,   292,
      60,  3951,   201,   201,   532,  4031,  4032,   535,   536,   537,
      59,   538,   201,   447,   201,   495,  4042,   177,   273,   491,
     308,   534,   538,   538,   538,  3376,   536,   301,   177,  4055,
     314,   535,   477,   375,  3947,   135,   330,   320,  5951,   512,
     177,   291,   447,   266,   177,  4775,   186,   470,  4074,  3400,
    5963,   535,   112,    59,  4208,   538,   535,  4083,   511,  4869,
     538,  5633,  3703,   488,  3705,  3416,   535,   538,   538,   535,
    3983,  4097,   533,   538,  5059,  4101,  4102,  4103,   535,   535,
     535,   535,  4108,   535,   534,  4111,   535,   538,  4114,   261,
     514,   538,  4042,   534,  4120,   534,  4122,   488,   534,  4125,
     157,   308,   535,   535,  4130,  4131,  4132,  4133,   311,   535,
    4136,  4137,  4138,  4139,  4140,  4141,  4142,  4143,  4144,  4145,
     447,   214,   308,  4149,  4150,  4151,   534,  3478,   535,   535,
    3481,   515,   447,  4159,   533,   297,  4206,   534,  4164,   534,
     447,   534,  4168,   160,   204,   292,   447,   157,   206,   422,
    4176,   402,   394,  4179,   157,  4181,   534,  4934,   157,  4534,
    3801,   534,   534,   394,    10,   251,   394,    13,   206,  4860,
     160,  4197,  4394,   308,  4200,  4201,   524,   447,  3529,  4205,
    4206,  3532,   472,   160,  4210,   488,  4212,  4213,   389,   253,
     331,  5182,   331,   469,   160,  4221,  4222,  4223,   419,    45,
    4422,   447,   447,   447,  3845,   389,    52,   267,   447,  6122,
    4906,   263,   272,   263,   128,  4241,  4242,  4243,  4244,  4245,
     263,  4247,  4248,   447,   389,  4251,   389,    10,   288,  4255,
      13,   447,    78,  4259,  4216,  4217,  4218,  4219,   389,  4265,
     157,  4673,  4674,  4675,  4676,  4677,   402,   447,   292,    47,
     447,   447,   447,  4233,    47,  4233,   535,   535,   535,   224,
     224,   533,    45,   323,   447,   447,  4292,   189,   535,    52,
     447,  3103,   312,   447,  4233,     3,   535,   538,   171,   457,
    5078,    48,   113,    10,  4255,   538,    13,   535,  4259,   171,
      17,    18,    19,   534,    38,    78,   157,  6171,  6172,   535,
    3941,  6175,   447,   157,   150,   524,   171,   302,    35,   189,
     157,   472,   372,  5009,   472,   308,   534,   389,   524,   478,
    4233,   389,  6235,  4349,  4350,  4351,  4352,   389,  6241,  4355,
     389,  4357,   399,   389,   155,   155,   396,   224,   224,   224,
     224,   224,   147,  5765,  3985,   224,   538,   224,   224,  4375,
     196,   224,   465,   228,   465,   201,   308,   417,   308,   532,
    5281,    59,   308,    25,   535,   308,   535,   150,    13,    31,
     538,   320,   291,   177,    10,   483,   533,    13,  4349,   227,
     535,    17,    18,    19,   538,   535,   318,   535,   534,  4611,
     227,   535,   535,   535,  5315,   436,    59,   535,   534,    35,
     315,   535,   534,  4778,  4430,   190,   252,   534,   444,   457,
    5106,   171,   375,   196,    76,    38,   243,   472,   201,   472,
     447,    59,   214,   437,  2639,  3257,   157,   472,  3260,    86,
    3262,  3263,   419,   181,   457,   394,  4077,   160,   447,   447,
     447,   389,   447,   447,   389,   535,  5423,   535,   535,   367,
    6363,   534,   491,   534,    59,  6087,   437,   478,   171,  4485,
      78,   157,   113,   308,   310,   457,   535,   224,   224,   252,
     224,   133,   224,   534,   240,   209,   447,   495,   140,   308,
     534,    38,   144,  4436,   535,   329,   305,     3,  4129,   457,
     308,    44,  4518,   447,  4447,   399,   538,   224,   477,   534,
     534,   538,   534,    90,   535,   538,  4532,   183,  4534,   184,
     172,   113,   177,  4154,   224,  4541,   535,   145,   297,   241,
     241,  4547,   535,   297,  5668,   297,  5670,   310,   297,   177,
      59,    10,  4558,   535,    13,   535,   489,   535,    17,    18,
      19,   535,   489,   320,   535,   329,   208,  4573,   534,   538,
     535,   534,  4578,  4579,   538,   227,   534,   490,   457,   302,
    4586,   407,   177,   444,   208,   491,    45,    78,   195,  4595,
     195,   297,    38,    52,    59,   447,   538,   297,   437,  4605,
     524,   538,    72,   310,   447,   447,  5018,  5019,   224,  5021,
     447,  4617,  4618,   157,   160,   447,  3947,   535,   224,    78,
     534,   127,  4628,    10,   179,   120,    13,  4578,  4579,    38,
      17,    18,    19,  4639,  4640,   201,   302,   399,   534,   472,
    5821,    38,   292,   173,   407,   302,   288,   491,    35,   399,
     292,  4657,  3983,    59,    84,   437,   491,    38,  4860,  5450,
     302,   177,   308,  4669,   534,  4671,  3478,   171,   362,  3481,
     312,   211,   311,   524,  5679,   222,   177,  5348,   416,  5860,
     538,  4012,   324,   477,    59,   535,   535,   513,   535,   535,
      38,    81,   447,   392,   310,   535,   534,  5373,   534,   525,
     526,   527,   528,   529,   530,   534,   308,  4713,   202,    38,
     361,  4604,   535,  5384,   157,   157,   534,  3529,   447,   534,
    3532,   534,   534,  4729,   534,  5906,  5907,   171,   370,   371,
     534,   534,    38,   297,   399,   264,   157,   196,   534,   472,
     535,  4747,   201,   534,   113,    38,   535,   312,   177,   535,
     513,   414,   457,   414,   171,    92,   136,   538,    38,   308,
     402,   535,   525,   526,   527,   528,   529,   530,   205,  4775,
     112,   538,  4778,    38,   535,    35,   534,   437,   534,   194,
    4786,  4787,   171,   534,   472,   538,   534,  4793,  4794,   534,
     437,   288,  4798,   252,   206,   534,   308,  4803,     6,   164,
    4806,  4807,   385,   495,   535,   385,    72,  4813,   534,   311,
      72,  4817,  4818,  4819,  4820,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   537,   136,   141,   491,   487,  4835,
     149,   308,  4838,   475,   168,   476,  4842,   224,  5795,   477,
     535,  4847,   491,   477,  4850,  4851,  5556,  4853,   535,  4855,
     168,   310,  4858,   538,  4860,   330,   443,   534,   265,   534,
    5570,   177,   443,  4869,   437,  4871,   358,   208,   437,   297,
     308,   399,   308,    38,  5831,  4206,   534,  4883,    38,   311,
     311,   534,  5592,   179,  4835,   202,  5298,  5242,   179,  5599,
     534,  4842,   156,  5898,   402,   495,  4847,  5309,  6079,  4850,
     353,   495,  4233,   353,  4910,  4911,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   384,  5916,   153,    59,  4925,
      59,   315,  5679,   310,  4255,    81,  4883,    38,  4259,   368,
      59,   535,    59,   447,   423,   125,   470,     6,  5895,   535,
    5295,   399,   534,  4564,   141,   495,   308,   495,   407,   308,
      35,   535,   297,  5663,  5664,   534,   534,   293,  3153,   534,
     293,   402,    24,  3158,   384,  3160,   538,   538,   308,   388,
      10,   384,   388,    13,    81,  3170,   534,   316,  3173,   478,
    3175,  3176,  6163,  6164,  3179,  4991,   447,   149,  3183,   177,
    3185,   534,  4998,  3188,   477,  4928,   538,   156,   425,   425,
     414,     6,   120,   414,   478,    45,  4939,   315,   535,   491,
     491,   332,    52,   179,  5020,   179,   472,   534,    81,   534,
     477,  5499,   535,   534,   934,   974,     6,  3441,  2978,  5035,
    5665,  2887,  3645,  4393,  4368,  1722,  3005,  6070,    78,  1419,
    3864,  3059,  5426,  6211,  5679,  5895,  4558,  5473,  4366,  4366,
    5068,  5449,  3633,  3571,   513,  3203,  6050,  5347,  6200,  3254,
    5066,  5926,  5925,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    52,  6091,  6235,  3638,  5082,  5113,  4579,  4605,
    4590,  5868,    10,  5089,  4548,    13,  3073,  5865,  4388,    17,
      18,    19,  5098,  3670,  3073,  3912,  1016,  4574,  5107,  5456,
    3956,  4641,  5777,  6320,  6454,    10,  6429,  5113,    13,  5440,
     150,  4613,    17,    18,    19,  3872,  6103,  5386,  5650,  5878,
    5126,  1882,  5128,  5389,    18,    28,   665,  4031,  4684,  5839,
    1240,  5841,  5618,    38,  4687,   522,   523,   524,   525,   526,
     527,   528,   529,   530,  6316,  4616,  5348,  3089,  5154,  1926,
    2745,  3549,  5499,  1923,  1937,  5765,   196,  3967,  1961,  5165,
     717,   201,  5113,  3804,   750,  3004,  4421,  3721,  6130,  6367,
    5372,  4645,   863,  3035,  4647,  5181,  2688,  5589,  1995,  6293,
    5186,  1835,  5384,  4669,  5384,  1539,  5181,  5614,  5617,  1435,
    1396,  5862,    41,    41,  4729,  5550,  1496,  3500,  1495,  3515,
    6033,  5843,  3481,  5383,  4243,  2698,  6211,  4261,  1498,  5306,
    5578,  3478,   252,  5577,  4670,  3478,  6345,  6027,   198,  5830,
    6176,  3478,  5554,  5229,  6383,  1452,  5581,   207,   208,  5844,
    4168,  3418,  5125,  5239,  2597,   215,  5242,   217,   218,  5245,
    5246,  5247,  2596,  5845,  2096,  3273,  3398,  4578,  5428,  3400,
    3034,   231,  5794,  6385,  3388,  3309,  4100,  2602,  2686,    -1,
    5672,    -1,    -1,  5898,  5270,  5271,    -1,    -1,  5274,    -1,
     310,    -1,  4893,  4604,   922,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5291,  5179,  5180,    10,  5295,
      -1,    13,    -1,    -1,    -1,  5301,   224,    -1,    -1,  5305,
      -1,    -1,    -1,  5309,    -1,    -1,  5312,    -1,  5314,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,    -1,    -1,    45,    -1,  4946,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5347,  5348,  5349,    -1,  5351,    -1,  4968,    -1,    -1,
      -1,    -1,    -1,    -1,  5305,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,
      -1,    -1,    -1,    -1,  6408,    -1,    -1,  5383,  5384,  3574,
      -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5347,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6370,    -1,    -1,    -1,    -1,    -1,  5040,
      -1,  5318,  5428,    -1,    -1,    -1,    -1,    -1,   150,    -1,
      -1,    -1,    -1,    -1,  5440,  6070,    -1,    -1,    -1,  5445,
      -1,    -1,    -1,  4255,  5450,    -1,    -1,  4259,    -1,    -1,
      -1,    -1,    -1,  5459,    -1,    -1,    -1,    -1,    -1,  3654,
      -1,  3656,  6130,  5469,    -1,    -1,  6130,  5473,    -1,    -1,
    5476,    -1,  6429,   513,   196,  5830,    -1,    -1,    -1,   201,
      -1,  5487,  5488,  5489,    -1,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,    -1,    -1,  6454,    -1,    -1,
      -1,  5499,  5499,  5499,    -1,  5499,    -1,  5499,    -1,    -1,
    5499,  4842,  5518,  5499,  5520,  5499,  4847,  5499,    -1,  4850,
      -1,    -1,    -1,    -1,  5499,  6303,  6304,  5533,    -1,  6430,
     252,  5499,    -1,  5499,    -1,    -1,    -1,  4349,  5489,  5499,
    5161,  5499,    -1,  5499,  5550,  5499,    -1,    -1,  5554,  5599,
    5556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5488,    -1,
    5499,  5454,    -1,    -1,  5570,    -1,    -1,  5518,    -1,    -1,
      -1,    -1,  5578,    -1,    -1,  5581,  6211,  6245,    -1,  5585,
      -1,  6245,    -1,    -1,    -1,    -1,  5592,    -1,   310,    -1,
    6300,    -1,  5485,  5599,   522,   523,   524,   525,   526,   527,
     528,   529,   530,    -1,    -1,  3800,  5499,    -1,    -1,    -1,
      -1,  3806,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,  5578,  5634,    -1,
      -1,    -1,    -1,    -1,    -1,  5641,    -1,    -1,    -1,    -1,
    6350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5657,    -1,    -1,    -1,    -1,    -1,  5663,  5664,    -1,
    5862,    -1,  5668,  5669,  5670,  5671,    -1,    -1,  6023,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   663,    -1,   407,    -1,    -1,    -1,    -1,
    5311,    -1,    -1,  5699,    -1,    -1,    -1,    -1,    -1,  6367,
      -1,  5707,   682,  6367,    -1,    -1,    -1,    -1,   688,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     700,    -1,    -1,    -1,    -1,    -1,  5732,    -1,    -1,  5735,
      -1,    -1,    -1,    -1,    -1,    -1,   716,    -1,    -1,    -1,
      -1,   721,    -1,    -1,    -1,    -1,   726,    -1,    -1,    -1,
     730,   731,    -1,    -1,    -1,  5761,    -1,   737,    -1,   739,
     740,    -1,    -1,    -1,    -1,    -1,  4578,  4579,    -1,    -1,
      -1,    -1,   752,   753,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   763,  5735,    -1,    -1,    -1,  5794,    -1,
      -1,   513,    -1,    -1,  5125,    -1,    -1,  3992,    -1,  3994,
    5806,  3996,    -1,   525,   526,   527,   528,   529,   530,  5815,
    5816,  5817,    -1,    -1,    -1,  5821,  6171,  6172,    -1,    -1,
    6175,  5827,    -1,    -1,  5830,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,  5839,    28,  5841,    -1,  5843,  5844,    -1,
     820,    -1,    -1,    10,  5737,  5851,    13,    -1,  5179,  5180,
      -1,    -1,    -1,    -1,  5860,    -1,  5862,    -1,    -1,    -1,
      -1,    25,   842,   843,  5870,    -1,    -1,    31,   848,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6057,    45,    -1,
      -1,    -1,    46,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   873,    -1,   875,    -1,    -1,    -1,    -1,
    5906,  5907,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    76,    -1,    -1,    -1,    -1,    -1,    -1,   899,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   922,    -1,    -1,  5951,    -1,    -1,    -1,    -1,
      -1,  6131,  6132,    -1,    -1,   935,    -1,  5963,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
      -1,    -1,    -1,    -1,  5305,    -1,   140,    -1,    -1,    -1,
     144,    -1,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5951,    -1,  6008,    -1,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    -1,  5963,    -1,    -1,    -1,    -1,  6023,    -1,    -1,
      -1,  6027,    -1,  4835,    -1,    -1,  5647,  6033,    -1,   196,
    4842,  5652,  5653,    -1,   201,  4847,    -1,    -1,  4850,  4851,
      -1,    -1,    -1,    -1,   208,    -1,    -1,    -1,    -1,    -1,
      -1,  6057,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1043,  1044,  1045,  6072,    -1,    -1,    -1,
      -1,    -1,  1052,  6079,    -1,    -1,    -1,  1057,    -1,    -1,
      -1,    -1,  1062,  1063,    -1,   252,    -1,  1067,    -1,  1069,
    5983,    -1,    -1,  1073,    -1,    -1,    -1,    -1,    -1,  6105,
      -1,    -1,    -1,    -1,    -1,    -1,  6112,    -1,    -1,  1089,
      -1,    -1,    -1,    -1,    -1,    -1,  6122,    -1,    -1,    -1,
      -1,    -1,    -1,  5454,   288,  6131,  6132,  6133,   292,    -1,
      -1,  6137,  6130,    -1,    -1,  6141,    -1,    -1,   302,    -1,
      -1,    -1,    -1,   310,    -1,  5766,    -1,    -1,   312,    -1,
      -1,    -1,    -1,  1133,  5485,  1135,  1136,  6163,  6164,  6165,
     324,    -1,    -1,    -1,    -1,  6171,  6172,    -1,  5499,  6175,
    6130,  6122,  6178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6130,    -1,    -1,    -1,  6245,  1176,    -1,    -1,  6205,
      -1,    -1,    -1,   367,    -1,    -1,   370,   371,    -1,    -1,
      -1,  6104,    -1,  5834,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1204,    -1,    -1,    -1,    -1,  6235,
    6236,  6237,    -1,    -1,    -1,  6241,    -1,  6130,   402,    -1,
     407,    -1,    -1,    -1,    -1,    -1,    -1,  6245,    -1,    -1,
      -1,    -1,    -1,  6259,    -1,    -1,    -1,    -1,    -1,  1239,
      -1,  6267,  6442,  6443,    -1,    -1,    -1,    -1,  5599,  6275,
    5082,    -1,    -1,  1253,    -1,  1255,    -1,  6283,    -1,    -1,
      -1,    -1,  6288,    -1,  6235,  6245,    -1,  6293,    -1,    -1,
    6241,    -1,  1272,    -1,  6300,     0,    -1,  1277,    -1,    -1,
      -1,  5113,    -1,    -1,    -1,    -1,  6245,    -1,    -1,  1289,
      -1,   475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6337,  6338,  6339,  6340,    -1,    -1,    -1,    -1,  6345,
      -1,    -1,    -1,    -1,  6350,    -1,   513,    -1,    -1,    -1,
      -1,  1331,  6245,    -1,  6360,    -1,    -1,  6363,   525,   526,
     527,   528,   529,   530,    -1,    -1,    -1,    -1,    -1,  6367,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6383,    -1,    -1,
    1360,  1361,  1362,    -1,  1364,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    99,     0,    -1,    -1,    -1,    -1,
      -1,    -1,  6408,  6409,  5735,  1385,  5737,  6367,    -1,    -1,
      -1,    -1,  6363,    -1,    -1,    -1,    -1,    -1,    25,  6425,
      -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,  6367,    -1,
    1410,    -1,    -1,    -1,    -1,    -1,  6442,  6443,  1418,  1419,
    6446,    -1,  6448,    -1,    -1,    -1,    -1,   152,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4653,  6465,
     165,  4656,  1442,    -1,    -1,    -1,   171,    -1,    -1,    76,
      -1,    -1,   177,    -1,  6367,    -1,    -1,    -1,   183,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,
      -1,  1471,    -1,  5305,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4700,    -1,    -1,  1488,    -1,
      -1,    -1,  1492,  1493,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,  1508,    -1,
      -1,    -1,    -1,   140,  1514,  5347,    -1,   144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,   253,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     165,    -1,    -1,    -1,    -1,   172,   171,    -1,    -1,    -1,
      -1,  5383,   177,    -1,    -1,    -1,    -1,    -1,   183,    -1,
      -1,   186,    -1,    -1,   778,   190,   780,    -1,   782,    -1,
      -1,    -1,    -1,    -1,   788,   789,   790,    -1,    -1,   304,
      -1,   208,  1582,   308,    -1,    -1,    -1,    -1,    -1,   314,
      -1,    -1,    -1,    -1,    -1,   220,  5428,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1623,    -1,    -1,    -1,    -1,   253,    -1,
      -1,    -1,  5983,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
     375,    -1,    -1,    -1,    -1,    -1,  1656,  5489,    -1,    -1,
      -1,   288,    -1,    35,    -1,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,   302,  4891,    -1,    -1,   304,
      52,    -1,    -1,   308,    -1,   312,  5518,    -1,    -1,   314,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,
      -1,    -1,    -1,  6344,    -1,    -1,    78,    -1,    -1,   434,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1720,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4947,  4948,    -1,  1735,  1736,  1737,    -1,   464,
     367,    -1,    -1,   370,   371,    -1,  5578,    -1,    -1,    -1,
     375,    -1,    -1,  6104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   488,    -1,   490,   491,    -1,   982,    -1,
      -1,    -1,    -1,    -1,    -1,   402,    -1,    -1,    -1,  6130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   512,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   532,    -1,   434,
     535,   536,   537,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,   196,    -1,  5041,  5042,    -1,   201,
      -1,    -1,    -1,    -1,    -1,  1835,    -1,    -1,  1052,   464,
      -1,    17,    -1,    -1,    -1,    -1,    -1,  1847,   475,    45,
      26,    -1,   224,   225,    -1,    -1,    52,    -1,  1858,    -1,
      -1,    -1,    -1,   488,    -1,   490,   491,    -1,    -1,    -1,
    1870,    -1,    -1,    -1,  1874,  5707,    -1,    -1,    -1,    -1,
     252,    -1,    78,    -1,    -1,    -1,    -1,   512,    -1,    -1,
      -1,    -1,    -1,  1893,  6245,    38,    -1,    -1,    -1,    -1,
      -1,  1901,    -1,  5735,    -1,    -1,    -1,   532,    -1,  1909,
     535,   536,   537,    -1,    -1,    -1,    -1,    -1,    -1,    62,
      -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,  1928,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1937,   310,    -1,
    1940,   313,    -1,  1943,    -1,    -1,  1946,  1947,    -1,    -1,
    1950,  1951,    -1,  1953,  1954,    98,  5171,    -1,    -1,  5174,
    5175,    -1,    -1,    -1,    -1,  1965,    -1,  1967,  1968,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1977,  1978,    10,
    1980,  1981,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
    5205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    35,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,  6367,    -1,   161,    -1,
    2020,    52,    -1,    -1,  2024,  2025,    -1,    -1,   224,   225,
      -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   198,   252,    -1,    -1,  2059,
      -1,  2061,    -1,    -1,    -1,    -1,  2066,  2067,    -1,    -1,
      -1,    -1,    -1,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,    -1,    -1,    -1,  2089,
      -1,  2091,    -1,  2093,  2094,  2095,  2096,  2097,  2098,   295,
     243,  2101,    -1,  2103,  2104,   248,    -1,  2107,    -1,    -1,
      -1,    -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,  5951,
      -1,  2121,  2122,  2123,  2124,    -1,    -1,    -1,    -1,    -1,
      -1,  5963,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2140,   513,  2142,    -1,    -1,    -1,    -1,    -1,    -1,   292,
     522,   523,   524,   525,   526,   527,   528,   529,   530,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,   539,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,   325,    -1,    17,    18,    19,    -1,    -1,    -1,
     333,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,  1413,
      -1,    -1,    35,    -1,  1418,  1419,    -1,    -1,    -1,    -1,
      -1,   407,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,   252,    -1,    -1,    -1,  6057,    -1,    -1,   371,    -1,
      -1,    -1,  1446,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1455,   385,  1457,    -1,    78,    -1,  1461,    -1,    -1,
      -1,   394,    -1,    -1,  1468,    -1,    -1,    -1,    -1,   402,
      -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   415,    -1,    -1,    -1,    -1,    -1,    -1,   310,
      -1,   424,   313,    -1,    -1,    -1,   429,  2287,    -1,    -1,
    6122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6131,
    6132,    -1,    -1,    -1,    -1,    -1,    -1,   450,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,    -1,
      -1,  2341,    -1,   486,    -1,    -1,  1560,   490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1570,    -1,    -1,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       0,   224,   225,    -1,    -1,    -1,    -1,  2397,    -1,    -1,
    1614,  1615,    -1,  6235,    -1,  5620,    -1,    -1,    -1,  6241,
      20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,    31,    -1,    33,    34,    -1,    -1,  6259,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,  1657,    -1,    -1,  1660,  1661,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5674,
      -1,    -1,   295,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,   310,    -1,    -1,
     313,    -1,   513,    -1,    -1,    -1,    -1,    97,    -1,    99,
     666,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,    -1,    -1,    -1,   535,    -1,   116,  6339,    -1,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,   136,    -1,    -1,    -1,
     140,  6363,    -1,    -1,    -1,    -1,    -1,   147,    -1,    -1,
     716,   717,    -1,    -1,    -1,    -1,   156,    -1,   158,    -1,
      -1,    -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   183,   407,    -1,    -1,  6409,  5793,    -1,
      -1,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,
     200,  2591,    -1,  6425,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2602,    -1,  2604,    -1,    38,    -1,    -1,    -1,
    6442,  6443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1852,    -1,
     816,    -1,  2642,    -1,   254,   255,  2646,    -1,    -1,  2649,
     260,  2651,    -1,    -1,  2654,    -1,    -1,    -1,  2658,    -1,
     836,    -1,    -1,    -1,    -1,   275,    98,    -1,   844,    -1,
      -1,   847,   848,   849,    -1,    -1,    -1,    -1,    -1,  2679,
     513,  2681,    -1,    -1,   294,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,  2698,    -1,
      -1,    -1,   535,    -1,    -1,   538,    -1,  2707,  2708,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   333,    -1,    -1,    -1,    -1,    -1,   161,
      -1,    -1,   342,  2733,    -1,    -1,    -1,    -1,    -1,    -1,
    2740,    -1,    -1,    -1,  2744,  2745,    -1,   357,    -1,    -1,
      -1,  2751,    -1,   363,   364,  2755,   366,    -1,    -1,  2759,
      -1,   371,    -1,    -1,    -1,    -1,   198,   377,  2768,    -1,
     380,    -1,    -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,
      -1,    -1,    -1,  2783,   394,   395,  2786,    -1,    -1,    -1,
      -1,    -1,   402,    -1,    -1,    -1,   406,  2797,    -1,  2799,
    2800,    -1,  2802,  2803,    -1,  2805,    -1,   417,    -1,    -1,
      -1,   243,    -1,    -1,    -1,    -1,   248,  2817,    -1,    -1,
      -1,    -1,    -1,    -1,   434,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2837,  2838,    -1,
      -1,    -1,    -1,    -1,    -1,   455,    -1,    -1,    -1,    -1,
      -1,    -1,  2852,    -1,    -1,  2069,  2070,   467,    -1,    -1,
     292,    -1,    -1,   473,    -1,    -1,    -1,    -1,   478,    -1,
      -1,    -1,  2086,  2087,  2874,  2875,  1052,    -1,  2878,    -1,
      -1,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,   325,    13,    -1,    -1,    -1,    17,    18,
      19,   333,  2902,  2117,  2904,   515,    -1,    -1,  2908,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,  2922,    -1,   534,    -1,    45,   537,    -1,  2929,
      -1,    -1,  2932,    52,    -1,    -1,    -1,    25,  2938,   371,
      -1,    -1,    -1,    31,   376,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    -1,   385,    -1,    -1,    -1,    -1,  2958,    78,
      -1,    -1,   394,    -1,  2964,    -1,    -1,    -1,    -1,    -1,
     402,  2971,    60,    -1,    -1,    -1,    -1,    -1,    -1,  6194,
      -1,    -1,    -1,   415,    -1,  2985,    -1,    -1,    76,    -1,
      -1,    -1,   424,    -1,    -1,    -1,    -1,   429,    -1,  2999,
      -1,    -1,    -1,    -1,  3004,    -1,    -1,    -1,    -1,    -1,
    3010,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,    -1,
      -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,  3028,  3029,
    3030,    -1,    -1,    -1,  3034,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    -1,   133,    -1,    -1,    -1,    -1,
      -1,    -1,   140,    -1,   486,    -1,   144,    46,   490,    -1,
      -1,  3061,  3062,    -1,    -1,    -1,    -1,    -1,    -1,  1245,
    3070,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,   201,    -1,   172,    -1,    -1,    76,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,  1277,    -1,  3103,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,   204,    -1,    -1,    -1,
     208,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,   252,    -1,  3135,    -1,    -1,    -1,  3139,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,
      -1,   140,    -1,    -1,    -1,   144,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,   267,
      -1,    -1,    -1,   172,   272,    -1,    -1,    -1,    -1,    -1,
    1366,   310,    -1,    -1,   313,    -1,    -1,    -1,    -1,  1375,
     288,    -1,    -1,    -1,   292,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   302,  1391,    -1,    -1,    -1,   208,
      -1,    -1,    -1,    -1,   312,    -1,    -1,  3227,    -1,  3229,
      -1,    -1,    -1,    -1,  1410,   323,   324,  1413,  1414,    52,
      -1,    -1,  1418,  1419,  3244,    -1,  3246,    -1,    -1,    -1,
      -1,    -1,    -1,  3253,    -1,    -1,    -1,  3257,    -1,  3259,
    3260,    -1,  3262,  3263,  3264,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3272,    -1,    -1,    -1,   196,  3277,    -1,   367,
      -1,   201,   370,   371,   372,    -1,    -1,    -1,   407,    -1,
      -1,    -1,    -1,    -1,  3294,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,   292,   224,   225,    -1,    -1,   396,    -1,
      -1,    -1,    -1,   302,   402,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,  3326,  3327,  3328,   417,
      -1,  3331,   252,    -1,    -1,   324,    -1,    -1,    -1,  3339,
    3340,  3341,  3342,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3350,    -1,    -1,    -1,    -1,  3355,  3356,    -1,  3358,    -1,
    3360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3372,  3373,    -1,   295,  3376,    -1,   367,    -1,
      -1,   370,   371,    -1,    -1,    -1,    -1,   475,    -1,    -1,
     310,    -1,    -1,   313,   513,    -1,    -1,  3397,    -1,  3399,
      -1,  3401,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    25,   402,    -1,    -1,    -1,    -1,    31,   538,
    3420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,  3441,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,  2669,  2670,    -1,    -1,    -1,
      -1,  2675,    -1,    76,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,  3478,    -1,
      -1,  3481,    52,    -1,    -1,    -1,   475,   407,    -1,    -1,
      -1,    -1,    -1,  2707,  2708,  3495,    -1,    -1,  1674,    -1,
    3500,    -1,    -1,    -1,    -1,    -1,  1682,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,  3515,    -1,    -1,    -1,    -1,
     133,    -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,  3529,
      -1,   144,  3532,    -1,    -1,    -1,    -1,    -1,    -1,  3539,
      -1,    -1,  3542,    -1,  3544,    62,    -1,    -1,    10,  3549,
      -1,    13,    -1,    -1,  2768,    17,    18,    19,    -1,   172,
      -1,    -1,    -1,    -1,  3564,  3565,    -1,    -1,    -1,    -1,
    3570,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    45,    -1,  3585,    -1,    -1,  3588,    -1,
      52,  3591,    -1,   513,    -1,   208,    -1,    -1,    -1,  3599,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,    -1,    78,    -1,   538,    -1,
      -1,    -1,    -1,    -1,  3624,    -1,   196,    -1,    -1,    -1,
    3630,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2855,    -1,    -1,   161,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3669,
    3670,  3671,    -1,    -1,    -1,   288,    -1,    -1,    -1,   292,
      -1,   198,   252,    -1,    -1,    -1,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,  3694,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,  3703,    -1,  3705,    -1,    -1,    -1,    -1,
      -1,   324,    -1,  3713,    -1,    -1,    -1,    -1,    -1,    -1,
    1896,    -1,    -1,    -1,  1900,   295,    -1,    -1,    -1,    -1,
    2944,   248,    -1,    -1,   196,  3735,    -1,    -1,  2952,   201,
     310,  2955,    25,   313,    -1,    -1,    -1,    -1,    31,    -1,
      -1,    -1,    -1,  2967,   367,    38,    -1,   370,   371,    -1,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   292,    -1,    60,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   402,
     252,    -1,    -1,    76,    -1,    -1,    10,    -1,    -1,    13,
      -1,  3801,    -1,    17,    18,    19,    -1,    -1,   325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,  3825,    -1,    -1,    -1,   112,
    3830,    45,    -1,   295,    -1,    -1,  3836,   407,    52,    -1,
      -1,    -1,    -1,    -1,    -1,  3845,    -1,    -1,   310,    -1,
     133,   313,    -1,    -1,   371,    -1,   373,   140,    -1,   376,
      -1,   144,   475,    -1,    78,    -1,    -1,    -1,   385,    -1,
      -1,    -1,  3872,  3873,    -1,    -1,    -1,   394,  3878,    -1,
    3880,    -1,    -1,    -1,    -1,   402,    -1,    -1,    -1,   172,
      -1,    -1,    -1,  3893,    -1,  3895,  2072,    -1,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,
      -1,    -1,   429,   726,    -1,  3915,    -1,    -1,    -1,    -1,
      -1,   204,    -1,    -1,    -1,   208,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   752,
      -1,  3941,    -1,   513,    -1,   407,    -1,    -1,    -1,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,  3962,  3963,    -1,   535,    -1,    -1,    -1,   486,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,   196,    -1,   267,  3985,    -1,   201,    -1,   272,
      -1,    -1,    52,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,  3216,    -1,  4004,   288,    45,    -1,    -1,   292,
     224,   225,    -1,    52,    -1,    -1,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,  4033,    -1,    -1,    -1,  4037,   252,    78,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,  4058,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,    -1,
      -1,    -1,    -1,   535,  4074,    -1,    -1,  4077,    -1,    -1,
      -1,   295,    -1,  4083,   367,    -1,   899,   370,   371,   372,
      -1,    -1,    -1,    -1,    -1,    -1,   310,  4097,    -1,   313,
      -1,  4101,  4102,  4103,    -1,    -1,    -1,    -1,  4108,    -1,
      -1,  4111,    -1,   396,  4114,    -1,    -1,    -1,    -1,   402,
    4120,    -1,  4122,    -1,    -1,  4125,    -1,    -1,    -1,  4129,
    4130,  4131,  4132,  4133,   417,    -1,  4136,  4137,  4138,  4139,
    4140,  4141,  4142,  4143,  4144,  4145,    -1,    -1,    -1,  4149,
    4150,  4151,    -1,    -1,  4154,    -1,    -1,   196,    -1,  4159,
      -1,    -1,   201,    -1,  4164,    -1,  4166,    -1,  4168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4176,    -1,    -1,  4179,
      -1,  4181,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,   475,   407,    -1,    -1,    -1,  4197,    -1,    -1,
    4200,  4201,    -1,    -1,    -1,  4205,  4206,    -1,    -1,    -1,
    4210,    -1,  4212,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3439,    -1,  3441,    -1,    -1,
    1043,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,  4241,    -1,  3457,    17,    18,    19,  4247,    -1,  1062,
      -1,    -1,    -1,    -1,    -1,  4255,   295,    -1,    -1,  4259,
    1073,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,    45,    -1,   313,    -1,  1089,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4292,  3507,  3508,    -1,    -1,    -1,    -1,   513,
    4300,    -1,    -1,    -1,    -1,    78,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,    -1,
      -1,   535,    -1,    -1,    -1,    -1,  4326,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4349,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,   407,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4388,    -1,
      -1,    25,    35,  4393,  4394,  4395,    -1,    31,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4421,  4422,   196,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
    1253,    -1,    76,    -1,    -1,  2621,    -1,    -1,    -1,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4467,    -1,    -1,
    4470,    -1,    -1,    -1,   513,    -1,    -1,    -1,    -1,   252,
      -1,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    -1,    -1,    -1,    -1,   535,    -1,    -1,   133,
      -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
     144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4534,    -1,    -1,   310,   172,    -1,
     313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,
    4560,  4561,    -1,    -1,  4564,    -1,    -1,    -1,    -1,    -1,
      -1,  4571,    -1,    -1,   208,    -1,    -1,    -1,  4578,  4579,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,  4588,    -1,
      -1,    -1,  2768,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,  4611,    -1,    -1,    -1,    -1,  4616,  4617,  4618,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4628,    -1,
      -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2824,    -1,
      -1,    -1,   295,    -1,   288,    -1,    -1,    -1,   292,  3873,
      -1,    -1,    -1,    -1,    -1,    -1,   726,   310,   302,    -1,
     313,  4671,    -1,    25,    -1,    -1,    -1,    -1,   312,    31,
      -1,    -1,  3896,    -1,  4684,    -1,    -1,  4687,    -1,    -1,
     324,    -1,   752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4713,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,  4729,
      -1,    -1,    -1,   367,  2910,    -1,   370,   371,    -1,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,  4747,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,  2934,    -1,
      -1,    -1,   535,    -1,   407,    -1,    -1,    -1,   402,  1582,
      -1,    52,    -1,    -1,    -1,  4775,    -1,    -1,  4778,    -1,
      -1,   133,    -1,    -1,    -1,    -1,  4786,  4787,   140,  4789,
      -1,    -1,   144,  4793,  4794,    -1,    -1,    -1,  4798,    -1,
      -1,    -1,    -1,  4803,    -1,    -1,  4806,  4807,    -1,    -1,
    1623,    -1,    -1,  4813,    -1,    -1,    -1,    -1,    -1,    -1,
     172,    -1,  2998,    -1,    -1,    -1,  3002,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4835,    -1,    -1,    -1,   899,
      -1,   475,  4842,  1656,    -1,    -1,    -1,  4847,    -1,  4063,
    4850,  4851,    -1,    -1,    -1,    -1,   208,    -1,  4858,    -1,
      -1,    -1,    -1,  3039,    -1,  3041,    -1,  3043,  3044,  4869,
     513,  4871,  3048,  3049,  3050,    -1,  3052,  3053,  3054,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
      -1,    -1,   535,  4893,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4906,    -1,    25,    -1,
      -1,  4911,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1735,  1736,  1737,    -1,    -1,    -1,    -1,    -1,
    3106,     8,    -1,    -1,    -1,    -1,   288,    14,    15,    -1,
     292,    -1,    -1,    20,    -1,    22,  4946,    -1,    23,    -1,
     302,    28,    -1,    28,    31,  3131,    -1,    -1,    -1,    76,
     312,    -1,    -1,  4963,    -1,    -1,    -1,    -1,  4968,    -1,
      -1,    -1,   324,    50,    51,  4975,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4991,    -1,    -1,    -1,    -1,    -1,    -1,  4998,    -1,
      -1,    -1,  1062,    -1,    79,    80,    -1,    -1,    -1,  5009,
      -1,    -1,    -1,  1073,    -1,   367,   133,    -1,   370,   371,
      -1,    96,    -1,   140,    -1,    -1,    -1,   144,    -1,  1089,
      -1,    -1,    -1,    -1,  1847,    -1,    -1,    -1,    -1,   114,
    5040,    -1,    -1,    -1,    -1,  1858,    -1,    -1,    -1,    -1,
     402,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,    -1,
      -1,  1874,    -1,   138,    -1,    -1,  5066,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    31,   151,    -1,    -1,    -1,
      -1,    -1,  5082,    -1,    -1,   160,    -1,  5087,    -1,    -1,
      -1,   208,    -1,    -1,    -1,    -1,    -1,    -1,   173,    -1,
      -1,    -1,    -1,    -1,   179,    -1,  5106,    -1,    -1,    -1,
      -1,    -1,    -1,  5113,    -1,  1928,    -1,    -1,    -1,    -1,
      76,    -1,    -1,   475,   201,    -1,    -1,    -1,   205,    -1,
    1943,   206,    -1,  1946,  1947,    -1,   213,    -1,    -1,   216,
      -1,    -1,   219,   220,    -1,   222,    -1,   224,    -1,    -1,
     227,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,  5159,
      -1,  5161,    -1,    -1,  1977,  1978,    -1,    -1,    -1,   244,
      -1,   288,    -1,    -1,    -1,   292,    -1,   133,    -1,    -1,
    4394,    25,    -1,    -1,   140,   302,    -1,    31,   144,    -1,
      -1,   266,    -1,  1253,    -1,   312,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5203,    -1,    -1,    -1,   324,  4422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,
      -1,    -1,  4436,    -1,    -1,    -1,    -1,    -1,    -1,  5229,
      -1,    -1,    76,  4447,    -1,    -1,    -1,    -1,    -1,  5239,
      -1,    -1,  5242,    -1,    -1,  5245,  5246,  5247,    -1,    -1,
     367,    -1,   208,   370,   371,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3441,  2079,    -1,    -1,    -1,
    5270,  5271,   347,   348,  5274,    -1,   351,    -1,    -1,    -1,
    2093,    -1,    -1,  2096,    -1,   402,    -1,    -1,    -1,   133,
      -1,  5291,    -1,    -1,    -1,  5295,   140,    -1,    -1,    -1,
     144,  5301,    -1,    52,   379,  5305,    -1,   382,  2121,  4523,
    4524,  5311,  5312,    -1,   389,    -1,    -1,    -1,    -1,    -1,
      -1,   396,    -1,  5323,   399,  5325,    -1,    -1,   172,    -1,
      -1,    -1,   288,    -1,    -1,    -1,   292,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   419,    -1,   302,  5347,    -1,    -1,
      -1,    -1,   427,  1413,    -1,    -1,   312,    -1,   475,   434,
      -1,    -1,   437,    -1,   208,    -1,    -1,   442,   324,    -1,
      -1,    -1,  5372,  5373,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   457,  5383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,  4611,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   484,
      -1,   367,  3588,    -1,   370,   371,    35,    -1,    -1,    -1,
      -1,    -1,    -1,  5423,    -1,    -1,    45,    -1,  5428,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   726,   402,    -1,   292,    -1,
      -1,    52,    -1,    -1,  1514,    -1,    -1,    -1,   302,    78,
      -1,    -1,    -1,    -1,    -1,  4679,    -1,    -1,   312,    -1,
      -1,   752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5489,
      -1,    -1,  5492,    -1,    -1,    -1,    -1,    -1,    -1,  3675,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5518,   475,
    5520,    -1,  1582,   367,    -1,    -1,   370,   371,    -1,    -1,
      -1,    -1,    -1,  5533,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5550,    -1,    -1,    -1,  5554,    -1,  5556,  3733,   402,    -1,
      -1,    -1,    -1,  1623,    -1,    -1,    -1,    -1,    -1,    -1,
    5570,    -1,    -1,    -1,    -1,    -1,    -1,   196,  5578,    -1,
      -1,  5581,   201,    -1,    -1,    -1,    -1,   664,    -1,    -1,
      -1,    -1,  5592,    -1,    -1,    -1,  1656,    -1,   675,  5599,
      -1,    -1,   679,    -1,    -1,   224,   225,    -1,    -1,   686,
     687,    -1,    -1,   690,    -1,   692,   693,    -1,   899,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3803,    -1,    -1,
     707,   475,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5641,    -1,    -1,    -1,    -1,    -1,  5647,   725,    -1,
      -1,    -1,  5652,  5653,    -1,    -1,    -1,  5657,    -1,    -1,
      -1,    -1,    -1,  5663,  5664,  5665,    -1,    -1,    -1,   746,
      -1,   748,    -1,    -1,    -1,  3851,   295,    -1,    -1,  5679,
      -1,   758,    -1,    -1,    -1,    -1,    -1,  3863,  3864,    -1,
      -1,   310,    -1,    -1,   313,    -1,    -1,  3873,    -1,  5699,
      -1,    -1,  3878,    -1,  3880,    -1,    -1,  5707,    -1,    -1,
    5710,    -1,    -1,    -1,  4928,   792,    -1,    -1,    -1,    -1,
    4934,    -1,    -1,    -1,    -1,  4939,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5735,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3926,    -1,  4966,  4967,    -1,    -1,    -1,  4971,  4972,    -1,
      -1,    -1,    -1,    -1,    -1,  5765,  5766,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1062,    -1,    -1,    -1,  3961,  3962,  1847,   407,    -1,
      -1,  2604,  1073,    -1,  5794,  5795,    -1,    -1,  1858,   876,
      -1,    62,    -1,    -1,    -1,    -1,  5806,    -1,  1089,    -1,
      -1,    -1,    -1,    -1,  1874,  5815,  5816,  5817,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5830,  5831,    -1,    -1,  5834,    -1,    -1,    98,    -1,  5839,
      -1,  5841,    -1,  5843,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5851,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1928,    -1,
    5870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1943,   961,    -1,  1946,  1947,    -1,    -1,
      -1,    -1,    -1,    -1,   513,  5895,    -1,    -1,  5898,    -1,
     161,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    -1,    -1,    -1,    -1,   535,  1977,  1978,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2740,    -1,    -1,
      -1,  2744,  2745,    -1,    -1,    -1,    -1,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5951,    -1,    -1,    -1,    -1,    -1,    -1,  1035,    -1,
      -1,    -1,    -1,  5963,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1253,    -1,    -1,    -1,    -1,   726,    -1,    -1,
      -1,    -1,    -1,  1060,    -1,    -1,  2799,   248,    -1,    -1,
      -1,    -1,  2805,    -1,    -1,    -1,    -1,    -1,  1075,  4175,
    1077,    -1,    -1,   752,    -1,    -1,    -1,    -1,  6008,    -1,
    1087,    -1,    -1,    -1,    -1,    -1,    -1,  1094,    -1,    -1,
      -1,    -1,    -1,  6023,    -1,    -1,    -1,   288,    -1,    -1,
      -1,   292,    -1,  6033,    -1,    -1,    -1,    -1,    -1,  2852,
      -1,    -1,    -1,  6043,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6057,    -1,    -1,
    1137,  2121,  1139,   324,   325,    -1,    10,    -1,    -1,    13,
    6070,    -1,   333,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,   367,    -1,    52,    -1,
     371,    -1,  6112,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      10,    -1,  6122,    13,   385,   726,    -1,    17,    18,    19,
      -1,  6131,  6132,   394,    78,    -1,    -1,  6137,  1215,    -1,
    1217,   402,  1219,    -1,  1221,    35,  1223,  1224,  1225,    -1,
     899,   752,    -1,  1230,   415,    45,    -1,    -1,  5372,    -1,
      -1,    -1,    52,   424,    -1,  1242,    -1,    -1,   429,    -1,
      -1,  6171,  6172,    -1,    10,  6175,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,  6211,    -1,    -1,    -1,    -1,    52,  3030,  4394,    -1,
      -1,    -1,    -1,    -1,    -1,   486,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1514,    -1,  6235,    -1,    -1,    -1,    -1,
      -1,  6241,    78,    -1,    -1,    -1,  4422,    -1,    -1,  3062,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,  6259,
      -1,  4437,    -1,    -1,  4440,    -1,  4442,  6267,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,    -1,  6283,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   899,    -1,
    6300,  1582,    -1,    -1,    -1,    -1,   196,    -1,   252,    -1,
      -1,   201,  4488,  1062,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3135,    -1,  1073,    -1,  3139,    -1,  4504,    -1,
      -1,    -1,    -1,  4509,   224,   225,    -1,    -1,    -1,  6339,
    1089,    -1,  1623,    -1,  6344,    -1,    -1,    -1,    -1,    -1,
    6350,   295,    -1,    -1,    -1,    -1,    -1,    -1,  1435,    -1,
     196,    -1,   252,  6363,    -1,   201,   310,    -1,    -1,   313,
    6370,    -1,    -1,    -1,    -1,  1656,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    -1,    -1,    -1,   295,    -1,    -1,  6408,  6409,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,  6425,    -1,    -1,    -1,  6429,
      -1,  3244,  4608,    -1,    -1,  4611,    -1,    98,    -1,    -1,
      -1,    -1,  6442,  6443,    -1,    -1,  3259,    -1,    -1,    -1,
      -1,  3264,    -1,    -1,  6454,    -1,    -1,    -1,    -1,   295,
      -1,  1062,    -1,   407,    -1,  5679,    -1,    -1,    -1,    -1,
      -1,    -1,  1073,    -1,   310,    -1,    -1,   313,    -1,  1556,
      -1,  3294,    -1,    -1,    -1,    -1,    -1,    -1,  1089,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     161,    -1,    -1,    -1,  1253,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4702,  4703,  4704,  4705,
      -1,  4707,  4708,  4709,  4710,  4711,    -1,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1628,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1847,    -1,    -1,   513,
      -1,   407,    -1,    -1,    -1,    -1,    -1,  1858,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   248,    -1,    -1,
      -1,   535,    -1,  1874,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    -1,    -1,    -1,   288,    -1,    -1,
      -1,   292,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,   535,    -1,  1928,    -1,  4825,
      -1,  4827,  1253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1943,   324,   325,  1946,  1947,    -1,    -1,    -1,
      -1,    -1,   333,  5887,    -1,    -1,    -1,   513,    -1,    -1,
    2740,    -1,    -1,    -1,  2744,  2745,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,  1977,  1978,    -1,   535,
      -1,    -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,    -1,
     371,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   385,    -1,  3539,    -1,    -1,  3542,
      -1,  3544,    -1,   394,    -1,    -1,  3549,    -1,    -1,  2799,
      -1,   402,    -1,    -1,    -1,  2805,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   424,    10,  1514,  1843,    13,   429,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,  3591,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3599,    -1,    -1,    35,
      -1,    -1,  2852,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,  1878,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,  3624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,   486,    17,    18,    19,    -1,
      -1,    -1,    78,  1582,    -1,    -1,    -1,    -1,    -1,    -1,
    2121,    -1,    -1,    -1,    35,    -1,    -1,  1924,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,  5038,  5039,    -1,    -1,    -1,  1944,    -1,    -1,
      -1,    -1,    -1,    -1,  1623,  5051,    -1,  5053,  5054,  5055,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
    3703,    -1,  3705,  1970,    -1,  1972,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1656,    -1,    -1,
    1987,    -1,  1989,  1514,    -1,    -1,    -1,    -1,    -1,    -1,
    1997,    -1,  1999,    -1,  2001,    -1,  2003,    -1,  2005,    -1,
      -1,    -1,  2009,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5119,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2046,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
      -1,  1582,  5158,    -1,    -1,    -1,    -1,    -1,  3801,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3062,    -1,    -1,   196,   252,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,  3830,    -1,    -1,
      -1,    -1,  1623,  3836,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3845,   224,   225,    -1,  5212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,
      -1,    -1,   726,    -1,    -1,  1656,    -1,    -1,    -1,    -1,
    3873,   252,    -1,    -1,   310,    -1,    -1,   313,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3135,    -1,    -1,   752,  3139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1847,    -1,
      -1,    -1,    -1,    -1,   295,    10,    -1,    -1,    13,  1858,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,   310,
      -1,    -1,   313,    -1,    98,  1874,    -1,    -1,  3941,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
    3963,    52,    -1,    -1,    -1,    -1,  6370,    -1,    -1,    -1,
      -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3985,    78,    -1,    -1,    -1,    -1,    -1,  1928,
      -1,    -1,    -1,    -1,  3244,    -1,    -1,   161,    -1,    -1,
      -1,    -1,    -1,    -1,  1943,    -1,  5372,  1946,  1947,  3259,
      -1,    -1,    -1,    -1,  3264,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6429,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   198,   899,    -1,    -1,  1977,  1978,
      -1,    -1,    -1,    -1,  3294,    -1,    -1,    -1,    -1,    -1,
    6454,    -1,  5418,    -1,    -1,    -1,  1847,    -1,    -1,    -1,
      -1,  5427,    -1,    -1,    -1,    -1,    -1,  1858,    -1,    -1,
      -1,    -1,    -1,    -1,  4077,    -1,    -1,   513,    -1,    -1,
      -1,    -1,    -1,  1874,   248,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,   535,
      -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,  4129,    -1,   292,   224,
     225,    -1,   513,    -1,    -1,    -1,    -1,  1928,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,  4154,  1943,    -1,   535,  1946,  1947,   252,    -1,    -1,
     324,   325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2121,    -1,    -1,    -1,  1977,  1978,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1062,    -1,
     295,    -1,    -1,   367,    -1,    -1,    -1,   371,    -1,  1073,
      -1,    -1,   376,    -1,    -1,   310,    -1,    -1,   313,    -1,
      -1,   385,    -1,    -1,    -1,  1089,    -1,    -1,    -1,    -1,
     394,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     424,    -1,    -1,    10,    -1,   429,    13,    -1,    -1,  2740,
      17,    18,    19,  2744,  2745,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,  3539,
      -1,    38,  3542,    -1,  3544,    -1,    -1,  4300,    45,  3549,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,   407,  5679,    -1,    -1,    -1,  5683,    -1,    -1,
      -1,    -1,   486,    -1,    -1,    -1,    -1,    -1,  2799,    -1,
    2121,    78,    -1,    -1,  2805,    -1,    -1,    -1,    -1,    -1,
      -1,  3591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3599,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3624,    -1,    -1,    -1,    -1,    -1,
      35,  2852,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1253,
      45,  4394,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,  4422,
      -1,    -1,    -1,    78,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,
     535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,
      -1,    -1,    -1,  3703,   201,  3705,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2734,  2735,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2753,  2754,    -1,  2756,
    2757,    -1,    -1,    -1,  2761,  2762,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,  2776,
      -1,    -1,    -1,  2780,    -1,    -1,    -1,  2784,  2785,    -1,
      -1,  2788,  2789,    -1,    -1,    -1,    -1,    -1,  2795,    -1,
      -1,    -1,  5898,    -1,    -1,    -1,  5902,    -1,  5904,    -1,
    2807,   196,  5908,  5909,    -1,    -1,   201,    -1,   295,    -1,
      -1,  3801,  2819,    -1,    -1,    -1,    -1,  2824,    -1,    -1,
      -1,  4564,    -1,   310,    -1,    -1,   313,    -1,    -1,   224,
     225,    -1,  2839,    -1,    -1,    -1,  2843,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2854,    -1,    -1,
    2857,  3062,  2859,  2860,  2861,  3845,    -1,   252,    -1,  2866,
    2867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4611,  2876,
      -1,    -1,    -1,  4616,    -1,  2882,    -1,    -1,    -1,  2886,
      -1,    -1,    -1,  3873,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2898,  2899,    -1,    -1,   726,  2903,    -1,    -1,    -1,
     295,    -1,  2909,  2910,    -1,    -1,    -1,    -1,    -1,    -1,
    1514,    -1,    -1,    -1,    -1,   310,  2923,    -1,   313,  2926,
     407,   752,    -1,    -1,  3135,    -1,  2933,  2934,  3139,    -1,
      10,    -1,  2939,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,  2951,    -1,    -1,  2954,    -1,    -1,
      -1,  3941,  2959,    -1,    -1,    35,    -1,    -1,  2965,  2966,
      -1,    -1,    -1,    -1,    -1,    45,  2973,    -1,    -1,    -1,
    2977,    -1,    52,  3963,  2981,  2982,  2983,  2984,  1582,  2986,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3000,  3001,  3985,  3003,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3014,  3015,  3016,
      -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,  1623,
      -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,    -1,
      -1,    -1,    -1,  3244,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,  4789,    -1,  3259,    -1,
      -1,    -1,  1656,  3264,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2740,    -1,    -1,  3071,  2744,  2745,    -1,   899,    -1,
      -1,    -1,  3079,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3294,    -1,    -1,    -1,  4077,    -1,    -1,
      -1,  3098,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6211,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,   513,    -1,
    2799,   201,    -1,    -1,    -1,    -1,  2805,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,  4129,
     535,  3148,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,
    4893,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3167,    -1,  3169,    -1,  4154,    -1,    -1,    52,    -1,    -1,
      -1,    -1,   252,  2852,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4946,    -1,    -1,    35,    -1,    -1,  2740,
      -1,    -1,    -1,  2744,  2745,   295,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,  4968,    -1,    -1,    -1,    -1,
     310,  1062,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1073,  1847,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,  1858,    -1,    -1,    -1,  1089,  3266,
      -1,    -1,    -1,    -1,  6370,    -1,    -1,    -1,  2799,    -1,
    1874,  6377,    -1,    -1,  2805,  6381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5040,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6415,
    4300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2852,    -1,  6429,  1928,    -1,    -1,   407,  3539,    -1,
      -1,  3542,    -1,  3544,    -1,    -1,    -1,    -1,  3549,  1943,
      -1,    -1,  1946,  1947,    -1,    -1,    -1,    -1,  6454,    -1,
      -1,  6457,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,   201,  1977,  1978,    -1,    -1,    -1,    -1,    -1,
    3591,    -1,    -1,  3062,    -1,    -1,    -1,    -1,  3599,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4394,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3624,    -1,    -1,  5159,    -1,  5161,    -1,
      -1,    -1,  1253,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4422,   513,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,   535,  3135,    -1,    -1,    -1,
    3139,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3703,    -1,  3705,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2121,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3062,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3244,    -1,    -1,  5311,    -1,
      -1,    -1,    -1,    -1,  4564,    -1,    -1,    -1,   407,  3586,
    3259,    -1,    -1,    -1,    -1,  3264,    -1,    -1,    -1,    -1,
    3801,    -1,    -1,    -1,    -1,    -1,  3603,    -1,    -1,    -1,
    3607,    -1,    -1,    -1,  3135,  3612,  3613,  3614,  3139,    -1,
      -1,    -1,    -1,    -1,    -1,  3294,    -1,    -1,    -1,    -1,
      -1,  4611,    -1,    -1,    -1,    -1,  4616,  3634,    -1,  5372,
      -1,    -1,    -1,    -1,  3845,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
    3657,  3658,  3659,  3660,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3873,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,  1514,   513,    -1,    -1,    -1,  3695,    -1,
    3697,  3698,  3699,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    10,    -1,    -1,    13,   535,    -1,    78,    17,
      18,    19,    -1,  3244,    -1,    -1,    -1,    -1,   208,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,  3259,    -1,
    3941,    -1,    -1,  3264,    -1,    -1,    -1,    45,    -1,    -1,
      -1,   231,    -1,    -1,    52,    -1,    -1,    -1,    -1,  5492,
      -1,  1582,  3963,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3294,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,  3985,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1623,    -1,    -1,    -1,    -1,    -1,    -1,  4789,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3826,
      -1,    -1,    -1,    -1,    -1,  1656,   196,    -1,    -1,    -1,
      -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   726,    -1,    -1,    -1,  3852,  3853,    -1,    -1,    -1,
    3857,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,
    3539,    -1,    -1,  3542,    -1,  3544,  4077,   752,    -1,    -1,
    3549,    -1,  3879,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4893,  5647,    -1,    -1,    -1,    -1,  5652,
    5653,    -1,  3591,    -1,    -1,    -1,   224,   225,  4129,    -1,
    3599,    -1,    -1,    -1,  3931,   295,    -1,    -1,    -1,  3936,
      -1,    -1,    -1,    -1,    -1,  3942,    -1,    -1,    -1,    -1,
     310,    -1,    -1,  4154,   252,  3624,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4946,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3972,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4968,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,  4001,    -1,  4003,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,  3539,    -1,
      -1,  3542,    -1,  3544,   899,    -1,  1847,    -1,  3549,    -1,
      -1,    -1,  5765,  5766,  3703,    -1,  3705,  1858,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   726,   407,    -1,    -1,
      -1,    -1,    -1,  1874,    -1,    -1,    -1,    -1,    -1,    -1,
    5040,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3591,    -1,   752,    -1,    -1,    -1,    -1,    -1,  3599,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4300,
      -1,  5834,    -1,  3624,    -1,    -1,    -1,  1928,    -1,   407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1943,    -1,    -1,  1946,  1947,    -1,    -1,    -1,
      -1,    -1,  3801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2740,    -1,    -1,    -1,
    2744,  2745,    -1,   513,    -1,    -1,  1977,  1978,    -1,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,    -1,  3845,    -1,    -1,    -1,
      -1,  5161,  3703,    -1,  3705,    -1,    -1,  1062,    -1,    -1,
      -1,    -1,    -1,  4394,    -1,    -1,    -1,    -1,  1073,    -1,
      -1,    -1,   682,    -1,  3873,  2799,    -1,    -1,   688,    -1,
      -1,  2805,    -1,    -1,  1089,   513,    -1,    -1,    -1,   899,
     700,  4422,    -1,    -1,   522,   523,   524,   525,   526,   527,
     528,   529,   530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2852,   199,
     200,    -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3941,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3801,    -1,    -1,   223,    -1,    -1,    -1,    -1,    -1,    -1,
     230,    -1,    -1,    -1,  3963,    -1,    -1,    -1,    -1,    -1,
    2121,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,  4312,  3985,  4314,    -1,    -1,
      -1,    -1,    -1,    -1,  3845,    -1,    35,    -1,    -1,    -1,
    4327,  5311,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,  4339,    52,    -1,    -1,  4343,    -1,    -1,    -1,
      -1,    -1,  3873,    -1,    -1,    -1,    -1,  4354,    -1,    -1,
      -1,    -1,    -1,  4564,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,  4373,    -1,  1253,    -1,
      -1,    -1,  1062,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5372,  1073,  4391,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4399,    -1,    -1,    -1,    -1,    -1,  4077,  1089,
    4611,    -1,    -1,    -1,    -1,  4616,    -1,    -1,    -1,    -1,
    3941,    -1,    -1,    -1,    -1,    -1,    -1,  4424,    -1,    -1,
      -1,  4428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3963,    -1,    -1,    -1,  4443,  4444,  4445,  4446,
      -1,    -1,    -1,    -1,    -1,    -1,  4453,  4454,  4455,  4456,
    4129,    -1,    -1,    -1,  3985,  4462,  4463,    -1,  3062,    -1,
      -1,  4468,  4469,    -1,  4471,  4472,  4473,  4474,  4475,  4476,
    4477,    -1,    -1,    -1,    -1,  4154,    -1,   196,    -1,    -1,
    4487,    -1,   201,    -1,  4491,  4492,  4493,  4494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5492,    -1,    -1,   224,   225,    -1,  4515,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4533,    -1,    -1,    -1,
      -1,  3135,    -1,   252,    -1,  3139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4077,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1253,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,  4789,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,    -1,    -1,   313,    -1,    -1,    -1,  4129,    -1,
      -1,  6344,  4609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4300,    -1,  4154,    -1,    -1,    -1,    -1,    -1,  1514,
      -1,    -1,    -1,    -1,    -1,  4642,    -1,    -1,    -1,    -1,
    3244,    -1,  4649,    -1,  4651,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3259,    -1,  5647,    -1,    -1,
    3264,    -1,  5652,  5653,    -1,  6408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4893,    -1,    -1,    -1,    -1,  4694,   407,    -1,
    3294,    -1,    -1,    -1,    -1,    -1,    -1,  1582,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4394,    -1,    -1,    -1,    -1,
      -1,    -1,   672,    -1,   674,    -1,    -1,   677,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4946,    -1,    -1,  1623,    -1,
      -1,   691,    -1,  4422,    -1,    -1,    -1,   697,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4968,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4300,
      -1,  1656,    -1,    -1,    -1,    -1,  5766,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    -1,    -1,    -1,    -1,   535,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1514,    -1,    -1,    -1,    -1,  5040,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,  5834,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,  4394,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4564,    -1,  4894,  4895,  4896,
      -1,  4422,  1582,  4900,  4901,  4902,  4903,    -1,    -1,    78,
    4907,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2740,
      -1,    -1,    -1,  2744,  2745,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4611,  1623,    -1,  3539,    -1,  4616,  3542,    -1,
    3544,    -1,    -1,    -1,    -1,  3549,    -1,    -1,    -1,    -1,
    5161,  4958,  4959,  4960,  4961,  4962,    -1,  4964,  4965,    -1,
      -1,    -1,  1847,    -1,    -1,    -1,  1656,    -1,  2799,  4976,
    4977,    -1,    -1,  1858,  2805,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3591,    -1,  1874,
      -1,    -1,    -1,    -1,    -1,  3599,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5010,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,
    3624,  2852,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4564,    -1,    -1,    -1,    -1,   988,   989,
      -1,    -1,    -1,  1928,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1943,    -1,
      -1,  1946,  1947,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
    4611,    -1,    -1,    -1,    -1,  4616,    -1,    -1,    -1,    -1,
      -1,    -1,  1977,  1978,    -1,    -1,    -1,    28,    -1,  3703,
    5311,  3705,    -1,    -1,    -1,  5112,    -1,    -1,    -1,  1059,
    4789,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1074,    -1,    -1,    -1,    -1,    -1,
      -1,   310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    -1,    -1,    -1,    -1,  1105,  1106,  1847,    -1,    -1,
      -1,  5372,    -1,    -1,    -1,    96,    -1,    -1,  1858,    -1,
    5177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1131,    -1,   114,  1874,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3801,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    -1,    -1,  5220,  4893,    -1,    -1,    -1,    -1,    -1,
     151,  1171,  1172,    -1,    -1,    -1,    -1,    -1,   407,   160,
    1720,  3062,    -1,    -1,    -1,    -1,  2121,    -1,  1928,    -1,
      -1,  3845,   173,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,    -1,    -1,  1943,    -1,   186,  1946,  1947,  4789,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4946,    -1,  3873,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,  5492,    -1,    -1,    -1,    -1,    -1,  1977,  1978,  4968,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3135,    -1,    -1,    -1,  3139,    -1,
      -1,  5318,    -1,   244,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   513,   266,    -1,  3941,    -1,    -1,
      -1,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    -1,    -1,  6344,    -1,   535,    -1,    -1,  3963,
      -1,  5040,  4893,    -1,    -1,    -1,    10,  5374,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,   310,
      -1,  3985,    -1,    -1,    -1,    -1,  5393,    -1,    -1,    -1,
      -1,    35,  5399,  5400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,  5409,  1893,    -1,    -1,   337,    -1,    52,  5416,
      -1,  1901,    -1,  3244,    -1,  4946,   347,   348,    -1,  1909,
     351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3259,    -1,
      -1,  2121,    -1,  3264,    78,    -1,  5647,  4968,    -1,    -1,
      -1,  5652,  5653,    -1,  5451,  5452,    -1,    -1,   379,    -1,
      -1,   382,    -1,    -1,    -1,   386,    -1,  5464,   389,  5466,
      -1,    -1,    -1,  3294,  1954,   396,    -1,    -1,   399,    -1,
      -1,    -1,    -1,  4077,  5481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5161,    -1,    -1,    -1,    -1,    -1,   419,    -1,
      -1,  1981,    -1,    -1,    -1,    -1,   427,    -1,    -1,  5506,
      -1,   432,    -1,   434,    -1,    -1,   437,    -1,    -1,  5040,
      -1,   442,    -1,    -1,    -1,    -1,    -1,  5524,    -1,    -1,
      -1,   452,    -1,    -1,    -1,  4129,   457,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4154,    -1,   196,   484,    -1,  5766,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   207,   208,    -1,    -1,
      -1,    -1,    -1,    -1,   215,    -1,   217,   218,   252,    -1,
      -1,    -1,    -1,    -1,    -1,  5622,    -1,    -1,    -1,    -1,
     231,    -1,    -1,  5834,    -1,  1575,    -1,    -1,    -1,    -1,
    5161,    -1,  5311,    -1,    -1,    -1,    -1,    -1,    -1,  5646,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1600,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,   313,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,  5372,    -1,    -1,  4300,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,  5713,    -1,  3539,    -1,
      -1,  3542,    -1,  3544,    45,    -1,    -1,    -1,  3549,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,  1677,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1706,  1707,  1708,  1709,
    3591,    -1,    -1,   407,    -1,    -1,    -1,    -1,  3599,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5784,    -1,    -1,
    5311,  5788,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4394,    -1,    -1,  3624,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5492,    -1,    -1,  5823,    -1,  4422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5858,    -1,    -1,    -1,  2740,    -1,    -1,    -1,  2744,
    2745,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,   513,
     201,    -1,  3703,    -1,  3705,  5882,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,    -1,
      -1,   535,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1853,  1854,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2799,    -1,    -1,    -1,    -1,  1869,
    2805,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5942,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1903,  1904,  1905,  1906,    -1,    -1,    -1,
    4564,  5492,    -1,    -1,   295,    -1,    -1,  2852,  5647,    -1,
    3801,    -1,    -1,  5652,  5653,    -1,    -1,    -1,    -1,   310,
      -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4611,    -1,    -1,
      -1,    -1,  4616,    -1,  3845,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1984,    -1,    -1,    -1,    -1,    -1,
    1990,    -1,  3873,    -1,    -1,    -1,    -1,    -1,    -1,  6056,
    2740,    -1,   663,    -1,  2744,  2745,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   682,    -1,    -1,    -1,    -1,   407,   688,    -1,    -1,
      -1,    -1,  6089,    -1,    -1,    -1,    -1,  5766,    -1,   700,
      -1,    -1,    -1,  6100,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,   716,    17,    18,    19,  2799,
    3941,    -1,    -1,    -1,    -1,  2805,  5647,    -1,    -1,   730,
     731,  5652,  5653,    -1,    35,    -1,   737,    -1,   739,   740,
      -1,    -1,  3963,  6344,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,   753,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   763,    -1,  3985,  5834,    -1,    -1,    -1,    -1,
      -1,    -1,  2852,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,
      -1,    -1,   513,    -1,    -1,  4789,    -1,    -1,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,    -1,    -1,    -1,   535,    -1,    -1,    -1,    -1,   820,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2180,    -1,    -1,    -1,    -1,  5766,    -1,   848,    -1,    -1,
      -1,    -1,    -1,  2733,    -1,    -1,  4077,    -1,    -1,    -1,
    3135,    -1,    -1,    -1,  3139,    -1,    -1,    -1,    -1,    -1,
      -1,  2751,   873,    -1,    -1,  2755,    -1,    -1,    -1,  2759,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,  4893,
     201,    -1,    -1,  2783,    -1,    -1,    -1,    -1,  4129,    -1,
      -1,    -1,    -1,  5834,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4154,   935,    -1,    -1,  2817,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,  4946,    -1,    -1,    -1,    -1,  2837,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3244,
      -1,    -1,    -1,    -1,  4968,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3062,    -1,  3259,    -1,    -1,    -1,    -1,  3264,
      -1,    -1,    -1,    -1,   295,  2875,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,
      -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    10,  3294,
      -1,    13,  2902,    -1,    -1,    17,    18,    19,  2908,    -1,
      -1,    -1,    -1,    -1,    -1,  6432,    -1,    -1,    -1,    -1,
      -1,    -1,  2922,    35,  1045,    -1,  5040,    -1,    -1,  2929,
      -1,  1052,  2932,    45,    -1,  3135,    -1,    -1,  2938,  3139,
      52,    -1,  1063,    -1,    -1,    -1,  1067,    -1,  1069,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2958,  4300,
      23,    -1,    -1,    -1,  2964,    28,    78,    -1,    -1,    -1,
      -1,  2971,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2985,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2999,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
    3010,    -1,    -1,    -1,    -1,    -1,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3244,    -1,    -1,  5161,    -1,    -1,
      -1,   114,    -1,  4394,    -1,  1176,    -1,    -1,    -1,  3259,
      -1,    -1,    -1,    -1,  3264,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,
      -1,  4422,    -1,    -1,   196,    -1,    -1,    -1,   151,   201,
      -1,    -1,   513,    -1,  3294,    -1,    -1,   160,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     173,    -1,   224,   225,   535,    -1,   179,    -1,  1239,    -1,
      -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1255,    -1,    -1,    -1,    -1,    -1,
     252,    -1,    -1,   206,  3539,    -1,    -1,  3542,    -1,  3544,
      -1,  1272,    -1,    -1,  3549,  6344,  1277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   295,    -1,  2645,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3591,  5311,   310,    -1,
      -1,   313,    -1,   266,  3599,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4564,    -1,    -1,    -1,  3227,    -1,  3624,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3246,   310,    -1,    -1,
      -1,    -1,    -1,  3253,    -1,    -1,    -1,    -1,  5372,    -1,
     323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4611,    -1,    -1,   208,   337,  4616,    -1,    -1,    -1,    -1,
      -1,    -1,   217,    -1,   347,   348,    -1,    -1,   351,  1410,
      -1,    -1,    -1,    -1,    -1,   407,   231,  1418,  1419,    -1,
      -1,    -1,    -1,  6344,    -1,    -1,    -1,    -1,  3703,    -1,
    3705,    -1,    -1,    -1,    -1,    -1,   379,    -1,    -1,   382,
      -1,    -1,    -1,   386,    -1,    -1,   389,    -1,    -1,    -1,
      -1,    -1,    -1,   396,    -1,    -1,   399,    -1,    -1,  3539,
      -1,    -1,  3542,    -1,  3544,    -1,  2806,    -1,    -1,  3549,
    1471,    10,    -1,    -1,    13,    -1,   419,    -1,    17,    18,
      19,    -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,    -1,
      -1,   434,    -1,    -1,   437,    -1,    35,    -1,  5492,   442,
      -1,    -1,    -1,    -1,    -1,    -1,    45,   450,    -1,   452,
      -1,  3591,    -1,    52,   457,    -1,    -1,    -1,    -1,  3599,
      -1,   513,    -1,    -1,    -1,    -1,  3801,    -1,   471,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,    78,
      -1,   484,    -1,   535,  3624,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4789,    -1,
    3845,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,  3873,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
    2950,    -1,    -1,  2953,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,  3703,    -1,  3705,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5647,    -1,    -1,    -1,   196,  5652,  5653,
      -1,    -1,   201,    -1,    78,    -1,  3941,    -1,    -1,    -1,
      -1,    -1,  4893,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,    -1,  3963,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3042,    -1,    -1,  3585,    -1,    -1,    -1,    -1,
    3985,    -1,    -1,   252,    -1,  3055,    -1,    -1,    -1,  1720,
      -1,  3801,    -1,  3063,    -1,  4946,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4968,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,   295,    -1,    -1,    -1,
      -1,    -1,  3102,    45,    -1,  3845,    -1,    -1,    -1,    -1,
      52,   310,  5766,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,  3123,    -1,    -1,    -1,   201,    -1,    -1,
      -1,    -1,    -1,  3873,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,  4077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,    -1,    -1,  3694,    -1,    -1,    -1,    -1,  5040,
      -1,    -1,    -1,    -1,    -1,    -1,  3166,    -1,  3168,    -1,
      -1,    -1,    -1,    -1,  1835,    -1,    -1,    -1,   252,    -1,
    5834,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   663,    -1,
      -1,    -1,    -1,    -1,  4129,    10,    -1,    -1,    13,    -1,
      -1,  3941,    17,    18,    19,    -1,    -1,   682,   407,  1870,
      -1,    -1,    -1,   688,    -1,    -1,    -1,    -1,    -1,  4154,
      35,   295,    -1,  3963,    39,   700,    10,    -1,    -1,    13,
      45,    -1,  1893,    17,    18,    19,   310,    52,    -1,   313,
    1901,   716,    -1,    -1,    -1,  3985,    -1,    -1,  1909,    -1,
      -1,    35,    -1,    -1,   196,    -1,   731,    -1,  3258,   201,
      -1,    45,    -1,    78,   739,  3265,    -1,   341,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   753,    -1,
    5161,    -1,   224,   225,    -1,  3825,    -1,    -1,   763,  1950,
    1951,    -1,  1953,  1954,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1965,    -1,  1967,  1968,    -1,    -1,
     252,    -1,    -1,    -1,   513,   130,    -1,    -1,    -1,  1980,
    1981,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    -1,   407,    -1,    -1,   535,  4077,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   820,    -1,    -1,    -1,    -1,
      -1,    -1,   426,   295,    -1,    -1,    -1,    -1,    -1,  2020,
      -1,    -1,    -1,  2024,  2025,  4300,    -1,    -1,   310,    -1,
      -1,   313,    -1,   848,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,   201,   171,    -1,  4129,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,   873,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,    -1,   196,    -1,  4154,    -1,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5311,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,   513,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,  4394,
     935,    -1,    -1,    -1,  4004,   407,    -1,    -1,   252,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     295,  2142,    -1,    -1,    -1,    -1,    -1,  4422,    -1,    -1,
      -1,  5372,    -1,  4033,    -1,   310,    -1,  4037,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,   313,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1045,   513,    -1,    -1,    -1,    -1,    -1,  1052,    -1,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,    -1,
      -1,   533,   407,    -1,  3594,  3595,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,  5492,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    35,    -1,   407,    17,    18,    19,    -1,    -1,  4564,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,  4394,    -1,    -1,   472,    -1,    52,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4611,    -1,    -1,    -1,
      -1,  4616,  4422,    -1,    -1,    78,    -1,    -1,    -1,    -1,
    6344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,
      -1,  1176,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1239,    -1,  5647,    -1,    -1,    -1,
      -1,  5652,  5653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1255,    -1,   196,    -1,    -1,    -1,  4326,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1272,    -1,    -1,
      -1,    -1,  1277,   196,    -1,    -1,    -1,    -1,   201,    -1,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4564,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,   252,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3847,    -1,    -1,
      -1,    -1,    -1,    -1,  4789,    10,    -1,    -1,    13,   252,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,  4611,    -1,    -1,    -1,    -1,  4616,    -1,    -1,    -1,
      35,   295,    -1,    -1,    -1,  5766,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,   310,    52,    -1,   313,
      -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,
     313,    -1,    -1,    78,    -1,   339,    -1,  4467,    -1,    -1,
    4470,    -1,    -1,    -1,    -1,  1410,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1418,  1419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5834,    -1,    -1,    -1,    -1,  4893,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   407,    -1,    -1,  1471,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4007,    -1,    -1,
      -1,  4946,    -1,    -1,   407,    -1,    -1,    -1,  2679,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4571,    -1,  4968,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,   201,    -1,  4588,  4789,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,    -1,  2733,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2751,    -1,    -1,    -1,  2755,    -1,    -1,   252,  2759,   513,
      -1,    -1,    -1,    -1,    -1,  5040,    -1,  2768,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,   512,
     513,    -1,  2783,    -1,    -1,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,  2800,
     295,  2802,  2803,    -1,  4684,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4893,    -1,   310,  2817,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,  2837,  2838,    -1,   334,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,  4946,    -1,    52,    -1,
      -1,    -1,    -1,  2874,  2875,    -1,    -1,  2878,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5161,    -1,  4968,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,  2902,    -1,  2904,    -1,  1720,    -1,  2908,    -1,    -1,
      -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2922,    -1,    -1,    -1,    -1,    -1,    -1,  2929,    -1,
      -1,  2932,    -1,    -1,    -1,    -1,    -1,  2938,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2958,    -1,    -1,
    5040,    -1,    -1,  2964,    -1,    -1,    -1,    -1,    -1,    -1,
    2971,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2985,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2999,    -1,
      -1,    -1,    -1,  3004,    -1,    -1,    -1,    -1,    -1,  3010,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,   513,    -1,
    1835,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,  5311,    -1,   842,   843,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1870,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,  3070,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1893,    -1,
      -1,  5161,    -1,  4963,    -1,    -1,  1901,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1909,  4975,    -1,  5372,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,     0,    -1,    -1,    -1,    -1,   922,    -1,
      -1,    -1,    -1,  6344,    -1,    -1,   310,    -1,    -1,   313,
      -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,  1953,  1954,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    -1,
      -1,    -1,  1967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,  1980,  1981,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,  4518,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    76,
      -1,    -1,  4532,    -1,    -1,    82,    -1,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      97,    -1,    99,    -1,    -1,    -1,    -1,  5492,    -1,    -1,
      -1,    -1,    -1,   407,    -1,    -1,  3227,    -1,  3229,   116,
      -1,  5311,   119,    -1,    -1,    -1,    -1,    -1,    -1,  1043,
    1044,    -1,    -1,    -1,    -1,  3246,    -1,   134,    -1,   136,
      -1,    -1,  3253,   140,    -1,    -1,    -1,    -1,    -1,  3260,
     147,  3262,  3263,    -1,    -1,    -1,    -1,    -1,    -1,   156,
      -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5372,    -1,    -1,    -1,   183,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5203,    -1,    -1,    -1,  2142,    -1,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,  3350,
      -1,    -1,    -1,    -1,    -1,  3356,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,   255,    -1,
      -1,    -1,  5647,   260,    -1,    -1,    -1,  5652,  5653,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,    -1,    -1,   294,    -1,    -1,
      -1,    -1,  5492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
    3441,    -1,    -1,  5323,    -1,  5325,   333,    -1,   209,    -1,
      -1,    -1,    79,    80,    -1,   342,    -1,    -1,    -1,    -1,
     221,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    96,
     357,   232,    -1,    -1,    -1,    -1,   363,   364,    -1,   366,
      -1,    -1,    -1,    -1,   371,  1289,    -1,   114,    -1,    -1,
     377,  5766,    -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,
     387,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,    -1,
      -1,   138,    -1,    -1,    -1,   402,    -1,    -1,    -1,   406,
      -1,    -1,    -1,    -1,   151,    -1,    -1,  1331,    -1,    -1,
     417,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   434,    -1,    -1,
      -1,    -1,   179,    -1,    -1,    -1,  1360,  1361,  1362,  5834,
    1364,    -1,    -1,  3564,  3565,    -1,    -1,  5647,   455,    -1,
      -1,    -1,  5652,  5653,    -1,    -1,    -1,    -1,    -1,   206,
     467,  1385,    -1,    -1,  3585,    -1,   473,  3588,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,   244,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,   515,    -1,
     517,   518,   519,   520,   521,    -1,    -1,    -1,    35,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    45,    -1,
     537,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3669,  3670,
    3671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5020,    78,    -1,   310,  1488,    -1,  5766,    -1,  1492,  1493,
      -1,    -1,    -1,  3694,    -1,  5035,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
     337,    -1,  3713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,   348,    35,    -1,   351,    38,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,  3735,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   379,    -1,  5834,   382,    -1,    -1,    -1,   386,
      -1,    -1,   389,    -1,    -1,    78,    -1,    -1,    -1,   396,
      -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     177,    -1,    -1,    -1,    -1,    -1,  5126,    -1,    -1,    -1,
      -1,    -1,   419,    -1,    -1,    -1,    -1,    -1,    -1,   196,
     427,    -1,    -1,    -1,   201,    -1,    -1,   434,    -1,    -1,
     437,    -1,    -1,    -1,    -1,   442,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   450,  3825,   452,    -1,   224,   225,    -1,
     457,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,   484,    -1,    -1,
      -1,    -1,    -1,    -1,  2679,    -1,    -1,    -1,    -1,    -1,
      -1,  3872,    -1,    -1,    -1,    -1,    -1,  3878,    -1,  3880,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    -1,  3893,    -1,  3895,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,   664,    -1,    -1,    -1,    -1,    -1,   670,
      -1,   224,   225,   310,    -1,    -1,   313,    -1,  2733,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1735,  1736,  1737,    -1,    -1,  2751,    -1,    -1,   252,
    2755,    -1,    -1,    -1,  2759,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2768,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3962,    -1,    -1,    -1,    -1,    -1,    -1,  2783,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   295,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,   310,    -1,    -1,
     313,    -1,  2817,  4004,    -1,    -1,    -1,    -1,    35,  5349,
     407,  5351,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,  2837,  2838,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,  4033,    -1,    -1,    -1,  4037,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,  4058,    -1,  2874,
    2875,    -1,    -1,  2878,    -1,    -1,    -1,    -1,    -1,  6344,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   845,    -1,    -1,  2902,    -1,  2904,
      -1,    -1,    -1,  2908,   407,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   864,    -1,    -1,    -1,  2922,    -1,    -1,
      -1,    -1,    -1,    -1,  2929,    -1,   513,  2932,    -1,    -1,
      -1,    -1,    -1,  2938,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2958,    -1,    -1,    -1,  5487,    -1,  2964,
      -1,    -1,    -1,    -1,    -1,    -1,  2971,    -1,    -1,    -1,
      -1,    -1,    -1,  6043,    -1,  4166,    -1,    -1,    -1,   196,
    2985,    -1,    -1,    -1,   201,   936,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2999,    -1,    -1,    -1,    -1,  3004,
      -1,    -1,    -1,    -1,    -1,  3010,    -1,   224,   225,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
      -1,    -1,   983,    -1,    -1,   252,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3070,    -1,    -1,    -1,    -1,
      -1,    23,  2066,    -1,  6344,    -1,    28,    -1,   295,    -1,
      -1,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,    -1,    -1,   310,    -1,  2089,   313,  2091,    -1,  2093,
      -1,    -1,  2096,  2097,  2098,    -1,    -1,    -1,    -1,    -1,
    2104,    -1,    -1,  2107,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,  2122,  2123,
    2124,    -1,    -1,    -1,    -1,  4326,    -1,    -1,    -1,  5669,
      -1,  5671,    -1,    -1,    96,    -1,  2140,  1098,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1127,  1128,  1129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,
     407,    -1,    -1,    -1,    -1,    -1,    -1,  4388,    -1,   151,
      -1,    -1,  4393,    -1,  4395,    -1,    -1,    10,   160,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,   173,  3227,    -1,  3229,    -1,   443,   179,    -1,    -1,
    4421,    -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,
      -1,  3246,    45,    -1,    -1,    -1,    -1,    -1,  3253,    52,
      -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,  4467,    -1,    -1,  4470,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1238,    -1,    -1,
      -1,    -1,    -1,  2287,    -1,    -1,   513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   266,    -1,    -1,    -1,    -1,    -1,
    1271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3350,    -1,  2341,    -1,    -1,
      -1,  3356,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4560,
    4561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   196,    -1,   347,   348,  4588,   201,   351,
      -1,    -1,    -1,  2397,    -1,    -1,    -1,  5937,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,   379,    -1,    -1,
     382,    -1,    -1,    -1,    -1,    -1,  3441,   389,    -1,    -1,
      -1,    -1,    -1,    -1,   396,    -1,    -1,   399,    -1,   252,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,    -1,    -1,
      -1,    -1,    -1,  1424,    -1,   427,    -1,    -1,    -1,    -1,
      -1,    -1,   434,    -1,    -1,   437,    -1,    -1,    -1,    -1,
     442,    -1,   295,  4684,    -1,    -1,  4687,    -1,   450,    -1,
      -1,    -1,    -1,    -1,    -1,   457,    -1,   310,    -1,    -1,
     313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6072,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,  1504,    -1,    -1,    -1,    -1,    -1,  3564,
    3565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,  1377,
    3585,    -1,    -1,  3588,    -1,    52,    -1,  2581,  2582,  2583,
    2584,  2585,  2586,  2587,  2588,  2589,    -1,  2591,    -1,    -1,
      -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,  2602,    -1,
    2604,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1432,    -1,    -1,  1588,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1597,    -1,  2642,    -1,
      -1,    -1,  2646,    -1,    -1,  2649,    -1,  2651,    -1,    -1,
    2654,    -1,    -1,    -1,  3669,  3670,  3671,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6205,    -1,    -1,  1629,    -1,
      -1,    -1,    -1,    -1,  1635,  1636,    -1,    -1,  1639,  3694,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1652,    -1,    -1,  1655,    -1,  6236,  6237,  3713,    -1,
     513,    -1,    -1,  2707,  2708,  4906,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,   196,
    3735,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,  1710,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4963,  1724,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,  4975,   252,    -1,    10,    -1,    -1,
      13,    -1,  2786,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,  5009,    -1,
    3825,    -1,    45,    -1,    -1,    -1,    -1,    -1,   295,    52,
    6360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   330,    -1,    -1,    -1,  3872,    -1,    -1,
      -1,    -1,    -1,  3878,    -1,  3880,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1834,    -1,    -1,    -1,    -1,  3893,    -1,
    3895,    -1,    -1,    -1,  1845,    -1,  5087,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5106,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,  1887,  1888,    -1,    -1,
     407,    -1,    -1,  1741,    -1,    -1,    -1,  1745,   171,    -1,
      -1,    -1,    -1,   224,   225,    -1,    -1,  3962,    -1,    -1,
      -1,  1912,    -1,    -1,    -1,    -1,    -1,    -1,  1919,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    10,
      -1,   252,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4004,
      -1,   224,   225,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5203,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,   295,    -1,    -1,    -1,  4033,   252,
      -1,    -1,  4037,    -1,  3028,  3029,  3030,    -1,    -1,   310,
    3034,  1992,   313,    -1,  1995,    -1,   513,    78,    -1,    -1,
      -1,    -1,    -1,  4058,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,    -1,  3061,    -1,    -1,
      -1,    -1,   295,    -1,    -1,    -1,  2027,  2028,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,
     313,    -1,    -1,  2044,    -1,    -1,  2047,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5323,    -1,  5325,    -1,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,  4166,    17,    18,    19,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,  5373,    -1,   407,    -1,    -1,    -1,    -1,    -1,
      45,    -1,  5383,   224,   225,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5423,    -1,    -1,    -1,    -1,  5428,    -1,    -1,
      -1,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,    -1,    -1,    -1,   295,    -1,  2064,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3272,   310,
      -1,    -1,   313,  3277,    -1,    -1,    -1,    -1,    -1,    -1,
     513,    -1,  2090,    -1,    -1,   150,  2094,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
      -1,  2109,  2110,  2111,    -1,  2113,    -1,    -1,    -1,    -1,
      -1,  4326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3328,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,  3339,   201,  3341,  3342,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3355,    -1,    -1,  3358,    -1,  3360,    -1,    -1,   224,
     225,    -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,
      -1,    -1,    -1,  4388,    -1,    -1,    -1,    -1,  4393,    -1,
    4395,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,
      -1,    -1,    -1,  3397,    -1,  3399,    -1,  3401,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,  4421,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,   310,    -1,    -1,   313,    -1,
      -1,    -1,  4467,    -1,    -1,  4470,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5665,    -1,    -1,    -1,    -1,    78,
      -1,    -1,   513,    -1,    -1,    -1,    -1,    -1,  5679,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,  3495,    -1,    -1,    -1,    -1,  3500,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5710,
      -1,  3515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,   407,    -1,    -1,  4560,  4561,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    -1,    -1,  4571,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,  3570,    -1,    10,    52,
      -1,    13,    -1,  4588,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,   201,    35,  5795,    78,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3630,    -1,    -1,    -1,
    5831,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
    2601,    -1,    -1,   252,    -1,    -1,    -1,    -1,   513,    -1,
    2611,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,  4684,
      -1,    -1,  4687,    -1,    -1,    -1,    -1,    -1,    -1,  2640,
      -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,   171,    -1,
      -1,    -1,    -1,    -1,  5895,    -1,    -1,  5898,    -1,    -1,
      -1,   310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2687,  2688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,
    2721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
    2598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     252,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3830,   310,    -1,    -1,
     313,    -1,  3836,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6043,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   295,    -1,    -1,  6057,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,  6070,
      -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,   487,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2694,    -1,    -1,    -1,
      -1,  4906,    -1,    -1,    -1,  2856,    -1,    -1,  2706,    -1,
      -1,    -1,    -1,  2711,   513,    -1,    -1,    -1,    -1,    -1,
    2871,  3915,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,    -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,
    6131,  6132,  2893,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,  4963,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4975,    35,    -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5009,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
    6211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2979,  2980,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4074,   513,  5087,    -1,    -1,    -1,    -1,    -1,    -1,  4083,
     522,   523,   524,   525,   526,   527,   528,   529,   530,    -1,
      -1,  5106,    -1,  4097,    -1,    -1,    -1,  4101,  4102,  4103,
      -1,    -1,    -1,    -1,  4108,    -1,    -1,  4111,    -1,    -1,
    4114,    -1,    -1,    -1,    -1,    -1,  4120,    -1,  4122,    -1,
    3081,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4149,  4150,  4151,    -1,    -1,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,  6370,
      -1,    -1,  4176,    -1,    -1,  4179,    -1,  4181,   252,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5203,    -1,
      -1,    -1,    -1,  4197,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4205,  4206,    -1,    -1,    -1,    -1,    -1,  4212,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,  6429,    -1,
      -1,    -1,    41,    -1,    -1,    -1,   310,  4241,    -1,   313,
      -1,  6442,  6443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6454,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,  4292,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,  5323,    -1,
    5325,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,  5373,    -1,
      -1,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   266,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3427,  3275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3292,    -1,    -1,  3448,    -1,    -1,
      -1,    -1,    -1,    -1,  3302,    -1,    -1,    -1,    -1,    -1,
    3308,   310,    -1,  3311,   313,    -1,    -1,    -1,    -1,    -1,
    3318,  3319,    -1,  3321,    -1,    -1,    -1,    -1,  3326,  3327,
      -1,  3329,    -1,  3331,    -1,    -1,    -1,  3335,   337,    -1,
    3338,    -1,    -1,    -1,    -1,  3343,    -1,    -1,    -1,    -1,
      -1,    -1,   351,    -1,  3352,    -1,    -1,    -1,    -1,  3357,
     359,    -1,    -1,    -1,    -1,    -1,  3364,  3365,  3366,  3367,
      -1,    -1,    -1,    -1,  3372,  3373,    -1,  3375,    -1,    -1,
     379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     389,    -1,    -1,    -1,    -1,    -1,  3394,   396,  3396,    -1,
     399,    -1,    -1,    -1,    -1,  3403,  3404,  3405,  3406,  3407,
    3408,  3409,  3410,  3411,  3412,    -1,    -1,    -1,    -1,    -1,
     419,    -1,    -1,  4617,  4618,    -1,    -1,    -1,   427,    -1,
      -1,    -1,    -1,    -1,  4628,   434,    -1,    -1,   437,    -1,
     439,    -1,   441,   442,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3449,    -1,    -1,    -1,    -1,    -1,    -1,   457,    -1,
    5665,    -1,    -1,    -1,    -1,    -1,   465,    -1,    -1,   468,
      -1,    -1,   471,    -1,  5679,    -1,    -1,  4671,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5710,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4713,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4729,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4747,    -1,    -1,    -1,    -1,    -1,    -1,
    3711,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3579,    -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,
    5795,    -1,  4786,  4787,    -1,    31,    -1,    33,    34,  4793,
    4794,    -1,    -1,    -1,  4798,    -1,    -1,    -1,    -1,  4803,
      -1,    -1,  4806,  4807,    -1,    -1,    -1,    -1,    -1,  4813,
      -1,    -1,    -1,    -1,    -1,    61,  5831,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    99,  4858,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4869,    -1,  4871,    -1,    -1,
     116,    -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,
    5895,    -1,    -1,  5898,    -1,    -1,    -1,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,
      -1,   147,    -1,    -1,    -1,    -1,    -1,  4911,    -1,    -1,
     156,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,
      -1,    -1,    -1,  3884,  3885,  3886,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,
    3901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3934,  3935,    -1,    -1,    -1,  3939,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4991,    -1,    -1,
      -1,    -1,    -1,    -1,  4998,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,   255,
      -1,    -1,    -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3834,  3835,  6043,   275,
      -1,  3839,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,    -1,
      -1,    -1,    -1,    -1,    -1,  6070,    -1,    -1,    -1,    -1,
    3868,    -1,  5066,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,    -1,
      -1,    -1,    -1,    -1,  4055,    -1,   342,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   357,    -1,    -1,    -1,    -1,    -1,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,   371,    -1,    -1,   374,    -1,
      -1,   377,    -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,
      -1,   387,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
      -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,    -1,    -1,
     406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6211,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   455,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   467,    -1,    -1,    -1,  5229,    -1,   473,    -1,    -1,
      -1,    -1,   478,    -1,    -1,  5239,    -1,    -1,    -1,    -1,
      -1,  5245,  5246,  5247,    -1,   491,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4221,  4222,  4223,    -1,    -1,  4073,  5270,  5271,    -1,   515,
    5274,  4079,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5291,   534,    -1,
      -1,   537,    -1,    -1,    -1,    -1,    -1,  5301,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5312,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4126,  4127,
      -1,    -1,  4130,  4131,  4132,  4133,    -1,    -1,  4136,  4137,
    4138,  4139,  4140,  4141,  4142,  4143,  4144,  4145,  4146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6370,    -1,    -1,    -1,    -1,
      -1,  4169,    -1,    -1,  4172,    -1,  4174,    -1,    -1,  4177,
    4178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4199,  4200,  4201,  4202,    -1,  4204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6454,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5520,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5533,
      -1,    -1,    -1,    -1,    -1,    -1,  4344,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5554,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4541,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5599,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4573,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5641,    -1,    -1,
      -1,    -1,    -1,    -1,  4605,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5657,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4640,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5699,  4657,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4534,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4577,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5794,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5806,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5815,  5816,  5817,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5843,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5851,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4817,  4818,  4819,  4820,
      -1,    -1,    -1,    -1,    -1,    -1,  5870,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4714,    -1,    -1,    -1,
    4718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4731,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4739,    -1,  4741,    -1,  4743,  4744,    -1,    -1,    -1,
      -1,  4749,  4750,  4751,  4752,    -1,    -1,    -1,  4756,  4757,
    4758,  4759,  4760,  4761,  4762,  4763,  4764,  4765,  4766,  4767,
    4768,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4792,    -1,    -1,  4795,    -1,  4797,
      -1,    -1,    -1,  4801,    -1,    -1,  4804,  4805,    -1,    -1,
    4808,  4809,    -1,    -1,  6008,    -1,  4814,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6033,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4868,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6137,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5165,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5069,    -1,  6267,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5156,  5157,
      -1,    -1,    -1,    -1,    -1,    -1,  5164,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6408,    -1,    -1,    -1,    -1,    -1,
    5218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5241,  5242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5260,    -1,  5262,    -1,    -1,    -1,  5266,  5267,
    5268,  5269,    -1,    -1,  5272,  5273,    -1,    -1,    -1,    -1,
    5278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5445,    -1,    -1,  5295,    -1,  5450,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5313,    -1,    -1,  5469,    -1,
      -1,    -1,  5320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5345,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5394,    -1,  5396,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5431,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5634,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5547,
      -1,  5549,  5550,  5551,  5552,  5553,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5566,  5567,
    5568,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5576,    -1,
      -1,  5732,    -1,  5581,    -1,    -1,  5584,    -1,    -1,    -1,
    5588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5606,    -1,
    5761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5791,    -1,    -1,    -1,    -1,  5796,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5807,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5828,    -1,  5830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5869,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5881,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5918,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6004,    -1,    -1,    -1,
      -1,    -1,    -1,  6011,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6040,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6055,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6171,  6172,    -1,    -1,  6175,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6277,
    6278,    -1,  6280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,  6346,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,   527,    -1,
      -1,    -1,    -1,    -1,    -1,   534,   535,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   513,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,   535,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   525,   526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   534,   535,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   534,   535,     3,    -1,     5,     6,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,   525,   526,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,   535,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   535,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    -1,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,    -1,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
      -1,    -1,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,    -1,   291,    -1,   293,   294,
     295,   296,    -1,    -1,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,    -1,   339,    -1,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,    -1,   479,   480,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
     535,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,    -1,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
      -1,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,    -1,   291,    -1,   293,   294,   295,   296,    -1,    -1,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,    -1,
     339,    -1,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,    -1,
     429,    -1,   431,   432,    -1,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,    -1,   452,    -1,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,    -1,
     479,   480,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,    -1,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
     509,   510,   511,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,   535,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
     513,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,     5,
       6,   534,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   513,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,   177,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,   247,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,
      -1,     3,    -1,     5,     6,   534,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,
       5,     6,   534,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    36,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,   513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,
      -1,    -1,    -1,    -1,   532,   533,   534,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,   527,    -1,    -1,     3,    -1,     5,     6,   534,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,
      -1,     3,    -1,     5,     6,   534,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,
       5,     6,   534,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,   513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,
      -1,    -1,     3,    -1,     5,     6,   534,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,   447,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,
      -1,     5,     6,   534,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,
     534,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,
      -1,    -1,    -1,     3,    -1,     5,     6,   534,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,
       3,    -1,     5,     6,   534,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,     5,
       6,   534,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,
      -1,     3,    -1,     5,     6,   534,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,
       5,     6,   534,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,   513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,
      -1,    -1,     3,    -1,     5,     6,   534,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,
      -1,     5,     6,   534,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,    -1,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,
     534,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,
       3,    -1,     5,     6,    -1,     8,     9,   534,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   525,   526,     3,    -1,     5,     6,    -1,     8,
       9,   534,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,     5,     6,    -1,     8,     9,    -1,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,
       9,    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,   515,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,   525,   526,   527,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,   515,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,   434,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,   515,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
     434,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     534,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
     534,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    -1,    -1,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
      -1,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,    -1,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,    -1,   489,    -1,    -1,    -1,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,    -1,   510,   511,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,     3,    -1,     5,     6,    -1,
      -1,    -1,    10,    11,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,    -1,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,   527,
     528,   529,   530,     3,    -1,     5,     6,    -1,    -1,    -1,
      10,    11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,
     510,   511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,   527,
     528,   529,   530,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   527,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   527,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   527,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   527,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     527,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,    -1,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,    -1,   250,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,    -1,   291,    -1,   293,   294,   295,   296,    -1,
      -1,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
      -1,   339,    -1,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,    -1,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,    -1,   452,    -1,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,   527,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,    -1,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,    -1,
     250,   251,   252,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
      -1,   291,    -1,   293,   294,   295,   296,    -1,    -1,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,    -1,   339,
      -1,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
      -1,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,    -1,   452,    -1,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,    -1,   479,
     480,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,
     510,   511,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,   527,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      -1,    -1,    -1,   525,   526,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    -1,   525,   526,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,   525,   526,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,   177,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,     5,     6,    -1,     8,     9,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,   106,   107,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
     106,   107,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,   106,
     107,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,   106,   107,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,   106,   107,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      -1,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,   252,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,   183,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    99,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,   309,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,   434,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,   434,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,   434,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,   309,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,   434,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,    -1,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,   480,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,    -1,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    -1,    54,    -1,
      -1,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,    -1,    -1,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,    -1,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,    -1,    -1,    -1,    -1,    -1,   223,   224,   225,
     226,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,    -1,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,    -1,
      -1,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,    -1,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    97,    99,   116,   119,   134,   136,   140,   147,
     156,   158,   165,   183,   200,   254,   255,   260,   275,   294,
     333,   342,   357,   363,   364,   366,   371,   377,   380,   387,
     394,   395,   402,   406,   417,   434,   455,   467,   473,   478,
     491,   515,   517,   518,   519,   520,   521,   534,   541,   542,
     543,   544,   549,   550,   556,   557,   559,   560,   561,   562,
     564,   567,   579,   584,   585,   588,   589,   590,   610,   613,
     614,   629,   680,   683,   684,   687,   690,   691,   692,   700,
     707,   709,   710,   713,   716,   717,   721,   730,   734,   735,
     736,   739,   741,   742,   743,   744,   752,   754,   774,   778,
     780,   781,   791,   793,   800,   801,   804,   805,   806,   807,
     808,   817,   819,   821,   824,   828,   829,   839,   840,   845,
     850,   861,   893,   896,   897,   898,   903,   906,   908,   910,
     912,   913,   917,   918,   921,   923,   924,   928,   929,   930,
     933,   934,   935,   936,   937,   944,   946,   947,   948,   949,
     955,   957,   958,   964,   965,   966,   969,   970,   971,   972,
     974,   975,   977,   978,   980,   981,   983,   995,   997,  1000,
    1002,  1004,  1013,  1015,  1021,  1026,  1036,  1040,  1041,  1042,
    1043,  1044,  1045,  1051,  1087,   449,   494,   950,    28,    79,
      96,   114,   120,   138,   151,   160,   173,   179,   186,   206,
     244,   266,   310,   337,   347,   348,   351,   379,   382,   386,
     389,   396,   399,   419,   427,   432,   434,   437,   442,   452,
     457,   471,   484,   706,   950,     3,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    30,    31,    32,    40,    41,
      42,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    58,    59,    60,    61,    62,    63,
      64,    67,    68,    69,    70,    71,    73,    74,    75,    76,
      77,    79,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    93,    94,    95,    96,    97,    98,   100,
     101,   102,   103,   107,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   121,   123,   124,   125,   126,   127,   128,
     129,   131,   132,   133,   134,   137,   138,   139,   140,   141,
     143,   144,   145,   146,   148,   149,   150,   151,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   164,   166,
     167,   168,   169,   170,   172,   174,   175,   176,   178,   179,
     180,   181,   182,   184,   185,   187,   188,   189,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   202,   203,
     204,   205,   206,   207,   208,   209,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   221,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   248,
     249,   250,   251,   252,   254,   255,   256,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     293,   294,   295,   296,   298,   299,   300,   301,   302,   303,
     305,   306,   307,   310,   311,   312,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   396,   397,   398,   399,   400,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   431,   432,   435,   436,   437,   438,   439,
     440,   441,   442,   444,   445,   446,   449,   450,   451,   452,
     453,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     466,   467,   468,   469,   470,   473,   474,   475,   476,   477,
     478,   479,   481,   482,   483,   484,   485,   486,   489,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,  1155,
    1248,  1260,  1261,  1265,  1266,  1267,     3,    29,  1037,  1245,
    1260,  1265,   482,   534,   988,   308,   343,   950,    54,   534,
     621,    23,    41,    66,    79,   114,   120,   138,   151,   160,
     173,   182,   186,   256,   310,   313,   337,   351,   379,   389,
     399,   419,   427,   437,   439,   441,   442,   457,   465,   468,
     471,   630,   689,   796,   851,   862,    29,   342,  1245,  1037,
      29,   336,   397,   439,   441,     6,   243,   904,   905,  1251,
      23,    28,    66,    79,    96,   114,   138,   151,   160,   173,
     179,   186,   206,   266,   310,   323,   337,   348,   351,   379,
     382,   386,   389,   396,   399,   419,   427,   434,   437,   442,
     450,   452,   457,   471,   484,   706,   809,   811,   812,   950,
    1245,    99,   482,   534,   684,   687,   690,   983,   996,  1000,
    1003,  1013,  1020,  1026,  1036,  1040,  1051,    11,    22,    29,
      49,   168,   175,   177,   201,   245,   283,   345,   365,   525,
     526,   825,   826,  1037,  1250,  1252,    29,    31,    99,   361,
     395,   830,   831,   832,  1260,   173,  1260,  1247,  1251,   434,
    1054,   825,  1260,   371,   402,   406,   449,  1245,   323,   266,
     534,   916,   387,  1260,    29,   400,   445,   449,   571,   580,
     581,  1260,   183,   830,   831,  1260,   343,   950,  1260,   242,
      29,   135,  1056,  1057,    67,    93,   256,   277,   379,   389,
     400,   445,   449,   497,   568,   569,   570,   571,    29,   400,
     445,   449,   571,   449,   309,  1099,  1100,  1243,  1260,  1054,
     527,  1260,   178,   534,   989,   534,   359,  1046,  1047,  1245,
    1046,     3,    53,    55,    56,    69,    70,   117,   118,   139,
     169,   218,   219,   221,   228,   278,   280,   300,   356,   404,
     410,   445,   446,   479,  1128,  1130,  1132,  1134,  1136,  1138,
    1139,  1140,  1142,  1143,  1144,  1146,  1147,  1151,  1261,  1265,
    1056,  1057,  1058,  1256,    12,  1257,  1258,  1260,  1257,  1257,
    1041,  1042,  1045,     0,   537,   534,   988,   152,   220,   314,
     464,  1059,  1060,  1041,  1043,  1044,   125,   216,   268,   470,
     538,    35,   954,   878,  1248,   814,  1260,   814,  1245,   346,
     814,   452,  1245,   113,   434,   866,  1248,  1260,  1267,     3,
     106,   110,   401,  1253,  1254,  1262,  1265,  1266,  1267,    29,
     195,  1243,   301,   484,    10,    17,    18,    19,    74,   164,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   900,
     902,  1186,  1187,  1260,   195,  1245,   866,  1245,    29,  1253,
    1254,   866,  1245,  1245,   195,  1243,  1245,   195,   814,  1245,
     371,   402,    29,   195,  1099,  1245,   392,  1245,   814,    29,
     263,  1253,  1254,   195,  1243,   243,   122,   226,   292,   355,
     951,   952,   953,   534,   532,   536,  1212,  1214,   512,   982,
     983,   984,   985,  1262,  1243,  1245,  1260,    28,    66,    80,
      92,   114,   138,   179,   206,   244,   310,   348,   379,   382,
     427,   437,   450,   457,   809,   810,   811,   812,  1251,   954,
     999,  1003,  1013,  1020,  1026,  1040,  1243,   270,   814,   534,
     195,   814,  1245,   814,   452,   195,  1245,   113,   434,   439,
     441,  1253,  1254,   439,   441,    74,   164,   900,   369,  1245,
    1245,  1253,   195,   545,  1260,   195,  1245,   195,   546,   814,
    1245,  1245,   392,   814,   263,  1253,   359,   396,   434,   484,
     266,    96,   206,    28,    92,   179,   348,   386,   450,   452,
     456,   701,    29,  1245,  1038,   578,  1251,  1262,   905,   270,
     195,   878,   879,   195,   909,   195,  1245,   195,   816,  1128,
     452,   113,   434,   195,   865,   866,   195,  1254,  1255,    87,
     484,    74,   164,   195,   901,   902,    59,   195,   865,   195,
    1255,   195,   865,   195,  1245,   195,  1245,   392,   909,   195,
     816,   195,   263,  1255,   243,   195,   813,   814,   195,  1244,
    1245,   195,  1245,   954,   534,  1001,   630,   996,   478,   982,
     988,   216,   470,  1252,   826,   827,    29,   827,  1252,   827,
      29,   827,  1252,   827,   827,   827,  1252,  1250,  1250,  1037,
     827,   346,   534,   432,   534,   657,   657,   657,   308,   447,
     538,   657,   389,  1099,  1101,   538,   945,   581,   569,   571,
      29,   571,  1251,   534,   998,    59,   484,   982,   114,   206,
     389,   432,   434,   914,   915,  1260,    48,   511,   226,   536,
     311,   308,   177,   311,  1251,   447,   954,   171,   822,   308,
       5,     8,     9,    10,    12,    37,    53,    55,    56,    65,
      66,    69,    70,    77,    79,   104,   105,   106,   107,   108,
     109,   110,   117,   118,   120,   157,   162,   163,   169,   185,
     187,   218,   219,   221,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   238,   249,   257,   258,   269,   278,   280,
     290,   292,   297,   298,   300,   310,   321,   338,   356,   384,
     401,   410,   428,   433,   445,   446,   451,   453,   454,   465,
     471,   479,   499,   500,   501,   502,   504,   505,   506,   507,
     513,   525,   526,   527,   534,  1041,  1131,  1134,  1137,  1138,
    1139,  1141,  1142,  1143,  1146,  1147,  1151,  1152,  1154,  1155,
    1156,  1158,  1182,  1183,  1184,  1188,  1206,  1211,  1237,  1240,
    1241,  1248,  1249,  1250,  1251,  1260,  1239,  1240,  1251,    29,
     586,  1242,  1243,   400,   568,   120,   577,  1251,   578,  1251,
      48,    71,   568,   511,   411,   952,   311,   177,   447,   524,
      48,   511,   226,   953,   534,  1243,   527,  1214,  1101,   982,
     176,   990,  1152,  1191,  1046,   538,   534,   991,   481,  1145,
    1145,  1145,   534,  1133,  1133,   340,   534,  1135,    69,    70,
    1145,  1133,  1130,   515,   516,   534,  1148,   534,  1148,    37,
    1129,   534,   115,   193,   271,   274,   393,   509,   534,  1149,
    1150,   536,   815,  1133,  1239,  1215,   535,   535,   543,   982,
     992,   993,   994,  1243,    29,   135,  1055,  1055,    59,  1055,
     165,   171,   253,   304,  1063,  1065,  1066,  1081,  1083,  1084,
    1085,  1059,  1060,   177,   222,   222,  1099,  1102,   534,    68,
     288,   324,   367,   402,   534,   876,   324,   363,   367,   402,
     815,   324,   367,   402,     3,    91,   145,   259,   324,   333,
     363,   367,   402,   437,   440,   491,   579,   582,   959,   960,
     961,   962,   846,    25,   140,   324,   367,   402,   475,   595,
    1245,    25,   140,   402,   470,   563,   495,   195,  1099,    62,
      98,   161,   198,   248,   288,   292,   324,   325,   367,   376,
     385,   394,   402,   415,   424,   429,   486,   579,   583,   882,
     894,   922,   534,   863,  1214,   367,   563,   201,   157,    25,
      31,    46,    76,   133,   140,   144,   172,   208,   288,   292,
     302,   312,   324,   367,   370,   371,   402,   475,   591,   593,
     594,   724,   922,     5,   525,   526,   698,  1252,    29,   195,
    1243,   814,   814,   534,   899,   324,   402,   536,   157,   308,
     324,   367,   402,   894,   922,    25,   140,   324,   367,   402,
     201,   558,   367,   491,   515,   551,   558,   324,   367,   402,
     894,   922,   308,   324,   367,   157,    38,    60,   112,   204,
     267,   272,   288,   323,   367,   372,   396,   402,   417,   591,
     695,   696,   324,   367,   483,   724,   732,   157,   324,   367,
     402,    25,    91,   133,   140,   144,   324,   363,   367,   402,
     409,   581,   569,   201,   157,    46,   131,   288,   367,   402,
     591,   592,   324,   367,   371,   402,    89,   132,   327,   440,
     308,    25,    31,   140,   324,   367,   402,   611,   612,   558,
     171,   367,   551,   558,   157,   367,   402,   591,  1245,   251,
     122,   309,   496,   538,   951,    29,   135,   480,   527,   535,
     871,  1152,  1192,  1193,  1261,  1152,  1213,     3,    29,    33,
      34,    35,    36,    37,    38,    39,    43,    57,    65,    66,
      72,    78,    80,    92,    99,   104,   105,   106,   108,   109,
     110,   120,   122,   130,   135,   136,   142,   147,   152,   163,
     165,   171,   173,   177,   183,   186,   190,   201,   210,   220,
     222,   246,   247,   253,   257,   258,   292,   297,   304,   308,
     309,   313,   314,   334,   344,   361,   375,   395,   401,   412,
     430,   433,   434,   443,   447,   448,   454,   464,   465,   471,
     472,   480,   487,   488,   490,   491,   527,  1246,  1263,  1265,
    1266,  1267,  1268,  1212,   535,   538,   163,   308,   454,   575,
     578,   698,   986,   472,   979,   308,   878,   534,   814,  1245,
    1128,   866,   301,    74,   164,   902,   866,   866,   171,  1128,
     814,  1245,  1245,   535,   657,  1245,    72,  1128,   292,   177,
     534,   782,   551,    38,   973,  1245,   292,   551,   495,   195,
    1243,   551,   814,   814,   782,   468,   630,   308,   171,   491,
     890,   551,   292,    48,   565,   292,   457,   731,   292,   991,
      91,   324,   708,    89,   132,   327,   440,    38,   782,   171,
     195,   551,   484,   195,  1243,   195,   685,  1243,  1243,   484,
     814,    87,   547,  1248,   452,  1248,  1248,  1245,   171,  1245,
     706,    40,    54,   111,   215,   288,   391,   157,    63,   373,
     538,   548,   157,   534,   157,   551,   157,   538,   548,   495,
     157,   538,   548,   157,   538,   195,   813,   195,   814,   195,
     814,   157,   538,   548,  1255,   157,   548,   157,   157,   548,
     157,   548,   157,    89,   132,   327,   440,   171,   157,   548,
     157,   171,   195,   157,   538,   548,   157,   538,   548,   157,
     308,  1191,   434,   535,   996,   222,  1102,   827,  1037,   827,
    1037,   827,  1037,   827,  1037,   827,  1037,  1037,  1037,   827,
    1037,   534,   658,   659,  1260,   658,    29,   114,   138,   173,
     179,   243,   244,   326,   348,   382,   389,   396,   434,   437,
     457,   835,  1242,  1255,   832,  1245,   201,   538,  1016,  1251,
    1128,  1195,    38,  1255,   547,   535,   547,   547,   547,   251,
    1260,   171,   835,  1255,   171,   387,  1260,   578,   308,   534,
    1215,   532,  1041,  1196,  1152,  1210,   534,   534,   171,   534,
     534,  1041,   534,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   534,   534,   534,   534,
    1152,   534,   534,   534,   534,   534,   534,   534,   534,   299,
     646,   534,   534,   534,   534,   534,   534,   534,   534,  1152,
    1152,  1152,  1041,  1152,  1191,  1214,  1251,   534,  1251,     3,
      10,    13,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   167,   168,   169,   170,   172,   173,
     174,   175,   176,   178,   179,   180,   181,   182,   184,   185,
     187,   188,   189,   191,   192,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   221,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   272,
     273,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     305,   306,   307,   309,   310,   311,   312,   313,   315,   316,
     317,   318,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   334,   335,   336,   337,   338,   339,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   482,   483,   484,   485,
     486,   487,   489,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   510,   511,
     513,   522,   523,   524,   525,   526,   527,   528,   529,   530,
    1186,  1188,  1190,  1264,  1269,   492,  1169,   320,  1152,   166,
    1170,   222,   538,  1052,   534,  1251,  1214,  1052,   123,   197,
     587,   538,    71,   120,   578,    38,     3,   120,   256,   576,
     698,  1147,  1251,  1251,    94,   137,  1164,   103,   120,   572,
     573,   575,   698,   120,   572,   251,  1243,    95,   372,   818,
     535,   988,    35,    45,    52,    78,   196,   201,   224,   252,
     310,   313,   407,   535,   538,  1047,  1244,    38,   534,  1191,
    1250,  1145,  1145,    37,  1129,   445,   445,  1250,  1250,   532,
     532,  1250,   447,   447,   447,   534,   447,  1250,  1246,   536,
    1133,   177,  1088,    15,   524,  1212,  1259,   535,   538,   991,
    1043,  1043,  1061,  1062,  1152,  1043,   168,   283,  1072,   240,
     288,   355,   405,   470,    29,  1067,  1152,   525,   526,  1068,
    1069,  1152,  1154,  1081,  1082,  1066,  1065,  1063,  1064,   171,
    1084,   302,  1086,  1063,  1081,  1102,  1005,  1243,  1102,    38,
    1260,  1191,    68,   447,   447,   389,   201,   213,   314,   317,
     404,   480,   527,   869,   870,   871,   873,   875,   877,  1128,
    1261,   447,   483,   447,   389,   447,   447,   389,   253,   447,
      79,   447,   437,   568,   324,   959,   961,   524,   963,   171,
     183,   201,   377,   847,   848,    72,    92,   292,   654,   655,
      92,   120,   292,   447,    92,   447,   120,   292,   389,    92,
     133,   144,   324,   367,   779,   389,   714,    28,    66,   138,
     179,   310,   348,   382,   450,   457,   809,   810,  1245,   157,
     367,   402,   591,   308,   698,   394,   248,   447,  1260,   447,
     297,   698,   124,   223,   389,   400,   449,   570,   814,   373,
     402,   882,   895,   128,   535,   864,   869,   447,   471,   437,
    1243,    72,    80,    92,   153,   173,   195,   344,   465,   637,
     652,   653,  1260,    80,    92,   919,   329,   308,   384,   386,
     452,    92,   919,    32,   370,   384,   386,   452,   384,  1243,
     172,   208,   302,   814,   534,   447,   447,   194,   534,   599,
      23,   262,   437,   468,   493,   599,    92,   538,   128,     5,
       5,   324,   201,   157,   367,   402,   591,   922,   472,   472,
     289,  1128,   447,   389,   534,   900,  1245,  1243,   447,   447,
     389,   895,   128,   107,   434,   435,   931,   932,  1100,  1243,
    1260,   932,   447,   447,   782,   932,   114,   402,   582,   447,
     553,   582,   447,   447,   389,   895,   128,  1243,   447,   447,
    1243,  1130,   698,    59,   697,   698,   698,   112,   267,   272,
      59,   447,   551,   276,   389,   551,   288,   696,   447,   447,
     297,  1251,   724,   814,   447,   447,   389,   419,   351,  1251,
     351,   447,   351,   447,   351,   782,   782,   437,  1099,   329,
     329,    92,   447,   919,   389,   447,   447,   599,   599,   814,
     814,   814,   814,  1243,    47,   477,    47,    47,   477,   447,
      47,   447,   477,   389,   534,   538,   582,   471,   740,  1254,
     447,   553,   582,  1243,   447,   919,   389,   324,   367,   355,
     368,   398,   574,   951,  1192,  1192,  1193,   535,    15,    16,
     538,  1059,  1060,   533,   539,  1243,   984,  1245,  1243,   224,
    1128,   224,   308,   224,   224,   698,   814,   814,   224,   224,
     224,  1128,   224,   224,   224,   308,   447,   177,   447,   615,
     457,   534,    38,   157,   814,   783,   784,  1263,   959,  1128,
     308,   157,   711,  1245,   292,   329,   534,   552,   796,   472,
     359,   484,  1243,    29,   932,   782,   552,   157,  1254,    99,
     183,   566,   629,   691,   754,   828,   850,   955,   157,  1251,
     732,   733,   157,   308,  1251,  1254,   259,   814,   814,   814,
     814,   148,   354,   534,   740,   292,   552,  1243,   292,   693,
     695,   292,    38,   302,   329,   534,   657,   657,   195,   688,
    1243,   171,   195,   545,  1260,   534,   786,   876,  1245,   534,
     867,   867,    38,  1128,    27,    50,   217,   755,   243,   491,
     493,  1039,   391,   879,   878,  1128,  1245,   534,   816,  1128,
     865,   866,  1255,  1254,   157,   548,   157,   472,   157,   472,
     901,   902,   548,   865,  1255,   865,  1245,  1245,  1128,   816,
    1255,   740,   157,   813,   814,  1244,  1245,  1245,   814,   535,
     195,  1243,   996,  1005,   402,  1037,  1037,  1037,  1037,  1037,
    1037,   658,   535,   538,   535,   180,   349,   383,   397,   435,
    1244,   813,   113,   399,   865,  1244,   301,   833,   834,  1260,
     865,   865,  1244,  1242,  1242,  1244,   813,   447,   184,   491,
     844,   152,   253,   737,   738,    23,   155,   384,   405,  1017,
    1099,   296,  1018,   535,   538,   999,   447,  1243,  1245,  1243,
     545,   830,   831,   177,   844,   831,  1260,    28,    80,   138,
     179,   244,   348,   382,   457,   809,   810,  1191,   533,  1191,
    1196,  1197,   487,  1207,  1208,  1152,  1191,   534,  1250,  1250,
       3,   115,   193,   271,   274,   393,   509,  1198,  1199,  1251,
    1191,  1191,  1152,  1225,   375,  1041,  1042,  1225,  1229,  1236,
    1225,  1225,  1152,  1154,  1192,  1229,  1232,  1233,  1152,  1233,
    1225,  1152,  1225,  1225,  1191,  1250,  1250,   535,  1152,  1152,
     900,  1152,  1192,  1194,  1201,   384,   525,   526,   534,  1153,
    1154,  1188,  1202,   535,  1191,  1152,  1194,  1203,  1152,    57,
     177,   247,   448,  1152,  1191,  1204,   135,   292,  1041,  1191,
     276,  1154,  1152,  1162,  1163,  1164,   276,  1152,  1164,   535,
     538,  1250,  1149,  1128,  1152,  1152,  1152,  1152,  1263,   256,
     445,    43,   430,  1216,   814,  1152,   534,  1041,  1205,   135,
     137,   163,   228,   284,   285,   286,   287,   291,   292,   297,
     454,   466,  1200,  1230,  1152,   534,  1152,   447,    52,   196,
     201,   252,   407,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,    29,    36,   412,  1185,   186,  1170,   384,
     534,  1182,   534,   319,  1174,   182,   256,   434,   439,   441,
     468,  1053,  1243,  1241,  1088,  1192,  1088,  1243,   449,   534,
    1251,   538,   535,   194,   194,   548,   994,   983,   987,  1152,
     535,   266,   292,  1048,  1191,   535,   535,   532,   511,   511,
     535,   535,  1250,   533,  1250,   535,   193,   271,  1150,   271,
    1150,  1150,  1250,   274,   535,  1246,   228,   237,   246,   385,
     508,   534,  1041,  1089,  1090,  1091,  1099,  1105,  1115,  1122,
    1155,  1157,  1158,  1237,  1260,   488,  1110,  1256,   994,   992,
     538,    39,   130,   472,   859,   384,   385,   525,   526,  1069,
    1071,  1154,   405,   240,   309,   538,     5,  1070,  1250,  1070,
     384,   385,  1071,  1242,   296,   409,  1019,  1082,  1064,   472,
    1014,    38,   472,  1260,   535,  1254,  1245,  1245,   317,    59,
    1261,   535,   871,   873,   870,   873,  1261,   314,   535,   538,
     815,  1254,  1245,  1245,  1254,  1245,  1245,  1254,   483,  1245,
    1245,   120,   575,   698,   379,   471,   830,   389,   183,   830,
     534,  1245,   297,   195,  1245,   297,  1254,  1245,  1245,  1152,
     297,  1245,  1245,    32,   370,   447,   447,  1245,   447,   715,
     878,   534,  1128,   866,    74,   164,   902,   866,   866,   171,
    1128,   814,  1245,   189,   288,   324,   367,   476,   718,   719,
     720,  1099,   447,   919,   389,   297,   124,   223,  1254,  1245,
     308,  1245,   308,   535,   538,  1253,  1255,  1245,   367,   591,
     534,   195,   637,  1245,   472,   852,   240,   292,   240,   472,
     646,   679,  1128,  1245,  1250,  1260,  1243,  1245,   251,  1245,
      29,   471,  1245,   195,  1245,   195,  1260,   386,   452,   386,
     452,   251,  1245,    29,   471,  1245,   251,   384,  1243,    25,
     140,   402,   725,   726,   727,   728,  1263,  1254,  1245,   120,
     178,   293,   472,   598,   601,   602,  1263,   270,  1245,    76,
     305,  1245,   594,   308,   447,   437,  1243,   447,   919,   389,
     128,  1245,  1245,   538,   535,   538,  1254,  1245,   925,   926,
    1263,   308,   367,   447,   748,  1254,  1245,  1245,   308,  1099,
     201,   538,   657,   657,  1214,  1254,  1245,  1245,  1253,     3,
      91,   146,   208,   331,   463,   471,   474,   554,  1254,  1245,
    1245,   308,   367,  1254,  1245,   367,   402,   591,   695,   698,
     814,  1245,   698,   814,  1245,   698,  1254,  1245,   402,  1254,
    1245,  1245,   120,   605,  1252,  1244,  1244,  1254,   890,  1245,
    1244,  1245,   367,   402,   591,   592,  1243,  1243,  1245,  1245,
    1245,  1245,  1254,  1245,    25,    31,   140,   324,   367,   402,
     324,   367,   402,   782,   367,   402,   367,   402,   367,   922,
    1114,  1260,   195,   792,  1260,   195,  1260,  1251,  1254,  1245,
    1245,  1251,  1245,   925,    25,   140,   612,   399,  1253,   367,
     402,   591,  1245,  1245,  1245,   447,   447,    85,   462,   355,
     538,  1059,  1059,  1059,  1152,  1152,   480,  1193,   535,  1152,
    1213,   979,   297,   820,  1251,    38,   820,   138,   814,   820,
     820,   224,   472,   472,   820,   820,   820,   243,   820,   820,
     820,   814,   350,   616,   616,   206,   434,   753,  1152,  1128,
     814,   535,   538,   524,   643,  1263,  1245,    63,   177,   389,
     483,   712,   719,   720,   157,   302,   252,   631,   633,   635,
     637,   649,   652,    26,   201,   379,   431,   554,   555,   171,
    1245,   484,  1243,    38,   749,   435,   890,   545,  1260,   565,
     630,   862,  1245,   173,   814,   534,   681,   682,  1157,  1260,
     351,  1251,   782,   782,   782,   782,   534,   782,  1112,  1113,
    1114,   399,   157,   534,   157,   157,   156,  1040,   814,   302,
     631,  1260,   472,   674,   491,   600,   292,    38,   657,  1251,
     292,   308,     3,   787,   788,   782,    27,   535,   868,   869,
     874,    38,   243,   376,   450,   490,   880,   881,   882,   883,
     880,   308,   243,   302,   125,   216,   455,   470,   756,   757,
    1245,   192,   192,   171,   548,    38,   551,   172,   967,   968,
     548,   548,   813,   814,  1245,   814,  1245,   548,   548,   548,
     548,   243,   548,   399,   171,   548,   548,   308,   548,   292,
     120,   322,   534,  1006,  1040,   534,  1022,  1023,  1024,  1260,
     535,   659,   201,   201,   201,   201,   201,   495,  1244,   698,
     699,   538,   536,   186,   836,   837,  1254,    59,   841,   842,
    1263,   447,   534,   177,   155,   405,   155,   405,   384,   470,
     273,  1128,  1254,   491,   686,   308,   836,   548,   177,   878,
     814,  1128,   866,   301,   866,   866,  1128,   814,  1245,   535,
     533,   533,   538,  1152,   142,  1208,  1209,    38,   535,  1152,
     535,   535,   535,   177,   535,   535,   512,  1226,  1227,   491,
     493,  1231,  1128,  1227,   535,    21,   297,   538,  1235,   314,
    1238,   538,   539,   477,   535,   535,    21,   297,   538,  1234,
    1234,   538,   535,  1229,   538,   535,   535,   535,   535,   538,
     538,   535,   334,   535,   535,   534,  1153,  1153,  1191,    13,
      17,    18,    19,   201,   224,   310,   522,   523,   524,   525,
     526,   527,   528,   529,   530,  1188,  1153,   535,   535,   171,
     177,   407,   535,   535,    38,  1204,  1191,  1204,  1204,   177,
     535,   135,   535,  1263,   330,  1167,    38,   535,   538,  1152,
    1263,   538,  1152,  1215,  1152,   535,   511,  1153,  1153,   150,
    1191,   177,    37,   301,   388,   477,   135,   137,   163,   291,
     297,   454,   466,  1200,  1230,   291,  1231,   150,   900,  1152,
     430,  1216,  1152,  1205,  1152,   447,   534,  1041,   534,  1174,
     534,  1191,   488,   534,  1175,  1260,   439,   441,   439,   441,
    1243,  1054,  1054,  1054,  1110,  1059,  1110,   952,  1250,  1149,
     573,   994,   266,   534,   535,  1250,  1148,  1148,   533,   533,
     535,   534,  1041,  1105,  1115,  1122,   177,   534,  1041,  1090,
    1091,    38,  1092,  1093,  1260,   538,   100,   178,   212,   227,
     250,   279,   378,  1096,  1093,    38,  1092,  1095,  1260,  1093,
    1093,   515,  1109,  1214,  1152,   186,  1073,  1062,   310,  1186,
    1189,   514,   860,     5,  1250,  1071,   309,   491,   470,  1068,
     261,  1089,   488,  1111,  1260,  1090,   877,   815,   873,   873,
      59,   875,   529,  1255,  1255,   308,  1244,   311,   308,  1152,
     655,   772,   157,   548,   447,  1254,  1245,   578,  1128,   814,
     814,  1128,   702,  1245,   189,   476,   447,   447,   702,   718,
     724,   367,   402,   591,  1245,  1245,  1245,   214,   297,   160,
     869,   323,   402,   447,  1152,   292,   153,   653,  1245,   534,
     534,   157,   534,   679,   206,   534,   772,   422,   641,   642,
     772,   402,    25,   140,   371,   372,   402,   595,   603,   604,
     724,   920,   394,   157,   548,   157,   548,  1245,  1245,  1245,
    1245,   394,   394,   251,   727,   728,   727,   535,   538,   729,
    1251,   206,   535,   538,   524,   536,   120,   606,  1260,   160,
    1254,  1245,   367,   402,   591,  1245,  1245,  1245,   308,   324,
     367,   402,    25,   140,   324,   367,   402,  1128,   289,  1128,
     535,   538,   524,  1243,   447,  1255,   472,   745,   160,   657,
     389,   931,   488,   664,   664,   657,   253,   331,   297,  1251,
     331,  1255,   469,   160,   447,   447,   389,   419,   890,   890,
     890,   323,   402,    92,   447,   919,   389,   120,   171,   607,
     167,   547,   447,   447,   263,   263,   263,   447,   447,   389,
     447,   447,   389,   447,   389,   447,   389,   447,   128,   548,
    1128,   292,  1251,   402,   920,   157,   548,   447,   447,   535,
    1245,   447,   919,   389,   447,  1254,  1245,   535,   535,   535,
    1193,   533,  1128,   814,   224,   820,  1245,  1245,  1245,   224,
     420,   421,   617,  1251,   617,   189,   535,   535,   177,   782,
     784,   289,   310,   525,   526,   698,   785,   873,  1189,  1251,
    1268,    72,    78,    92,   120,   122,   181,   210,   292,   297,
     344,   361,   465,   644,   645,   648,   156,   487,   551,   578,
    1245,   578,   312,   722,  1243,  1243,  1243,   535,   538,  1255,
     186,   379,  1255,  1250,   457,  1243,   657,     3,   171,   750,
     890,    48,   565,   434,   731,   113,   991,  1152,   177,   538,
    1244,   600,   789,   790,  1251,   535,   538,  1245,   171,   658,
    1243,   685,  1243,  1245,   686,   534,   632,  1243,   535,  1245,
     491,   493,   675,   599,    38,   157,  1040,   674,   447,   157,
    1099,   524,   535,   538,   756,   535,   538,   120,   524,   884,
    1251,   578,   434,   872,   873,   171,   889,    51,   374,   885,
     886,   883,   886,   125,   216,   395,   470,   942,  1245,   302,
     308,   313,   189,  1040,  1128,   534,   535,   538,   548,   472,
     548,   472,   548,  1245,  1245,   740,   814,   157,   478,   432,
     471,  1007,  1008,  1009,  1260,   308,  1010,  1024,  1025,   538,
    1088,   524,  1215,   389,   389,   389,   389,   389,  1244,   538,
     834,  1260,  1254,   491,   538,   838,  1254,   538,   844,   163,
     311,   454,   843,  1101,   399,   155,   155,   113,   288,   835,
     844,  1255,   224,   224,   224,   224,   698,   224,   224,   224,
     224,   224,  1196,   443,  1152,   147,  1128,   535,  1152,   228,
     465,   465,   535,  1227,  1229,   308,   308,  1225,  1229,    59,
    1235,  1152,  1225,  1225,   308,   308,  1233,  1231,  1231,  1152,
     535,  1152,  1200,  1152,  1152,   535,  1191,   538,  1128,  1153,
    1153,  1153,  1153,   135,   137,   292,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1152,  1152,  1152,  1128,
     535,   535,   535,  1191,   535,   538,    59,  1154,  1168,   535,
    1263,  1163,   341,   426,  1166,   535,   538,   483,  1159,    38,
     535,  1251,  1152,    35,    35,  1152,   535,  1152,   177,   291,
    1231,  1152,   535,   150,  1153,  1153,   150,   150,  1152,  1152,
    1060,   535,  1191,   538,  1152,  1176,  1260,  1054,  1054,  1054,
    1054,  1243,  1243,  1243,  1073,   535,  1073,   535,   999,   533,
    1225,  1093,  1095,  1093,  1093,   534,   503,  1154,   535,  1260,
     534,  1090,   227,   318,  1097,  1090,  1097,   227,  1096,  1097,
     227,   436,  1103,   534,  1260,   534,   315,    59,   190,  1080,
     534,   860,   168,   245,   309,   491,   444,   103,  1152,   375,
    1012,   308,   535,   529,   877,   457,   180,   383,   390,   397,
     435,   458,   849,   171,   849,   535,   122,   210,   288,   292,
     773,  1245,  1245,    38,   472,   472,   243,   815,  1254,  1245,
     447,   919,   389,   447,   214,  1245,    59,   437,  1245,   535,
     157,   534,   662,   663,   855,  1157,  1260,   658,   637,   658,
     772,  1245,   658,   120,  1260,    86,   639,   640,   419,   181,
     159,   194,   292,   599,   551,   113,   159,   181,   292,   419,
     599,   639,   641,   696,   402,   604,   457,  1245,  1260,   394,
     726,  1245,   602,   785,  1263,  1245,   323,   402,   447,   919,
     389,   447,   160,   447,   447,   389,   179,   310,   422,   794,
     795,   179,   310,   802,   803,   447,   447,   389,   535,   535,
     535,   926,   289,   698,   873,   927,  1189,  1251,  1268,   367,
    1245,   534,   491,   746,  1245,   664,   107,  1260,   534,   664,
    1252,  1251,  1251,  1251,  1245,  1245,  1245,  1245,   605,    59,
     437,  1245,  1245,  1245,  1245,   478,  1245,  1245,   171,   171,
     369,   171,   195,  1254,  1245,  1245,  1254,  1245,  1245,  1245,
    1245,  1245,  1245,  1245,   308,    78,   596,   157,    27,    50,
     457,  1260,  1245,  1251,   724,  1245,  1245,  1245,  1245,  1059,
     535,   224,   820,   224,   224,   224,   820,   551,   472,   622,
     623,   702,   772,   491,   493,   814,   534,   814,  1245,  1153,
      32,    59,   647,   123,   197,   122,   297,   240,  1243,   646,
     179,   348,   768,   775,   776,  1260,   711,   534,   329,   534,
     632,   650,   209,   669,   635,  1255,  1255,  1128,   534,   600,
      29,   125,   216,   395,   470,   751,   447,   747,  1254,   195,
    1243,   733,   495,   308,   535,  1089,   682,   890,   535,   538,
    1114,   722,   740,   535,   693,    38,   302,   329,   534,  1001,
     634,   636,   638,   652,  1260,   329,   670,   671,   632,   669,
     599,   305,   308,   676,  1040,   688,   686,   600,  1251,  1245,
     852,   785,     3,   788,   308,   874,  1152,  1152,   538,   534,
     880,   457,   538,    44,  1152,   447,   534,   658,  1243,   757,
     702,   535,   967,   968,  1245,  1245,   548,   399,   548,   477,
     535,   538,  1215,    90,  1012,   535,   538,  1023,  1111,  1152,
    1244,  1244,  1244,  1244,  1244,   698,   183,   837,   844,   842,
     535,  1245,   113,   177,   548,   844,   297,   823,  1251,   823,
     823,   823,   224,   823,   823,   823,   823,   823,  1152,   535,
     145,   241,   241,   535,   297,   297,   535,  1061,  1229,   330,
    1217,   297,   297,  1229,  1229,  1217,  1217,   535,   535,   177,
     535,  1152,   177,   135,   137,   177,   171,   150,   535,   498,
    1161,  1191,   360,   477,    59,  1168,  1154,   489,   489,   535,
    1152,   288,  1152,   538,  1160,  1130,  1152,  1152,  1152,  1152,
      35,    35,  1152,  1152,   150,   535,   535,   535,  1152,   535,
     329,  1177,  1243,  1243,  1243,  1243,  1080,  1251,  1080,  1251,
     535,   538,  1106,  1107,  1157,   534,  1167,  1092,   534,  1244,
    1090,   308,   472,  1098,  1090,   227,  1090,  1248,  1113,   534,
    1113,  1260,  1055,  1152,   490,  1171,   900,   444,   302,  1240,
    1152,   457,   535,   447,   830,   177,   772,   123,   197,   208,
     122,   474,   548,  1128,  1245,  1245,  1245,  1245,  1245,  1245,
    1245,  1255,  1245,   772,   637,  1152,   535,   538,   491,    78,
     854,   858,   854,   535,   535,   535,   120,  1260,   722,   605,
     647,   195,   195,   297,   698,    38,   647,   297,   605,  1128,
     548,   548,   524,    59,   437,  1245,  1245,  1245,  1245,  1245,
    1254,  1245,  1245,  1250,  1250,  1128,   538,  1250,  1250,   538,
    1254,  1245,  1245,   447,  1152,    72,  1152,  1255,  1245,   447,
     447,   177,   201,   491,  1244,  1244,   814,  1244,   157,   160,
     814,  1251,  1251,  1128,   548,   548,   447,   535,   224,   820,
     820,   820,   820,   534,   618,   619,   551,   127,   179,   213,
     179,  1152,   292,   645,   120,    38,   890,   657,   890,  1248,
      35,   156,   201,   723,   727,   302,   631,   607,   154,   203,
     534,   399,   472,   658,    38,  1255,   745,   565,   292,   534,
     173,  1245,   681,  1251,   399,   600,   156,  1040,   814,   302,
     631,   686,   535,   538,   491,   643,    59,   674,   607,   670,
      84,   437,   677,   491,   956,    38,   677,   177,   308,   534,
    1243,  1251,   871,   891,   892,  1261,   886,  1128,   171,   887,
    1243,   177,   447,   911,   362,   758,   211,   703,   548,   535,
     548,   548,  1245,  1040,   322,  1040,  1009,   308,   534,  1011,
     524,  1024,  1012,   311,   222,   836,   548,   823,  1245,   535,
    1218,  1219,  1225,   120,   143,   149,   163,   297,   454,   466,
    1221,  1222,  1224,   535,   535,  1229,  1229,  1152,   535,  1153,
     177,  1152,  1152,  1152,   534,   535,   538,   535,  1168,   535,
     477,   416,   535,   205,   288,  1165,  1152,  1152,  1152,   535,
      59,  1059,  1171,  1171,   392,  1049,  1152,   535,   538,    38,
    1108,   120,  1120,  1121,  1153,    81,  1244,   535,  1152,   534,
    1090,  1098,   534,   535,  1113,   535,   102,   187,   381,   534,
    1074,  1075,  1076,  1077,  1078,  1079,  1152,  1172,  1173,  1260,
    1059,   535,  1037,   487,  1027,  1028,  1029,  1030,   836,   308,
     836,   535,   447,   402,  1018,   535,   202,   660,   663,   310,
     900,   814,   546,   814,   361,   660,   660,   643,    38,   157,
     157,   534,   596,   785,  1255,  1245,   447,   534,   866,   900,
     902,   795,   534,   534,   803,  1245,   535,   534,   535,   402,
    1018,  1245,  1245,   534,   534,   534,   491,   515,   976,   369,
     976,   976,   171,  1245,   596,  1245,   820,   624,   625,  1263,
      54,   101,   126,   145,   150,   172,   176,   191,   297,   352,
     620,   618,  1251,   866,    38,   907,   907,   535,   194,   534,
     472,   678,   264,   661,   678,   534,   776,   768,   534,   535,
     538,  1243,   535,   399,    29,    83,    86,    93,   121,   181,
     194,   207,   419,   422,   651,   651,  1242,  1245,  1245,   535,
    1040,   746,   157,   113,   722,   177,  1245,    38,  1245,   686,
     632,  1243,   535,   636,   312,  1260,   675,   670,   674,   125,
     140,   341,  1245,    64,    72,   256,  1040,   814,  1099,   853,
     855,   177,   771,   873,   535,   538,   457,   147,   544,   885,
     888,  1110,   414,   414,   535,   282,   306,   759,   760,   761,
     171,   764,   702,   288,   476,   704,   705,  1007,    92,   853,
     136,  1152,  1245,   844,   538,    38,  1152,    37,   301,   308,
     535,   491,   493,  1220,  1221,  1223,   171,  1153,  1162,  1191,
     288,   510,   205,   535,  1191,   188,   354,   385,  1178,    58,
     129,   112,  1050,    38,  1123,  1109,  1106,   534,  1153,   535,
     538,    38,  1116,  1117,  1260,   535,  1244,  1191,   535,   534,
     403,   534,   535,   538,   538,    38,  1064,   265,   292,  1012,
    1028,    35,  1031,  1031,   838,   849,   548,  1245,   437,   854,
     534,   890,   534,   859,   599,  1243,   890,   890,   194,  1152,
     472,   597,   402,  1018,  1245,  1195,   171,   798,   798,  1195,
    1195,  1152,   437,  1191,  1191,   608,   609,  1262,   813,   814,
     813,   814,  1244,   548,   535,   538,   120,   527,   534,   575,
     626,   698,   973,  1251,   973,   292,   297,   352,   973,   973,
    1110,   907,    42,   199,   288,   656,   534,   694,  1152,   206,
     178,   328,   408,   308,   665,   666,   667,   535,  1248,     6,
     777,   727,   632,   669,  1245,   535,   722,   164,   797,   600,
     956,  1243,   495,  1089,   722,  1040,  1001,   670,   632,   669,
     643,   534,   676,   674,   675,   385,   385,    72,   311,    72,
     686,   852,   535,   538,  1243,   772,   880,   891,  1128,   537,
     136,   491,   491,   760,   384,   434,   762,   141,   765,   487,
     767,   476,   702,   477,  1245,   535,   293,   470,   722,   548,
    1219,  1263,   149,    37,    88,   461,   495,    37,   495,   239,
     307,  1228,   308,   535,  1152,   535,   535,   477,    52,   103,
     460,  1152,  1179,  1180,  1179,  1179,   535,   168,   168,   658,
    1245,  1217,  1113,   538,  1121,  1263,   535,   538,   171,  1128,
     535,   535,  1191,   534,  1191,  1075,  1173,  1175,  1082,   265,
    1152,   443,   443,   177,  1245,   658,   678,   900,   860,   859,
     657,   678,   678,   694,   535,  1152,   437,   535,   314,   392,
     358,   799,   799,   535,   535,   535,  1245,   535,   535,   535,
     538,  1250,   976,   625,   575,   627,   628,  1251,  1251,   297,
     527,   658,   527,   658,  1251,  1251,   208,   695,   535,   437,
     125,   470,   308,   667,   308,   666,   534,   535,   538,   607,
     399,   722,   814,    38,    38,   534,  1245,   956,   686,   674,
     607,   670,   534,   672,   673,  1157,  1260,   677,   675,   676,
     311,   311,   534,   202,   856,   855,   171,   886,    30,   217,
     943,   179,   179,   973,   384,   418,   766,   534,   156,  1040,
    1110,   402,   495,    37,   495,    37,   495,   495,   353,   353,
    1223,   143,   149,  1180,   384,   170,   339,   170,   339,   153,
    1181,  1181,  1181,    59,    59,   402,    81,   535,  1154,  1117,
     315,     3,   120,   292,   297,   332,  1118,  1119,    38,  1094,
     368,  1104,   535,  1074,   535,    59,   125,   136,   470,  1032,
    1033,   136,   216,  1034,   836,  1018,   535,   664,   535,   860,
     661,   772,   772,  1245,   866,    59,  1018,   447,   608,   814,
     535,   538,   527,   658,   535,   423,  1245,    63,   288,   373,
     402,   668,   668,   535,     6,   399,  1245,   794,  1040,   722,
     675,   670,   674,  1152,   535,   538,   858,   858,   676,   677,
     853,   534,   646,   141,   293,   534,   938,   940,   944,  1003,
    1013,  1020,  1040,  1051,   866,   866,   763,  1260,  1152,   768,
    1022,   495,   495,   308,   308,   535,  1221,    35,   103,   186,
     288,   444,   658,   658,  1260,   534,  1167,  1153,  1153,   297,
    1153,  1119,  1260,   534,   535,   413,   438,   293,   402,   293,
     120,   322,   478,   534,  1035,   548,   772,   665,  1018,   814,
     534,   628,    24,   120,   297,  1245,   722,   956,   676,   674,
     675,   535,   673,   546,   546,   677,   535,   855,   857,   600,
     384,   939,   940,   941,  1041,  1042,   538,   538,   535,  1248,
    1110,   388,   388,   308,  1180,   384,   316,   402,   402,   447,
     472,   281,  1124,  1125,  1260,    81,  1152,  1022,   478,  1007,
     534,  1008,   772,  1191,   657,   657,   722,   677,   675,   676,
     858,   856,   535,   538,   677,   767,   535,   537,   447,   177,
     534,   425,   425,   149,  1260,  1260,   228,  1248,  1249,  1260,
     332,  1126,   535,   538,   171,  1128,  1116,   535,   477,  1191,
     535,   535,   676,   677,   546,   646,   855,  1110,   156,   941,
     414,   414,     5,   769,   770,  1250,  1251,  1263,   534,   120,
    1251,  1224,  1125,   315,   157,   332,  1127,  1226,   535,  1035,
     535,   322,  1035,   677,   600,   768,   491,   491,   535,   538,
    1192,  1249,    38,    81,   535,  1127,  1251,  1220,  1127,  1007,
     677,  1248,   179,   179,   770,  1059,   472,  1245,   534,  1224,
    1228,  1220,   477,  1110,   534,   866,   866,   535,  1260,    81,
    1124,  1223,  1228,  1035,   769,   534,   535,  1223,   535,  1124,
     535
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   540,   541,   541,   541,   541,   541,   541,   542,   542,
     543,   543,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   545,   545,   546,
     546,   547,   547,   548,   548,   548,   549,   550,   551,   551,
     551,   552,   552,   553,   553,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   555,   555,   555,   555,   555,   555,
     556,   557,   557,   558,   558,   559,   559,   559,   559,   560,
     560,   560,   560,   560,   560,   561,   562,   563,   563,   564,
     564,   564,   564,   565,   565,   566,   566,   566,   566,   566,
     566,   567,   567,   567,   567,   568,   568,   568,   569,   569,
     569,   569,   570,   570,   570,   570,   570,   570,   570,   570,
     570,   570,   570,   571,   571,   572,   572,   573,   573,   574,
     574,   574,   574,   575,   575,   575,   575,   576,   576,   576,
     576,   576,   576,   576,   577,   577,   577,   578,   578,   579,
     579,   580,   580,   580,   580,   581,   581,   582,   582,   583,
     583,   584,   584,   584,   584,   584,   584,   584,   585,   586,
     586,   587,   587,   588,   589,   589,   589,   589,   589,   590,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     591,   591,   592,   592,   592,   593,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   595,   595,   596,
     596,   597,   597,   598,   598,   598,   598,   599,   600,   600,
     601,   601,   602,   602,   602,   602,   603,   603,   604,   604,
     604,   604,   605,   605,   606,   606,   607,   607,   607,   607,
     608,   609,   609,   610,   611,   611,   612,   612,   612,   612,
     613,   613,   614,   614,   615,   615,   616,   616,   617,   617,
     617,   618,   618,   619,   619,   620,   620,   620,   620,   620,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     621,   621,   622,   622,   623,   623,   624,   624,   625,   626,
     626,   626,   626,   626,   626,   627,   627,   628,   629,   629,
     629,   629,   629,   629,   630,   630,   630,   630,   630,   630,
     630,   630,   631,   631,   632,   632,   633,   633,   634,   634,
     635,   635,   635,   636,   636,   637,   638,   638,   639,   639,
     640,   640,   641,   641,   642,   642,   643,   643,   644,   644,
     644,   644,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   646,   646,   646,   647,   647,   648,   648,   648,   648,
     649,   650,   650,   650,   651,   651,   651,   651,   651,   651,
     651,   651,   651,   651,   652,   652,   653,   653,   653,   653,
     653,   653,   653,   654,   654,   655,   655,   656,   656,   657,
     657,   658,   658,   659,   660,   660,   661,   661,   661,   661,
     662,   662,   663,   663,   664,   664,   665,   665,   665,   665,
     665,   666,   667,   668,   668,   668,   668,   668,   669,   669,
     670,   670,   671,   672,   672,   673,   673,   673,   674,   674,
     675,   675,   675,   676,   676,   676,   676,   677,   677,   678,
     678,   679,   680,   680,   681,   681,   682,   682,   682,   683,
     683,   684,   684,   685,   686,   686,   686,   687,   687,   688,
     689,   689,   690,   691,   691,   692,   692,   693,   693,   694,
     694,   695,   695,   696,   696,   696,   696,   696,   696,   696,
     696,   696,   696,   696,   696,   696,   696,   697,   697,   698,
     698,   698,   698,   699,   699,   700,   700,   701,   701,   702,
     702,   703,   703,   704,   704,   705,   705,   706,   706,   707,
     708,   708,   709,   709,   710,   710,   711,   711,   712,   712,
     712,   712,   713,   714,   714,   715,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   717,
     718,   718,   718,   718,   719,   719,   720,   720,   721,   721,
     722,   722,   723,   723,   724,   725,   725,   726,   726,   726,
     726,   727,   728,   729,   730,   730,   731,   731,   732,   732,
     733,   733,   734,   734,   734,   735,   735,   735,   735,   736,
     737,   737,   738,   738,   739,   739,   740,   740,   741,   741,
     742,   743,   744,   745,   745,   746,   746,   747,   747,   748,
     748,   749,   749,   750,   750,   751,   751,   751,   751,   751,
     752,   753,   753,   754,   754,   755,   755,   755,   756,   756,
     757,   757,   757,   757,   757,   758,   758,   759,   759,   760,
     761,   761,   762,   762,   763,   764,   764,   765,   765,   766,
     766,   767,   767,   768,   768,   769,   769,   769,   770,   770,
     770,   770,   771,   771,   772,   772,   773,   773,   773,   773,
     773,   773,   774,   774,   775,   775,   776,   777,   777,   778,
     779,   779,   779,   779,   780,   781,   781,   781,   781,   781,
     781,   781,   781,   781,   781,   781,   781,   781,   781,   781,
     781,   782,   783,   783,   784,   784,   785,   785,   785,   785,
     785,   785,   786,   787,   787,   788,   789,   789,   790,   790,
     791,   791,   791,   791,   791,   792,   792,   793,   794,   794,
     795,   795,   795,   795,   795,   796,   796,   797,   797,   798,
     798,   798,   799,   799,   800,   801,   801,   802,   802,   803,
     803,   804,   804,   805,   805,   806,   807,   808,   808,   808,
     808,   808,   808,   808,   808,   808,   808,   808,   808,   809,
     809,   809,   809,   809,   809,   809,   809,   809,   809,   809,
     809,   809,   810,   810,   810,   810,   810,   811,   811,   811,
     811,   811,   811,   811,   811,   812,   812,   812,   813,   813,
     814,   814,   815,   815,   816,   816,   817,   818,   818,   818,
     819,   819,   819,   819,   819,   819,   819,   819,   819,   819,
     819,   819,   819,   819,   819,   819,   819,   819,   820,   820,
     821,   821,   821,   821,   821,   821,   821,   821,   821,   821,
     822,   822,   823,   823,   824,   824,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   826,   826,   827,   827,   828,   829,   829,   830,
     830,   830,   830,   830,   831,   831,   832,   832,   832,   832,
     832,   833,   833,   834,   834,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   836,   836,   837,   837,
     838,   838,   839,   839,   840,   840,   841,   841,   842,   843,
     843,   843,   844,   844,   845,   846,   846,   847,   847,   847,
     848,   848,   848,   849,   849,   849,   849,   849,   849,   850,
     850,   851,   851,   852,   852,   853,   853,   854,   854,   855,
     855,   855,   856,   856,   857,   857,   858,   858,   859,   859,
     859,   860,   860,   860,   861,   861,   861,   861,   862,   862,
     863,   863,   864,   864,   865,   865,   866,   866,   866,   866,
     867,   867,   868,   868,   869,   869,   869,   869,   869,   870,
     870,   870,   870,   870,   871,   872,   873,   873,   873,   874,
     874,   874,   875,   876,   876,   876,   876,   877,   877,   878,
     879,   879,   880,   880,   881,   881,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   883,   883,   883,   883,   883,   884,   884,
     885,   886,   886,   886,   887,   887,   888,   888,   889,   889,
     890,   890,   891,   892,   892,   893,   893,   893,   894,   894,
     895,   895,   896,   896,   896,   896,   896,   896,   897,   897,
     898,   898,   899,   899,   899,   899,   900,   900,   901,   901,
     902,   903,   904,   904,   905,   905,   906,   906,   906,   907,
     907,   907,   908,   909,   909,   910,   911,   911,   911,   911,
     912,   913,   913,   913,   914,   914,   915,   915,   916,   916,
     917,   917,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   919,   919,   920,
     920,   921,   921,   921,   921,   921,   921,   922,   922,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   924,   925,   925,   926,
     926,   926,   927,   927,   927,   927,   927,   928,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   930,   930,   930,   931,   931,   931,   931,   931,
     931,   931,   932,   932,   933,   933,   933,   933,   934,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   936,   936,
     937,   938,   938,   938,   939,   939,   940,   940,   940,   940,
     940,   941,   941,   942,   942,   942,   942,   943,   943,   943,
     944,   945,   945,   946,   947,   947,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   949,   949,
     950,   950,   950,   951,   951,   951,   951,   951,   952,   952,
     952,   953,   953,   954,   954,   954,   955,   955,   955,   955,
     956,   956,   956,   956,   957,   958,   959,   959,   960,   960,
     961,   961,   961,   962,   962,   962,   962,   962,   962,   962,
     963,   963,   964,   964,   964,   964,   965,   966,   966,   966,
     966,   967,   967,   968,   969,   970,   970,   971,   972,   972,
     972,   972,   972,   972,   972,   973,   973,   974,   975,   975,
     975,   975,   975,   975,   976,   976,   977,   978,   978,   978,
     978,   978,   979,   979,   980,   980,   981,   981,   982,   982,
     983,   983,   984,   985,   985,   985,   986,   986,   986,   987,
     987,   988,   988,   989,   989,   990,   990,   991,   991,   992,
     993,   993,   994,   994,   995,   995,   995,   995,   996,   996,
     996,   996,   996,   996,   996,   996,   996,   996,   997,   998,
     998,   999,   999,   999,   999,   999,  1000,  1000,  1000,  1001,
    1001,  1002,  1002,  1002,  1002,  1003,  1004,  1005,  1005,  1006,
    1006,  1006,  1006,  1006,  1007,  1007,  1008,  1008,  1009,  1010,
    1010,  1010,  1011,  1011,  1011,  1012,  1012,  1013,  1014,  1014,
    1015,  1016,  1016,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1018,  1018,  1019,  1019,  1019,  1020,  1021,  1022,  1022,
    1023,  1023,  1024,  1025,  1025,  1026,  1027,  1027,  1028,  1028,
    1028,  1028,  1028,  1029,  1029,  1030,  1030,  1031,  1031,  1032,
    1033,  1034,  1034,  1034,  1034,  1034,  1035,  1036,  1037,  1038,
    1038,  1038,  1038,  1038,  1038,  1039,  1039,  1039,  1040,  1040,
    1041,  1041,  1042,  1042,  1042,  1042,  1042,  1042,  1042,  1042,
    1043,  1043,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1045,
    1045,  1045,  1046,  1046,  1047,  1048,  1048,  1048,  1049,  1049,
    1049,  1050,  1050,  1050,  1051,  1051,  1052,  1052,  1053,  1053,
    1053,  1053,  1053,  1053,  1053,  1053,  1053,  1054,  1054,  1055,
    1055,  1055,  1056,  1056,  1057,  1057,  1058,  1058,  1059,  1059,
    1060,  1061,  1061,  1062,  1062,  1063,  1063,  1063,  1063,  1064,
    1064,  1065,  1065,  1065,  1065,  1065,  1065,  1066,  1066,  1067,
    1067,  1068,  1069,  1069,  1069,  1070,  1070,  1071,  1071,  1072,
    1072,  1073,  1073,  1074,  1074,  1075,  1075,  1075,  1075,  1075,
    1076,  1077,  1078,  1079,  1080,  1080,  1081,  1081,  1082,  1082,
    1083,  1083,  1084,  1085,  1085,  1085,  1085,  1086,  1086,  1087,
    1087,  1088,  1088,  1089,  1089,  1090,  1090,  1090,  1090,  1090,
    1090,  1090,  1090,  1090,  1090,  1090,  1090,  1091,  1091,  1091,
    1091,  1091,  1091,  1092,  1092,  1092,  1092,  1093,  1093,  1094,
    1094,  1095,  1095,  1095,  1095,  1095,  1096,  1096,  1096,  1096,
    1097,  1097,  1098,  1098,  1099,  1099,  1100,  1100,  1100,  1101,
    1101,  1102,  1102,  1102,  1103,  1104,  1104,  1105,  1105,  1106,
    1107,  1107,  1108,  1108,  1109,  1109,  1110,  1110,  1111,  1111,
    1111,  1112,  1112,  1113,  1113,  1114,  1115,  1115,  1116,  1116,
    1117,  1117,  1117,  1118,  1118,  1119,  1119,  1119,  1119,  1119,
    1120,  1120,  1121,  1121,  1122,  1123,  1123,  1124,  1124,  1125,
    1125,  1125,  1125,  1125,  1125,  1126,  1126,  1127,  1127,  1128,
    1128,  1128,  1128,  1128,  1128,  1129,  1129,  1129,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1131,  1131,  1131,  1131,
    1131,  1132,  1132,  1133,  1133,  1134,  1134,  1134,  1134,  1134,
    1134,  1134,  1134,  1134,  1134,  1134,  1135,  1135,  1136,  1136,
    1137,  1137,  1138,  1139,  1140,  1140,  1141,  1141,  1142,  1143,
    1144,  1144,  1144,  1144,  1144,  1144,  1145,  1145,  1146,  1146,
    1146,  1146,  1147,  1148,  1148,  1148,  1149,  1149,  1149,  1149,
    1149,  1149,  1149,  1149,  1149,  1149,  1149,  1149,  1149,  1149,
    1150,  1150,  1151,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1154,  1154,  1154,  1154,  1154,  1154,  1154,
    1154,  1154,  1154,  1154,  1154,  1154,  1154,  1155,  1155,  1155,
    1155,  1155,  1155,  1155,  1156,  1156,  1156,  1157,  1157,  1157,
    1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,
    1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,
    1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,
    1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,
    1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,
    1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,  1158,
    1159,  1159,  1160,  1160,  1160,  1160,  1161,  1162,  1162,  1163,
    1163,  1164,  1164,  1165,  1165,  1165,  1166,  1166,  1166,  1167,
    1167,  1167,  1167,  1168,  1168,  1169,  1169,  1170,  1170,  1171,
    1171,  1172,  1172,  1173,  1174,  1174,  1174,  1175,  1176,  1176,
    1177,  1177,  1178,  1178,  1178,  1178,  1179,  1179,  1180,  1180,
    1180,  1180,  1180,  1181,  1181,  1181,  1181,  1181,  1182,  1182,
    1182,  1183,  1183,  1184,  1185,  1185,  1185,  1186,  1186,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1188,  1188,  1189,  1189,  1190,  1190,  1190,  1190,  1190,
    1190,  1191,  1191,  1192,  1192,  1193,  1193,  1193,  1194,  1194,
    1195,  1195,  1196,  1196,  1196,  1197,  1197,  1198,  1199,  1199,
    1199,  1199,  1199,  1199,  1199,  1199,  1200,  1200,  1200,  1200,
    1201,  1201,  1202,  1203,  1203,  1203,  1203,  1203,  1204,  1204,
    1204,  1205,  1205,  1206,  1207,  1207,  1208,  1209,  1209,  1210,
    1210,  1211,  1211,  1212,  1212,  1212,  1212,  1213,  1213,  1214,
    1214,  1215,  1215,  1216,  1216,  1217,  1217,  1218,  1218,  1219,
    1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1221,
    1221,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1223,
    1223,  1223,  1223,  1224,  1224,  1225,  1226,  1226,  1227,  1227,
    1228,  1228,  1228,  1228,  1228,  1229,  1229,  1230,  1230,  1230,
    1230,  1230,  1231,  1231,  1231,  1231,  1231,  1232,  1232,  1233,
    1233,  1234,  1234,  1234,  1235,  1235,  1235,  1236,  1236,  1237,
    1237,  1238,  1238,  1239,  1239,  1240,  1240,  1241,  1241,  1241,
    1241,  1242,  1242,  1243,  1243,  1244,  1244,  1245,  1246,  1247,
    1248,  1248,  1249,  1249,  1249,  1249,  1249,  1249,  1249,  1249,
    1249,  1249,  1249,  1249,  1249,  1250,  1251,  1252,  1252,  1252,
    1253,  1254,  1254,  1254,  1254,  1255,  1255,  1256,  1257,  1258,
    1258,  1259,  1259,  1260,  1260,  1260,  1261,  1261,  1261,  1262,
    1262,  1262,  1262,  1263,  1263,  1263,  1263,  1263,  1264,  1264,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       0,     1,     0,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     2,     0,     1,     1,     1,     1,     1,
       1,     3,     2,     3,     3,     2,     5,     1,     3,     3,
       3,     3,     1,     3,     3,     2,     2,     2,     2,     3,
       3,     3,     3,     1,     3,     1,     3,     1,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       3,     1,     2,     3,     2,     1,     1,     2,     1,     2,
       1,     3,     3,     2,     3,     4,     3,     2,     4,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     4,
       6,     4,     6,    10,    13,     4,     6,     4,    10,    13,
       4,     6,     4,     6,     5,     7,    11,    14,     5,     7,
       1,     3,     4,     4,     4,     3,     2,     5,     3,     6,
       4,     6,     6,     9,     5,     7,     6,     6,     5,     5,
       5,     5,     9,     4,     5,     7,     6,     4,     8,     4,
       2,     4,     3,     6,     4,     3,     3,     3,     2,     2,
       3,     4,     4,     3,     3,     3,     3,     3,     3,     4,
       4,     3,     2,     3,     2,     2,     3,     4,     3,     2,
       2,     3,     4,     4,     4,     5,     1,     3,     2,     2,
       0,     2,     0,     1,     1,     1,     3,     3,     2,     0,
       1,     3,     3,     1,     5,     3,     1,     2,     1,     3,
       2,     3,     1,     1,     1,     1,     6,     6,    10,     1,
       2,     1,     3,     4,     1,     3,     4,     6,     4,     8,
       2,     2,    11,     9,     1,     1,     1,     0,     1,     1,
       1,     1,     3,     2,     0,     1,     1,     3,     3,     1,
       1,     3,     3,     3,     3,     4,     4,     3,     3,     2,
       1,     0,     3,     0,     1,     0,     1,     3,     2,     1,
       1,     1,     1,     3,     0,     1,     3,     1,    13,    16,
      12,    15,    14,    17,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     6,     2,     4,     2,     2,
       1,     0,     2,     2,     1,     0,     2,     0,     3,     1,
       1,     2,     2,     1,     4,     4,     5,     2,     5,     7,
       5,     2,     3,     0,     1,     2,     1,     2,     2,     2,
       3,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     9,     3,     9,
       4,    10,    11,     3,     1,     5,     3,     2,     0,     3,
       0,     1,     3,     1,     4,     0,     2,     2,     2,     0,
       1,     3,     3,     6,     4,     0,     1,     1,     2,     2,
       0,     3,     3,     2,     1,     1,     3,     3,     4,     0,
       1,     0,     6,     1,     3,     3,     3,     5,     2,     0,
       2,     2,     0,     3,     4,     4,     0,     2,     0,     4,
       0,     3,     8,    11,     1,     3,     1,     1,     3,     6,
       8,     7,    10,     6,     2,     3,     0,     8,    11,     5,
       1,     0,     6,     5,     8,     4,     6,     1,     0,     3,
       0,     1,     2,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     3,     1,     3,     1,     0,     1,
       2,     2,     1,     1,     3,     6,    10,     1,     0,     1,
       2,     2,     0,     2,     2,     1,     0,     1,     0,     7,
       2,     0,     3,     5,     5,     8,     2,     0,     2,     2,
       2,     1,     5,     2,     0,     2,     6,     6,     6,    10,
       6,     6,     6,     9,     9,     6,     6,     9,     6,     7,
       2,     2,     2,     2,     1,     2,     1,     0,     7,     6,
       4,     0,     1,     3,     4,     1,     3,     1,     2,     2,
       2,     2,     1,     1,    10,    13,     2,     0,     2,     2,
       1,     0,     5,     4,     4,    11,    14,    12,    15,    11,
       2,     1,     4,     0,     8,    11,     1,     1,     7,     9,
       8,    10,     8,     4,     0,     5,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     1,     1,     1,     1,     1,
       8,     1,     1,    17,    21,     1,     1,     2,     1,     3,
       1,     1,     1,     3,     1,     2,     0,     1,     2,     4,
       1,     1,     1,     1,     1,     3,     0,     1,     0,     1,
       1,     4,     0,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     0,     0,     2,     2,     1,     2,     2,
       2,     2,    11,    13,     1,     3,     5,     1,     3,     5,
       1,     2,     2,     1,     8,     6,     5,     4,     4,     3,
       7,     8,     6,     6,     6,     6,     6,     4,     7,     5,
       8,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     3,     1,     0,     1,     3,
       7,     9,     9,     8,     6,     3,     0,    13,     1,     3,
       5,     5,     3,     6,     2,     1,     0,     2,     0,     2,
       4,     0,     1,     0,     6,     8,     8,     1,     3,     5,
       5,     7,     9,     7,     9,     5,     6,     6,     4,     6,
       4,     6,     8,     4,     6,     4,     6,     5,     7,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     2,     2,     1,
       3,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     2,     3,     1,     3,     5,     2,     2,     0,
       6,     6,     6,     6,     6,     6,     6,     6,     8,     9,
       8,     6,     6,     9,     9,     9,     7,    10,     1,     1,
       8,     8,     8,     8,     8,     8,     8,     9,     8,     8,
       2,     0,     1,     1,     2,     2,     1,     2,     3,     3,
       3,     3,     4,     4,     3,     3,     3,     4,     4,     3,
       4,     4,     1,     1,     1,     0,     8,     8,    11,     1,
       1,     2,     4,     5,     1,     3,     2,     2,     2,     2,
       2,     1,     3,     1,     3,     1,     2,     2,     4,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     5,     5,     5,     5,     5,     1,     3,     1,     2,
       3,     0,     5,     7,     6,     9,     3,     1,     2,     1,
       1,     1,     3,     0,     5,     2,     0,     3,     3,     3,
       7,     7,    10,     1,     1,     1,     1,     1,     1,    16,
      19,     1,     0,     2,     0,     1,     3,     4,     5,     2,
       2,     4,     4,     0,     1,     3,     2,     0,     1,     1,
       0,     2,     2,     0,     9,    12,     7,     7,     2,     0,
       3,     2,     1,     3,     1,     3,     2,     1,     1,     2,
       3,     2,     1,     3,     3,     3,     2,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     4,     5,     1,
       3,     3,     1,     3,     3,     5,     6,     1,     3,     2,
       1,     3,     1,     0,     1,     2,     4,     5,     1,     1,
       1,     1,     3,     3,     2,     2,     1,     2,     2,     2,
       2,     1,     2,     2,     2,     2,     1,     1,     1,     3,
       2,     1,     4,     0,     3,     0,     1,     1,     3,     5,
       2,     0,     2,     1,     3,     5,     5,     5,     1,     2,
       1,     0,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     3,     5,     5,     5,     1,     3,     1,     3,
       2,     2,     1,     2,     1,     2,    11,    10,    10,     2,
       2,     0,     9,     2,     0,    10,    11,    11,     5,     5,
       8,     5,     5,     5,     1,     1,     1,     1,     3,     0,
       5,     5,     6,     6,     6,     6,     6,     8,     8,     6,
       6,     7,     9,     9,     8,    10,     6,     6,     6,     6,
       6,     6,     6,     8,     6,     8,     6,     8,     7,     9,
       6,     8,     7,     9,     8,    10,     8,    10,     9,    11,
       8,    10,     9,    11,     8,     8,     7,     6,     6,     6,
       6,     8,     8,     8,     8,     6,     9,     1,     0,     2,
       0,     8,     8,     8,    10,     9,     8,     1,     0,     6,
       6,     6,     6,     6,     6,     6,     9,     9,     6,     6,
       6,     8,     6,     8,     8,     8,     8,     6,     8,     6,
       8,     7,     9,     7,     9,     6,     7,     1,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     7,     6,     6,
       6,     6,     6,     6,     7,     7,     6,     9,     9,     6,
       6,     6,     6,     6,     6,     8,     8,     8,     6,     7,
       6,     6,     4,     7,     6,     4,     4,     4,     3,     4,
       3,     1,     1,     3,     5,     5,     5,     5,     8,     5,
       5,     6,     7,     7,     7,     4,     4,     5,     4,     6,
      13,     1,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     0,
       3,     2,     0,     2,     2,     2,     3,     3,     3,     3,
       2,     3,     2,     5,     4,     3,     3,     3,     3,     3,
       1,     1,     0,     3,     2,     2,     1,     2,     1,     3,
       2,     1,     0,     2,     3,     0,     9,    11,    12,    14,
       3,     4,     4,     0,     2,     5,     1,     0,     1,     2,
       3,     3,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     0,     5,     4,     6,     6,     4,     3,     5,     7,
       9,     1,     3,     1,     5,     4,     4,     6,     4,     6,
       6,     5,     7,     9,     6,     1,     0,     6,    11,    11,
      11,    13,     9,    11,     1,     1,    10,     6,     4,     4,
       2,     5,     2,     0,     6,     5,     3,     5,     1,     3,
       1,     1,     2,     1,     1,     1,     1,     1,     0,     1,
       0,     1,     0,     1,     0,     1,     0,     3,     0,     2,
       1,     3,     1,     0,     2,     4,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     3,
       0,     1,     1,     1,     1,     1,     3,     9,    12,     3,
       0,     2,     3,     2,     3,     7,     4,     1,     3,     1,
       4,     4,     7,     2,     1,     1,     1,     3,     2,     8,
       5,     0,     4,     3,     0,     2,     0,     7,     2,     0,
       5,     3,     0,     2,     2,     2,     3,     1,     3,     1,
       2,     1,     0,     1,     2,     0,     8,     3,     1,     3,
       3,     5,     2,     1,     3,    10,     1,     2,     4,     4,
       4,     5,     5,     2,     5,     3,     5,     2,     0,     3,
       1,     2,     5,     5,     8,     3,     4,     7,     1,     0,
       3,     2,     2,     2,     2,     0,     2,     2,     1,     1,
       3,     3,     1,     2,     4,     4,     2,     3,     5,     5,
       1,     1,     9,     9,     1,     2,     4,     4,     4,     2,
       2,     3,     1,     3,     9,     1,     2,     0,     7,     7,
       0,    10,     6,     0,     1,     0,     2,     0,     3,     3,
       4,     4,     4,     4,     3,     2,     1,     1,     0,     1,
       1,     0,     1,     5,     1,     0,     1,     1,     1,     0,
       3,     1,     3,     4,     3,     2,     2,     1,     1,     1,
       0,     2,     4,     5,     6,     4,     5,     2,     3,     1,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     4,     0,     1,     3,     1,     1,     1,     1,     1,
       2,     4,     4,     5,     2,     0,     1,     3,     1,     0,
       1,     2,     3,     2,     4,     2,     3,     2,     0,     4,
       5,     2,     0,     1,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     1,     4,     2,     3,     3,     4,     5,
       4,     5,     4,     5,     2,     4,     1,     1,     0,     2,
       0,     1,     4,     5,     4,     0,     2,     2,     2,     1,
       1,     0,     5,     2,     1,     1,     2,     2,     4,     1,
       3,     1,     2,     3,     6,     4,     0,     2,     6,     2,
       1,     3,     4,     0,     2,     0,     2,     0,     2,     4,
       0,     1,     0,     1,     3,     3,     7,    12,     1,     3,
       2,     3,     3,     1,     2,     2,     2,     2,     1,     2,
       1,     3,     3,     2,    13,     2,     0,     1,     3,     3,
       6,     7,     5,     7,     9,     1,     0,     2,     0,     2,
       3,     5,     6,     2,     3,     3,     4,     0,     1,     1,
       1,     1,     1,     2,     4,     1,     1,     1,     1,     1,
       1,     2,     3,     3,     0,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     1,     3,     0,     1,     1,
       1,     1,     5,     2,     1,     1,     1,     1,     4,     1,
       2,     2,     1,     3,     3,     2,     1,     0,     5,     2,
       5,     2,     1,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     4,     1,     1,     3,     3,     5,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     2,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     3,     4,     4,
       6,     3,     3,     4,     3,     4,     4,     5,     4,     5,
       1,     1,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     5,
       6,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     4,     3,     5,     6,
       8,     6,     6,     4,     4,     3,     1,     1,     1,     1,
       5,     1,     1,     4,     1,     4,     1,     4,     1,     4,
       1,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       6,     4,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       5,     4,     6,     5,     7,     7,     8,     4,     7,     4,
       6,     6,     4,     5,     4,     5,     3,    11,     8,     9,
       2,     3,     3,     3,     4,     0,     4,     1,     3,     3,
       1,     1,     1,     1,     2,     0,     2,     2,     0,     2,
       3,     3,     4,     2,     2,     5,     0,     5,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     3,     3,     3,     0,     1,     4,     2,     2,
       2,     2,     2,     3,     2,     2,     3,     0,     4,     3,
       5,     4,     3,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     4,     1,     4,     1,     2,     1,
       2,     1,     3,     1,     3,     1,     3,     3,     1,     0,
       1,     3,     3,     3,     2,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       7,     5,     3,     5,     5,     3,     3,     5,     3,     2,
       1,     1,     3,     5,     1,     2,     4,     2,     0,     1,
       0,     1,     2,     2,     2,     3,     5,     1,     0,     1,
       2,     0,     2,     1,     0,     2,     0,     1,     3,     3,
       2,     3,     2,     3,     4,     4,     3,     3,     0,     2,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     3,
       3,     6,     0,     3,     0,     2,     4,     2,     1,     0,
       5,     2,     5,     2,     0,     3,     0,     1,     2,     2,
       2,     2,     3,     2,     3,     2,     0,     1,     3,     3,
       3,     3,     3,     0,     3,     3,     0,     1,     3,     7,
       7,     3,     0,     1,     0,     1,     3,     3,     2,     1,
       1,     1,     3,     1,     2,     1,     3,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     6,     2,
       3,     5,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     3,    10,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 956 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 30759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 3:
#line 961 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 30767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 4:
#line 965 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 30776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 5:
#line 970 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 6:
#line 978 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 7:
#line 986 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 8:
#line 1006 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 30828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 9:
#line 1018 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 30839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1168 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1169 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1173 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1174 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1178 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30875 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1179 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1183 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 30887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1184 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 30893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1185 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 30899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1195 "gram_minimal.y" /* yacc.c:1646  */
    {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 30910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1211 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30923 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1233 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1234 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1238 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1239 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30947 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1244 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30956 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1249 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 30964 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1253 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30978 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1263 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 30990 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1271 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 30998 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1275 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 31006 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1279 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31014 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1284 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1288 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 31071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1335 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 31077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1338 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 31085 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1342 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1346 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31101 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1350 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31109 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1354 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31117 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1368 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1387 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 31143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1396 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 31156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1407 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1408 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1413 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1422 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1431 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1440 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31220 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1462 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31232 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1470 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31244 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1478 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31256 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1486 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1494 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1502 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1520 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1539 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 31319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1550 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 31325 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1551 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 31331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1563 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1574 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1585 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1601 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1620 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 31411 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1626 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1654 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1661 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1668 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 31450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1675 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1685 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1694 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1707 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31500 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1716 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31513 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1725 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31525 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1733 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31537 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1743 "gram_minimal.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 31543 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1745 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31555 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1754 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1766 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 31583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1774 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31596 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1783 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1795 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1804 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1813 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 31650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1821 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1831 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31676 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1841 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1843 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 31688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1846 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1847 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31700 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1851 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 31706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1853 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31712 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1856 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 31718 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1857 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 31724 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1858 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 31730 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1859 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 31736 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1863 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 31742 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1864 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 31748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1865 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 31754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1871 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31760 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1884 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1888 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1892 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const    *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 31797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1909 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 31809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1916 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31815 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1917 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1918 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31827 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1922 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31833 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1923 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1924 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1928 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1929 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1933 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 31863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1935 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minimum */
					(yyval.node) = (Node *) n;
				}
#line 31873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1945 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 31891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1953 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 31903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1961 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 31915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1972 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 31927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1980 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 31938 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1990 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31944 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1991 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31950 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1996 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31956 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1997 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31962 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 261:
#line 2004 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 31972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 262:
#line 2010 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 31982 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 263:
#line 2016 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 264:
#line 2023 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 32004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 265:
#line 2030 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 32015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 266:
#line 2037 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 32026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2044 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 32037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2055 "gram_minimal.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2065 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2066 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2070 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2071 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32073 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2080 "gram_minimal.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 32083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2096 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 32094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2103 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 32105 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2110 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 32116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2117 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 32127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2124 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 32138 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2144 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2154 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2164 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2174 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2184 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32210 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2196 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2208 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2218 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2228 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2238 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2250 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2262 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2272 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2282 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2292 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2302 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2312 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2322 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32400 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2334 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2346 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32430 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2356 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2368 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2369 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2375 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2389 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2402 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 32506 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2418 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2435 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2445 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32549 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2455 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2465 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2475 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2485 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2494 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2503 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetExpression;
					n->name = (yyvsp[-6].str);
					n->def = (yyvsp[-1].node);
					(yyval.node) = (Node *) n;
				}
#line 32625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2513 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 32637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2522 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2532 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2542 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2558 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32695 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2568 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32708 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2578 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2588 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2598 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 32754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2615 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2625 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2635 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2645 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2656 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2670 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32840 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2686 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32852 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2695 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32864 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2704 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2719 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32894 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2728 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32908 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2739 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32922 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2750 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 32933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2758 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2767 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2776 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 32968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2784 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 32979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2792 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2801 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2810 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2819 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 33026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2827 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 33037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2835 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2844 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 33060 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2852 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 33071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2860 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2869 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2878 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2887 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2896 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 33131 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2905 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 33143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2914 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 33157 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2925 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 33168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2933 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 33180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2942 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2951 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33204 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2960 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33216 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2969 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33228 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2978 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 33240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2987 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2995 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33262 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 364:
#line 3003 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 365:
#line 3011 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 366:
#line 3018 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 367:
#line 3028 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 368:
#line 3029 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 369:
#line 3034 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 370:
#line 3042 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3046 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3047 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33339 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3052 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3060 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3068 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3076 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3086 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33393 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3089 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3090 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33411 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3095 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3101 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3105 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 33433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3109 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 33442 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3114 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 33450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3121 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3123 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3128 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3132 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3136 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 33493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3147 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 33501 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3153 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 33507 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3154 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33513 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3158 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33519 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3159 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33525 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3165 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3218 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3231 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 33611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3245 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 33624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3257 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 33632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3264 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 33640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3268 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 33648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3282 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 33662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3294 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3295 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3301 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 33687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3311 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3322 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3333 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 33735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3360 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3367 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3403 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 33795 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3437 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 33819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3459 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3460 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3464 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3465 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3474 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3475 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3476 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3479 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3480 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3485 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3486 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3491 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 33893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3495 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3499 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3503 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33917 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3507 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 33925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3511 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3515 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3519 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3523 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3527 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 33965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3531 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 33973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3535 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) makeNode(A_Star), (yylsp[-3]));
				}
#line 33981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3539 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3543 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 33997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3547 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3556 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 34013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3559 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 34019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3564 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3567 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 34033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3578 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3582 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3589 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 34057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3595 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3596 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 34069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3597 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 34075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3598 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString("default"); }
#line 34081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3599 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 34087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3600 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3605 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34101 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3609 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34109 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3616 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34115 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3630 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34137 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3650 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3670 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3691 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3712 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34228 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3733 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3765 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34263 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3766 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34269 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3767 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34275 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3769 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 34286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3776 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 34297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3782 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 34303 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3783 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 34309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3787 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3788 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3792 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3793 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3798 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3802 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34349 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3809 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34357 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3813 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34365 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3819 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3820 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3821 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3825 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34389 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3826 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3830 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->storage_name = (yyvsp[-3].str);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 34421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3854 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3873 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 34467 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3894 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3895 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 34479 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3899 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3900 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3904 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3905 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 34503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3909 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3910 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3914 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3915 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3920 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3927 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3928 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3930 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3962 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3970 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3978 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3991 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 506:
#line 4003 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 507:
#line 4016 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34659 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 508:
#line 4028 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 34673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 509:
#line 4038 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 34701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 510:
#line 4062 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 511:
#line 4081 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 512:
#line 4082 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 513:
#line 4083 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 514:
#line 4087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 34746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 515:
#line 4088 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 34752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 516:
#line 4108 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 517:
#line 4116 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 518:
#line 4124 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 519:
#line 4132 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 520:
#line 4144 "gram_minimal.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 34813 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 521:
#line 4155 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 34819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 522:
#line 4156 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 34825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 523:
#line 4157 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 34831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 524:
#line 4161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 34837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 525:
#line 4162 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 34843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 526:
#line 4163 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 34849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 527:
#line 4164 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 34855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 528:
#line 4165 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 34861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 529:
#line 4166 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 34867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 530:
#line 4167 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 34873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 531:
#line 4168 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 34879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 532:
#line 4169 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 34885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4170 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 34891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4180 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4187 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4192 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4207 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34948 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4224 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4241 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34988 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4257 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35008 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4275 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35030 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4294 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 35054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4328 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 35066 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4335 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35072 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4340 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 35090 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4354 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-2]);
					n->keys = list_make1(makeString("value"));
					/* no NOT VALID support yet */
					processCASbits((yyvsp[0].ival), (yylsp[0]), "NOT NULL",
								   NULL, NULL, NULL,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 35108 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4369 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 35114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4370 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 35120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4374 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4375 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35132 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35138 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4380 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35144 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4384 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 35152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4390 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4394 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 35172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4398 "gram_minimal.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 35184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4406 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 35192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4410 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 35200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4416 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 35206 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4418 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 35212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4422 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 35220 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4427 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 35228 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4433 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35234 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4434 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4439 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 35254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4449 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 35268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4459 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 35280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4467 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 35292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4475 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 35308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4489 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 35322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4501 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 35330 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4508 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4516 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35354 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4524 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4532 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 35378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4540 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 35390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4549 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4550 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4554 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 35408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4555 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 35414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4559 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = parsePartitionStrategy((yyvsp[-3].str));
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 35428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4570 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 35434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4571 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 35440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4575 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4586 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4597 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 35485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4610 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4611 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4616 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4617 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4618 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4621 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 35521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4622 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 35527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4623 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 35533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4624 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 35539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4627 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4628 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4631 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35557 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4632 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4635 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4657 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4670 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4690 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 35607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4691 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 35613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4695 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 35623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4701 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 35633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4707 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 35643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4724 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4733 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4755 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4769 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4787 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4801 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35727 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4802 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4803 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4816 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4830 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4847 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35791 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4860 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 35797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4861 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 35803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4874 "gram_minimal.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 35816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4895 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4906 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4920 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 35859 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4929 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 35872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4940 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35878 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4944 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35890 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4945 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4948 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35902 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4949 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35908 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4953 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 35916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4957 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4961 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 35932 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4965 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 35940 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4969 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35948 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4973 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35956 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4977 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35964 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4981 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 35972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4985 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 35980 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4989 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 35988 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4993 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 35997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4998 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 645:
#line 5002 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 36013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 646:
#line 5006 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 649:
#line 5016 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 36027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 650:
#line 5017 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 36033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 651:
#line 5019 "gram_minimal.y" /* yacc.c:1646  */
    {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 36044 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 652:
#line 5025 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 36050 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 653:
#line 5028 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 654:
#line 5029 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36062 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 655:
#line 5042 "gram_minimal.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 36082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 656:
#line 5059 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 657:
#line 5073 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 658:
#line 5074 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36110 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 659:
#line 5082 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 660:
#line 5083 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 661:
#line 5087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 662:
#line 5088 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 663:
#line 5092 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 664:
#line 5093 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 665:
#line 5097 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 666:
#line 5098 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 669:
#line 5114 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 670:
#line 5125 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36178 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 671:
#line 5126 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 36184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 672:
#line 5140 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 36196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 673:
#line 5148 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 36208 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 674:
#line 5166 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36221 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 675:
#line 5175 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36234 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 676:
#line 5187 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 677:
#line 5189 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36246 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 678:
#line 5194 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 679:
#line 5198 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36262 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 680:
#line 5202 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 36273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 681:
#line 5209 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 36281 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 682:
#line 5221 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 683:
#line 5232 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 684:
#line 5234 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 685:
#line 5239 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36313 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 686:
#line 5252 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 36327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 687:
#line 5262 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 688:
#line 5272 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 689:
#line 5282 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 36369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 690:
#line 5292 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 691:
#line 5302 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 692:
#line 5312 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36411 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 693:
#line 5322 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 694:
#line 5332 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5342 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5352 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36467 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5362 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 36481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5372 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5391 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36508 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5402 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5403 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 36520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5404 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5405 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 36532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5409 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5410 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5414 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5415 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5426 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5435 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 36582 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5447 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5448 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5453 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5457 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5464 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5469 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5473 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5480 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 36640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5484 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 36649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5489 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 36658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5494 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 36666 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5501 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 36674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5507 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5512 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5524 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5537 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36718 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5551 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36724 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5552 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36730 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5557 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36736 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5558 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36742 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5562 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5563 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5574 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5584 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5593 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5613 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5634 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5655 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5677 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5710 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 36903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5724 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 36909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5725 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 36915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5730 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 36927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5738 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 36938 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5754 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5764 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36966 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5776 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 36978 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5790 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 36991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5799 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 37004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5817 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5844 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5861 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5874 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 37055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5875 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5879 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 37067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5880 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37073 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5884 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5885 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 37085 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5889 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37091 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5890 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 37097 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5895 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 37115 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5908 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37121 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5912 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5913 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 37133 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5917 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 37139 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5918 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 37145 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5919 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 37151 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5920 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 37157 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5921 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 37163 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5932 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 37176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 37182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5944 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 37188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5958 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 37213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5982 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 37243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 775:
#line 6010 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 37249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 776:
#line 6011 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 37255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 777:
#line 6012 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 37261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 778:
#line 6017 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 779:
#line 6019 "gram_minimal.y" /* yacc.c:1646  */
    {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 37290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 780:
#line 6041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 37296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 781:
#line 6043 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 37302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 782:
#line 6045 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 37308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 783:
#line 6047 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 37314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 784:
#line 6049 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 37320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 785:
#line 6053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 786:
#line 6054 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 787:
#line 6058 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 788:
#line 6059 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 37344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 789:
#line 6064 "gram_minimal.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 37357 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 790:
#line 6075 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 791:
#line 6076 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 792:
#line 6080 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 793:
#line 6089 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 794:
#line 6093 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 795:
#line 6098 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 37395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 796:
#line 6102 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 37407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 799:
#line 6117 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37413 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 800:
#line 6118 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 801:
#line 6122 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 37425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 802:
#line 6123 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37431 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 805:
#line 6132 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37437 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 806:
#line 6133 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37443 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 807:
#line 6134 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 808:
#line 6139 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 37457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 809:
#line 6142 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 810:
#line 6143 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 811:
#line 6144 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 812:
#line 6148 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 37481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 813:
#line 6149 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 37487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 814:
#line 6154 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 37493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 815:
#line 6156 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 37521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 816:
#line 6182 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 37527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 817:
#line 6183 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 37533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 818:
#line 6184 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 37539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 819:
#line 6185 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 37545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 820:
#line 6186 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 37551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 821:
#line 6187 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 37557 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 822:
#line 6202 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 823:
#line 6214 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 824:
#line 6227 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 825:
#line 6229 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37597 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 826:
#line 6234 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 37603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 827:
#line 6239 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37609 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 828:
#line 6241 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37615 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 829:
#line 6246 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 37627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 830:
#line 6256 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 37633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 831:
#line 6257 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 37639 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 832:
#line 6258 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 37645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 833:
#line 6259 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 37651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 834:
#line 6271 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 37663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 835:
#line 6290 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 836:
#line 6302 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 837:
#line 6315 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 838:
#line 6326 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37726 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 839:
#line 6337 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 37742 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 840:
#line 6349 "gram_minimal.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 841:
#line 6358 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 842:
#line 6366 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 843:
#line 6374 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 844:
#line 6384 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 845:
#line 6394 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6404 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6414 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6424 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37864 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6435 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 37878 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6445 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6457 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6460 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37905 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6461 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6465 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 37919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6469 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 37927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6475 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 37933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6476 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 37939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6477 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 37945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6478 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 37951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6479 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6480 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 37963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6483 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6486 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6487 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6496 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 37989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6502 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6503 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6507 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6509 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 38013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6520 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38029 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6532 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6544 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6556 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 38077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6568 "gram_minimal.y" /* yacc.c:1646  */
    {
				/*
				 * The following problems must be solved before this can be
				 * implemented:
				 *
				 * - There must be no instance of the target value in
				 *   any table.
				 *
				 * - The value must not appear in any catalog metadata,
				 *   such as stored view expressions or column defaults.
				 *
				 * - The value must not appear in any non-leaf page of a
				 *   btree (and similar issues with other index types).
				 *   This is problematic because a value could persist
				 *   there long after it's gone from user-visible data.
				 *
				 * - Concurrent sessions must not be able to insert the
				 *   value while the preceding conditions are being checked.
				 *
				 * - Possibly more...
				 */
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("dropping an enum value is not implemented"),
						 parser_errposition((yylsp[-2]))));
			}
#line 38108 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6596 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6597 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6615 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6629 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 38142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6630 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 38148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6635 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6649 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6659 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 38192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6668 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 38206 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6678 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 38218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6687 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6688 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6691 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6692 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6695 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6696 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6697 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6701 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 38278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6720 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6731 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38310 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6741 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38324 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6753 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 38330 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6754 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 38336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6759 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38349 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6768 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6781 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6792 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38392 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6806 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6817 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6840 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6851 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6870 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6881 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6892 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6903 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38506 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6914 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6925 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6936 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6947 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38566 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6958 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6969 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38596 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6980 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6991 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 919:
#line 7005 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 38632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 920:
#line 7006 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 38638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 921:
#line 7007 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 38644 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 922:
#line 7008 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 38650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 923:
#line 7009 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 38656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 924:
#line 7010 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 38662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 925:
#line 7011 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 38668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 926:
#line 7012 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 38674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 927:
#line 7013 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 38680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 928:
#line 7014 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 38686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 929:
#line 7015 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 38692 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 930:
#line 7016 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 38698 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 931:
#line 7017 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 38704 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 932:
#line 7027 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 38710 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 933:
#line 7028 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 38716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 934:
#line 7029 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 38722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 935:
#line 7030 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 38728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 936:
#line 7031 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 38734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 937:
#line 7035 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 38740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 938:
#line 7036 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 38746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 939:
#line 7037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 38752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 940:
#line 7038 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 38758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 941:
#line 7039 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 38764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 942:
#line 7040 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 38770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 943:
#line 7041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 38776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 944:
#line 7042 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 38782 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 945:
#line 7047 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 38788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 946:
#line 7048 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 38794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 947:
#line 7049 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 38800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 948:
#line 7053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 38806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 949:
#line 7054 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 38812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 950:
#line 7057 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38818 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 951:
#line 7058 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 38824 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 952:
#line 7062 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38830 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 953:
#line 7064 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 38836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 954:
#line 7068 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 38842 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 955:
#line 7069 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 38848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 956:
#line 7081 "gram_minimal.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 957:
#line 7092 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 958:
#line 7093 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 959:
#line 7094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 960:
#line 7105 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38892 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 961:
#line 7114 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38905 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 962:
#line 7123 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38918 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 963:
#line 7132 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 964:
#line 7141 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38944 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 965:
#line 7150 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 966:
#line 7159 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38970 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 967:
#line 7168 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 968:
#line 7177 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38996 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 969:
#line 7186 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39014 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 970:
#line 7200 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 971:
#line 7209 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 972:
#line 7218 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 973:
#line 7227 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39066 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 974:
#line 7236 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 975:
#line 7245 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 976:
#line 7254 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39105 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 977:
#line 7263 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 978:
#line 7274 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 979:
#line 7275 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 980:
#line 7291 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39144 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 981:
#line 7302 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 982:
#line 7313 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 983:
#line 7324 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 984:
#line 7335 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 985:
#line 7346 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 986:
#line 7357 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39228 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 987:
#line 7368 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 988:
#line 7379 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39256 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 989:
#line 7390 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39270 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 990:
#line 7401 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 991:
#line 7402 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39282 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 992:
#line 7405 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 993:
#line 7406 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 994:
#line 7417 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 39305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 995:
#line 7424 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 39316 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 996:
#line 7433 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 997:
#line 7442 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7451 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7460 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7469 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7478 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 39394 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7487 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7496 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7505 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7514 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7523 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39459 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7532 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39472 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7541 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7550 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7559 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7568 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7595 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 39542 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7613 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39561 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7629 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7656 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7658 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7660 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39598 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7662 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7670 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39622 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7679 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 39628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7680 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 39634 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7684 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39646 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7692 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7700 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39670 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7708 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 39681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7715 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7726 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 39701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7730 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 39709 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7737 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.str) = (yyvsp[0].str);
			}
#line 39717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7741 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 39725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7752 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7761 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39751 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7770 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7779 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39777 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7788 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7797 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7806 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7815 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39829 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7824 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39842 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7833 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7842 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39868 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7851 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7860 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7868 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39906 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7877 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7886 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39932 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7895 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7904 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39958 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7913 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7922 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39984 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7931 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 40003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7944 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 40009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7948 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7949 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7955 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7966 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-3].list);
					n->grantee_roles = (yyvsp[-1].list);
					n->opt = NIL;
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40048 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7977 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-5].list);
					n->grantee_roles = (yyvsp[-3].list);
					n->opt = (yyvsp[-1].list);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7991 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->opt = NIL;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 8003 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					DefElem *opt;

					opt = makeDefElem(pstrdup((yyvsp[-7].str)),
									  (Node *) makeBoolean(false), (yylsp[-7]));
					n->is_grant = false;
					n->opt = list_make1(opt);
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 8020 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 8021 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40110 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 8026 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem(pstrdup((yyvsp[-1].str)), (yyvsp[0].node), (yylsp[-1]));
			}
#line 40118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 8032 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 40124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 8033 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 40130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 8034 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(false); }
#line 40136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 8037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 8038 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 40148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 8049 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 8059 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 8060 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 8065 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 8069 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 8073 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 8085 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 8099 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 8114 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 8130 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 40255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 8131 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 40261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 8132 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 40267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 8133 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 40273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 8134 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 40279 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 8135 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 40285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 8150 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 40319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 8182 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 40353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 8214 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40359 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 8215 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40365 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 8219 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 8220 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 40377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 8223 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 40383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 8224 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 40389 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 8230 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 40405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 8242 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 40421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 8261 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 40430 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 8266 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 40439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 8271 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 40448 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 8277 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40454 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 8278 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40460 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 8281 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 40466 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 8282 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 40472 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 8285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 8286 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 8290 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 40490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 8291 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 40496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 8292 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 40502 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 8295 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 40508 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 8296 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 40514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 8297 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 40520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 8315 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40537 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 8329 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40555 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 8344 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40572 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 8358 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 8373 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 8374 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 8377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 8378 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 8382 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 8383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 8387 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40631 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 8389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 8394 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 40650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 8408 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 8416 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 8424 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 8439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 8440 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 8444 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 8446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 8461 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 8471 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 8481 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 8491 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 8501 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 8513 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 40787 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 8514 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 40793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 8515 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 8516 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40805 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 8517 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 40811 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 8528 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 40823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 8542 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40829 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 8544 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 40839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 8550 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 40850 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 8560 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 40858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 8564 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 40867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 8569 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 40876 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 8577 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 40891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 8619 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 40899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 8623 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 40907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 8627 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 40915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 8631 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 40924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 8638 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40930 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 8639 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40936 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 8644 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 40949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8655 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8657 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8662 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8667 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 8668 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 8676 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 40987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8680 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 40995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8684 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8688 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 41011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8692 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 41019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8696 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 41027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8700 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 41035 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8704 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 41043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8708 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 41051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8712 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 41059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8716 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8720 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 41075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8724 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 41083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8728 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 41091 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8732 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8736 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 41108 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8741 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8748 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8752 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41132 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8756 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8760 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8764 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 41156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8769 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 41162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8771 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 41170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8777 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 41181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8787 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 41189 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8791 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 41203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8801 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 41211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8808 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 41223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8816 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 41231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8827 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 41237 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8828 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 41243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8832 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8833 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8837 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 41269 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8850 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 41277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8854 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 41285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8869 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41298 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8878 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8887 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41324 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8899 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41330 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8900 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8924 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8935 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8946 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8957 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8968 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41411 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8979 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8993 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 9004 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 9018 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 9029 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 9043 "gram_minimal.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 41498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 9051 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 41504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 9053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 41510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 9055 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 41516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 9060 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 41522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 9062 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 41528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 9066 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 41534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 9068 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 41540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 9073 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 41552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 9092 "gram_minimal.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 9101 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 9102 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 9107 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 41583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 9111 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 9124 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41606 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 9136 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41621 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 9148 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 41636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 9160 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 41642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 9161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 41648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 9162 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 41654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 9167 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 9179 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 9180 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 9191 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 9204 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 41704 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 9208 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 41712 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 9212 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 41720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 9216 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 41728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 9223 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41742 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 9245 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 9258 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = REINDEX_OBJECT_SCHEMA;
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 9271 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 9285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 41799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 9286 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 41805 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 9289 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 41811 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 9290 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 41817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 9293 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 9294 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 41829 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 9305 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 41843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 9315 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 41857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 9333 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 9343 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 9353 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 9363 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 9373 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 9383 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 9393 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 9403 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 9413 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 9423 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 9433 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 9443 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42025 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 9453 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 9464 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 9475 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 9485 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 9495 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42097 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 9505 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9515 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9525 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42139 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9535 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9546 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42169 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9557 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9568 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 9579 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 9590 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9601 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42244 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9612 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9623 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9634 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42289 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9645 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9656 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9667 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9679 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9691 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 9703 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 9715 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9727 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9739 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42430 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9750 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9761 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9773 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42477 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9785 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9796 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42507 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9807 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9816 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9826 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42548 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9836 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9846 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9856 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42590 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9866 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9876 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9886 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9896 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42646 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9906 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9924 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 42669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9925 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9936 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9946 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42703 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9956 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9966 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42732 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9977 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9987 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42760 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9998 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42766 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9999 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 42772 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 10010 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 10020 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 10030 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 10040 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 10050 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42842 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 10060 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42856 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 10070 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42870 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 10080 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 10090 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 10100 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42912 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 10110 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42926 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 10120 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42940 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 10130 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 10140 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 10150 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42982 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 10160 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42996 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 10170 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43010 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 10180 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43024 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 10190 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43038 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 10200 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43052 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 10210 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43066 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 10220 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43080 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 10230 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 10240 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43108 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 10250 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 10260 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 10270 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43150 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 10289 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 10298 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 10299 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 43174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 10303 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 43180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 10305 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 43186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 10307 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0])); }
#line 43192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 10312 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 43198 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 10313 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 43204 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 10314 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 43210 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 10315 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 43216 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 10316 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 43222 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 10329 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43234 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 10345 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 10354 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 10363 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 10372 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 10381 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 10390 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43312 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 10399 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43325 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 10408 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 10417 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 10426 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 10435 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 10444 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 10453 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 10462 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 10471 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43429 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 10480 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43442 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 10489 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 10498 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 10507 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 10516 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 10525 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43507 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 10534 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 10543 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 10552 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 10580 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43558 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 10588 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 43571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 10597 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 43585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 10623 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43598 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 10632 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43609 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 10639 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 10645 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 43650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 10672 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 43664 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 10683 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 10692 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 10700 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 43693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 10702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 43699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 10724 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 10732 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 43725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 10742 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 43739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 10752 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 43753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 10771 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 10790 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10800 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43795 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10810 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10820 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43824 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10831 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10842 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43854 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10853 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10864 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10875 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10893 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 43911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10902 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 43924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 10921 "gram_minimal.y" /* yacc.c:1646  */
    {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 10936 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43947 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 10937 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10938 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10944 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 43969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10950 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 43979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 10966 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10967 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10970 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 43997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 44003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10972 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 44009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10973 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 44015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10977 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10978 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10979 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10992 "gram_minimal.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 11002 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 11003 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 44057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 11007 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44068 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 11017 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 11024 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44090 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 11044 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 11054 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44117 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 11063 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44131 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 11073 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44145 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 11083 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 11092 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 11101 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 11110 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 11119 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44210 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 11128 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 11137 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 11146 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 11158 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44262 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 11167 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 11185 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 44283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 11188 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 44290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 11191 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 44297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 11194 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 44304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 11197 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 44311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 11204 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 44317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 11206 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 44323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 11208 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 44329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 11214 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 11218 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 11219 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 11220 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 11234 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 11248 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 11262 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 44409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 11281 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 44431 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 11301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44437 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 11302 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44443 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 11303 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 44449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 11304 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 44455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 11315 "gram_minimal.y" /* yacc.c:1646  */
    {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44466 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 11332 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 11342 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 11343 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 11347 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 44496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 11348 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 44502 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 11353 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 11357 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 44518 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 11361 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 44526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 11378 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 11379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 44538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 11380 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 11381 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 11382 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 11383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 11384 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44568 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 11404 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 11412 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 11420 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 44605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 11429 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 44616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 11439 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 11457 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 11466 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 11475 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44667 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 11484 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 11496 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 44688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 11500 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 44696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 11511 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 44704 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 11523 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 44715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 11541 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44726 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 11548 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 11565 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 44751 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 11579 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 11589 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 11598 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 11607 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 11617 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 44816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 11629 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 44831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 11641 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 11664 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44856 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 11675 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 44872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 11687 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 44888 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 11699 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 44904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 11711 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 44920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 11723 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 44934 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 11733 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 44948 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 11762 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 44963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 11785 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44976 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 11794 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 11804 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 45004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 11816 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 45019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 11828 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 45034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 11841 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 11842 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 45046 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 11855 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 45071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 11876 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 45084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 11887 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 45100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 11899 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 45113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 11911 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 45121 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 11915 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 45129 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 11927 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 45137 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 11933 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 11934 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 45149 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 11935 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "format"; }
#line 45155 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 11939 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 45161 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 11940 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 45167 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 11941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 11945 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 11946 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45185 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 11950 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45191 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 11951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 11954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 11955 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11958 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11959 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45221 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11963 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45227 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 11964 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 11969 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 45241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 11976 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 11978 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 11982 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11983 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11997 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 45277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 12005 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 45292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 12016 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 45304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 12024 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 45316 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 12054 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 45329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 12064 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 12065 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 12084 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 12093 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 45374 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 12111 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 45395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 12129 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 12130 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 12141 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 45420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 12150 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 45433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 12159 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 12168 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45459 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 12188 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 45471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 12198 "gram_minimal.y" /* yacc.c:1646  */
    {
				InsertStmt *insert = makeNode(InsertStmt);
				insert->relation = (yyvsp[0].range);
				(yyval.node) = (Node *) insert;
				/*
				 * Assign the node directly to the parsetree and exit the scanner
				 * we don't want to keep parsing for information we don't need
				 */
				pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
				YYACCEPT;
			}
#line 45487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 12219 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 12223 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 12231 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 12237 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45525 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 12244 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 12250 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 12257 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 45556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 12265 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 45562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 12266 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 45568 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 12271 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45574 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 12273 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 12278 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 12289 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 45605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 12299 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 45618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 12308 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 45626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 12315 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 45638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 12324 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 45650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 12332 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 45658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 12338 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45664 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 12339 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45670 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 12352 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 45685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 12365 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 12366 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45697 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 12378 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 45710 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 12388 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 45716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 12389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 45722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 12392 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 45728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 12393 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 45734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 12394 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 45740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 12395 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 45746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 12396 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 45752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 12397 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 45758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 12398 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 45764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 12399 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 45770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 12402 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 12403 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45782 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 12407 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 45788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 12408 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 45794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 12409 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 45800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 12425 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 45816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 12438 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[0].range);
					n->targetList = NULL;
					n->fromClause = NULL;
					n->whereClause = NULL;
					n->returningList = NULL;
					n->withClause = (yyvsp[-2].with);
					(yyval.node) = (Node *)n;
					pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
					YYACCEPT;
				}
#line 45833 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 12452 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 12453 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 45845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 12458 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 45854 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 12463 "gram_minimal.y" /* yacc.c:1646  */
    {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 45879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 12487 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 12497 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45897 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 12498 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 45903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 12515 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-9].with);
					m->relation = (yyvsp[-6].range);
					m->sourceRelation = (yyvsp[-4].node);
					m->joinCondition = (yyvsp[-2].node);
					m->mergeWhenClauses = (yyvsp[-1].list);
					m->returningList = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 45920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 12530 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45926 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 12531 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 45932 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 12542 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 45943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 12549 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 45954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 12556 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 45965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 12563 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 45979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 12573 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 45993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 12585 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_MATCHED; }
#line 45999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 12586 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_SOURCE; }
#line 46005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 12590 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 46011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 12591 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 46017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 12595 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 12596 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46029 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 12601 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 46043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 12614 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 46057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 12627 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 12636 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 12645 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46096 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 12654 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46109 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 12663 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 46122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 12675 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 46130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 12687 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 46144 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 12698 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46150 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 12701 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 12702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 46162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 12703 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 46168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 12704 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 46174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 12705 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 46180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 12706 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 46186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 12709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 12710 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 46198 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 12711 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46204 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 12764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46210 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 12765 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46216 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 12780 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46222 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 12782 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 12789 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46245 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 12797 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 12805 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 46269 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 12813 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46281 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 12821 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 12829 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 12839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 12840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 12875 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 46335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 12891 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 46354 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 12905 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 12907 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 46383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 12926 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 46391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 12930 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 46399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 12934 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 46407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 12949 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 46418 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 12956 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 46429 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 12963 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 46440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 12972 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 12973 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46452 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12977 "gram_minimal.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 46469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12992 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 46475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 12993 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 46481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 12994 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 46487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12999 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46501 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 13009 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 13019 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 46523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 13026 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 46539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 13038 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 46555 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 13050 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 46563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 13056 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 46569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 13057 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 46575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 13062 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 46590 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 13073 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 46596 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 13082 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 13087 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 13092 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 13097 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 13102 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46644 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 13110 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 13118 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 46665 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 13123 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 13128 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 13139 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 46689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 13140 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 46695 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 13141 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 46701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 13148 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 46707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 13149 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 13158 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 13159 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 13163 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 13164 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 13168 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46743 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 13172 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 46749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 13173 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 46755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 13177 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 46768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 13186 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 46781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 13199 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 46790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 13204 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 46799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 13209 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 46807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 13213 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 13224 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 46826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 13225 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 46832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 13230 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 13239 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 46858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 13255 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 13264 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 46884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 13273 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46897 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 13282 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 46910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 13294 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 13297 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46922 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 13301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46928 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 13303 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 46937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 13310 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 13330 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 13332 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 13334 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 13338 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 46967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 13339 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 46973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 13343 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 13344 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 13347 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 13348 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 13374 "gram_minimal.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 47009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 13382 "gram_minimal.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 47021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 13392 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 13393 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 47033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 13397 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 13398 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 13399 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 13400 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 13401 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 13406 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 47071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 13419 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 13426 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 13433 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 47095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 13439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47101 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 13440 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 13444 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 13445 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 13449 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 13450 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47131 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 13454 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47137 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 13455 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 47143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 13460 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 47156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 13471 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 47162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 13472 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 47168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 13473 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 47174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 13474 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 47180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 13478 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 13479 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 13490 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 47203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 13497 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 47214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 13515 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47220 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 13516 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 13520 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47232 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 13521 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 47238 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 13528 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 47247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 13533 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 47260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 13542 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 47272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 13550 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 47285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 13559 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 13566 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 13574 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 13583 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 13592 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 47342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 13596 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 47351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 13601 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) jt;
				}
#line 47362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 13608 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					jt->lateral = true;
					(yyval.node) = (Node *) jt;
				}
#line 47374 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 13637 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 47382 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 13641 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 47400 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 13655 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 47425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 13676 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 47451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 13698 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 13711 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 13728 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 13734 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 13739 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 13745 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 13751 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 47530 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 13752 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 47536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 13763 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 47546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 13768 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 47552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 13777 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 47560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 13781 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 47568 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 13785 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 13792 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47590 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 13799 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 47598 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 13804 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 47604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 13805 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 47610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 13806 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 47616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 13807 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 47622 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 13828 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 47630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 13832 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 13840 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 13847 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 13854 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 13861 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 13868 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47690 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 13878 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 47696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 13879 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 47702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 13893 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47710 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 13897 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 47722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13905 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 47734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13919 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 47749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13932 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 47755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13933 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47761 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13949 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13960 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47791 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13973 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 47797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13977 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 47803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13978 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 47809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13981 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 47815 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13982 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13985 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 47827 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13986 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 47833 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13991 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13992 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13997 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 13999 "gram_minimal.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 47864 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 14007 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47870 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 14012 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47876 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 14013 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 14018 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 47890 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 14022 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 47898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 14028 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 14053 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 47936 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 14065 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 47951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 14077 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 14078 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 47963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 14083 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 47981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 14097 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 48042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 14154 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 48057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 14168 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 48063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 14170 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 48069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 14175 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 48075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 14177 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 48081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 14179 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 48087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 14181 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 48093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 14183 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("path", (yyvsp[0].node), (yylsp[-1])); }
#line 48099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 14188 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48105 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 14190 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 14195 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 14203 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 48135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 14219 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTable *n = makeNode(JsonTable);
					char	  *pathstring;

					n->context_item = (JsonValueExpr *) (yyvsp[-10].node);
					if (!IsA((yyvsp[-8].node), A_Const) ||
						castNode(A_Const, (yyvsp[-8].node))->val.node.type != T_String)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("only string constants are supported in JSON_TABLE path specification"),
								 parser_errposition((yylsp[-8]))));
					pathstring = castNode(A_Const, (yyvsp[-8].node))->val.sval.sval;
					n->pathspec = makeJsonTablePathSpec(pathstring, (yyvsp[-7].str), (yylsp[-8]), (yylsp[-7]));
					n->passing = (yyvsp[-6].list);
					n->columns = (yyvsp[-3].list);
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-12]);
					(yyval.node) = (Node *) n;
				}
#line 48159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 14241 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 14242 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 48171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 14247 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48177 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 14249 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 48183 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 14254 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FOR_ORDINALITY;
					n->name = (yyvsp[-2].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 14267 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_REGULAR;
					n->name = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48216 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 14287 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FORMATTED;
					n->name = (yyvsp[-6].str);
					n->typeName = (yyvsp[-5].typnam);
					n->format = (JsonFormat *) (yyvsp[-4].node);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 14305 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_EXISTS;
					n->name = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->wrapper = JSW_NONE;
					n->quotes = JS_QUOTES_UNSPEC;
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-1].node);
					n->on_empty = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 48256 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 14322 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-4].str), NULL, (yylsp[-4]), -1);
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 14334 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-6].str), (yyvsp[-4].str), (yylsp[-6]), (yylsp[-4]));
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 48286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 14353 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonTablePathSpec((yyvsp[0].str), NULL, (yylsp[0]), -1); }
#line 48292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 14355 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48298 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 14369 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 48307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 14374 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 48317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 14381 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 48326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 14386 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 48336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 14392 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 48345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 14397 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 48355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 14406 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 48361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 14408 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 48367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 14410 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 48373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 14414 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 14415 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 14416 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 14417 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 14418 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 14420 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 48412 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 14425 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 48422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 14430 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 14445 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 14446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 14447 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 14448 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48452 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 14449 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 14461 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 14467 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 48478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 14474 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 14475 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 14482 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 14487 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48508 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 14492 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 14497 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 14502 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 14507 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 14512 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 14517 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 14523 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48573 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 14529 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 14535 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 14542 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 48617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 14563 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 48625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 14573 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 14577 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 14585 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 14589 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 14597 "gram_minimal.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 14609 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 14630 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48697 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 14634 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 14640 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 14644 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 14657 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 48738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 14665 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 14675 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 14677 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 14679 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 48768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 14681 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 14683 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 14685 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 14689 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 48792 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 14690 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48798 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 14698 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48811 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 14707 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 14715 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 14724 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 14735 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 14742 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 48863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 14743 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 14744 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48875 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 14749 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 48881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 14751 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 48887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 14753 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 48893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 14755 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 48899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 14757 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 48905 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 14759 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 14761 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 48920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 14766 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 48929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 14771 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 48939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 14777 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 48951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 14785 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 48960 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 14790 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 48971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 14797 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 48981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 14803 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 14808 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 48995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 14812 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 49004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 14820 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("json");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 49013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 14854 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 14856 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 49025 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 14858 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49038 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 14867 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 14874 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   -1);
				}
#line 49060 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 14890 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49066 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 14892 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 49072 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 14894 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49078 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 14896 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 14898 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49090 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 14900 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49096 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 14902 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 14904 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49108 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 14906 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 14908 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14910 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14912 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49132 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14914 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49138 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14916 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49144 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14919 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49150 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14921 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14924 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14926 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14928 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 49174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14930 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 49180 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14933 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 49189 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14938 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14947 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 49211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14952 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14961 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 49233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14966 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49246 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14975 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 49255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14980 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14990 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 49281 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14999 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 15008 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 15017 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 49320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 15036 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 15045 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 15054 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 49359 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 15063 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 15072 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 49393 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 15089 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49406 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 15098 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 15107 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 15116 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 15125 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 15134 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 15143 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 49479 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 15147 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 49487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 15151 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 15159 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 15167 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 15175 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 15183 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 49560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 15204 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 49587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 15227 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 49603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 15239 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 49614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 15246 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 49634 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 15262 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 49643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 15267 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49653 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 15273 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 49664 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 15280 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 49675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 15287 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 15295 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 49699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 15304 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 49709 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 15322 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 49719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 15339 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 15365 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 15367 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 49750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 15369 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 15371 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 49762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 15373 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 15375 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 15377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 15379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 15381 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49792 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 15383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49798 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 15385 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 15387 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 15389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 15391 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 15393 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 15395 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49834 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 15397 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49840 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 15399 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 15401 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 49854 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 15405 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 49862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 15409 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 49871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 15414 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 15429 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 15430 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 15432 "gram_minimal.y" /* yacc.c:1646  */
    {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 49914 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 15449 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 49931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 15462 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 15464 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 15466 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 15478 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 49988 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 15503 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 15515 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50020 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 15527 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50032 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 15535 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 50047 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 15546 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 50062 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 15557 "gram_minimal.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 50074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 15567 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 50084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 15573 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50097 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 15582 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 15592 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 15602 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 50142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 15615 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 50156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 15625 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 50179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 15656 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 50219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 15692 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 50233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 15702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50239 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 15712 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50245 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 15713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 15714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 15722 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 15729 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 50276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 15733 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 50284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 15737 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 15741 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 50300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 15745 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 15749 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 50316 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 15753 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50324 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 15757 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 50332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 15761 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 15765 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 50348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 15769 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 50356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 15773 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 50364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 15777 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("system_user"),
											   NIL,
											   COERCE_SQL_SYNTAX,
											   (yylsp[0]));
				}
#line 50375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 15784 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 50383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 15788 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 50391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 15792 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 50399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 15796 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 50405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 15798 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 15805 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 15812 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 50438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 15819 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 15826 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 15837 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 15851 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50496 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 15861 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 15872 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 50531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 15888 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 15898 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 15905 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 15912 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 15919 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 50586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 15923 "gram_minimal.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 50598 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 15931 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 15940 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 15949 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 50632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 15953 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 50640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 15957 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 50648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 15961 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 50656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 15965 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 50664 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 15969 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 15978 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 50685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 15982 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 50699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 15992 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 50707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 15996 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 16000 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50724 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 16005 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-5].ival);
					n->expr = (yyvsp[-4].node);
					n->typeName = (yyvsp[-2].typnam);
					n->indent = (yyvsp[-1].boolean);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 50739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 16016 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Support for legacy (non-standard) json_object() */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("json_object"),
											   (yyvsp[-1].list), COERCE_EXPLICIT_CALL, (yylsp[-3]));
				}
#line 50749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 16025 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-4].list);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 16036 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 16051 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 16066 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-3].node);
					n->format = (JsonFormat *) (yyvsp[-2].node);
					n->absent_on_null = true;	/* XXX */
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 16079 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 16089 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonParseExpr *n = makeNode(JsonParseExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->unique_keys = (yyvsp[-1].boolean);
					n->output = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 16099 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonScalarExpr *n = makeNode(JsonScalarExpr);

					n->expr = (Expr *) (yyvsp[-1].node);
					n->output = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 16108 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonSerializeExpr *n = makeNode(JsonSerializeExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 16117 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeSupportFunc *m = makeNode(MergeSupportFunc);

					m->msftype = TEXTOID;
					m->location = (yylsp[-2]);
					(yyval.node) = (Node *) m;
				}
#line 50874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 16131 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_QUERY_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-8].node);
					n->pathspec = (yyvsp[-6].node);
					n->passing = (yyvsp[-5].list);
					n->output = (JsonOutput *) (yyvsp[-4].node);
					n->wrapper = (yyvsp[-3].ival);
					n->quotes = (yyvsp[-2].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-10]);
					(yyval.node) = (Node *) n;
				}
#line 50894 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 16150 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_EXISTS_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-5].node);
					n->pathspec = (yyvsp[-3].node);
					n->passing = (yyvsp[-2].list);
					n->output = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 50911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 16167 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_VALUE_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-6].node);
					n->pathspec = (yyvsp[-4].node);
					n->passing = (yyvsp[-3].list);
					n->output = (JsonOutput *) (yyvsp[-2].node);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 50929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 16187 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 16189 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 50941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 16193 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 50947 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 16195 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 50953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 16197 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 50959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 16199 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 50965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 16202 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 50971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 16205 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 50977 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 16206 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 50983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 16210 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 50995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 16218 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 51007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 16227 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 51013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 16228 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 51019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 16231 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 51025 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 16232 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51031 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 16233 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 16236 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 51043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 16237 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 16238 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 16244 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 16248 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 16252 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 16256 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 16271 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 16272 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 16276 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 51105 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 16277 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 51111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 16285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51117 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 16286 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 16290 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 51129 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 16292 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 51135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 16297 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 51146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 16306 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 51152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 16308 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 51170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 16322 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 51176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 16327 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 51195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 16353 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 16354 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 51207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 16357 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 16358 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 16367 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 16375 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 16383 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 16391 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 16402 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 51290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 16420 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 51332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 16466 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 16475 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 16484 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 16493 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 16502 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 16513 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 51403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 16514 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 51409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 16515 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 51415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 16516 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 51421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 16517 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 51427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 16531 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 16532 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 16533 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 51445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 16536 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 16537 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 16540 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 51463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 16543 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 51469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 16544 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 51475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 16545 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 51481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 16548 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 16549 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 16552 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 51499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 16553 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 51505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 16554 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 51511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 16555 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 51517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 16556 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 51523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 16557 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 51529 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 16558 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 51535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 16559 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 51541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 16560 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 51547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 16561 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 51553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 16562 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 51559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 16563 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 51565 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 16567 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 16569 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 16574 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 16576 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 16581 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 16583 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 16585 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 51607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 16587 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 51613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 16589 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 51619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 16591 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 51625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 16603 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 16607 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 16614 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 16618 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 16624 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51665 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 16628 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 16638 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 16649 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 16650 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 16653 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 51711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 16654 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 51717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 16658 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 16662 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 16666 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 51741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 16671 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51747 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 16672 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 51753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 16678 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 51761 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 16687 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 16688 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 51773 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 16689 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 51779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 16690 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 51785 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 16691 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 51791 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 16692 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 51797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 16693 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 51803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 16694 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 16698 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 51815 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 16699 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 51821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 16700 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 51827 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 16701 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 51833 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 16707 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51842 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 16712 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 16720 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 51857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 16742 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51865 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 16746 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 51874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 16751 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 16762 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 51910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 16779 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51918 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 16784 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 51924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 16785 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51930 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 16786 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51936 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 16790 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 51948 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 16797 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 51954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 16808 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 51969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 16822 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 16823 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 51981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 16828 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 51994 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 16839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 52000 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 16840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52006 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 16843 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 52012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 16844 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52018 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 16848 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 52026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 16852 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 52034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 16859 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 52042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 16863 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 52050 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 16867 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 52063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 16876 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 52076 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 16887 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 52082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 16888 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 16892 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2330:
#line 16893 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2331:
#line 16897 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2332:
#line 16898 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2335:
#line 16907 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2336:
#line 16908 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2337:
#line 16912 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2338:
#line 16913 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 52136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2339:
#line 16918 "gram_minimal.y" /* yacc.c:1646  */
    {
				JsonArgument *n = makeNode(JsonArgument);

				n->val = (JsonValueExpr *) (yyvsp[-2].node);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 52148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2340:
#line 16929 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_NONE; }
#line 52154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2341:
#line 16930 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_NONE; }
#line 52160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2342:
#line 16931 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2343:
#line 16932 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2344:
#line 16933 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_CONDITIONAL; }
#line 52178 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2345:
#line 16934 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2346:
#line 16935 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_CONDITIONAL; }
#line 52190 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2347:
#line 16936 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2348:
#line 16937 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNSPEC; }
#line 52202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2349:
#line 16942 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonBehavior(JSON_BEHAVIOR_DEFAULT, (yyvsp[0].node), (yylsp[-1])); }
#line 52208 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2350:
#line 16944 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonBehavior((yyvsp[0].ival), NULL, (yylsp[0])); }
#line 52214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2351:
#line 16948 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_ERROR; }
#line 52220 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2352:
#line 16949 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_NULL; }
#line 52226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2353:
#line 16950 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_TRUE; }
#line 52232 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2354:
#line 16951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_FALSE; }
#line 52238 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2355:
#line 16952 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_UNKNOWN; }
#line 52244 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2356:
#line 16953 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 52250 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2357:
#line 16954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_OBJECT; }
#line 52256 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2358:
#line 16956 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 52262 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2359:
#line 16961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-2].node), NULL); }
#line 52268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2360:
#line 16963 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-2].node)); }
#line 52274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2361:
#line 16965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-5].node), (yyvsp[-2].node)); }
#line 52280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2362:
#line 16967 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, NULL); }
#line 52286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2363:
#line 16972 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 52292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2364:
#line 16974 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52298 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2365:
#line 16979 "gram_minimal.y" /* yacc.c:1646  */
    {
				/* formatted_expr will be set during parse-analysis. */
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), NULL,
												castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 52308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2366:
#line 16988 "gram_minimal.y" /* yacc.c:1646  */
    {
					int		encoding;

					if (!pg_strcasecmp((yyvsp[0].str), "utf8"))
						encoding = JS_ENC_UTF8;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf16"))
						encoding = JS_ENC_UTF16;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf32"))
						encoding = JS_ENC_UTF32;
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("unrecognized JSON encoding: %s", (yyvsp[0].str))));

					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, encoding, (yylsp[-3]));
				}
#line 52329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2367:
#line 17005 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, JS_ENC_DEFAULT, (yylsp[-1]));
				}
#line 52337 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2368:
#line 17012 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 52345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2369:
#line 17016 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 52353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2370:
#line 17022 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_KEEP; }
#line 52359 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2371:
#line 17023 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_KEEP; }
#line 52365 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2372:
#line 17024 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_OMIT; }
#line 52371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2373:
#line 17025 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_OMIT; }
#line 52377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2374:
#line 17026 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_UNSPEC; }
#line 52383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2375:
#line 17031 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 52396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2376:
#line 17039 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2377:
#line 17053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 52408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2378:
#line 17054 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 52414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2379:
#line 17055 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ARRAY; }
#line 52420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2380:
#line 17056 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_OBJECT; }
#line 52426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2381:
#line 17057 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_SCALAR; }
#line 52432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2382:
#line 17066 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2383:
#line 17067 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2384:
#line 17068 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2385:
#line 17069 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2386:
#line 17070 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2387:
#line 17075 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2388:
#line 17077 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 52474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2389:
#line 17087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52480 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2390:
#line 17090 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2391:
#line 17095 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2392:
#line 17096 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2393:
#line 17097 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2394:
#line 17101 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2395:
#line 17102 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2396:
#line 17103 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2397:
#line 17107 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2398:
#line 17108 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 52534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2399:
#line 17118 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2400:
#line 17136 "gram_minimal.y" /* yacc.c:1646  */
    {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2401:
#line 17150 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52573 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2402:
#line 17151 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2403:
#line 17160 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2404:
#line 17161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2405:
#line 17165 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 52597 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2406:
#line 17166 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 52603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2407:
#line 17170 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 52615 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2408:
#line 17178 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 52627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2409:
#line 17186 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 52639 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2410:
#line 17194 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 52656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2411:
#line 17216 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 52662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2412:
#line 17217 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 52668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2413:
#line 17229 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 52676 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2414:
#line 17233 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 52684 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2415:
#line 17239 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52690 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2416:
#line 17241 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 52696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2417:
#line 17245 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2418:
#line 17247 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52708 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2419:
#line 17249 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2420:
#line 17260 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2421:
#line 17262 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 52729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2422:
#line 17273 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 52737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2423:
#line 17277 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52745 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2424:
#line 17281 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2425:
#line 17285 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52761 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2426:
#line 17289 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2427:
#line 17298 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2428:
#line 17306 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2429:
#line 17338 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 52830 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2430:
#line 17342 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 52841 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2431:
#line 17349 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52853 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2432:
#line 17357 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 52861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2433:
#line 17361 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 52869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2434:
#line 17365 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 52877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2435:
#line 17370 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 52883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2436:
#line 17371 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2437:
#line 17373 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 52895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2438:
#line 17374 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 52901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2439:
#line 17375 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 52907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2440:
#line 17380 "gram_minimal.y" /* yacc.c:1646  */
    {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 52950 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2441:
#line 17421 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 52982 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2442:
#line 17449 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 52990 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2443:
#line 17453 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 52998 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2444:
#line 17457 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 53006 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2445:
#line 17463 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 53012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2446:
#line 17465 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 53018 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2447:
#line 17482 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 53049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2448:
#line 17515 "gram_minimal.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 53064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2449:
#line 17527 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2450:
#line 17528 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 53076 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2453:
#line 17549 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2454:
#line 17550 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2455:
#line 17551 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2456:
#line 17556 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2457:
#line 17557 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2458:
#line 17558 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2459:
#line 17563 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2460:
#line 17564 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2461:
#line 17565 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2462:
#line 17566 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2463:
#line 17572 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2464:
#line 17573 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2465:
#line 17574 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2466:
#line 17575 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2467:
#line 17576 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2468:
#line 17582 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2469:
#line 17583 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53178 "gram_minimal.c" /* yacc.c:1646  */
    break;


#line 53182 "gram_minimal.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 18595 "gram_minimal.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}



static Node *
makeFloatConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBoolAConst(bool state, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.boolval.type = T_Boolean;
    n->val.boolval.boolval = state;
    n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.bsval.type = T_BitString;
    n->val.bsval.bsval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
    A_Const    *n = makeNode(A_Const);

    n->isnull = true;
    n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node       *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location)));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Parse a user-supplied partition strategy string into parse node
 * PartitionStrategy representation, or die trying.
 */
static PartitionStrategy
parsePartitionStrategy(char *strategy)
{
	if (pg_strcasecmp(strategy, "list") == 0)
		return PARTITION_STRATEGY_LIST;
	else if (pg_strcasecmp(strategy, "range") == 0)
		return PARTITION_STRATEGY_RANGE;
	else if (pg_strcasecmp(strategy, "hash") == 0)
		return PARTITION_STRATEGY_HASH;

	ereport(ERROR,
			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
			 errmsg("unrecognized partitioning strategy \"%s\"",
					strategy)));
	return PARTITION_STRATEGY_LIST;		/* keep compiler quiet */

}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("invalid publication object list"),
				 errdetail("One of TABLE or TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				 parser_errposition(pubobj->location)));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid table name"),
						 parser_errposition(pubobj->location)));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("WHERE clause not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("column specification not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid schema name"),
						 parser_errposition(pubobj->location)));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
minimal_parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

